package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.AdministratorRoles;
import com.trendmicro.deepsecurity.model.Role;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class AdministratorRolesApi {
  private ApiClient apiClient;

  public AdministratorRolesApi() {
    this(Configuration.getDefaultApiClient());
  }

  public AdministratorRolesApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create an Administrator Role
   * Create a new administrator role.
   * @param administratorrole The settings of the new administrator role. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return Role
   * @throws ApiException if fails to make API call
   */
  public Role createAdministratorRole(Role administratorrole, String apiVersion) throws ApiException {
    Object localVarPostBody = administratorrole;
    
    // verify the required parameter 'administratorrole' is set
    if (administratorrole == null) {
      throw new ApiException(400, "Missing the required parameter 'administratorrole' when calling createAdministratorRole");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createAdministratorRole");
    }
    
    // create path and map variables
    String localVarPath = "/roles".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<Role> localVarReturnType = new GenericType<Role>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete an Administrator Role
   * Delete an administrator role by ID.
   * @param roleID The ID number of the administrator role to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteAdministratorRole(Integer roleID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'roleID' is set
    if (roleID == null) {
      throw new ApiException(400, "Missing the required parameter 'roleID' when calling deleteAdministratorRole");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteAdministratorRole");
    }
    
    // create path and map variables
    String localVarPath = "/roles/{roleID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "roleID" + "\\}", apiClient.escapeString(roleID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe an Administrator Role
   * Describe an administrator role by ID.
   * @param roleID The ID number of the administrator role to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return Role
   * @throws ApiException if fails to make API call
   */
  public Role describeAdministratorRole(Integer roleID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'roleID' is set
    if (roleID == null) {
      throw new ApiException(400, "Missing the required parameter 'roleID' when calling describeAdministratorRole");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeAdministratorRole");
    }
    
    // create path and map variables
    String localVarPath = "/roles/{roleID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "roleID" + "\\}", apiClient.escapeString(roleID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<Role> localVarReturnType = new GenericType<Role>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List Administrator Roles
   * Lists all administrator roles.
   * @param apiVersion The version of the api being called. (required)
   * @return AdministratorRoles
   * @throws ApiException if fails to make API call
   */
  public AdministratorRoles listAdministratorRoles(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listAdministratorRoles");
    }
    
    // create path and map variables
    String localVarPath = "/roles".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<AdministratorRoles> localVarReturnType = new GenericType<AdministratorRoles>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify an Administrator Role
   * Modify an administrator role by ID. Any properties that have no value are not modified.
   * @param roleID The ID number of the administrator role to modify. (required)
   * @param administrator The settings of the administrator role to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return Role
   * @throws ApiException if fails to make API call
   */
  public Role modifyAdministratorRole(Integer roleID, Role administrator, String apiVersion) throws ApiException {
    Object localVarPostBody = administrator;
    
    // verify the required parameter 'roleID' is set
    if (roleID == null) {
      throw new ApiException(400, "Missing the required parameter 'roleID' when calling modifyAdministratorRole");
    }
    
    // verify the required parameter 'administrator' is set
    if (administrator == null) {
      throw new ApiException(400, "Missing the required parameter 'administrator' when calling modifyAdministratorRole");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyAdministratorRole");
    }
    
    // create path and map variables
    String localVarPath = "/roles/{roleID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "roleID" + "\\}", apiClient.escapeString(roleID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<Role> localVarReturnType = new GenericType<Role>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search Administrator Roles
   * Search for administrator roles using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return AdministratorRoles
   * @throws ApiException if fails to make API call
   */
  public AdministratorRoles searchAdministratorRoles(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchAdministratorRoles");
    }
    
    // create path and map variables
    String localVarPath = "/roles/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<AdministratorRoles> localVarReturnType = new GenericType<AdministratorRoles>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
