package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.Administrator;
import com.trendmicro.deepsecurity.model.Administrators;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class AdministratorsApi {
  private ApiClient apiClient;

  public AdministratorsApi() {
    this(Configuration.getDefaultApiClient());
  }

  public AdministratorsApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create an Administrator
   * Create a new administrator.
   * @param administrator The settings of the new administrator. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return Administrator
   * @throws ApiException if fails to make API call
   */
  public Administrator createAdministrator(Administrator administrator, String apiVersion) throws ApiException {
    Object localVarPostBody = administrator;
    
    // verify the required parameter 'administrator' is set
    if (administrator == null) {
      throw new ApiException(400, "Missing the required parameter 'administrator' when calling createAdministrator");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createAdministrator");
    }
    
    // create path and map variables
    String localVarPath = "/administrators".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<Administrator> localVarReturnType = new GenericType<Administrator>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete an Administrator
   * Delete an administrator by ID.
   * @param administratorID The ID number of the administrator to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteAdministrator(Integer administratorID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'administratorID' is set
    if (administratorID == null) {
      throw new ApiException(400, "Missing the required parameter 'administratorID' when calling deleteAdministrator");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteAdministrator");
    }
    
    // create path and map variables
    String localVarPath = "/administrators/{administratorID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "administratorID" + "\\}", apiClient.escapeString(administratorID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe an Administrator
   * Describe an administrator by ID.
   * @param administratorID The ID number of the administrator to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return Administrator
   * @throws ApiException if fails to make API call
   */
  public Administrator describeAdministrator(Integer administratorID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'administratorID' is set
    if (administratorID == null) {
      throw new ApiException(400, "Missing the required parameter 'administratorID' when calling describeAdministrator");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeAdministrator");
    }
    
    // create path and map variables
    String localVarPath = "/administrators/{administratorID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "administratorID" + "\\}", apiClient.escapeString(administratorID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<Administrator> localVarReturnType = new GenericType<Administrator>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List Administrators
   * Lists all administrators.
   * @param apiVersion The version of the api being called. (required)
   * @return Administrators
   * @throws ApiException if fails to make API call
   */
  public Administrators listAdministrators(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listAdministrators");
    }
    
    // create path and map variables
    String localVarPath = "/administrators".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<Administrators> localVarReturnType = new GenericType<Administrators>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify an Administrator
   * Modify an administrator by ID. Any unset elements will be left unchanged.
   * @param administratorID The ID number of the administrator to modify. (required)
   * @param administrator The settings of the administrator to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return Administrator
   * @throws ApiException if fails to make API call
   */
  public Administrator modifyAdministrator(Integer administratorID, Administrator administrator, String apiVersion) throws ApiException {
    Object localVarPostBody = administrator;
    
    // verify the required parameter 'administratorID' is set
    if (administratorID == null) {
      throw new ApiException(400, "Missing the required parameter 'administratorID' when calling modifyAdministrator");
    }
    
    // verify the required parameter 'administrator' is set
    if (administrator == null) {
      throw new ApiException(400, "Missing the required parameter 'administrator' when calling modifyAdministrator");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyAdministrator");
    }
    
    // create path and map variables
    String localVarPath = "/administrators/{administratorID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "administratorID" + "\\}", apiClient.escapeString(administratorID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<Administrator> localVarReturnType = new GenericType<Administrator>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search Administrators
   * Search for administrators using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return Administrators
   * @throws ApiException if fails to make API call
   */
  public Administrators searchAdministrators(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchAdministrators");
    }
    
    // create path and map variables
    String localVarPath = "/administrators/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<Administrators> localVarReturnType = new GenericType<Administrators>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
