package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.AgentVersionControlProfile;
import com.trendmicro.deepsecurity.model.AgentVersionControlProfiles;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class AgentVersionControlProfilesApi {
  private ApiClient apiClient;

  public AgentVersionControlProfilesApi() {
    this(Configuration.getDefaultApiClient());
  }

  public AgentVersionControlProfilesApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Describe an agent version control profile
   * Describe an Agent Version Control Profile by ID.
   * @param agentVersionControlProfileID The ID number of the agent version control profile to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return AgentVersionControlProfile
   * @throws ApiException if fails to make API call
   */
  public AgentVersionControlProfile describeAgentVersionControlProfile(Integer agentVersionControlProfileID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'agentVersionControlProfileID' is set
    if (agentVersionControlProfileID == null) {
      throw new ApiException(400, "Missing the required parameter 'agentVersionControlProfileID' when calling describeAgentVersionControlProfile");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeAgentVersionControlProfile");
    }
    
    // create path and map variables
    String localVarPath = "/agentversioncontrolprofiles/{agentVersionControlProfileID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "agentVersionControlProfileID" + "\\}", apiClient.escapeString(agentVersionControlProfileID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<AgentVersionControlProfile> localVarReturnType = new GenericType<AgentVersionControlProfile>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List agent version control profiles
   * Lists all agent version control profiles.
   * @param apiVersion The version of the api being called. (required)
   * @return AgentVersionControlProfiles
   * @throws ApiException if fails to make API call
   */
  public AgentVersionControlProfiles listAgentVersionControlProfiles(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listAgentVersionControlProfiles");
    }
    
    // create path and map variables
    String localVarPath = "/agentversioncontrolprofiles".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<AgentVersionControlProfiles> localVarReturnType = new GenericType<AgentVersionControlProfiles>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
