package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.CommonObjectMigrationTask;
import com.trendmicro.deepsecurity.model.CommonObjectMigrationTasks;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class CommonObjectMigrationTasksApi {
  private ApiClient apiClient;

  public CommonObjectMigrationTasksApi() {
    this(Configuration.getDefaultApiClient());
  }

  public CommonObjectMigrationTasksApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create a Common Object Migration Task
   * Create a task to migrate common objects.
   * @param commonObjectMigrationTask The task to migrate the common objects. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return CommonObjectMigrationTask
   * @throws ApiException if fails to make API call
   */
  public CommonObjectMigrationTask createCommonObjectMigrationTask(CommonObjectMigrationTask commonObjectMigrationTask, String apiVersion) throws ApiException {
    Object localVarPostBody = commonObjectMigrationTask;
    
    // verify the required parameter 'commonObjectMigrationTask' is set
    if (commonObjectMigrationTask == null) {
      throw new ApiException(400, "Missing the required parameter 'commonObjectMigrationTask' when calling createCommonObjectMigrationTask");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createCommonObjectMigrationTask");
    }
    
    // create path and map variables
    String localVarPath = "/commonobjectmigrationtasks".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<CommonObjectMigrationTask> localVarReturnType = new GenericType<CommonObjectMigrationTask>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Describe a Common Object Migration Task
   * Describe a common object migration task.
   * @param commonObjectMigrationTaskID The ID number of the common object migration task to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return CommonObjectMigrationTask
   * @throws ApiException if fails to make API call
   */
  public CommonObjectMigrationTask describeCommonObjectMigrationTask(Integer commonObjectMigrationTaskID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'commonObjectMigrationTaskID' is set
    if (commonObjectMigrationTaskID == null) {
      throw new ApiException(400, "Missing the required parameter 'commonObjectMigrationTaskID' when calling describeCommonObjectMigrationTask");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeCommonObjectMigrationTask");
    }
    
    // create path and map variables
    String localVarPath = "/commonobjectmigrationtasks/{commonObjectMigrationTaskID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "commonObjectMigrationTaskID" + "\\}", apiClient.escapeString(commonObjectMigrationTaskID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<CommonObjectMigrationTask> localVarReturnType = new GenericType<CommonObjectMigrationTask>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List Common Object Migration Tasks
   * List all common object migration tasks.
   * @param apiVersion The version of the api being called. (required)
   * @return CommonObjectMigrationTasks
   * @throws ApiException if fails to make API call
   */
  public CommonObjectMigrationTasks listCommonObjectMigrationTasks(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listCommonObjectMigrationTasks");
    }
    
    // create path and map variables
    String localVarPath = "/commonobjectmigrationtasks".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<CommonObjectMigrationTasks> localVarReturnType = new GenericType<CommonObjectMigrationTasks>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search Common Object Migration Tasks
   * Search for common obeject migration tasks using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return CommonObjectMigrationTasks
   * @throws ApiException if fails to make API call
   */
  public CommonObjectMigrationTasks searchCommonObjectMigrationTasks(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchCommonObjectMigrationTasks");
    }
    
    // create path and map variables
    String localVarPath = "/commonobjectmigrationtasks/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<CommonObjectMigrationTasks> localVarReturnType = new GenericType<CommonObjectMigrationTasks>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
