package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.CloudResourceTypeDetail;
import com.trendmicro.deepsecurity.model.CloudResourceTypeDetails;
import com.trendmicro.deepsecurity.model.ComputerGroup;
import com.trendmicro.deepsecurity.model.ComputerGroups;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class ComputerGroupsApi {
  private ApiClient apiClient;

  public ComputerGroupsApi() {
    this(Configuration.getDefaultApiClient());
  }

  public ComputerGroupsApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create a Computer Group
   * Create a new computer group.
   * @param computerGroup The settings of the new computer group. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return ComputerGroup
   * @throws ApiException if fails to make API call
   */
  public ComputerGroup createComputerGroup(ComputerGroup computerGroup, String apiVersion) throws ApiException {
    Object localVarPostBody = computerGroup;
    
    // verify the required parameter 'computerGroup' is set
    if (computerGroup == null) {
      throw new ApiException(400, "Missing the required parameter 'computerGroup' when calling createComputerGroup");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createComputerGroup");
    }
    
    // create path and map variables
    String localVarPath = "/computergroups".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ComputerGroup> localVarReturnType = new GenericType<ComputerGroup>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete a Computer Group
   * Delete a computer group by ID.
   * @param computerGroupID The ID number of the computer group to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteComputerGroup(Integer computerGroupID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'computerGroupID' is set
    if (computerGroupID == null) {
      throw new ApiException(400, "Missing the required parameter 'computerGroupID' when calling deleteComputerGroup");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteComputerGroup");
    }
    
    // create path and map variables
    String localVarPath = "/computergroups/{computerGroupID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "computerGroupID" + "\\}", apiClient.escapeString(computerGroupID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * The Name and Value of the CloudResourceType to describe.
   * 
   * @param cloudResourceType The ID number of the computer group to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return CloudResourceTypeDetail
   * @throws ApiException if fails to make API call
   */
  public CloudResourceTypeDetail describeCloudResourceType(String cloudResourceType, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'cloudResourceType' is set
    if (cloudResourceType == null) {
      throw new ApiException(400, "Missing the required parameter 'cloudResourceType' when calling describeCloudResourceType");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeCloudResourceType");
    }
    
    // create path and map variables
    String localVarPath = "/computergroups/cloudresourcetypes/{cloudResourceType}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "cloudResourceType" + "\\}", apiClient.escapeString(cloudResourceType.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<CloudResourceTypeDetail> localVarReturnType = new GenericType<CloudResourceTypeDetail>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Describe a Computer Group
   * Describe a computer group by ID.
   * @param computerGroupID The ID number of the computer group to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return ComputerGroup
   * @throws ApiException if fails to make API call
   */
  public ComputerGroup describeComputerGroup(Integer computerGroupID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'computerGroupID' is set
    if (computerGroupID == null) {
      throw new ApiException(400, "Missing the required parameter 'computerGroupID' when calling describeComputerGroup");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeComputerGroup");
    }
    
    // create path and map variables
    String localVarPath = "/computergroups/{computerGroupID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "computerGroupID" + "\\}", apiClient.escapeString(computerGroupID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ComputerGroup> localVarReturnType = new GenericType<ComputerGroup>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List CloudResourceType
   * 
   * @param apiVersion The version of the api being called. (required)
   * @return CloudResourceTypeDetails
   * @throws ApiException if fails to make API call
   */
  public CloudResourceTypeDetails listCloudResourceType(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listCloudResourceType");
    }
    
    // create path and map variables
    String localVarPath = "/computergroups/cloudresourcetypes".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<CloudResourceTypeDetails> localVarReturnType = new GenericType<CloudResourceTypeDetails>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List Computer Groups
   * Lists all computer groups.
   * @param apiVersion The version of the api being called. (required)
   * @return ComputerGroups
   * @throws ApiException if fails to make API call
   */
  public ComputerGroups listComputerGroups(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listComputerGroups");
    }
    
    // create path and map variables
    String localVarPath = "/computergroups".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ComputerGroups> localVarReturnType = new GenericType<ComputerGroups>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify a Computer Group
   * Modify a computer group by ID. Any unset elements will be left unchanged.
   * @param computerGroupID The ID number of the computer group to modify. (required)
   * @param computerGroup The settings of the computer group to modify. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return ComputerGroup
   * @throws ApiException if fails to make API call
   */
  public ComputerGroup modifyComputerGroup(Integer computerGroupID, ComputerGroup computerGroup, String apiVersion) throws ApiException {
    Object localVarPostBody = computerGroup;
    
    // verify the required parameter 'computerGroupID' is set
    if (computerGroupID == null) {
      throw new ApiException(400, "Missing the required parameter 'computerGroupID' when calling modifyComputerGroup");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyComputerGroup");
    }
    
    // create path and map variables
    String localVarPath = "/computergroups/{computerGroupID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "computerGroupID" + "\\}", apiClient.escapeString(computerGroupID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ComputerGroup> localVarReturnType = new GenericType<ComputerGroup>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search Computer Groups
   * Search for computer groups using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return ComputerGroups
   * @throws ApiException if fails to make API call
   */
  public ComputerGroups searchComputerGroups(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchComputerGroups");
    }
    
    // create path and map variables
    String localVarPath = "/computergroups/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ComputerGroups> localVarReturnType = new GenericType<ComputerGroups>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
