package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.BatchComputerMoveTask;
import com.trendmicro.deepsecurity.model.BatchComputerMoveTaskList;
import com.trendmicro.deepsecurity.model.ComputerMoveTask;
import com.trendmicro.deepsecurity.model.ComputerMoveTasks;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class ComputerMoveTasksApi {
  private ApiClient apiClient;

  public ComputerMoveTasksApi() {
    this(Configuration.getDefaultApiClient());
  }

  public ComputerMoveTasksApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create a Batch Computer Move Task
   * Create a new batch computer move task.
   * @param batchComputerMoveTask Tasks to move the computers. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return BatchComputerMoveTaskList
   * @throws ApiException if fails to make API call
   */
  public BatchComputerMoveTaskList createBatchComputerMoveTask(BatchComputerMoveTask batchComputerMoveTask, String apiVersion) throws ApiException {
    Object localVarPostBody = batchComputerMoveTask;
    
    // verify the required parameter 'batchComputerMoveTask' is set
    if (batchComputerMoveTask == null) {
      throw new ApiException(400, "Missing the required parameter 'batchComputerMoveTask' when calling createBatchComputerMoveTask");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createBatchComputerMoveTask");
    }
    
    // create path and map variables
    String localVarPath = "/batchcomputermovetasks".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<BatchComputerMoveTaskList> localVarReturnType = new GenericType<BatchComputerMoveTaskList>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Create a Computer Move Task
   * Create a new computer move task.
   * @param computerMoveTask The task to move the computers. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return ComputerMoveTask
   * @throws ApiException if fails to make API call
   */
  public ComputerMoveTask createComputerMoveTask(ComputerMoveTask computerMoveTask, String apiVersion) throws ApiException {
    Object localVarPostBody = computerMoveTask;
    
    // verify the required parameter 'computerMoveTask' is set
    if (computerMoveTask == null) {
      throw new ApiException(400, "Missing the required parameter 'computerMoveTask' when calling createComputerMoveTask");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createComputerMoveTask");
    }
    
    // create path and map variables
    String localVarPath = "/computermovetasks".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ComputerMoveTask> localVarReturnType = new GenericType<ComputerMoveTask>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Describe a Computer Move Task
   * Describe a computer move task.
   * @param computerMoveTaskID The ID number of the computer move task to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return ComputerMoveTask
   * @throws ApiException if fails to make API call
   */
  public ComputerMoveTask describeComputerMoveTask(Long computerMoveTaskID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'computerMoveTaskID' is set
    if (computerMoveTaskID == null) {
      throw new ApiException(400, "Missing the required parameter 'computerMoveTaskID' when calling describeComputerMoveTask");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeComputerMoveTask");
    }
    
    // create path and map variables
    String localVarPath = "/computermovetasks/{computerMoveTaskID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "computerMoveTaskID" + "\\}", apiClient.escapeString(computerMoveTaskID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ComputerMoveTask> localVarReturnType = new GenericType<ComputerMoveTask>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List Computer Move Tasks
   * List all computer move tasks.
   * @param apiVersion The version of the api being called. (required)
   * @return ComputerMoveTasks
   * @throws ApiException if fails to make API call
   */
  public ComputerMoveTasks listComputerMoveTasks(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listComputerMoveTasks");
    }
    
    // create path and map variables
    String localVarPath = "/computermovetasks".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ComputerMoveTasks> localVarReturnType = new GenericType<ComputerMoveTasks>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search Computer Move Tasks
   * Search for computer move task using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return ComputerMoveTasks
   * @throws ApiException if fails to make API call
   */
  public ComputerMoveTasks searchComputerMoveTasks(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchComputerMoveTasks");
    }
    
    // create path and map variables
    String localVarPath = "/computermovetasks/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ComputerMoveTasks> localVarReturnType = new GenericType<ComputerMoveTasks>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
