package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.EndpointBasecampAgentDeploymentScript;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class EndpointBasecampAgentDeploymentScriptsApi {
  private ApiClient apiClient;

  public EndpointBasecampAgentDeploymentScriptsApi() {
    this(Configuration.getDefaultApiClient());
  }

  public EndpointBasecampAgentDeploymentScriptsApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Generate Endpoint Basecamp Agent Deployment Scripts
   * Generate Endpoint Basecamp Agent deployment scripts by platform.
   * @param endpointBasecampAgentDeploymentScript The platform type for the Endpoint Basecamp Agent. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return EndpointBasecampAgentDeploymentScript
   * @throws ApiException if fails to make API call
   */
  public EndpointBasecampAgentDeploymentScript generateEndpointBasecampAgentDeploymentScript(EndpointBasecampAgentDeploymentScript endpointBasecampAgentDeploymentScript, String apiVersion) throws ApiException {
    Object localVarPostBody = endpointBasecampAgentDeploymentScript;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling generateEndpointBasecampAgentDeploymentScript");
    }
    
    // create path and map variables
    String localVarPath = "/endpointbasecampagentdeploymentscripts".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<EndpointBasecampAgentDeploymentScript> localVarReturnType = new GenericType<EndpointBasecampAgentDeploymentScript>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
