package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.FileList;
import com.trendmicro.deepsecurity.model.FileLists;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class FileListsApi {
  private ApiClient apiClient;

  public FileListsApi() {
    this(Configuration.getDefaultApiClient());
  }

  public FileListsApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create a File List
   * Create a new file list.
   * @param fileList The settings of the new file list. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return FileList
   * @throws ApiException if fails to make API call
   */
  public FileList createFileList(FileList fileList, String apiVersion) throws ApiException {
    Object localVarPostBody = fileList;
    
    // verify the required parameter 'fileList' is set
    if (fileList == null) {
      throw new ApiException(400, "Missing the required parameter 'fileList' when calling createFileList");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createFileList");
    }
    
    // create path and map variables
    String localVarPath = "/filelists".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<FileList> localVarReturnType = new GenericType<FileList>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete a File List
   * Delete a file list by ID.
   * @param fileListID The ID number of the file list to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteFileList(Integer fileListID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'fileListID' is set
    if (fileListID == null) {
      throw new ApiException(400, "Missing the required parameter 'fileListID' when calling deleteFileList");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteFileList");
    }
    
    // create path and map variables
    String localVarPath = "/filelists/{fileListID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "fileListID" + "\\}", apiClient.escapeString(fileListID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe a File List
   * Describe a file list by ID.
   * @param fileListID The ID number of the anti-malware configuration to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return FileList
   * @throws ApiException if fails to make API call
   */
  public FileList describeFileList(Integer fileListID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'fileListID' is set
    if (fileListID == null) {
      throw new ApiException(400, "Missing the required parameter 'fileListID' when calling describeFileList");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeFileList");
    }
    
    // create path and map variables
    String localVarPath = "/filelists/{fileListID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "fileListID" + "\\}", apiClient.escapeString(fileListID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<FileList> localVarReturnType = new GenericType<FileList>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List File Lists
   * Lists all file lists.
   * @param apiVersion The version of the api being called. (required)
   * @return FileLists
   * @throws ApiException if fails to make API call
   */
  public FileLists listFileLists(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listFileLists");
    }
    
    // create path and map variables
    String localVarPath = "/filelists".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<FileLists> localVarReturnType = new GenericType<FileLists>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify a File List
   * Modify a file list by ID. Any unset elements will be left unchanged.
   * @param fileListID The ID number of the file list to modify. (required)
   * @param fileList The settings of the file list to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return FileList
   * @throws ApiException if fails to make API call
   */
  public FileList modifyFileList(Integer fileListID, FileList fileList, String apiVersion) throws ApiException {
    Object localVarPostBody = fileList;
    
    // verify the required parameter 'fileListID' is set
    if (fileListID == null) {
      throw new ApiException(400, "Missing the required parameter 'fileListID' when calling modifyFileList");
    }
    
    // verify the required parameter 'fileList' is set
    if (fileList == null) {
      throw new ApiException(400, "Missing the required parameter 'fileList' when calling modifyFileList");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyFileList");
    }
    
    // create path and map variables
    String localVarPath = "/filelists/{fileListID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "fileListID" + "\\}", apiClient.escapeString(fileListID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<FileList> localVarReturnType = new GenericType<FileList>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search File Lists
   * Search for file lists using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return FileLists
   * @throws ApiException if fails to make API call
   */
  public FileLists searchFileLists(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchFileLists");
    }
    
    // create path and map variables
    String localVarPath = "/filelists/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<FileLists> localVarReturnType = new GenericType<FileLists>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
