package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.FirewallRule;
import com.trendmicro.deepsecurity.model.FirewallRules;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class FirewallRulesApi {
  private ApiClient apiClient;

  public FirewallRulesApi() {
    this(Configuration.getDefaultApiClient());
  }

  public FirewallRulesApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create a Firewall Rule
   * Create a new firewall rule.
   * @param firewallRule The settings of the new firewall rule. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return FirewallRule
   * @throws ApiException if fails to make API call
   */
  public FirewallRule createFirewallRule(FirewallRule firewallRule, String apiVersion) throws ApiException {
    Object localVarPostBody = firewallRule;
    
    // verify the required parameter 'firewallRule' is set
    if (firewallRule == null) {
      throw new ApiException(400, "Missing the required parameter 'firewallRule' when calling createFirewallRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createFirewallRule");
    }
    
    // create path and map variables
    String localVarPath = "/firewallrules".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<FirewallRule> localVarReturnType = new GenericType<FirewallRule>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete a Firewall Rule
   * Delete a firewall rule by ID.
   * @param firewallRuleID The ID number of the firewall rule to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteFirewallRule(Integer firewallRuleID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'firewallRuleID' is set
    if (firewallRuleID == null) {
      throw new ApiException(400, "Missing the required parameter 'firewallRuleID' when calling deleteFirewallRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteFirewallRule");
    }
    
    // create path and map variables
    String localVarPath = "/firewallrules/{firewallRuleID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "firewallRuleID" + "\\}", apiClient.escapeString(firewallRuleID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe a Firewall Rule
   * Describe a firewall rule by ID.
   * @param firewallRuleID The ID number of the firewall rule to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return FirewallRule
   * @throws ApiException if fails to make API call
   */
  public FirewallRule describeFirewallRule(Integer firewallRuleID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'firewallRuleID' is set
    if (firewallRuleID == null) {
      throw new ApiException(400, "Missing the required parameter 'firewallRuleID' when calling describeFirewallRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeFirewallRule");
    }
    
    // create path and map variables
    String localVarPath = "/firewallrules/{firewallRuleID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "firewallRuleID" + "\\}", apiClient.escapeString(firewallRuleID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<FirewallRule> localVarReturnType = new GenericType<FirewallRule>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List Firewall Rules
   * Lists all firewall rules.
   * @param apiVersion The version of the api being called. (required)
   * @return FirewallRules
   * @throws ApiException if fails to make API call
   */
  public FirewallRules listFirewallRules(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listFirewallRules");
    }
    
    // create path and map variables
    String localVarPath = "/firewallrules".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<FirewallRules> localVarReturnType = new GenericType<FirewallRules>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify a Firewall Rule
   * Modify a firewall rule by ID. Any unset elements will be left unchanged.
   * @param firewallRuleID The ID number of the firewall rule to modify. (required)
   * @param firewallRules The settings of the firewall rule to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return FirewallRule
   * @throws ApiException if fails to make API call
   */
  public FirewallRule modifyFirewallRule(Integer firewallRuleID, FirewallRule firewallRules, String apiVersion) throws ApiException {
    Object localVarPostBody = firewallRules;
    
    // verify the required parameter 'firewallRuleID' is set
    if (firewallRuleID == null) {
      throw new ApiException(400, "Missing the required parameter 'firewallRuleID' when calling modifyFirewallRule");
    }
    
    // verify the required parameter 'firewallRules' is set
    if (firewallRules == null) {
      throw new ApiException(400, "Missing the required parameter 'firewallRules' when calling modifyFirewallRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyFirewallRule");
    }
    
    // create path and map variables
    String localVarPath = "/firewallrules/{firewallRuleID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "firewallRuleID" + "\\}", apiClient.escapeString(firewallRuleID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<FirewallRule> localVarReturnType = new GenericType<FirewallRule>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search Firewall Rules
   * Search for firewall rules using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return FirewallRules
   * @throws ApiException if fails to make API call
   */
  public FirewallRules searchFirewallRules(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchFirewallRules");
    }
    
    // create path and map variables
    String localVarPath = "/firewallrules/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<FirewallRules> localVarReturnType = new GenericType<FirewallRules>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
