package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.Action;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class GcpConnectorActionsApi {
  private ApiClient apiClient;

  public GcpConnectorActionsApi() {
    this(Configuration.getDefaultApiClient());
  }

  public GcpConnectorActionsApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create a connector action
   * Create a connector action by connector ID.
   * @param gcpConnectorID The ID number of the GCP Connector. (required)
   * @param gcpConnectorAction The property of the new GCP Connector action. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return Action
   * @throws ApiException if fails to make API call
   */
  public Action createGCPConnectorAction(Integer gcpConnectorID, Action gcpConnectorAction, String apiVersion) throws ApiException {
    Object localVarPostBody = gcpConnectorAction;
    
    // verify the required parameter 'gcpConnectorID' is set
    if (gcpConnectorID == null) {
      throw new ApiException(400, "Missing the required parameter 'gcpConnectorID' when calling createGCPConnectorAction");
    }
    
    // verify the required parameter 'gcpConnectorAction' is set
    if (gcpConnectorAction == null) {
      throw new ApiException(400, "Missing the required parameter 'gcpConnectorAction' when calling createGCPConnectorAction");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createGCPConnectorAction");
    }
    
    // create path and map variables
    String localVarPath = "/gcpconnectors/{gcpConnectorID}/actions".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "gcpConnectorID" + "\\}", apiClient.escapeString(gcpConnectorID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<Action> localVarReturnType = new GenericType<Action>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Describe a connector action
   * Describe a connector action by connector ID and action ID.
   * @param gcpConnectorID The ID number of the GCP Connector. (required)
   * @param actionID The ID number of the GCP Connector action. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return Action
   * @throws ApiException if fails to make API call
   */
  public Action describeGCPConnectorAction(Integer gcpConnectorID, Long actionID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'gcpConnectorID' is set
    if (gcpConnectorID == null) {
      throw new ApiException(400, "Missing the required parameter 'gcpConnectorID' when calling describeGCPConnectorAction");
    }
    
    // verify the required parameter 'actionID' is set
    if (actionID == null) {
      throw new ApiException(400, "Missing the required parameter 'actionID' when calling describeGCPConnectorAction");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeGCPConnectorAction");
    }
    
    // create path and map variables
    String localVarPath = "/gcpconnectors/{gcpConnectorID}/actions/{actionID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "gcpConnectorID" + "\\}", apiClient.escapeString(gcpConnectorID.toString()))
      .replaceAll("\\{" + "actionID" + "\\}", apiClient.escapeString(actionID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<Action> localVarReturnType = new GenericType<Action>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
