package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.GCPConnector;
import com.trendmicro.deepsecurity.model.GCPConnectors;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class GcpConnectorsApi {
  private ApiClient apiClient;

  public GcpConnectorsApi() {
    this(Configuration.getDefaultApiClient());
  }

  public GcpConnectorsApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create a GCP Connector
   * Create a new GCP Connector.
   * @param gcpConnector The settings of the new GCP connector. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return GCPConnector
   * @throws ApiException if fails to make API call
   */
  public GCPConnector createGCPConnector(GCPConnector gcpConnector, String apiVersion) throws ApiException {
    Object localVarPostBody = gcpConnector;
    
    // verify the required parameter 'gcpConnector' is set
    if (gcpConnector == null) {
      throw new ApiException(400, "Missing the required parameter 'gcpConnector' when calling createGCPConnector");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createGCPConnector");
    }
    
    // create path and map variables
    String localVarPath = "/gcpconnectors".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<GCPConnector> localVarReturnType = new GenericType<GCPConnector>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete a GCP Connector
   * Delete a GCP connector by ID.
   * @param gcpConnectorID ID number of the GCP Connector to be deleted. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteGCPConnector(Integer gcpConnectorID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'gcpConnectorID' is set
    if (gcpConnectorID == null) {
      throw new ApiException(400, "Missing the required parameter 'gcpConnectorID' when calling deleteGCPConnector");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteGCPConnector");
    }
    
    // create path and map variables
    String localVarPath = "/gcpconnectors/{gcpConnectorID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "gcpConnectorID" + "\\}", apiClient.escapeString(gcpConnectorID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe a GCP Connector
   * Describe a GCP connector by ID.
   * @param gcpConnectorID ID number of the GCP connector to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return GCPConnector
   * @throws ApiException if fails to make API call
   */
  public GCPConnector describeGCPConnector(Integer gcpConnectorID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'gcpConnectorID' is set
    if (gcpConnectorID == null) {
      throw new ApiException(400, "Missing the required parameter 'gcpConnectorID' when calling describeGCPConnector");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeGCPConnector");
    }
    
    // create path and map variables
    String localVarPath = "/gcpconnectors/{gcpConnectorID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "gcpConnectorID" + "\\}", apiClient.escapeString(gcpConnectorID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<GCPConnector> localVarReturnType = new GenericType<GCPConnector>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List GCP Connectors
   * List all GCP connectors.
   * @param apiVersion The version of the api being called. (required)
   * @return GCPConnectors
   * @throws ApiException if fails to make API call
   */
  public GCPConnectors listGCPConnectors(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listGCPConnectors");
    }
    
    // create path and map variables
    String localVarPath = "/gcpconnectors".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<GCPConnectors> localVarReturnType = new GenericType<GCPConnectors>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify a GCP Connector
   * Modify a GCP connector by ID.
   * @param gcpConnectorID ID number of the GCP Connector to modify. (required)
   * @param gcpConnector The settings of the GCP connector to modify. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return GCPConnector
   * @throws ApiException if fails to make API call
   */
  public GCPConnector modifyGCPConnector(Integer gcpConnectorID, GCPConnector gcpConnector, String apiVersion) throws ApiException {
    Object localVarPostBody = gcpConnector;
    
    // verify the required parameter 'gcpConnectorID' is set
    if (gcpConnectorID == null) {
      throw new ApiException(400, "Missing the required parameter 'gcpConnectorID' when calling modifyGCPConnector");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyGCPConnector");
    }
    
    // create path and map variables
    String localVarPath = "/gcpconnectors/{gcpConnectorID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "gcpConnectorID" + "\\}", apiClient.escapeString(gcpConnectorID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<GCPConnector> localVarReturnType = new GenericType<GCPConnector>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search GCP Connectors
   * Search for GCP connectors using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return GCPConnectors
   * @throws ApiException if fails to make API call
   */
  public GCPConnectors searchGCPConnectors(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchGCPConnectors");
    }
    
    // create path and map variables
    String localVarPath = "/gcpconnectors/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<GCPConnectors> localVarReturnType = new GenericType<GCPConnectors>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
