package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.IpList;
import com.trendmicro.deepsecurity.model.IpLists;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class IpListsApi {
  private ApiClient apiClient;

  public IpListsApi() {
    this(Configuration.getDefaultApiClient());
  }

  public IpListsApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create an IP List
   * Create a new IP list.
   * @param ipList The settings of the new IP list. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return IpList
   * @throws ApiException if fails to make API call
   */
  public IpList createIPList(IpList ipList, String apiVersion) throws ApiException {
    Object localVarPostBody = ipList;
    
    // verify the required parameter 'ipList' is set
    if (ipList == null) {
      throw new ApiException(400, "Missing the required parameter 'ipList' when calling createIPList");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createIPList");
    }
    
    // create path and map variables
    String localVarPath = "/iplists".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<IpList> localVarReturnType = new GenericType<IpList>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete an IP List
   * Delete an IP list by ID.
   * @param ipListID The ID number of the IP list to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteIPList(Integer ipListID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'ipListID' is set
    if (ipListID == null) {
      throw new ApiException(400, "Missing the required parameter 'ipListID' when calling deleteIPList");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteIPList");
    }
    
    // create path and map variables
    String localVarPath = "/iplists/{ipListID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "ipListID" + "\\}", apiClient.escapeString(ipListID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe an IP List
   * Describe an IP list by ID.
   * @param ipListID The ID number of the IP list to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return IpList
   * @throws ApiException if fails to make API call
   */
  public IpList describeIPList(Integer ipListID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'ipListID' is set
    if (ipListID == null) {
      throw new ApiException(400, "Missing the required parameter 'ipListID' when calling describeIPList");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeIPList");
    }
    
    // create path and map variables
    String localVarPath = "/iplists/{ipListID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "ipListID" + "\\}", apiClient.escapeString(ipListID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<IpList> localVarReturnType = new GenericType<IpList>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List IP Lists
   * Lists all IP lists.
   * @param apiVersion The version of the api being called. (required)
   * @return IpLists
   * @throws ApiException if fails to make API call
   */
  public IpLists listIPLists(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listIPLists");
    }
    
    // create path and map variables
    String localVarPath = "/iplists".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<IpLists> localVarReturnType = new GenericType<IpLists>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify an IP List
   * Modify an IP list by ID. Any unset elements will be left unchanged.
   * @param ipListID The ID number of the IP list to modify. (required)
   * @param ipList The settings of the IP list to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return IpList
   * @throws ApiException if fails to make API call
   */
  public IpList modifyIPList(Integer ipListID, IpList ipList, String apiVersion) throws ApiException {
    Object localVarPostBody = ipList;
    
    // verify the required parameter 'ipListID' is set
    if (ipListID == null) {
      throw new ApiException(400, "Missing the required parameter 'ipListID' when calling modifyIPList");
    }
    
    // verify the required parameter 'ipList' is set
    if (ipList == null) {
      throw new ApiException(400, "Missing the required parameter 'ipList' when calling modifyIPList");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyIPList");
    }
    
    // create path and map variables
    String localVarPath = "/iplists/{ipListID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "ipListID" + "\\}", apiClient.escapeString(ipListID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<IpList> localVarReturnType = new GenericType<IpList>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search IP Lists
   * Search for IP lists using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return IpLists
   * @throws ApiException if fails to make API call
   */
  public IpLists searchIPLists(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchIPLists");
    }
    
    // create path and map variables
    String localVarPath = "/iplists/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<IpLists> localVarReturnType = new GenericType<IpLists>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
