package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.LogInspectionRule;
import com.trendmicro.deepsecurity.model.LogInspectionRules;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class LogInspectionRulesApi {
  private ApiClient apiClient;

  public LogInspectionRulesApi() {
    this(Configuration.getDefaultApiClient());
  }

  public LogInspectionRulesApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create a Log Inspection Rule
   * Create a new log inspection rule.
   * @param logInspectionRule The settings of the new log inspection rule. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return LogInspectionRule
   * @throws ApiException if fails to make API call
   */
  public LogInspectionRule createLogInspectionRule(LogInspectionRule logInspectionRule, String apiVersion) throws ApiException {
    Object localVarPostBody = logInspectionRule;
    
    // verify the required parameter 'logInspectionRule' is set
    if (logInspectionRule == null) {
      throw new ApiException(400, "Missing the required parameter 'logInspectionRule' when calling createLogInspectionRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createLogInspectionRule");
    }
    
    // create path and map variables
    String localVarPath = "/loginspectionrules".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<LogInspectionRule> localVarReturnType = new GenericType<LogInspectionRule>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete a Log Inspection Rule
   * Delete a log inspection rule by ID.
   * @param logInspectionRuleID The ID number of the log inspection rule to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteLogInspectionRule(Integer logInspectionRuleID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'logInspectionRuleID' is set
    if (logInspectionRuleID == null) {
      throw new ApiException(400, "Missing the required parameter 'logInspectionRuleID' when calling deleteLogInspectionRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteLogInspectionRule");
    }
    
    // create path and map variables
    String localVarPath = "/loginspectionrules/{logInspectionRuleID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "logInspectionRuleID" + "\\}", apiClient.escapeString(logInspectionRuleID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe a Log Inspection Rule
   * Describe a log inspection rule by ID.
   * @param logInspectionRuleID The ID number of the log inspection rule to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return LogInspectionRule
   * @throws ApiException if fails to make API call
   */
  public LogInspectionRule describeLogInspectionRule(Integer logInspectionRuleID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'logInspectionRuleID' is set
    if (logInspectionRuleID == null) {
      throw new ApiException(400, "Missing the required parameter 'logInspectionRuleID' when calling describeLogInspectionRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeLogInspectionRule");
    }
    
    // create path and map variables
    String localVarPath = "/loginspectionrules/{logInspectionRuleID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "logInspectionRuleID" + "\\}", apiClient.escapeString(logInspectionRuleID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<LogInspectionRule> localVarReturnType = new GenericType<LogInspectionRule>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List Log Inspection Rules
   * Lists all log inspection rules.
   * @param apiVersion The version of the api being called. (required)
   * @return LogInspectionRules
   * @throws ApiException if fails to make API call
   */
  public LogInspectionRules listLogInspectionRules(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listLogInspectionRules");
    }
    
    // create path and map variables
    String localVarPath = "/loginspectionrules".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<LogInspectionRules> localVarReturnType = new GenericType<LogInspectionRules>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify a Log Inspection Rule
   * Modify a log inspection rule by ID. Any unset elements will be left unchanged.
   * @param logInspectionRuleID The ID number of the log inspection rule to modify. (required)
   * @param logInspectionRule The settings of the log inspection rule to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return LogInspectionRule
   * @throws ApiException if fails to make API call
   */
  public LogInspectionRule modifyLogInspectionRule(Integer logInspectionRuleID, LogInspectionRule logInspectionRule, String apiVersion) throws ApiException {
    Object localVarPostBody = logInspectionRule;
    
    // verify the required parameter 'logInspectionRuleID' is set
    if (logInspectionRuleID == null) {
      throw new ApiException(400, "Missing the required parameter 'logInspectionRuleID' when calling modifyLogInspectionRule");
    }
    
    // verify the required parameter 'logInspectionRule' is set
    if (logInspectionRule == null) {
      throw new ApiException(400, "Missing the required parameter 'logInspectionRule' when calling modifyLogInspectionRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyLogInspectionRule");
    }
    
    // create path and map variables
    String localVarPath = "/loginspectionrules/{logInspectionRuleID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "logInspectionRuleID" + "\\}", apiClient.escapeString(logInspectionRuleID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<LogInspectionRule> localVarReturnType = new GenericType<LogInspectionRule>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search Log Inspection Rules
   * Search for log inspection rules using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return LogInspectionRules
   * @throws ApiException if fails to make API call
   */
  public LogInspectionRules searchLogInspectionRules(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchLogInspectionRules");
    }
    
    // create path and map variables
    String localVarPath = "/loginspectionrules/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<LogInspectionRules> localVarReturnType = new GenericType<LogInspectionRules>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
