package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.MacList;
import com.trendmicro.deepsecurity.model.MacLists;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class MacListsApi {
  private ApiClient apiClient;

  public MacListsApi() {
    this(Configuration.getDefaultApiClient());
  }

  public MacListsApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create a MAC List
   * Create a new MAC list.
   * @param macList The settings of the new MAC list. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return MacList
   * @throws ApiException if fails to make API call
   */
  public MacList createMACList(MacList macList, String apiVersion) throws ApiException {
    Object localVarPostBody = macList;
    
    // verify the required parameter 'macList' is set
    if (macList == null) {
      throw new ApiException(400, "Missing the required parameter 'macList' when calling createMACList");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createMACList");
    }
    
    // create path and map variables
    String localVarPath = "/maclists".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<MacList> localVarReturnType = new GenericType<MacList>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete a MAC List
   * Delete a MAC list by ID.
   * @param macListID The ID number of the MAC list to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteMACList(Integer macListID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'macListID' is set
    if (macListID == null) {
      throw new ApiException(400, "Missing the required parameter 'macListID' when calling deleteMACList");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteMACList");
    }
    
    // create path and map variables
    String localVarPath = "/maclists/{macListID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "macListID" + "\\}", apiClient.escapeString(macListID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe a MAC List
   * Describe a MAC list by ID.
   * @param macListID The ID number of the MAC list to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return MacList
   * @throws ApiException if fails to make API call
   */
  public MacList describeMACList(Integer macListID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'macListID' is set
    if (macListID == null) {
      throw new ApiException(400, "Missing the required parameter 'macListID' when calling describeMACList");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeMACList");
    }
    
    // create path and map variables
    String localVarPath = "/maclists/{macListID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "macListID" + "\\}", apiClient.escapeString(macListID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<MacList> localVarReturnType = new GenericType<MacList>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List MAC Lists
   * Lists all MAC lists.
   * @param apiVersion The version of the api being called. (required)
   * @return MacLists
   * @throws ApiException if fails to make API call
   */
  public MacLists listMACLists(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listMACLists");
    }
    
    // create path and map variables
    String localVarPath = "/maclists".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<MacLists> localVarReturnType = new GenericType<MacLists>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify a MAC List
   * Modify a MAC list by ID. Any unset elements will be left unchanged.
   * @param macListID The ID number of the MAC list to modify. (required)
   * @param macList The settings of the MAC list to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return MacList
   * @throws ApiException if fails to make API call
   */
  public MacList modifyMACList(Integer macListID, MacList macList, String apiVersion) throws ApiException {
    Object localVarPostBody = macList;
    
    // verify the required parameter 'macListID' is set
    if (macListID == null) {
      throw new ApiException(400, "Missing the required parameter 'macListID' when calling modifyMACList");
    }
    
    // verify the required parameter 'macList' is set
    if (macList == null) {
      throw new ApiException(400, "Missing the required parameter 'macList' when calling modifyMACList");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyMACList");
    }
    
    // create path and map variables
    String localVarPath = "/maclists/{macListID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "macListID" + "\\}", apiClient.escapeString(macListID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<MacList> localVarReturnType = new GenericType<MacList>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search MAC Lists
   * Search for MAC lists using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return MacLists
   * @throws ApiException if fails to make API call
   */
  public MacLists searchMACLists(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchMACLists");
    }
    
    // create path and map variables
    String localVarPath = "/maclists/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<MacLists> localVarReturnType = new GenericType<MacLists>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
