package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.ScheduledTask;
import com.trendmicro.deepsecurity.model.ScheduledTasks;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class ScheduledTasksApi {
  private ApiClient apiClient;

  public ScheduledTasksApi() {
    this(Configuration.getDefaultApiClient());
  }

  public ScheduledTasksApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create a Scheduled Task
   * Create a new scheduled task.
   * @param scheduledTask The settings of the new scheduled task. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return ScheduledTask
   * @throws ApiException if fails to make API call
   */
  public ScheduledTask createScheduledTask(ScheduledTask scheduledTask, String apiVersion) throws ApiException {
    Object localVarPostBody = scheduledTask;
    
    // verify the required parameter 'scheduledTask' is set
    if (scheduledTask == null) {
      throw new ApiException(400, "Missing the required parameter 'scheduledTask' when calling createScheduledTask");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createScheduledTask");
    }
    
    // create path and map variables
    String localVarPath = "/scheduledtasks".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ScheduledTask> localVarReturnType = new GenericType<ScheduledTask>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete a Scheduled Task
   * Delete a scheduled task by ID.
   * @param scheduledTaskID The ID number of the scheduled task to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteScheduledTask(Integer scheduledTaskID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'scheduledTaskID' is set
    if (scheduledTaskID == null) {
      throw new ApiException(400, "Missing the required parameter 'scheduledTaskID' when calling deleteScheduledTask");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteScheduledTask");
    }
    
    // create path and map variables
    String localVarPath = "/scheduledtasks/{scheduledTaskID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "scheduledTaskID" + "\\}", apiClient.escapeString(scheduledTaskID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe a Scheduled Task
   * Describe a scheduled task by ID.
   * @param scheduledTaskID The ID number of the scheduled task to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return ScheduledTask
   * @throws ApiException if fails to make API call
   */
  public ScheduledTask describeScheduledTask(Integer scheduledTaskID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'scheduledTaskID' is set
    if (scheduledTaskID == null) {
      throw new ApiException(400, "Missing the required parameter 'scheduledTaskID' when calling describeScheduledTask");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeScheduledTask");
    }
    
    // create path and map variables
    String localVarPath = "/scheduledtasks/{scheduledTaskID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "scheduledTaskID" + "\\}", apiClient.escapeString(scheduledTaskID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ScheduledTask> localVarReturnType = new GenericType<ScheduledTask>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List Scheduled Tasks
   * Lists all scheduled tasks.
   * @param apiVersion The version of the api being called. (required)
   * @return ScheduledTasks
   * @throws ApiException if fails to make API call
   */
  public ScheduledTasks listScheduledTasks(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listScheduledTasks");
    }
    
    // create path and map variables
    String localVarPath = "/scheduledtasks".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ScheduledTasks> localVarReturnType = new GenericType<ScheduledTasks>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify a Scheduled Task
   * Modify a scheduled task by ID. Any unset elements will be left unchanged.
   * @param scheduledTaskID The ID number of the scheduled task to modify. (required)
   * @param scheduledTask The settings of the scheduled task to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return ScheduledTask
   * @throws ApiException if fails to make API call
   */
  public ScheduledTask modifyScheduledTask(Integer scheduledTaskID, ScheduledTask scheduledTask, String apiVersion) throws ApiException {
    Object localVarPostBody = scheduledTask;
    
    // verify the required parameter 'scheduledTaskID' is set
    if (scheduledTaskID == null) {
      throw new ApiException(400, "Missing the required parameter 'scheduledTaskID' when calling modifyScheduledTask");
    }
    
    // verify the required parameter 'scheduledTask' is set
    if (scheduledTask == null) {
      throw new ApiException(400, "Missing the required parameter 'scheduledTask' when calling modifyScheduledTask");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyScheduledTask");
    }
    
    // create path and map variables
    String localVarPath = "/scheduledtasks/{scheduledTaskID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "scheduledTaskID" + "\\}", apiClient.escapeString(scheduledTaskID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ScheduledTask> localVarReturnType = new GenericType<ScheduledTask>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search Scheduled Tasks
   * Search for scheduled tasks using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return ScheduledTasks
   * @throws ApiException if fails to make API call
   */
  public ScheduledTasks searchScheduledTasks(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchScheduledTasks");
    }
    
    // create path and map variables
    String localVarPath = "/scheduledtasks/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ScheduledTasks> localVarReturnType = new GenericType<ScheduledTasks>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
