package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.SearchFilter;
import com.trendmicro.deepsecurity.model.SmartFolder;
import com.trendmicro.deepsecurity.model.SmartFolders;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class SmartFoldersApi {
  private ApiClient apiClient;

  public SmartFoldersApi() {
    this(Configuration.getDefaultApiClient());
  }

  public SmartFoldersApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create a Smart Folder
   * Create a smart folder.
   * @param smartFolder The settings of the smart folder to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return SmartFolder
   * @throws ApiException if fails to make API call
   */
  public SmartFolder createSmartFolder(SmartFolder smartFolder, String apiVersion) throws ApiException {
    Object localVarPostBody = smartFolder;
    
    // verify the required parameter 'smartFolder' is set
    if (smartFolder == null) {
      throw new ApiException(400, "Missing the required parameter 'smartFolder' when calling createSmartFolder");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createSmartFolder");
    }
    
    // create path and map variables
    String localVarPath = "/smartfolders".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<SmartFolder> localVarReturnType = new GenericType<SmartFolder>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete a Smart Folder
   * Delete a smart folder by ID.
   * @param smartFolderID The ID number of the smart folder to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteSmartFolder(Long smartFolderID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'smartFolderID' is set
    if (smartFolderID == null) {
      throw new ApiException(400, "Missing the required parameter 'smartFolderID' when calling deleteSmartFolder");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteSmartFolder");
    }
    
    // create path and map variables
    String localVarPath = "/smartfolders/{smartFolderID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "smartFolderID" + "\\}", apiClient.escapeString(smartFolderID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe a Smart Folder
   * Describe a smart folder by ID.
   * @param smartFolderID The ID number of the smart folder to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return SmartFolder
   * @throws ApiException if fails to make API call
   */
  public SmartFolder describeSmartFolder(Long smartFolderID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'smartFolderID' is set
    if (smartFolderID == null) {
      throw new ApiException(400, "Missing the required parameter 'smartFolderID' when calling describeSmartFolder");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeSmartFolder");
    }
    
    // create path and map variables
    String localVarPath = "/smartfolders/{smartFolderID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "smartFolderID" + "\\}", apiClient.escapeString(smartFolderID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<SmartFolder> localVarReturnType = new GenericType<SmartFolder>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List Smart Folders
   * Lists all smart folders.
   * @param apiVersion The version of the api being called. (required)
   * @return SmartFolders
   * @throws ApiException if fails to make API call
   */
  public SmartFolders listSmartFolders(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listSmartFolders");
    }
    
    // create path and map variables
    String localVarPath = "/smartfolders".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<SmartFolders> localVarReturnType = new GenericType<SmartFolders>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify a Smart Folder
   * Modify a smart folder by ID. Any unset elements will be left unchanged.
   * @param smartFolderID The ID number of the smart folder to modify. (required)
   * @param smartFolder The settings of the smart folder to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return SmartFolder
   * @throws ApiException if fails to make API call
   */
  public SmartFolder modifySmartFolder(Long smartFolderID, SmartFolder smartFolder, String apiVersion) throws ApiException {
    Object localVarPostBody = smartFolder;
    
    // verify the required parameter 'smartFolderID' is set
    if (smartFolderID == null) {
      throw new ApiException(400, "Missing the required parameter 'smartFolderID' when calling modifySmartFolder");
    }
    
    // verify the required parameter 'smartFolder' is set
    if (smartFolder == null) {
      throw new ApiException(400, "Missing the required parameter 'smartFolder' when calling modifySmartFolder");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifySmartFolder");
    }
    
    // create path and map variables
    String localVarPath = "/smartfolders/{smartFolderID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "smartFolderID" + "\\}", apiClient.escapeString(smartFolderID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<SmartFolder> localVarReturnType = new GenericType<SmartFolder>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search Smart Folders
   * Search for smart folders using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return SmartFolders
   * @throws ApiException if fails to make API call
   */
  public SmartFolders searchSmartFolders(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchSmartFolders");
    }
    
    // create path and map variables
    String localVarPath = "/smartfolders/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<SmartFolders> localVarReturnType = new GenericType<SmartFolders>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
