package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.ApplicationControlTrustRule;
import com.trendmicro.deepsecurity.model.TrustRuleUpdateRequest;
import com.trendmicro.deepsecurity.model.TrustRules;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class TrustRulesApi {
  private ApiClient apiClient;

  public TrustRulesApi() {
    this(Configuration.getDefaultApiClient());
  }

  public TrustRulesApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create a Trust Rule
   * Create a new trust rule.
   * @param trustrule Settings of the new trust rule. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return ApplicationControlTrustRule
   * @throws ApiException if fails to make API call
   */
  public ApplicationControlTrustRule createTrustRule(ApplicationControlTrustRule trustrule, String apiVersion) throws ApiException {
    Object localVarPostBody = trustrule;
    
    // verify the required parameter 'trustrule' is set
    if (trustrule == null) {
      throw new ApiException(400, "Missing the required parameter 'trustrule' when calling createTrustRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createTrustRule");
    }
    
    // create path and map variables
    String localVarPath = "/applicationcontroltrustrules".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApplicationControlTrustRule> localVarReturnType = new GenericType<ApplicationControlTrustRule>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete a Trust Rule.
   * Delete a trust rule by ID.
   * @param acTrustRuleID The ID number of the trust rule to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteTrustRule(Long acTrustRuleID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'acTrustRuleID' is set
    if (acTrustRuleID == null) {
      throw new ApiException(400, "Missing the required parameter 'acTrustRuleID' when calling deleteTrustRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteTrustRule");
    }
    
    // create path and map variables
    String localVarPath = "/applicationcontroltrustrules/{acTrustRuleID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "acTrustRuleID" + "\\}", apiClient.escapeString(acTrustRuleID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe a Trust Rule
   * Describe a trust rule by ID.
   * @param acTrustRuleID The ID number of the trust rule to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return ApplicationControlTrustRule
   * @throws ApiException if fails to make API call
   */
  public ApplicationControlTrustRule describeTrustRule(Long acTrustRuleID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'acTrustRuleID' is set
    if (acTrustRuleID == null) {
      throw new ApiException(400, "Missing the required parameter 'acTrustRuleID' when calling describeTrustRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeTrustRule");
    }
    
    // create path and map variables
    String localVarPath = "/applicationcontroltrustrules/{acTrustRuleID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "acTrustRuleID" + "\\}", apiClient.escapeString(acTrustRuleID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApplicationControlTrustRule> localVarReturnType = new GenericType<ApplicationControlTrustRule>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List all Trust Rules
   * List all trust rules.
   * @param apiVersion The version of the api being called. (required)
   * @return TrustRules
   * @throws ApiException if fails to make API call
   */
  public TrustRules listTrustRules(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listTrustRules");
    }
    
    // create path and map variables
    String localVarPath = "/applicationcontroltrustrules".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<TrustRules> localVarReturnType = new GenericType<TrustRules>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify a Trust Rule
   * Modify a trust rule by ID.
   * @param acTrustRuleID The ID of the trust rule to modify. (required)
   * @param requestTrustRulesetUpdate The attributes of the trust rule to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return ApplicationControlTrustRule
   * @throws ApiException if fails to make API call
   */
  public ApplicationControlTrustRule modifyTrustRule(Long acTrustRuleID, TrustRuleUpdateRequest requestTrustRulesetUpdate, String apiVersion) throws ApiException {
    Object localVarPostBody = requestTrustRulesetUpdate;
    
    // verify the required parameter 'acTrustRuleID' is set
    if (acTrustRuleID == null) {
      throw new ApiException(400, "Missing the required parameter 'acTrustRuleID' when calling modifyTrustRule");
    }
    
    // verify the required parameter 'requestTrustRulesetUpdate' is set
    if (requestTrustRulesetUpdate == null) {
      throw new ApiException(400, "Missing the required parameter 'requestTrustRulesetUpdate' when calling modifyTrustRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyTrustRule");
    }
    
    // create path and map variables
    String localVarPath = "/applicationcontroltrustrules/{acTrustRuleID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "acTrustRuleID" + "\\}", apiClient.escapeString(acTrustRuleID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApplicationControlTrustRule> localVarReturnType = new GenericType<ApplicationControlTrustRule>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
