package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.VCenterConnectorAction;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class VCenterConnectorActionsApi {
  private ApiClient apiClient;

  public VCenterConnectorActionsApi() {
    this(Configuration.getDefaultApiClient());
  }

  public VCenterConnectorActionsApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create a connector action
   * Create a connector action by connector ID.
   * @param virtualID ID number of the vCenter connector. (required)
   * @param vCenterConnectorAction Property of the new vCenter connector action. (required)
   * @param apiVersion Version of the API being called. (required)
   * @return VCenterConnectorAction
   * @throws ApiException if fails to make API call
   */
  public VCenterConnectorAction createVCenterConnectorAction(Integer virtualID, VCenterConnectorAction vCenterConnectorAction, String apiVersion) throws ApiException {
    Object localVarPostBody = vCenterConnectorAction;
    
    // verify the required parameter 'virtualID' is set
    if (virtualID == null) {
      throw new ApiException(400, "Missing the required parameter 'virtualID' when calling createVCenterConnectorAction");
    }
    
    // verify the required parameter 'vCenterConnectorAction' is set
    if (vCenterConnectorAction == null) {
      throw new ApiException(400, "Missing the required parameter 'vCenterConnectorAction' when calling createVCenterConnectorAction");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createVCenterConnectorAction");
    }
    
    // create path and map variables
    String localVarPath = "/vcenterconnectors/{virtualID}/actions".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "virtualID" + "\\}", apiClient.escapeString(virtualID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<VCenterConnectorAction> localVarReturnType = new GenericType<VCenterConnectorAction>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Describe a connector action
   * Describe a connector action by connector ID and action ID.
   * @param virtualID ID number of the vCenter connector. (required)
   * @param actionID ID number of the vCenter connector action. (required)
   * @param apiVersion Version of the API being called. (required)
   * @return VCenterConnectorAction
   * @throws ApiException if fails to make API call
   */
  public VCenterConnectorAction describeVCenterConnectorAction(Integer virtualID, Long actionID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'virtualID' is set
    if (virtualID == null) {
      throw new ApiException(400, "Missing the required parameter 'virtualID' when calling describeVCenterConnectorAction");
    }
    
    // verify the required parameter 'actionID' is set
    if (actionID == null) {
      throw new ApiException(400, "Missing the required parameter 'actionID' when calling describeVCenterConnectorAction");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeVCenterConnectorAction");
    }
    
    // create path and map variables
    String localVarPath = "/vcenterconnectors/{virtualID}/actions/{actionID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "virtualID" + "\\}", apiClient.escapeString(virtualID.toString()))
      .replaceAll("\\{" + "actionID" + "\\}", apiClient.escapeString(actionID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<VCenterConnectorAction> localVarReturnType = new GenericType<VCenterConnectorAction>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
