package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.VCenterConnector;
import com.trendmicro.deepsecurity.model.VCenterConnectors;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class VCenterConnectorsApi {
  private ApiClient apiClient;

  public VCenterConnectorsApi() {
    this(Configuration.getDefaultApiClient());
  }

  public VCenterConnectorsApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create a vCenter connector
   * Create a new vCenter connector.
   * @param vcenterConnector Settings for the new vCenter connector. (required)
   * @param apiVersion Version of the API being called. (required)
   * @return VCenterConnector
   * @throws ApiException if fails to make API call
   */
  public VCenterConnector createVCenterConnector(VCenterConnector vcenterConnector, String apiVersion) throws ApiException {
    Object localVarPostBody = vcenterConnector;
    
    // verify the required parameter 'vcenterConnector' is set
    if (vcenterConnector == null) {
      throw new ApiException(400, "Missing the required parameter 'vcenterConnector' when calling createVCenterConnector");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createVCenterConnector");
    }
    
    // create path and map variables
    String localVarPath = "/vcenterconnectors".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<VCenterConnector> localVarReturnType = new GenericType<VCenterConnector>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete a vCenter connector
   * Delete a vCenter connector by ID.
   * @param virtualID ID number of the vCenter connector whose NSX Manager will be removed. (required)
   * @param apiVersion Version of the API being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteVCenterConnector(Integer virtualID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'virtualID' is set
    if (virtualID == null) {
      throw new ApiException(400, "Missing the required parameter 'virtualID' when calling deleteVCenterConnector");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteVCenterConnector");
    }
    
    // create path and map variables
    String localVarPath = "/vcenterconnectors/{virtualID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "virtualID" + "\\}", apiClient.escapeString(virtualID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe a vCenter Connector
   * Describe a vCenter connector by ID.
   * @param virtualID ID number of the vCenter connector to describe. (required)
   * @param apiVersion Version of the API being called. (required)
   * @return VCenterConnector
   * @throws ApiException if fails to make API call
   */
  public VCenterConnector describeVCenterConnector(Integer virtualID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'virtualID' is set
    if (virtualID == null) {
      throw new ApiException(400, "Missing the required parameter 'virtualID' when calling describeVCenterConnector");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeVCenterConnector");
    }
    
    // create path and map variables
    String localVarPath = "/vcenterconnectors/{virtualID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "virtualID" + "\\}", apiClient.escapeString(virtualID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<VCenterConnector> localVarReturnType = new GenericType<VCenterConnector>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List vCenter connectors
   * List all vCenter connectors.
   * @param apiVersion Version of the API being called. (required)
   * @return VCenterConnectors
   * @throws ApiException if fails to make API call
   */
  public VCenterConnectors listVCenterConnectors(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listVCenterConnectors");
    }
    
    // create path and map variables
    String localVarPath = "/vcenterconnectors".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<VCenterConnectors> localVarReturnType = new GenericType<VCenterConnectors>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify a vCenter Connector
   * Modify a vCenter connector by ID.
   * @param virtualID ID number of the vCenter Connector to modify. (required)
   * @param vcenterConnector The settings of the vCenter connector to modify. (optional)
   * @param apiVersion Version of the API being called. (required)
   * @return VCenterConnector
   * @throws ApiException if fails to make API call
   */
  public VCenterConnector modifyVCenterConnector(Integer virtualID, VCenterConnector vcenterConnector, String apiVersion) throws ApiException {
    Object localVarPostBody = vcenterConnector;
    
    // verify the required parameter 'virtualID' is set
    if (virtualID == null) {
      throw new ApiException(400, "Missing the required parameter 'virtualID' when calling modifyVCenterConnector");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyVCenterConnector");
    }
    
    // create path and map variables
    String localVarPath = "/vcenterconnectors/{virtualID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "virtualID" + "\\}", apiClient.escapeString(virtualID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<VCenterConnector> localVarReturnType = new GenericType<VCenterConnector>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Remove NSX Manager
   * Remove the NSX Manager associated with the vCenter connector by ID.
   * @param virtualID ID number of the vCenter Connector to be deleted. (required)
   * @param apiVersion Version of the API being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void removeNSXManager(Integer virtualID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'virtualID' is set
    if (virtualID == null) {
      throw new ApiException(400, "Missing the required parameter 'virtualID' when calling removeNSXManager");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling removeNSXManager");
    }
    
    // create path and map variables
    String localVarPath = "/vcenterconnectors/{virtualID}/nsxmanagers".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "virtualID" + "\\}", apiClient.escapeString(virtualID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
}
