/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * A region in AWS that instances and workspaces can be synchronized to.
 */
@ApiModel(description = "A region in AWS that instances and workspaces can be synchronized to.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class AWSRegion {
  @JsonProperty("region")
  private String region = null;

  @JsonProperty("computersSynced")
  private Integer computersSynced = null;

  @JsonProperty("workspacesSynced")
  private Integer workspacesSynced = null;

  public AWSRegion region(String region) {
    this.region = region;
    return this;
  }

   /**
   * The Amazon region name.
   * @return region
  **/
  @ApiModelProperty(value = "The Amazon region name.")
  public String getRegion() {
    return region;
  }

  public void setRegion(String region) {
    this.region = region;
  }

  public AWSRegion computersSynced(Integer computersSynced) {
    this.computersSynced = computersSynced;
    return this;
  }

   /**
   * The number of instances in the region during the last sync.
   * @return computersSynced
  **/
  @ApiModelProperty(value = "The number of instances in the region during the last sync.")
  public Integer getComputersSynced() {
    return computersSynced;
  }

  public void setComputersSynced(Integer computersSynced) {
    this.computersSynced = computersSynced;
  }

  public AWSRegion workspacesSynced(Integer workspacesSynced) {
    this.workspacesSynced = workspacesSynced;
    return this;
  }

   /**
   * The number of workspaces in the region during the last sync.
   * @return workspacesSynced
  **/
  @ApiModelProperty(value = "The number of workspaces in the region during the last sync.")
  public Integer getWorkspacesSynced() {
    return workspacesSynced;
  }

  public void setWorkspacesSynced(Integer workspacesSynced) {
    this.workspacesSynced = workspacesSynced;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    AWSRegion awSRegion = (AWSRegion) o;
    return Objects.equals(this.region, awSRegion.region) &&
        Objects.equals(this.computersSynced, awSRegion.computersSynced) &&
        Objects.equals(this.workspacesSynced, awSRegion.workspacesSynced);
  }

  @Override
  public int hashCode() {
    return Objects.hash(region, computersSynced, workspacesSynced);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class AWSRegion {\n");
    
    sb.append("    region: ").append(toIndentedString(region)).append("\n");
    sb.append("    computersSynced: ").append(toIndentedString(computersSynced)).append("\n");
    sb.append("    workspacesSynced: ").append(toIndentedString(workspacesSynced)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

