/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Administrator details. An Administrator object represents a Deep Security user.
 */
@ApiModel(description = "Administrator details. An Administrator object represents a Deep Security user.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class Administrator {
  @JsonProperty("username")
  private String username = null;

  @JsonProperty("password")
  private String password = null;

  @JsonProperty("fullName")
  private String fullName = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("roleID")
  private Integer roleID = null;

  /**
   * Locale of the Administrator.
   */
  public enum LocaleEnum {
    EN_US("en-US"),
    
    JA_JP("ja-JP");

    private String value;

    LocaleEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static LocaleEnum fromValue(String text) {
      for (LocaleEnum b : LocaleEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("locale")
  private LocaleEnum locale = null;

  @JsonProperty("timeZone")
  private String timeZone = null;

  /**
   * Time format preference of the Administrator. Can be either the 12-hour format or the 24-hour format. Searchable as Choice.
   */
  public enum TimeFormatEnum {
    _12("12"),
    
    _24("24");

    private String value;

    TimeFormatEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TimeFormatEnum fromValue(String text) {
      for (TimeFormatEnum b : TimeFormatEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("timeFormat")
  private TimeFormatEnum timeFormat = null;

  @JsonProperty("passwordNeverExpires")
  private Boolean passwordNeverExpires = null;

  @JsonProperty("active")
  private Boolean active = null;

  /**
   * Specifies the type of multi-factor authentication used to authenticate the Administrator. Defaults to &#x60;none&#x60;. Searchable as Choice.
   */
  public enum MfaTypeEnum {
    NONE("none"),
    
    LOCAL_TOTP("local-totp");

    private String value;

    MfaTypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static MfaTypeEnum fromValue(String text) {
      for (MfaTypeEnum b : MfaTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("mfaType")
  private MfaTypeEnum mfaType = null;

  @JsonProperty("phoneNumber")
  private String phoneNumber = null;

  @JsonProperty("mobileNumber")
  private String mobileNumber = null;

  @JsonProperty("pagerNumber")
  private String pagerNumber = null;

  @JsonProperty("emailAddress")
  private String emailAddress = null;

  @JsonProperty("primaryContact")
  private Boolean primaryContact = null;

  @JsonProperty("receiveNotifications")
  private Boolean receiveNotifications = null;

  @JsonProperty("reportPDFPasswordEnabled")
  private Boolean reportPDFPasswordEnabled = null;

  @JsonProperty("reportPDFPassword")
  private String reportPDFPassword = null;

  @JsonProperty("created")
  private Long created = null;

  @JsonProperty("lastPasswordChange")
  private Long lastPasswordChange = null;

  @JsonProperty("lastSignIn")
  private Long lastSignIn = null;

  @JsonProperty("unlockTime")
  private Long unlockTime = null;

  @JsonProperty("unsuccessfulSignInAttempts")
  private Integer unsuccessfulSignInAttempts = null;

  @JsonProperty("directoryName")
  private String directoryName = null;

  @JsonProperty("directoryInfo")
  private String directoryInfo = null;

  @JsonProperty("external")
  private Boolean external = null;

  @JsonProperty("externalUserID")
  private String externalUserID = null;

  /**
   * Administrator account type. Can either be &#x60;normal&#x60; or &#x60;temporary&#x60;. Defaults to &#x60;normal&#x60;. Searchable as Choice.
   */
  public enum TypeEnum {
    NORMAL("normal"),
    
    TEMPORARY("temporary");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TypeEnum fromValue(String text) {
      for (TypeEnum b : TypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("type")
  private TypeEnum type = null;

  @JsonProperty("readOnly")
  private Boolean readOnly = null;

  @JsonProperty("ID")
  private Integer ID = null;

  @JsonProperty("UTCOffset")
  private String utCOffset = null;

  public Administrator username(String username) {
    this.username = username;
    return this;
  }

   /**
   * Username of the Administrator. Searchable as String.
   * @return username
  **/
  @ApiModelProperty(value = "Username of the Administrator. Searchable as String.")
  public String getUsername() {
    return username;
  }

  public void setUsername(String username) {
    this.username = username;
  }

  public Administrator password(String password) {
    this.password = password;
    return this;
  }

   /**
   * Password of the Administrator.
   * @return password
  **/
  @ApiModelProperty(value = "Password of the Administrator.")
  public String getPassword() {
    return password;
  }

  public void setPassword(String password) {
    this.password = password;
  }

  public Administrator fullName(String fullName) {
    this.fullName = fullName;
    return this;
  }

   /**
   * Full name of the Administrator. Searchable as String.
   * @return fullName
  **/
  @ApiModelProperty(value = "Full name of the Administrator. Searchable as String.")
  public String getFullName() {
    return fullName;
  }

  public void setFullName(String fullName) {
    this.fullName = fullName;
  }

  public Administrator description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the Administrator. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the Administrator. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public Administrator roleID(Integer roleID) {
    this.roleID = roleID;
    return this;
  }

   /**
   * ID of the role assigned to the Administrator. Searchable as Numeric.
   * @return roleID
  **/
  @ApiModelProperty(value = "ID of the role assigned to the Administrator. Searchable as Numeric.")
  public Integer getRoleID() {
    return roleID;
  }

  public void setRoleID(Integer roleID) {
    this.roleID = roleID;
  }

  public Administrator locale(LocaleEnum locale) {
    this.locale = locale;
    return this;
  }

   /**
   * Locale of the Administrator.
   * @return locale
  **/
  @ApiModelProperty(value = "Locale of the Administrator.")
  public LocaleEnum getLocale() {
    return locale;
  }

  public void setLocale(LocaleEnum locale) {
    this.locale = locale;
  }

  public Administrator timeZone(String timeZone) {
    this.timeZone = timeZone;
    return this;
  }

   /**
   * Time zone of the Administrator. Searchable as String.
   * @return timeZone
  **/
  @ApiModelProperty(value = "Time zone of the Administrator. Searchable as String.")
  public String getTimeZone() {
    return timeZone;
  }

  public void setTimeZone(String timeZone) {
    this.timeZone = timeZone;
  }

  public Administrator timeFormat(TimeFormatEnum timeFormat) {
    this.timeFormat = timeFormat;
    return this;
  }

   /**
   * Time format preference of the Administrator. Can be either the 12-hour format or the 24-hour format. Searchable as Choice.
   * @return timeFormat
  **/
  @ApiModelProperty(value = "Time format preference of the Administrator. Can be either the 12-hour format or the 24-hour format. Searchable as Choice.")
  public TimeFormatEnum getTimeFormat() {
    return timeFormat;
  }

  public void setTimeFormat(TimeFormatEnum timeFormat) {
    this.timeFormat = timeFormat;
  }

  public Administrator passwordNeverExpires(Boolean passwordNeverExpires) {
    this.passwordNeverExpires = passwordNeverExpires;
    return this;
  }

   /**
   * Enabled if the Administrator&#39;s password never expires. Defaults to &#x60;false&#x60;. Searchable as Boolean.
   * @return passwordNeverExpires
  **/
  @ApiModelProperty(value = "Enabled if the Administrator's password never expires. Defaults to `false`. Searchable as Boolean.")
  public Boolean isPasswordNeverExpires() {
    return passwordNeverExpires;
  }

  public void setPasswordNeverExpires(Boolean passwordNeverExpires) {
    this.passwordNeverExpires = passwordNeverExpires;
  }

  public Administrator active(Boolean active) {
    this.active = active;
    return this;
  }

   /**
   * If set to &#x60;true&#x60;, the Administrator can authenticate. If set to &#x60;false&#x60;, the Administrator is locked out. Searchable as Boolean.
   * @return active
  **/
  @ApiModelProperty(value = "If set to `true`, the Administrator can authenticate. If set to `false`, the Administrator is locked out. Searchable as Boolean.")
  public Boolean isActive() {
    return active;
  }

  public void setActive(Boolean active) {
    this.active = active;
  }

  public Administrator mfaType(MfaTypeEnum mfaType) {
    this.mfaType = mfaType;
    return this;
  }

   /**
   * Specifies the type of multi-factor authentication used to authenticate the Administrator. Defaults to &#x60;none&#x60;. Searchable as Choice.
   * @return mfaType
  **/
  @ApiModelProperty(value = "Specifies the type of multi-factor authentication used to authenticate the Administrator. Defaults to `none`. Searchable as Choice.")
  public MfaTypeEnum getMfaType() {
    return mfaType;
  }

  public void setMfaType(MfaTypeEnum mfaType) {
    this.mfaType = mfaType;
  }

  public Administrator phoneNumber(String phoneNumber) {
    this.phoneNumber = phoneNumber;
    return this;
  }

   /**
   * Phone number of the Administrator. Searchable as String.
   * @return phoneNumber
  **/
  @ApiModelProperty(value = "Phone number of the Administrator. Searchable as String.")
  public String getPhoneNumber() {
    return phoneNumber;
  }

  public void setPhoneNumber(String phoneNumber) {
    this.phoneNumber = phoneNumber;
  }

  public Administrator mobileNumber(String mobileNumber) {
    this.mobileNumber = mobileNumber;
    return this;
  }

   /**
   * Mobile number of the Administrator. Searchable as String.
   * @return mobileNumber
  **/
  @ApiModelProperty(value = "Mobile number of the Administrator. Searchable as String.")
  public String getMobileNumber() {
    return mobileNumber;
  }

  public void setMobileNumber(String mobileNumber) {
    this.mobileNumber = mobileNumber;
  }

  public Administrator pagerNumber(String pagerNumber) {
    this.pagerNumber = pagerNumber;
    return this;
  }

   /**
   * Pager number of the Administrator. Searchable as String.
   * @return pagerNumber
  **/
  @ApiModelProperty(value = "Pager number of the Administrator. Searchable as String.")
  public String getPagerNumber() {
    return pagerNumber;
  }

  public void setPagerNumber(String pagerNumber) {
    this.pagerNumber = pagerNumber;
  }

  public Administrator emailAddress(String emailAddress) {
    this.emailAddress = emailAddress;
    return this;
  }

   /**
   * Email address of the Administrator. Searchable as String.
   * @return emailAddress
  **/
  @ApiModelProperty(value = "Email address of the Administrator. Searchable as String.")
  public String getEmailAddress() {
    return emailAddress;
  }

  public void setEmailAddress(String emailAddress) {
    this.emailAddress = emailAddress;
  }

  public Administrator primaryContact(Boolean primaryContact) {
    this.primaryContact = primaryContact;
    return this;
  }

   /**
   * If set to &#x60;true&#x60;, the administrator is a primary contact. Primary contacts receive Deep Security as a Service account-related emails for that tenant. A valid &#x60;emailAddress&#x60; is required. Searchable as Boolean.
   * @return primaryContact
  **/
  @ApiModelProperty(value = "If set to `true`, the administrator is a primary contact. Primary contacts receive Deep Security as a Service account-related emails for that tenant. A valid `emailAddress` is required. Searchable as Boolean.")
  public Boolean isPrimaryContact() {
    return primaryContact;
  }

  public void setPrimaryContact(Boolean primaryContact) {
    this.primaryContact = primaryContact;
  }

  public Administrator receiveNotifications(Boolean receiveNotifications) {
    this.receiveNotifications = receiveNotifications;
    return this;
  }

   /**
   * If set to &#x60;true&#x60;, alert emails will be sent to the Administrator. A valid &#x60;emailAddress&#x60; is required. Searchable as Boolean.
   * @return receiveNotifications
  **/
  @ApiModelProperty(value = "If set to `true`, alert emails will be sent to the Administrator. A valid `emailAddress` is required. Searchable as Boolean.")
  public Boolean isReceiveNotifications() {
    return receiveNotifications;
  }

  public void setReceiveNotifications(Boolean receiveNotifications) {
    this.receiveNotifications = receiveNotifications;
  }

  public Administrator reportPDFPasswordEnabled(Boolean reportPDFPasswordEnabled) {
    this.reportPDFPasswordEnabled = reportPDFPasswordEnabled;
    return this;
  }

   /**
   * Controls whether the reports that the Administrator generates are password-protected. Set to &#x60;true&#x60; to password-protect, and &#x60;false&#x60; otherwise. Defaults to &#x60;false&#x60;. Searchable as Boolean.
   * @return reportPDFPasswordEnabled
  **/
  @ApiModelProperty(value = "Controls whether the reports that the Administrator generates are password-protected. Set to `true` to password-protect, and `false` otherwise. Defaults to `false`. Searchable as Boolean.")
  public Boolean isReportPDFPasswordEnabled() {
    return reportPDFPasswordEnabled;
  }

  public void setReportPDFPasswordEnabled(Boolean reportPDFPasswordEnabled) {
    this.reportPDFPasswordEnabled = reportPDFPasswordEnabled;
  }

  public Administrator reportPDFPassword(String reportPDFPassword) {
    this.reportPDFPassword = reportPDFPassword;
    return this;
  }

   /**
   * Password that protects the reports that the Administrator generates. Ignored when &#x60;reportPDFPasswordEnabled&#x60; is &#x60;false&#x60;.
   * @return reportPDFPassword
  **/
  @ApiModelProperty(value = "Password that protects the reports that the Administrator generates. Ignored when `reportPDFPasswordEnabled` is `false`.")
  public String getReportPDFPassword() {
    return reportPDFPassword;
  }

  public void setReportPDFPassword(String reportPDFPassword) {
    this.reportPDFPassword = reportPDFPassword;
  }

   /**
   * Timestamp when the Administrator was created, in milliseconds since epoch. Searchable as Date.
   * @return created
  **/
  @ApiModelProperty(value = "Timestamp when the Administrator was created, in milliseconds since epoch. Searchable as Date.")
  public Long getCreated() {
    return created;
  }

   /**
   * Timestamp when the Administrator&#39;s password was last changed, in milliseconds since epoch. Searchable as Date.
   * @return lastPasswordChange
  **/
  @ApiModelProperty(value = "Timestamp when the Administrator's password was last changed, in milliseconds since epoch. Searchable as Date.")
  public Long getLastPasswordChange() {
    return lastPasswordChange;
  }

   /**
   * Timestamp when the Administrator last signed in, in milliseconds since epoch. Searchable as Date.
   * @return lastSignIn
  **/
  @ApiModelProperty(value = "Timestamp when the Administrator last signed in, in milliseconds since epoch. Searchable as Date.")
  public Long getLastSignIn() {
    return lastSignIn;
  }

   /**
   * Timestamp at which the Administrator will be unlocked, in milliseconds since epoch. Ignored if the Administrator is not locked out using a time-based lock out scheme. Searchable as Date.
   * @return unlockTime
  **/
  @ApiModelProperty(value = "Timestamp at which the Administrator will be unlocked, in milliseconds since epoch. Ignored if the Administrator is not locked out using a time-based lock out scheme. Searchable as Date.")
  public Long getUnlockTime() {
    return unlockTime;
  }

   /**
   * Number of unsuccessful sign-in attempts for the Administrator. This number is reset to &#x60;0&#x60; when a successful authentication occurs. Searchable as Numeric.
   * @return unsuccessfulSignInAttempts
  **/
  @ApiModelProperty(value = "Number of unsuccessful sign-in attempts for the Administrator. This number is reset to `0` when a successful authentication occurs. Searchable as Numeric.")
  public Integer getUnsuccessfulSignInAttempts() {
    return unsuccessfulSignInAttempts;
  }

   /**
   * Security Account Manager (SAM) account name for the Administrator. Ignored if the Administrator is not managed by an identity provider. Searchable as String.
   * @return directoryName
  **/
  @ApiModelProperty(value = "Security Account Manager (SAM) account name for the Administrator. Ignored if the Administrator is not managed by an identity provider. Searchable as String.")
  public String getDirectoryName() {
    return directoryName;
  }

   /**
   * Unique ID used for single sign-on using a Security Account Manager (SAM) identity provider. Ignored if the Administrator is not managed by an identity provider.
   * @return directoryInfo
  **/
  @ApiModelProperty(value = "Unique ID used for single sign-on using a Security Account Manager (SAM) identity provider. Ignored if the Administrator is not managed by an identity provider.")
  public String getDirectoryInfo() {
    return directoryInfo;
  }

   /**
   * If set to &#x60;true&#x60; the Administrator is externally authenticated using SAML. Defaults to &#x60;false&#x60;. Ignored if the Administrator is not externally authenticated. Searchable as Boolean.
   * @return external
  **/
  @ApiModelProperty(value = "If set to `true` the Administrator is externally authenticated using SAML. Defaults to `false`. Ignored if the Administrator is not externally authenticated. Searchable as Boolean.")
  public Boolean isExternal() {
    return external;
  }

   /**
   * SAML User ID of the Administrator. Used to support external authentication of the Administrator. Ignored if the Administrator is not externally authenticated. Searchable as String.
   * @return externalUserID
  **/
  @ApiModelProperty(value = "SAML User ID of the Administrator. Used to support external authentication of the Administrator. Ignored if the Administrator is not externally authenticated. Searchable as String.")
  public String getExternalUserID() {
    return externalUserID;
  }

   /**
   * Administrator account type. Can either be &#x60;normal&#x60; or &#x60;temporary&#x60;. Defaults to &#x60;normal&#x60;. Searchable as Choice.
   * @return type
  **/
  @ApiModelProperty(value = "Administrator account type. Can either be `normal` or `temporary`. Defaults to `normal`. Searchable as Choice.")
  public TypeEnum getType() {
    return type;
  }

   /**
   * Set to &#x60;true&#x60; if the Administrator is read-only. Defaults to &#x60;false&#x60;. Searchable as Boolean.
   * @return readOnly
  **/
  @ApiModelProperty(value = "Set to `true` if the Administrator is read-only. Defaults to `false`. Searchable as Boolean.")
  public Boolean isReadOnly() {
    return readOnly;
  }

   /**
   * ID of the Administrator. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the Administrator. Searchable as ID.")
  public Integer getID() {
    return ID;
  }

  public Administrator utCOffset(String utCOffset) {
    this.utCOffset = utCOffset;
    return this;
  }

   /**
   * UTC offset of the Administrator.
   * @return utCOffset
  **/
  @ApiModelProperty(value = "UTC offset of the Administrator.")
  public String getUtCOffset() {
    return utCOffset;
  }

  public void setUtCOffset(String utCOffset) {
    this.utCOffset = utCOffset;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Administrator administrator = (Administrator) o;
    return Objects.equals(this.username, administrator.username) &&
        Objects.equals(this.password, administrator.password) &&
        Objects.equals(this.fullName, administrator.fullName) &&
        Objects.equals(this.description, administrator.description) &&
        Objects.equals(this.roleID, administrator.roleID) &&
        Objects.equals(this.locale, administrator.locale) &&
        Objects.equals(this.timeZone, administrator.timeZone) &&
        Objects.equals(this.timeFormat, administrator.timeFormat) &&
        Objects.equals(this.passwordNeverExpires, administrator.passwordNeverExpires) &&
        Objects.equals(this.active, administrator.active) &&
        Objects.equals(this.mfaType, administrator.mfaType) &&
        Objects.equals(this.phoneNumber, administrator.phoneNumber) &&
        Objects.equals(this.mobileNumber, administrator.mobileNumber) &&
        Objects.equals(this.pagerNumber, administrator.pagerNumber) &&
        Objects.equals(this.emailAddress, administrator.emailAddress) &&
        Objects.equals(this.primaryContact, administrator.primaryContact) &&
        Objects.equals(this.receiveNotifications, administrator.receiveNotifications) &&
        Objects.equals(this.reportPDFPasswordEnabled, administrator.reportPDFPasswordEnabled) &&
        Objects.equals(this.reportPDFPassword, administrator.reportPDFPassword) &&
        Objects.equals(this.created, administrator.created) &&
        Objects.equals(this.lastPasswordChange, administrator.lastPasswordChange) &&
        Objects.equals(this.lastSignIn, administrator.lastSignIn) &&
        Objects.equals(this.unlockTime, administrator.unlockTime) &&
        Objects.equals(this.unsuccessfulSignInAttempts, administrator.unsuccessfulSignInAttempts) &&
        Objects.equals(this.directoryName, administrator.directoryName) &&
        Objects.equals(this.directoryInfo, administrator.directoryInfo) &&
        Objects.equals(this.external, administrator.external) &&
        Objects.equals(this.externalUserID, administrator.externalUserID) &&
        Objects.equals(this.type, administrator.type) &&
        Objects.equals(this.readOnly, administrator.readOnly) &&
        Objects.equals(this.ID, administrator.ID) &&
        Objects.equals(this.utCOffset, administrator.utCOffset);
  }

  @Override
  public int hashCode() {
    return Objects.hash(username, password, fullName, description, roleID, locale, timeZone, timeFormat, passwordNeverExpires, active, mfaType, phoneNumber, mobileNumber, pagerNumber, emailAddress, primaryContact, receiveNotifications, reportPDFPasswordEnabled, reportPDFPassword, created, lastPasswordChange, lastSignIn, unlockTime, unsuccessfulSignInAttempts, directoryName, directoryInfo, external, externalUserID, type, readOnly, ID, utCOffset);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Administrator {\n");
    
    sb.append("    username: ").append(toIndentedString(username)).append("\n");
    sb.append("    password: ").append(toIndentedString(password)).append("\n");
    sb.append("    fullName: ").append(toIndentedString(fullName)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    roleID: ").append(toIndentedString(roleID)).append("\n");
    sb.append("    locale: ").append(toIndentedString(locale)).append("\n");
    sb.append("    timeZone: ").append(toIndentedString(timeZone)).append("\n");
    sb.append("    timeFormat: ").append(toIndentedString(timeFormat)).append("\n");
    sb.append("    passwordNeverExpires: ").append(toIndentedString(passwordNeverExpires)).append("\n");
    sb.append("    active: ").append(toIndentedString(active)).append("\n");
    sb.append("    mfaType: ").append(toIndentedString(mfaType)).append("\n");
    sb.append("    phoneNumber: ").append(toIndentedString(phoneNumber)).append("\n");
    sb.append("    mobileNumber: ").append(toIndentedString(mobileNumber)).append("\n");
    sb.append("    pagerNumber: ").append(toIndentedString(pagerNumber)).append("\n");
    sb.append("    emailAddress: ").append(toIndentedString(emailAddress)).append("\n");
    sb.append("    primaryContact: ").append(toIndentedString(primaryContact)).append("\n");
    sb.append("    receiveNotifications: ").append(toIndentedString(receiveNotifications)).append("\n");
    sb.append("    reportPDFPasswordEnabled: ").append(toIndentedString(reportPDFPasswordEnabled)).append("\n");
    sb.append("    reportPDFPassword: ").append(toIndentedString(reportPDFPassword)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    lastPasswordChange: ").append(toIndentedString(lastPasswordChange)).append("\n");
    sb.append("    lastSignIn: ").append(toIndentedString(lastSignIn)).append("\n");
    sb.append("    unlockTime: ").append(toIndentedString(unlockTime)).append("\n");
    sb.append("    unsuccessfulSignInAttempts: ").append(toIndentedString(unsuccessfulSignInAttempts)).append("\n");
    sb.append("    directoryName: ").append(toIndentedString(directoryName)).append("\n");
    sb.append("    directoryInfo: ").append(toIndentedString(directoryInfo)).append("\n");
    sb.append("    external: ").append(toIndentedString(external)).append("\n");
    sb.append("    externalUserID: ").append(toIndentedString(externalUserID)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    readOnly: ").append(toIndentedString(readOnly)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("    utCOffset: ").append(toIndentedString(utCOffset)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

