/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.AvailableVersion;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Agent version control details.
 */
@ApiModel(description = "Agent version control details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class AgentVersionControl {
  /**
   * OS of the agent version control. Searchable as Choice.
   */
  public enum OsEnum {
    WINDOWS("Windows"),
    
    LINUX("Linux"),
    
    UNIX("Unix");

    private String value;

    OsEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static OsEnum fromValue(String text) {
      for (OsEnum b : OsEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("os")
  private OsEnum os = null;

  /**
   * Distro of the agent version control. Searchable as Choice.
   */
  public enum DistroEnum {
    RED_HAT("Red Hat"),
    
    CENT_OS("CentOS"),
    
    SUSE("SUSE"),
    
    UBUNTU("Ubuntu"),
    
    DEBIAN("Debian"),
    
    ORACLE_LINUX("Oracle Linux"),
    
    AMAZON_LINUX("Amazon Linux"),
    
    CLOUD_LINUX("CloudLinux"),
    
    ALMA_LINUX("AlmaLinux"),
    
    ROCKY_LINUX("Rocky Linux"),
    
    MIRACLE_LINUX("Miracle Linux"),
    
    SOLARIS("Solaris"),
    
    NAVIX("Navix"),
    
    AIX("AIX");

    private String value;

    DistroEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static DistroEnum fromValue(String text) {
      for (DistroEnum b : DistroEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("distro")
  private DistroEnum distro = null;

  /**
   * Platform of the agent version control. Searchable as Choice.
   */
  public enum PlatformEnum {
    MICROSOFT_WINDOWS_2000_SERVER("Microsoft Windows 2000 Server"),
    
    MICROSOFT_WINDOWS_SERVER_2003("Microsoft Windows Server 2003"),
    
    MICROSOFT_WINDOWS_SERVER_2003_R2("Microsoft Windows Server 2003 R2"),
    
    MICROSOFT_WINDOWS_SERVER_2008("Microsoft Windows Server 2008"),
    
    MICROSOFT_WINDOWS_SERVER_2008_R2("Microsoft Windows Server 2008 R2"),
    
    MICROSOFT_WINDOWS_SERVER_2012("Microsoft Windows Server 2012"),
    
    MICROSOFT_WINDOWS_SERVER_2012_R2("Microsoft Windows Server 2012 R2"),
    
    MICROSOFT_WINDOWS_SERVER_2016("Microsoft Windows Server 2016"),
    
    MICROSOFT_WINDOWS_SERVER_2019("Microsoft Windows Server 2019"),
    
    MICROSOFT_WINDOWS_SERVER_2022("Microsoft Windows Server 2022"),
    
    MICROSOFT_WINDOWS_2000_PROFESSIONAL("Microsoft Windows 2000 Professional"),
    
    MICROSOFT_WINDOWS_XP("Microsoft Windows XP"),
    
    MICROSOFT_WINDOWS_7("Microsoft Windows 7"),
    
    MICROSOFT_WINDOWS_8("Microsoft Windows 8"),
    
    MICROSOFT_WINDOWS_8_1("Microsoft Windows 8.1"),
    
    MICROSOFT_WINDOWS_10("Microsoft Windows 10"),
    
    MICROSOFT_WINDOWS_11("Microsoft Windows 11"),
    
    SOLARIS_10_U4_TO_U6("Solaris 10 U4 to U6"),
    
    SOLARIS_10_U7_TO_U11("Solaris 10 U7 to U11"),
    
    SOLARIS_11_0_TO_11_3("Solaris 11.0 to 11.3"),
    
    SOLARIS_11_4("Solaris 11.4"),
    
    AIX_5_3("AIX 5.3"),
    
    AIX_6_1("AIX 6.1"),
    
    AIX_7_1("AIX 7.1"),
    
    AIX_7_2("AIX 7.2"),
    
    AIX_7_3("AIX 7.3"),
    
    RED_HAT_ENTERPRISE_5("Red Hat Enterprise 5"),
    
    RED_HAT_ENTERPRISE_6("Red Hat Enterprise 6"),
    
    RED_HAT_ENTERPRISE_7("Red Hat Enterprise 7"),
    
    RED_HAT_ENTERPRISE_8("Red Hat Enterprise 8"),
    
    RED_HAT_ENTERPRISE_9("Red Hat Enterprise 9"),
    
    RED_HAT_ENTERPRISE_WORKSTATION_7("Red Hat Enterprise Workstation 7"),
    
    UBUNTU_LINUX_10("Ubuntu Linux 10"),
    
    UBUNTU_LINUX_12("Ubuntu Linux 12"),
    
    UBUNTU_LINUX_14("Ubuntu Linux 14"),
    
    UBUNTU_LINUX_16("Ubuntu Linux 16"),
    
    UBUNTU_LINUX_18("Ubuntu Linux 18"),
    
    UBUNTU_LINUX_20("Ubuntu Linux 20"),
    
    UBUNTU_LINUX_22("Ubuntu Linux 22"),
    
    CENT_OS_5("CentOS 5"),
    
    CENT_OS_6("CentOS 6"),
    
    CENT_OS_7("CentOS 7"),
    
    CENT_OS_8("CentOS 8"),
    
    DEBIAN_6("Debian 6"),
    
    DEBIAN_7("Debian 7"),
    
    DEBIAN_8("Debian 8"),
    
    DEBIAN_9("Debian 9"),
    
    DEBIAN_10("Debian 10"),
    
    DEBIAN_11("Debian 11"),
    
    DEBIAN_12("Debian 12"),
    
    AMAZON_LINUX("Amazon Linux"),
    
    AMAZON_LINUX_2("Amazon Linux 2"),
    
    AMAZON_LINUX_2023("Amazon Linux 2023"),
    
    ORACLE_LINUX_RELEASE_5("Oracle Linux Release 5"),
    
    ORACLE_LINUX_RELEASE_6("Oracle Linux Release 6"),
    
    ORACLE_LINUX_RELEASE_7("Oracle Linux Release 7"),
    
    ORACLE_LINUX_RELEASE_8("Oracle Linux Release 8"),
    
    ORACLE_LINUX_RELEASE_9("Oracle Linux Release 9"),
    
    SUSE_ENTERPRISE_SERVER_10("SUSE Enterprise Server 10"),
    
    SUSE_ENTERPRISE_SERVER_11("SUSE Enterprise Server 11"),
    
    SUSE_ENTERPRISE_SERVER_12("SUSE Enterprise Server 12"),
    
    SUSE_ENTERPRISE_SERVER_15("SUSE Enterprise Server 15"),
    
    CLOUD_LINUX_5("CloudLinux 5"),
    
    CLOUD_LINUX_6("CloudLinux 6"),
    
    CLOUD_LINUX_7("CloudLinux 7"),
    
    CLOUD_LINUX_8("CloudLinux 8"),
    
    ALMA_LINUX_8("AlmaLinux 8"),
    
    ALMA_LINUX_9("AlmaLinux 9"),
    
    ROCKY_LINUX_8("Rocky Linux 8"),
    
    ROCKY_LINUX_9("Rocky Linux 9"),
    
    MIRACLE_LINUX_8("Miracle Linux 8"),
    
    MIRACLE_LINUX_9("Miracle Linux 9"),
    
    NAVIX_8("Navix 8");

    private String value;

    PlatformEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static PlatformEnum fromValue(String text) {
      for (PlatformEnum b : PlatformEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("platform")
  private PlatformEnum platform = null;

  /**
   * Architecture of the agent version control. Searchable as Choice.
   */
  public enum ArchitectureEnum {
    _32_BIT("32-bit"),
    
    _64_BIT("64-bit"),
    
    SPARC("sparc"),
    
    POWERPC("powerpc"),
    
    _64_BIT_ARM("64-bit Arm"),
    
    PPC64LE("ppc64le");

    private String value;

    ArchitectureEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ArchitectureEnum fromValue(String text) {
      for (ArchitectureEnum b : ArchitectureEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("architecture")
  private ArchitectureEnum architecture = null;

  /**
   * Type of the agent version control. Searchable as Choice.
   */
  public enum TypeEnum {
    LATEST("latest"),
    
    LATEST_LTS("latest-lts"),
    
    SPECIFIED("specified"),
    
    UNKNOWN("unknown");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TypeEnum fromValue(String text) {
      for (TypeEnum b : TypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("type")
  private TypeEnum type = null;

  @JsonProperty("version")
  private String version = null;

  @JsonProperty("availableVersions")
  private List<AvailableVersion> availableVersions = null;

  @JsonProperty("ID")
  private Integer ID = null;

   /**
   * OS of the agent version control. Searchable as Choice.
   * @return os
  **/
  @ApiModelProperty(value = "OS of the agent version control. Searchable as Choice.")
  public OsEnum getOs() {
    return os;
  }

   /**
   * Distro of the agent version control. Searchable as Choice.
   * @return distro
  **/
  @ApiModelProperty(value = "Distro of the agent version control. Searchable as Choice.")
  public DistroEnum getDistro() {
    return distro;
  }

   /**
   * Platform of the agent version control. Searchable as Choice.
   * @return platform
  **/
  @ApiModelProperty(value = "Platform of the agent version control. Searchable as Choice.")
  public PlatformEnum getPlatform() {
    return platform;
  }

   /**
   * Architecture of the agent version control. Searchable as Choice.
   * @return architecture
  **/
  @ApiModelProperty(value = "Architecture of the agent version control. Searchable as Choice.")
  public ArchitectureEnum getArchitecture() {
    return architecture;
  }

  public AgentVersionControl type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * Type of the agent version control. Searchable as Choice.
   * @return type
  **/
  @ApiModelProperty(value = "Type of the agent version control. Searchable as Choice.")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }

  public AgentVersionControl version(String version) {
    this.version = version;
    return this;
  }

   /**
   * Version of the agent version control. Searchable as String.
   * @return version
  **/
  @ApiModelProperty(value = "Version of the agent version control. Searchable as String.")
  public String getVersion() {
    return version;
  }

  public void setVersion(String version) {
    this.version = version;
  }

   /**
   * List of available versions for the platform.
   * @return availableVersions
  **/
  @ApiModelProperty(value = "List of available versions for the platform.")
  public List<AvailableVersion> getAvailableVersions() {
    return availableVersions;
  }

  public AgentVersionControl ID(Integer ID) {
    this.ID = ID;
    return this;
  }

   /**
   * ID of the agent version control. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the agent version control. Searchable as ID.")
  public Integer getID() {
    return ID;
  }

  public void setID(Integer ID) {
    this.ID = ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    AgentVersionControl agentVersionControl = (AgentVersionControl) o;
    return Objects.equals(this.os, agentVersionControl.os) &&
        Objects.equals(this.distro, agentVersionControl.distro) &&
        Objects.equals(this.platform, agentVersionControl.platform) &&
        Objects.equals(this.architecture, agentVersionControl.architecture) &&
        Objects.equals(this.type, agentVersionControl.type) &&
        Objects.equals(this.version, agentVersionControl.version) &&
        Objects.equals(this.availableVersions, agentVersionControl.availableVersions) &&
        Objects.equals(this.ID, agentVersionControl.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(os, distro, platform, architecture, type, version, availableVersions, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class AgentVersionControl {\n");
    
    sb.append("    os: ").append(toIndentedString(os)).append("\n");
    sb.append("    distro: ").append(toIndentedString(distro)).append("\n");
    sb.append("    platform: ").append(toIndentedString(platform)).append("\n");
    sb.append("    architecture: ").append(toIndentedString(architecture)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("    availableVersions: ").append(toIndentedString(availableVersions)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

