/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * API Usage Metrics are useful to view data on which API endpoints are used and how.
 */
@ApiModel(description = "API Usage Metrics are useful to view data on which API endpoints are used and how.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class ApiUsageMetric {
  @JsonProperty("apiType")
  private String apiType = null;

  @JsonProperty("action")
  private String action = null;

  @JsonProperty("method")
  private String method = null;

  @JsonProperty("date")
  private Long date = null;

  @JsonProperty("tenantGUID")
  private String tenantGUID = null;

  @JsonProperty("duration")
  private Long duration = null;

  @JsonProperty("statusCode")
  private Integer statusCode = null;

  @JsonProperty("authenticationMethod")
  private String authenticationMethod = null;

  @JsonProperty("expandParameter")
  private String expandParameter = null;

  @JsonProperty("responseItemCount")
  private Integer responseItemCount = null;

  @JsonProperty("ID")
  private Long ID = null;

  public ApiUsageMetric apiType(String apiType) {
    this.apiType = apiType;
    return this;
  }

   /**
   * Type of API called (\&quot;REST\&quot; or \&quot;SOAP\&quot;). Searchable as String.
   * @return apiType
  **/
  @ApiModelProperty(value = "Type of API called (\"REST\" or \"SOAP\"). Searchable as String.")
  public String getApiType() {
    return apiType;
  }

  public void setApiType(String apiType) {
    this.apiType = apiType;
  }

  public ApiUsageMetric action(String action) {
    this.action = action;
    return this;
  }

   /**
   * Http action (\&quot;GET\&quot;, \&quot;PUT\&quot;, \&quot;POST\&quot; or \&quot;DELETE\&quot;). Searchable as String.
   * @return action
  **/
  @ApiModelProperty(value = "Http action (\"GET\", \"PUT\", \"POST\" or \"DELETE\"). Searchable as String.")
  public String getAction() {
    return action;
  }

  public void setAction(String action) {
    this.action = action;
  }

  public ApiUsageMetric method(String method) {
    this.method = method;
    return this;
  }

   /**
   * Method or API Endpoint called. Searchable as String.
   * @return method
  **/
  @ApiModelProperty(value = "Method or API Endpoint called. Searchable as String.")
  public String getMethod() {
    return method;
  }

  public void setMethod(String method) {
    this.method = method;
  }

  public ApiUsageMetric date(Long date) {
    this.date = date;
    return this;
  }

   /**
   * Date of API call in milliseconds since epoch. Searchable as Date.
   * @return date
  **/
  @ApiModelProperty(value = "Date of API call in milliseconds since epoch. Searchable as Date.")
  public Long getDate() {
    return date;
  }

  public void setDate(Long date) {
    this.date = date;
  }

  public ApiUsageMetric tenantGUID(String tenantGUID) {
    this.tenantGUID = tenantGUID;
    return this;
  }

   /**
   * GUID of the tenant who called the API. Searchable as String.
   * @return tenantGUID
  **/
  @ApiModelProperty(value = "GUID of the tenant who called the API. Searchable as String.")
  public String getTenantGUID() {
    return tenantGUID;
  }

  public void setTenantGUID(String tenantGUID) {
    this.tenantGUID = tenantGUID;
  }

  public ApiUsageMetric duration(Long duration) {
    this.duration = duration;
    return this;
  }

   /**
   * Duration of the API call from request to response in milliseconds. Searchable as Numeric.
   * @return duration
  **/
  @ApiModelProperty(value = "Duration of the API call from request to response in milliseconds. Searchable as Numeric.")
  public Long getDuration() {
    return duration;
  }

  public void setDuration(Long duration) {
    this.duration = duration;
  }

  public ApiUsageMetric statusCode(Integer statusCode) {
    this.statusCode = statusCode;
    return this;
  }

   /**
   * Http status code returned by the API. Searchable as Numeric.
   * @return statusCode
  **/
  @ApiModelProperty(value = "Http status code returned by the API. Searchable as Numeric.")
  public Integer getStatusCode() {
    return statusCode;
  }

  public void setStatusCode(Integer statusCode) {
    this.statusCode = statusCode;
  }

  public ApiUsageMetric authenticationMethod(String authenticationMethod) {
    this.authenticationMethod = authenticationMethod;
    return this;
  }

   /**
   * Method used to authenticate the API call (\&quot;sID\&quot;, \&quot;API-Key\&quot;, or empty string). Searchable as String.
   * @return authenticationMethod
  **/
  @ApiModelProperty(value = "Method used to authenticate the API call (\"sID\", \"API-Key\", or empty string). Searchable as String.")
  public String getAuthenticationMethod() {
    return authenticationMethod;
  }

  public void setAuthenticationMethod(String authenticationMethod) {
    this.authenticationMethod = authenticationMethod;
  }

  public ApiUsageMetric expandParameter(String expandParameter) {
    this.expandParameter = expandParameter;
    return this;
  }

   /**
   * \&quot;expand\&quot; parameter passed to /computers endpoint. Searchable as String.
   * @return expandParameter
  **/
  @ApiModelProperty(value = "\"expand\" parameter passed to /computers endpoint. Searchable as String.")
  public String getExpandParameter() {
    return expandParameter;
  }

  public void setExpandParameter(String expandParameter) {
    this.expandParameter = expandParameter;
  }

  public ApiUsageMetric responseItemCount(Integer responseItemCount) {
    this.responseItemCount = responseItemCount;
    return this;
  }

   /**
   * Number of items returned to the client from a list/search operation. Searchable as Numeric.
   * @return responseItemCount
  **/
  @ApiModelProperty(value = "Number of items returned to the client from a list/search operation. Searchable as Numeric.")
  public Integer getResponseItemCount() {
    return responseItemCount;
  }

  public void setResponseItemCount(Integer responseItemCount) {
    this.responseItemCount = responseItemCount;
  }

   /**
   * ID of the APIUsageMetric. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the APIUsageMetric. Searchable as ID.")
  public Long getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiUsageMetric apiUsageMetric = (ApiUsageMetric) o;
    return Objects.equals(this.apiType, apiUsageMetric.apiType) &&
        Objects.equals(this.action, apiUsageMetric.action) &&
        Objects.equals(this.method, apiUsageMetric.method) &&
        Objects.equals(this.date, apiUsageMetric.date) &&
        Objects.equals(this.tenantGUID, apiUsageMetric.tenantGUID) &&
        Objects.equals(this.duration, apiUsageMetric.duration) &&
        Objects.equals(this.statusCode, apiUsageMetric.statusCode) &&
        Objects.equals(this.authenticationMethod, apiUsageMetric.authenticationMethod) &&
        Objects.equals(this.expandParameter, apiUsageMetric.expandParameter) &&
        Objects.equals(this.responseItemCount, apiUsageMetric.responseItemCount) &&
        Objects.equals(this.ID, apiUsageMetric.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(apiType, action, method, date, tenantGUID, duration, statusCode, authenticationMethod, expandParameter, responseItemCount, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiUsageMetric {\n");
    
    sb.append("    apiType: ").append(toIndentedString(apiType)).append("\n");
    sb.append("    action: ").append(toIndentedString(action)).append("\n");
    sb.append("    method: ").append(toIndentedString(method)).append("\n");
    sb.append("    date: ").append(toIndentedString(date)).append("\n");
    sb.append("    tenantGUID: ").append(toIndentedString(tenantGUID)).append("\n");
    sb.append("    duration: ").append(toIndentedString(duration)).append("\n");
    sb.append("    statusCode: ").append(toIndentedString(statusCode)).append("\n");
    sb.append("    authenticationMethod: ").append(toIndentedString(authenticationMethod)).append("\n");
    sb.append("    expandParameter: ").append(toIndentedString(expandParameter)).append("\n");
    sb.append("    responseItemCount: ").append(toIndentedString(responseItemCount)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

