/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.ComputerModuleStatus;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Computer-level configuration for the Application Control module. Null for tenants for whom Application Control is hidden.
 */
@ApiModel(description = "Computer-level configuration for the Application Control module. Null for tenants for whom Application Control is hidden.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class ApplicationControlComputerExtension {
  /**
   * Module state. The &#39;inherited&#39; value is write-only.
   */
  public enum StateEnum {
    INHERITED("inherited"),
    
    ON("on"),
    
    OFF("off");

    private String value;

    StateEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StateEnum fromValue(String text) {
      for (StateEnum b : StateEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("state")
  private StateEnum state = null;

  @JsonProperty("moduleStatus")
  private ComputerModuleStatus moduleStatus = null;

  @JsonProperty("blockUnrecognized")
  private Boolean blockUnrecognized = null;

  @JsonProperty("rulesetID")
  private Long rulesetID = null;

  @JsonProperty("trustRulesetID")
  private String trustRulesetID = null;

  /**
   * Maintenance mode status.
   */
  public enum MaintenanceModeStatusEnum {
    OFF("off"),
    
    START_REQUESTED("start-requested"),
    
    ON("on"),
    
    STOP_REQUESTED("stop-requested"),
    
    RESET_DURATION_REQUESTED("reset-duration-requested");

    private String value;

    MaintenanceModeStatusEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static MaintenanceModeStatusEnum fromValue(String text) {
      for (MaintenanceModeStatusEnum b : MaintenanceModeStatusEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("maintenanceModeStatus")
  private MaintenanceModeStatusEnum maintenanceModeStatus = null;

  @JsonProperty("maintenanceModeDuration")
  private Integer maintenanceModeDuration = null;

  @JsonProperty("maintenanceModeStartTime")
  private Long maintenanceModeStartTime = null;

  @JsonProperty("maintenanceModeEndTime")
  private Long maintenanceModeEndTime = null;

  public ApplicationControlComputerExtension state(StateEnum state) {
    this.state = state;
    return this;
  }

   /**
   * Module state. The &#39;inherited&#39; value is write-only.
   * @return state
  **/
  @ApiModelProperty(value = "Module state. The 'inherited' value is write-only.")
  public StateEnum getState() {
    return state;
  }

  public void setState(StateEnum state) {
    this.state = state;
  }

  public ApplicationControlComputerExtension moduleStatus(ComputerModuleStatus moduleStatus) {
    this.moduleStatus = moduleStatus;
    return this;
  }

   /**
   * Get moduleStatus
   * @return moduleStatus
  **/
  @ApiModelProperty(value = "")
  public ComputerModuleStatus getModuleStatus() {
    return moduleStatus;
  }

  public void setModuleStatus(ComputerModuleStatus moduleStatus) {
    this.moduleStatus = moduleStatus;
  }

  public ApplicationControlComputerExtension blockUnrecognized(Boolean blockUnrecognized) {
    this.blockUnrecognized = blockUnrecognized;
    return this;
  }

   /**
   * Controls whether to block unrecognized software until it is explicitly allowed. Set to true to block.
   * @return blockUnrecognized
  **/
  @ApiModelProperty(value = "Controls whether to block unrecognized software until it is explicitly allowed. Set to true to block.")
  public Boolean isBlockUnrecognized() {
    return blockUnrecognized;
  }

  public void setBlockUnrecognized(Boolean blockUnrecognized) {
    this.blockUnrecognized = blockUnrecognized;
  }

  public ApplicationControlComputerExtension rulesetID(Long rulesetID) {
    this.rulesetID = rulesetID;
    return this;
  }

   /**
   * ID of the shared allowlist ruleset.
   * @return rulesetID
  **/
  @ApiModelProperty(value = "ID of the shared allowlist ruleset.")
  public Long getRulesetID() {
    return rulesetID;
  }

  public void setRulesetID(Long rulesetID) {
    this.rulesetID = rulesetID;
  }

  public ApplicationControlComputerExtension trustRulesetID(String trustRulesetID) {
    this.trustRulesetID = trustRulesetID;
    return this;
  }

   /**
   * ID of the trust ruleset. An empty string will set it to \&quot;None\&quot; and assigning a value of 0 will set it to \&quot;Inherited\&quot;.
   * @return trustRulesetID
  **/
  @ApiModelProperty(value = "ID of the trust ruleset. An empty string will set it to \"None\" and assigning a value of 0 will set it to \"Inherited\".")
  public String getTrustRulesetID() {
    return trustRulesetID;
  }

  public void setTrustRulesetID(String trustRulesetID) {
    this.trustRulesetID = trustRulesetID;
  }

  public ApplicationControlComputerExtension maintenanceModeStatus(MaintenanceModeStatusEnum maintenanceModeStatus) {
    this.maintenanceModeStatus = maintenanceModeStatus;
    return this;
  }

   /**
   * Maintenance mode status.
   * @return maintenanceModeStatus
  **/
  @ApiModelProperty(value = "Maintenance mode status.")
  public MaintenanceModeStatusEnum getMaintenanceModeStatus() {
    return maintenanceModeStatus;
  }

  public void setMaintenanceModeStatus(MaintenanceModeStatusEnum maintenanceModeStatus) {
    this.maintenanceModeStatus = maintenanceModeStatus;
  }

  public ApplicationControlComputerExtension maintenanceModeDuration(Integer maintenanceModeDuration) {
    this.maintenanceModeDuration = maintenanceModeDuration;
    return this;
  }

   /**
   * Duration of maintenance mode in minutes.
   * @return maintenanceModeDuration
  **/
  @ApiModelProperty(value = "Duration of maintenance mode in minutes.")
  public Integer getMaintenanceModeDuration() {
    return maintenanceModeDuration;
  }

  public void setMaintenanceModeDuration(Integer maintenanceModeDuration) {
    this.maintenanceModeDuration = maintenanceModeDuration;
  }

   /**
   * Timestamp of the date the maintenanceMode was started, in milliseconds since epoch.
   * @return maintenanceModeStartTime
  **/
  @ApiModelProperty(value = "Timestamp of the date the maintenanceMode was started, in milliseconds since epoch.")
  public Long getMaintenanceModeStartTime() {
    return maintenanceModeStartTime;
  }

   /**
   * Timestamp of the date the maintenanceMode was ended, in milliseconds since epoch.
   * @return maintenanceModeEndTime
  **/
  @ApiModelProperty(value = "Timestamp of the date the maintenanceMode was ended, in milliseconds since epoch.")
  public Long getMaintenanceModeEndTime() {
    return maintenanceModeEndTime;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApplicationControlComputerExtension applicationControlComputerExtension = (ApplicationControlComputerExtension) o;
    return Objects.equals(this.state, applicationControlComputerExtension.state) &&
        Objects.equals(this.moduleStatus, applicationControlComputerExtension.moduleStatus) &&
        Objects.equals(this.blockUnrecognized, applicationControlComputerExtension.blockUnrecognized) &&
        Objects.equals(this.rulesetID, applicationControlComputerExtension.rulesetID) &&
        Objects.equals(this.trustRulesetID, applicationControlComputerExtension.trustRulesetID) &&
        Objects.equals(this.maintenanceModeStatus, applicationControlComputerExtension.maintenanceModeStatus) &&
        Objects.equals(this.maintenanceModeDuration, applicationControlComputerExtension.maintenanceModeDuration) &&
        Objects.equals(this.maintenanceModeStartTime, applicationControlComputerExtension.maintenanceModeStartTime) &&
        Objects.equals(this.maintenanceModeEndTime, applicationControlComputerExtension.maintenanceModeEndTime);
  }

  @Override
  public int hashCode() {
    return Objects.hash(state, moduleStatus, blockUnrecognized, rulesetID, trustRulesetID, maintenanceModeStatus, maintenanceModeDuration, maintenanceModeStartTime, maintenanceModeEndTime);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApplicationControlComputerExtension {\n");
    
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("    moduleStatus: ").append(toIndentedString(moduleStatus)).append("\n");
    sb.append("    blockUnrecognized: ").append(toIndentedString(blockUnrecognized)).append("\n");
    sb.append("    rulesetID: ").append(toIndentedString(rulesetID)).append("\n");
    sb.append("    trustRulesetID: ").append(toIndentedString(trustRulesetID)).append("\n");
    sb.append("    maintenanceModeStatus: ").append(toIndentedString(maintenanceModeStatus)).append("\n");
    sb.append("    maintenanceModeDuration: ").append(toIndentedString(maintenanceModeDuration)).append("\n");
    sb.append("    maintenanceModeStartTime: ").append(toIndentedString(maintenanceModeStartTime)).append("\n");
    sb.append("    maintenanceModeEndTime: ").append(toIndentedString(maintenanceModeEndTime)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

