/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Rule details.
 */
@ApiModel(description = "Rule details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class ApplicationControlGlobalRule {
  @JsonProperty("sha256")
  private String sha256 = null;

  @JsonProperty("sha1")
  private String sha1 = null;

  @JsonProperty("md5")
  private String md5 = null;

  @JsonProperty("description")
  private String description = null;

  /**
   * Action to take when a user attempts to launch the executable named in the rule. Searchable as Choice.
   */
  public enum ActionEnum {
    BLOCK("block");

    private String value;

    ActionEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ActionEnum fromValue(String text) {
      for (ActionEnum b : ActionEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("action")
  private ActionEnum action = null;

  @JsonProperty("lastUpdatedAdministrator")
  private Integer lastUpdatedAdministrator = null;

  @JsonProperty("lastUpdated")
  private Long lastUpdated = null;

  @JsonProperty("ID")
  private Long ID = null;

  public ApplicationControlGlobalRule sha256(String sha256) {
    this.sha256 = sha256;
    return this;
  }

   /**
   * SHA-256 hash of the executable named in the rule. Searchable as String.
   * @return sha256
  **/
  @ApiModelProperty(value = "SHA-256 hash of the executable named in the rule. Searchable as String.")
  public String getSha256() {
    return sha256;
  }

  public void setSha256(String sha256) {
    this.sha256 = sha256;
  }

  public ApplicationControlGlobalRule sha1(String sha1) {
    this.sha1 = sha1;
    return this;
  }

   /**
   * SHA-1 hash of the executable named in the rule. Searchable as String.
   * @return sha1
  **/
  @ApiModelProperty(value = "SHA-1 hash of the executable named in the rule. Searchable as String.")
  public String getSha1() {
    return sha1;
  }

  public void setSha1(String sha1) {
    this.sha1 = sha1;
  }

  public ApplicationControlGlobalRule md5(String md5) {
    this.md5 = md5;
    return this;
  }

   /**
   * MD5 hash of the executable named in the rule. Searchable as String.
   * @return md5
  **/
  @ApiModelProperty(value = "MD5 hash of the executable named in the rule. Searchable as String.")
  public String getMd5() {
    return md5;
  }

  public void setMd5(String md5) {
    this.md5 = md5;
  }

  public ApplicationControlGlobalRule description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the rule. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the rule. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

   /**
   * Action to take when a user attempts to launch the executable named in the rule. Searchable as Choice.
   * @return action
  **/
  @ApiModelProperty(value = "Action to take when a user attempts to launch the executable named in the rule. Searchable as Choice.")
  public ActionEnum getAction() {
    return action;
  }

   /**
   * ID of the last administrator to update the rule. Searchable as Numeric.
   * @return lastUpdatedAdministrator
  **/
  @ApiModelProperty(value = "ID of the last administrator to update the rule. Searchable as Numeric.")
  public Integer getLastUpdatedAdministrator() {
    return lastUpdatedAdministrator;
  }

   /**
   * Timestamp of the last rule modification, in milliseconds since epoch. Searchable as Date.
   * @return lastUpdated
  **/
  @ApiModelProperty(value = "Timestamp of the last rule modification, in milliseconds since epoch. Searchable as Date.")
  public Long getLastUpdated() {
    return lastUpdated;
  }

   /**
   * ID of the application control rule. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the application control rule. Searchable as ID.")
  public Long getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApplicationControlGlobalRule applicationControlGlobalRule = (ApplicationControlGlobalRule) o;
    return Objects.equals(this.sha256, applicationControlGlobalRule.sha256) &&
        Objects.equals(this.sha1, applicationControlGlobalRule.sha1) &&
        Objects.equals(this.md5, applicationControlGlobalRule.md5) &&
        Objects.equals(this.description, applicationControlGlobalRule.description) &&
        Objects.equals(this.action, applicationControlGlobalRule.action) &&
        Objects.equals(this.lastUpdatedAdministrator, applicationControlGlobalRule.lastUpdatedAdministrator) &&
        Objects.equals(this.lastUpdated, applicationControlGlobalRule.lastUpdated) &&
        Objects.equals(this.ID, applicationControlGlobalRule.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(sha256, sha1, md5, description, action, lastUpdatedAdministrator, lastUpdated, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApplicationControlGlobalRule {\n");
    
    sb.append("    sha256: ").append(toIndentedString(sha256)).append("\n");
    sb.append("    sha1: ").append(toIndentedString(sha1)).append("\n");
    sb.append("    md5: ").append(toIndentedString(md5)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    action: ").append(toIndentedString(action)).append("\n");
    sb.append("    lastUpdatedAdministrator: ").append(toIndentedString(lastUpdatedAdministrator)).append("\n");
    sb.append("    lastUpdated: ").append(toIndentedString(lastUpdated)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

