/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.PolicyModuleStatus;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Policy-level configuration for the Application Control module
 */
@ApiModel(description = "Policy-level configuration for the Application Control module")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class ApplicationControlPolicyExtension {
  /**
   * Module state. The &#39;inherited&#39; value is write-only.
   */
  public enum StateEnum {
    INHERITED("inherited"),
    
    ON("on"),
    
    OFF("off");

    private String value;

    StateEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StateEnum fromValue(String text) {
      for (StateEnum b : StateEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("state")
  private StateEnum state = null;

  @JsonProperty("moduleStatus")
  private PolicyModuleStatus moduleStatus = null;

  @JsonProperty("blockUnrecognized")
  private Boolean blockUnrecognized = null;

  @JsonProperty("rulesetID")
  private Long rulesetID = null;

  @JsonProperty("trustRulesetID")
  private String trustRulesetID = null;

  public ApplicationControlPolicyExtension state(StateEnum state) {
    this.state = state;
    return this;
  }

   /**
   * Module state. The &#39;inherited&#39; value is write-only.
   * @return state
  **/
  @ApiModelProperty(value = "Module state. The 'inherited' value is write-only.")
  public StateEnum getState() {
    return state;
  }

  public void setState(StateEnum state) {
    this.state = state;
  }

  public ApplicationControlPolicyExtension moduleStatus(PolicyModuleStatus moduleStatus) {
    this.moduleStatus = moduleStatus;
    return this;
  }

   /**
   * Get moduleStatus
   * @return moduleStatus
  **/
  @ApiModelProperty(value = "")
  public PolicyModuleStatus getModuleStatus() {
    return moduleStatus;
  }

  public void setModuleStatus(PolicyModuleStatus moduleStatus) {
    this.moduleStatus = moduleStatus;
  }

  public ApplicationControlPolicyExtension blockUnrecognized(Boolean blockUnrecognized) {
    this.blockUnrecognized = blockUnrecognized;
    return this;
  }

   /**
   * Block unrecognized software until it is explicitly allowed.
   * @return blockUnrecognized
  **/
  @ApiModelProperty(value = "Block unrecognized software until it is explicitly allowed.")
  public Boolean isBlockUnrecognized() {
    return blockUnrecognized;
  }

  public void setBlockUnrecognized(Boolean blockUnrecognized) {
    this.blockUnrecognized = blockUnrecognized;
  }

  public ApplicationControlPolicyExtension rulesetID(Long rulesetID) {
    this.rulesetID = rulesetID;
    return this;
  }

   /**
   * ID of the shared allowlist ruleset.
   * @return rulesetID
  **/
  @ApiModelProperty(value = "ID of the shared allowlist ruleset.")
  public Long getRulesetID() {
    return rulesetID;
  }

  public void setRulesetID(Long rulesetID) {
    this.rulesetID = rulesetID;
  }

  public ApplicationControlPolicyExtension trustRulesetID(String trustRulesetID) {
    this.trustRulesetID = trustRulesetID;
    return this;
  }

   /**
   * ID of the trust ruleset. An empty string will set it to \&quot;None\&quot; and assigning a value of 0 will set it to \&quot;Inherited\&quot;.
   * @return trustRulesetID
  **/
  @ApiModelProperty(value = "ID of the trust ruleset. An empty string will set it to \"None\" and assigning a value of 0 will set it to \"Inherited\".")
  public String getTrustRulesetID() {
    return trustRulesetID;
  }

  public void setTrustRulesetID(String trustRulesetID) {
    this.trustRulesetID = trustRulesetID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApplicationControlPolicyExtension applicationControlPolicyExtension = (ApplicationControlPolicyExtension) o;
    return Objects.equals(this.state, applicationControlPolicyExtension.state) &&
        Objects.equals(this.moduleStatus, applicationControlPolicyExtension.moduleStatus) &&
        Objects.equals(this.blockUnrecognized, applicationControlPolicyExtension.blockUnrecognized) &&
        Objects.equals(this.rulesetID, applicationControlPolicyExtension.rulesetID) &&
        Objects.equals(this.trustRulesetID, applicationControlPolicyExtension.trustRulesetID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(state, moduleStatus, blockUnrecognized, rulesetID, trustRulesetID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApplicationControlPolicyExtension {\n");
    
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("    moduleStatus: ").append(toIndentedString(moduleStatus)).append("\n");
    sb.append("    blockUnrecognized: ").append(toIndentedString(blockUnrecognized)).append("\n");
    sb.append("    rulesetID: ").append(toIndentedString(rulesetID)).append("\n");
    sb.append("    trustRulesetID: ").append(toIndentedString(trustRulesetID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

