/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.DriftRights;
import com.trendmicro.deepsecurity.model.RuleRights;
import com.trendmicro.deepsecurity.model.RulesetRights;
import com.trendmicro.deepsecurity.model.SoftwareInventoryRights;
import com.trendmicro.deepsecurity.model.TrustEntityManagementRights;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Application control rights details.
 */
@ApiModel(description = "Application control rights details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class ApplicationControlRights {
  @JsonProperty("driftRights")
  private DriftRights driftRights = null;

  @JsonProperty("rulesetRights")
  private RulesetRights rulesetRights = null;

  @JsonProperty("ruleRights")
  private RuleRights ruleRights = null;

  @JsonProperty("softwareInventoryRights")
  private SoftwareInventoryRights softwareInventoryRights = null;

  @JsonProperty("trustEntityManagementRights")
  private TrustEntityManagementRights trustEntityManagementRights = null;

  public ApplicationControlRights driftRights(DriftRights driftRights) {
    this.driftRights = driftRights;
    return this;
  }

   /**
   * Rights related to drift.
   * @return driftRights
  **/
  @ApiModelProperty(value = "Rights related to drift.")
  public DriftRights getDriftRights() {
    return driftRights;
  }

  public void setDriftRights(DriftRights driftRights) {
    this.driftRights = driftRights;
  }

  public ApplicationControlRights rulesetRights(RulesetRights rulesetRights) {
    this.rulesetRights = rulesetRights;
    return this;
  }

   /**
   * Rights related to rulesets.
   * @return rulesetRights
  **/
  @ApiModelProperty(value = "Rights related to rulesets.")
  public RulesetRights getRulesetRights() {
    return rulesetRights;
  }

  public void setRulesetRights(RulesetRights rulesetRights) {
    this.rulesetRights = rulesetRights;
  }

  public ApplicationControlRights ruleRights(RuleRights ruleRights) {
    this.ruleRights = ruleRights;
    return this;
  }

   /**
   * Rights related to rules.
   * @return ruleRights
  **/
  @ApiModelProperty(value = "Rights related to rules.")
  public RuleRights getRuleRights() {
    return ruleRights;
  }

  public void setRuleRights(RuleRights ruleRights) {
    this.ruleRights = ruleRights;
  }

  public ApplicationControlRights softwareInventoryRights(SoftwareInventoryRights softwareInventoryRights) {
    this.softwareInventoryRights = softwareInventoryRights;
    return this;
  }

   /**
   * Rights related to software inventory.
   * @return softwareInventoryRights
  **/
  @ApiModelProperty(value = "Rights related to software inventory.")
  public SoftwareInventoryRights getSoftwareInventoryRights() {
    return softwareInventoryRights;
  }

  public void setSoftwareInventoryRights(SoftwareInventoryRights softwareInventoryRights) {
    this.softwareInventoryRights = softwareInventoryRights;
  }

  public ApplicationControlRights trustEntityManagementRights(TrustEntityManagementRights trustEntityManagementRights) {
    this.trustEntityManagementRights = trustEntityManagementRights;
    return this;
  }

   /**
   * Rights related to trust entity management.
   * @return trustEntityManagementRights
  **/
  @ApiModelProperty(value = "Rights related to trust entity management.")
  public TrustEntityManagementRights getTrustEntityManagementRights() {
    return trustEntityManagementRights;
  }

  public void setTrustEntityManagementRights(TrustEntityManagementRights trustEntityManagementRights) {
    this.trustEntityManagementRights = trustEntityManagementRights;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApplicationControlRights applicationControlRights = (ApplicationControlRights) o;
    return Objects.equals(this.driftRights, applicationControlRights.driftRights) &&
        Objects.equals(this.rulesetRights, applicationControlRights.rulesetRights) &&
        Objects.equals(this.ruleRights, applicationControlRights.ruleRights) &&
        Objects.equals(this.softwareInventoryRights, applicationControlRights.softwareInventoryRights) &&
        Objects.equals(this.trustEntityManagementRights, applicationControlRights.trustEntityManagementRights);
  }

  @Override
  public int hashCode() {
    return Objects.hash(driftRights, rulesetRights, ruleRights, softwareInventoryRights, trustEntityManagementRights);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApplicationControlRights {\n");
    
    sb.append("    driftRights: ").append(toIndentedString(driftRights)).append("\n");
    sb.append("    rulesetRights: ").append(toIndentedString(rulesetRights)).append("\n");
    sb.append("    ruleRights: ").append(toIndentedString(ruleRights)).append("\n");
    sb.append("    softwareInventoryRights: ").append(toIndentedString(softwareInventoryRights)).append("\n");
    sb.append("    trustEntityManagementRights: ").append(toIndentedString(trustEntityManagementRights)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

