/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.TrustRuleAttribute;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * TrustRuleset rule details.
 */
@ApiModel(description = "TrustRuleset rule details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class ApplicationControlTrustRule {
  /**
   * Type of the rule. Searchable as Choice.
   */
  public enum TypeEnum {
    ALLOW_FROM_SOURCE_TARGET("allowFromSourceTarget"),
    
    ALLOW_FROM_SOURCE("allowFromSource"),
    
    ALLOW_BY_TARGET("allowByTarget"),
    
    IGNORE_FROM_SOURCE("ignoreFromSource"),
    
    BLOCK_BY_TARGET("blockByTarget");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TypeEnum fromValue(String text) {
      for (TypeEnum b : TypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("type")
  private TypeEnum type = null;

  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("isAssigned")
  private Boolean isAssigned = null;

  @JsonProperty("createdTime")
  private Long createdTime = null;

  @JsonProperty("lastUpdatedTime")
  private Long lastUpdatedTime = null;

  @JsonProperty("rulesetIDs")
  private List<Long> rulesetIDs = null;

  @JsonProperty("attributes")
  private List<TrustRuleAttribute> attributes = null;

  @JsonProperty("ID")
  private Long ID = null;

  public ApplicationControlTrustRule type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * Type of the rule. Searchable as Choice.
   * @return type
  **/
  @ApiModelProperty(value = "Type of the rule. Searchable as Choice.")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }

  public ApplicationControlTrustRule name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the trust rule. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the trust rule. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public ApplicationControlTrustRule description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the trust rule. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the trust rule. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

   /**
   * Whether the rule is assigned to any rulesets
   * @return isAssigned
  **/
  @ApiModelProperty(value = "Whether the rule is assigned to any rulesets")
  public Boolean isIsAssigned() {
    return isAssigned;
  }

   /**
   * Timestamp of the trust rule&#39;s creation, in milliseconds since epoch. Searchable as Date.
   * @return createdTime
  **/
  @ApiModelProperty(value = "Timestamp of the trust rule's creation, in milliseconds since epoch. Searchable as Date.")
  public Long getCreatedTime() {
    return createdTime;
  }

   /**
   * Timestamp of when the trust rule was last updated, in milliseconds since epoch. Searchable as Date.
   * @return lastUpdatedTime
  **/
  @ApiModelProperty(value = "Timestamp of when the trust rule was last updated, in milliseconds since epoch. Searchable as Date.")
  public Long getLastUpdatedTime() {
    return lastUpdatedTime;
  }

   /**
   * IDs of all rulesets that the rule is assigned to.
   * @return rulesetIDs
  **/
  @ApiModelProperty(value = "IDs of all rulesets that the rule is assigned to.")
  public List<Long> getRulesetIDs() {
    return rulesetIDs;
  }

  public ApplicationControlTrustRule attributes(List<TrustRuleAttribute> attributes) {
    this.attributes = attributes;
    return this;
  }

  public ApplicationControlTrustRule addAttributesItem(TrustRuleAttribute attributesItem) {
    if (this.attributes == null) {
      this.attributes = new ArrayList<>();
    }
    this.attributes.add(attributesItem);
    return this;
  }

   /**
   * Attributes that define the trust rule.
   * @return attributes
  **/
  @ApiModelProperty(value = "Attributes that define the trust rule.")
  public List<TrustRuleAttribute> getAttributes() {
    return attributes;
  }

  public void setAttributes(List<TrustRuleAttribute> attributes) {
    this.attributes = attributes;
  }

   /**
   * ID of the trust rule. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the trust rule. Searchable as ID.")
  public Long getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApplicationControlTrustRule applicationControlTrustRule = (ApplicationControlTrustRule) o;
    return Objects.equals(this.type, applicationControlTrustRule.type) &&
        Objects.equals(this.name, applicationControlTrustRule.name) &&
        Objects.equals(this.description, applicationControlTrustRule.description) &&
        Objects.equals(this.isAssigned, applicationControlTrustRule.isAssigned) &&
        Objects.equals(this.createdTime, applicationControlTrustRule.createdTime) &&
        Objects.equals(this.lastUpdatedTime, applicationControlTrustRule.lastUpdatedTime) &&
        Objects.equals(this.rulesetIDs, applicationControlTrustRule.rulesetIDs) &&
        Objects.equals(this.attributes, applicationControlTrustRule.attributes) &&
        Objects.equals(this.ID, applicationControlTrustRule.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(type, name, description, isAssigned, createdTime, lastUpdatedTime, rulesetIDs, attributes, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApplicationControlTrustRule {\n");
    
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    isAssigned: ").append(toIndentedString(isAssigned)).append("\n");
    sb.append("    createdTime: ").append(toIndentedString(createdTime)).append("\n");
    sb.append("    lastUpdatedTime: ").append(toIndentedString(lastUpdatedTime)).append("\n");
    sb.append("    rulesetIDs: ").append(toIndentedString(rulesetIDs)).append("\n");
    sb.append("    attributes: ").append(toIndentedString(attributes)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

