/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.VirtualMachineMetadata;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Details of an Azure virtual machine that is managed using the Azure Resource Manager (ARM).
 */
@ApiModel(description = "Details of an Azure virtual machine that is managed using the Azure Resource Manager (ARM).")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class AzureARMVirtualMachineSummary {
  @JsonProperty("cloudProvider")
  private String cloudProvider = null;

  @JsonProperty("subscriptionID")
  private String subscriptionID = null;

  @JsonProperty("deploymentModel")
  private String deploymentModel = null;

  @JsonProperty("resourceGroup")
  private String resourceGroup = null;

  @JsonProperty("state")
  private String state = null;

  @JsonProperty("location")
  private String location = null;

  @JsonProperty("type")
  private String type = null;

  @JsonProperty("operatingSystem")
  private String operatingSystem = null;

  @JsonProperty("publicIPAddress")
  private String publicIPAddress = null;

  @JsonProperty("privateIPAddress")
  private String privateIPAddress = null;

  @JsonProperty("cloudService")
  private String cloudService = null;

  @JsonProperty("deploymentID")
  private String deploymentID = null;

  @JsonProperty("imageID")
  private String imageID = null;

  @JsonProperty("securityGroup")
  private String securityGroup = null;

  @JsonProperty("metadata")
  private List<VirtualMachineMetadata> metadata = null;

  @JsonProperty("DNSName")
  private String dnSName = null;

  public AzureARMVirtualMachineSummary cloudProvider(String cloudProvider) {
    this.cloudProvider = cloudProvider;
    return this;
  }

   /**
   * Cloud provider: \&quot;Azure\&quot;.
   * @return cloudProvider
  **/
  @ApiModelProperty(value = "Cloud provider: \"Azure\".")
  public String getCloudProvider() {
    return cloudProvider;
  }

  public void setCloudProvider(String cloudProvider) {
    this.cloudProvider = cloudProvider;
  }

  public AzureARMVirtualMachineSummary subscriptionID(String subscriptionID) {
    this.subscriptionID = subscriptionID;
    return this;
  }

   /**
   * Subscription ID. Searchable as String.
   * @return subscriptionID
  **/
  @ApiModelProperty(value = "Subscription ID. Searchable as String.")
  public String getSubscriptionID() {
    return subscriptionID;
  }

  public void setSubscriptionID(String subscriptionID) {
    this.subscriptionID = subscriptionID;
  }

  public AzureARMVirtualMachineSummary deploymentModel(String deploymentModel) {
    this.deploymentModel = deploymentModel;
    return this;
  }

   /**
   * Deployment model: \&quot;Classic\&quot; or \&quot;Resource Manager\&quot;.
   * @return deploymentModel
  **/
  @ApiModelProperty(value = "Deployment model: \"Classic\" or \"Resource Manager\".")
  public String getDeploymentModel() {
    return deploymentModel;
  }

  public void setDeploymentModel(String deploymentModel) {
    this.deploymentModel = deploymentModel;
  }

  public AzureARMVirtualMachineSummary resourceGroup(String resourceGroup) {
    this.resourceGroup = resourceGroup;
    return this;
  }

   /**
   * Name of resource group. Searchable as String.
   * @return resourceGroup
  **/
  @ApiModelProperty(value = "Name of resource group. Searchable as String.")
  public String getResourceGroup() {
    return resourceGroup;
  }

  public void setResourceGroup(String resourceGroup) {
    this.resourceGroup = resourceGroup;
  }

  public AzureARMVirtualMachineSummary state(String state) {
    this.state = state;
    return this;
  }

   /**
   * Power state, for example, \&quot;POWER ON\&quot;.
   * @return state
  **/
  @ApiModelProperty(value = "Power state, for example, \"POWER ON\".")
  public String getState() {
    return state;
  }

  public void setState(String state) {
    this.state = state;
  }

  public AzureARMVirtualMachineSummary location(String location) {
    this.location = location;
    return this;
  }

   /**
   * Physical location of the resource, for example: \&quot;East US\&quot;. Searchable as String.
   * @return location
  **/
  @ApiModelProperty(value = "Physical location of the resource, for example: \"East US\". Searchable as String.")
  public String getLocation() {
    return location;
  }

  public void setLocation(String location) {
    this.location = location;
  }

  public AzureARMVirtualMachineSummary type(String type) {
    this.type = type;
    return this;
  }

   /**
   * Hardware type, for example: \&quot;Standard_DS1_v2\&quot;. Searchable as String.
   * @return type
  **/
  @ApiModelProperty(value = "Hardware type, for example: \"Standard_DS1_v2\". Searchable as String.")
  public String getType() {
    return type;
  }

  public void setType(String type) {
    this.type = type;
  }

  public AzureARMVirtualMachineSummary operatingSystem(String operatingSystem) {
    this.operatingSystem = operatingSystem;
    return this;
  }

   /**
   * Operating system, for example: \&quot;Microsoft Windows\&quot;. Searchable as String.
   * @return operatingSystem
  **/
  @ApiModelProperty(value = "Operating system, for example: \"Microsoft Windows\". Searchable as String.")
  public String getOperatingSystem() {
    return operatingSystem;
  }

  public void setOperatingSystem(String operatingSystem) {
    this.operatingSystem = operatingSystem;
  }

  public AzureARMVirtualMachineSummary publicIPAddress(String publicIPAddress) {
    this.publicIPAddress = publicIPAddress;
    return this;
  }

   /**
   * Public IP address. Searchable as String.
   * @return publicIPAddress
  **/
  @ApiModelProperty(value = "Public IP address. Searchable as String.")
  public String getPublicIPAddress() {
    return publicIPAddress;
  }

  public void setPublicIPAddress(String publicIPAddress) {
    this.publicIPAddress = publicIPAddress;
  }

  public AzureARMVirtualMachineSummary privateIPAddress(String privateIPAddress) {
    this.privateIPAddress = privateIPAddress;
    return this;
  }

   /**
   * Private IP address. Searchable as String.
   * @return privateIPAddress
  **/
  @ApiModelProperty(value = "Private IP address. Searchable as String.")
  public String getPrivateIPAddress() {
    return privateIPAddress;
  }

  public void setPrivateIPAddress(String privateIPAddress) {
    this.privateIPAddress = privateIPAddress;
  }

  public AzureARMVirtualMachineSummary cloudService(String cloudService) {
    this.cloudService = cloudService;
    return this;
  }

   /**
   * Cloud service, for example: \&quot;DH-DC\&quot;. Searchable as String.
   * @return cloudService
  **/
  @ApiModelProperty(value = "Cloud service, for example: \"DH-DC\". Searchable as String.")
  public String getCloudService() {
    return cloudService;
  }

  public void setCloudService(String cloudService) {
    this.cloudService = cloudService;
  }

  public AzureARMVirtualMachineSummary deploymentID(String deploymentID) {
    this.deploymentID = deploymentID;
    return this;
  }

   /**
   * Deployment ID, for example: \&quot;76ab36a0fb8d4c4ab6b802acdf58b3a4\&quot;. Searchable as String.
   * @return deploymentID
  **/
  @ApiModelProperty(value = "Deployment ID, for example: \"76ab36a0fb8d4c4ab6b802acdf58b3a4\". Searchable as String.")
  public String getDeploymentID() {
    return deploymentID;
  }

  public void setDeploymentID(String deploymentID) {
    this.deploymentID = deploymentID;
  }

  public AzureARMVirtualMachineSummary imageID(String imageID) {
    this.imageID = imageID;
    return this;
  }

   /**
   * Image ID, for example: \&quot;a699494373c04fc0bc8f2bb1389d6106__Windows-Server-2012-R2-201503.01-en.us-127GB.vhd\&quot;. Searchable as String.
   * @return imageID
  **/
  @ApiModelProperty(value = "Image ID, for example: \"a699494373c04fc0bc8f2bb1389d6106__Windows-Server-2012-R2-201503.01-en.us-127GB.vhd\". Searchable as String.")
  public String getImageID() {
    return imageID;
  }

  public void setImageID(String imageID) {
    this.imageID = imageID;
  }

  public AzureARMVirtualMachineSummary securityGroup(String securityGroup) {
    this.securityGroup = securityGroup;
    return this;
  }

   /**
   * Network security group, for example: \&quot;bh-Win10Pro-1-nsg\&quot;. Searchable as String.
   * @return securityGroup
  **/
  @ApiModelProperty(value = "Network security group, for example: \"bh-Win10Pro-1-nsg\". Searchable as String.")
  public String getSecurityGroup() {
    return securityGroup;
  }

  public void setSecurityGroup(String securityGroup) {
    this.securityGroup = securityGroup;
  }

  public AzureARMVirtualMachineSummary metadata(List<VirtualMachineMetadata> metadata) {
    this.metadata = metadata;
    return this;
  }

  public AzureARMVirtualMachineSummary addMetadataItem(VirtualMachineMetadata metadataItem) {
    if (this.metadata == null) {
      this.metadata = new ArrayList<>();
    }
    this.metadata.add(metadataItem);
    return this;
  }

   /**
   * List of tag name/value metadata pairs.
   * @return metadata
  **/
  @ApiModelProperty(value = "List of tag name/value metadata pairs.")
  public List<VirtualMachineMetadata> getMetadata() {
    return metadata;
  }

  public void setMetadata(List<VirtualMachineMetadata> metadata) {
    this.metadata = metadata;
  }

  public AzureARMVirtualMachineSummary dnSName(String dnSName) {
    this.dnSName = dnSName;
    return this;
  }

   /**
   * Get dnSName
   * @return dnSName
  **/
  @ApiModelProperty(value = "")
  public String getDnSName() {
    return dnSName;
  }

  public void setDnSName(String dnSName) {
    this.dnSName = dnSName;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    AzureARMVirtualMachineSummary azureARMVirtualMachineSummary = (AzureARMVirtualMachineSummary) o;
    return Objects.equals(this.cloudProvider, azureARMVirtualMachineSummary.cloudProvider) &&
        Objects.equals(this.subscriptionID, azureARMVirtualMachineSummary.subscriptionID) &&
        Objects.equals(this.deploymentModel, azureARMVirtualMachineSummary.deploymentModel) &&
        Objects.equals(this.resourceGroup, azureARMVirtualMachineSummary.resourceGroup) &&
        Objects.equals(this.state, azureARMVirtualMachineSummary.state) &&
        Objects.equals(this.location, azureARMVirtualMachineSummary.location) &&
        Objects.equals(this.type, azureARMVirtualMachineSummary.type) &&
        Objects.equals(this.operatingSystem, azureARMVirtualMachineSummary.operatingSystem) &&
        Objects.equals(this.publicIPAddress, azureARMVirtualMachineSummary.publicIPAddress) &&
        Objects.equals(this.privateIPAddress, azureARMVirtualMachineSummary.privateIPAddress) &&
        Objects.equals(this.cloudService, azureARMVirtualMachineSummary.cloudService) &&
        Objects.equals(this.deploymentID, azureARMVirtualMachineSummary.deploymentID) &&
        Objects.equals(this.imageID, azureARMVirtualMachineSummary.imageID) &&
        Objects.equals(this.securityGroup, azureARMVirtualMachineSummary.securityGroup) &&
        Objects.equals(this.metadata, azureARMVirtualMachineSummary.metadata) &&
        Objects.equals(this.dnSName, azureARMVirtualMachineSummary.dnSName);
  }

  @Override
  public int hashCode() {
    return Objects.hash(cloudProvider, subscriptionID, deploymentModel, resourceGroup, state, location, type, operatingSystem, publicIPAddress, privateIPAddress, cloudService, deploymentID, imageID, securityGroup, metadata, dnSName);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class AzureARMVirtualMachineSummary {\n");
    
    sb.append("    cloudProvider: ").append(toIndentedString(cloudProvider)).append("\n");
    sb.append("    subscriptionID: ").append(toIndentedString(subscriptionID)).append("\n");
    sb.append("    deploymentModel: ").append(toIndentedString(deploymentModel)).append("\n");
    sb.append("    resourceGroup: ").append(toIndentedString(resourceGroup)).append("\n");
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("    location: ").append(toIndentedString(location)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    operatingSystem: ").append(toIndentedString(operatingSystem)).append("\n");
    sb.append("    publicIPAddress: ").append(toIndentedString(publicIPAddress)).append("\n");
    sb.append("    privateIPAddress: ").append(toIndentedString(privateIPAddress)).append("\n");
    sb.append("    cloudService: ").append(toIndentedString(cloudService)).append("\n");
    sb.append("    deploymentID: ").append(toIndentedString(deploymentID)).append("\n");
    sb.append("    imageID: ").append(toIndentedString(imageID)).append("\n");
    sb.append("    securityGroup: ").append(toIndentedString(securityGroup)).append("\n");
    sb.append("    metadata: ").append(toIndentedString(metadata)).append("\n");
    sb.append("    dnSName: ").append(toIndentedString(dnSName)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

