/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Defines an Azure Cloud Connector that is used to retrieve information from Azure.
 */
@ApiModel(description = "Defines an Azure Cloud Connector that is used to retrieve information from Azure.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class AzureConnector {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("azureTenantID")
  private String azureTenantID = null;

  @JsonProperty("subscriptionID")
  private String subscriptionID = null;

  @JsonProperty("azureAdApplicationID")
  private String azureAdApplicationID = null;

  @JsonProperty("azureAdApplicationSecret")
  private String azureAdApplicationSecret = null;

  @JsonProperty("azureAdApplicationCertificate")
  private String azureAdApplicationCertificate = null;

  @JsonProperty("azureAdApplicationPrivateKey")
  private String azureAdApplicationPrivateKey = null;

  @JsonProperty("azureAdApplicationPrivateKeySecret")
  private String azureAdApplicationPrivateKeySecret = null;

  @JsonProperty("azureAdApplicationCertificateExpirationDate")
  private Long azureAdApplicationCertificateExpirationDate = null;

  @JsonProperty("resourceApiEndPoint")
  private String resourceApiEndPoint = null;

  @JsonProperty("loginApiEndPoint")
  private String loginApiEndPoint = null;

  @JsonProperty("lastSyncTime")
  private Long lastSyncTime = null;

  @JsonProperty("ID")
  private Integer ID = null;

  public AzureConnector name(String name) {
    this.name = name;
    return this;
  }

   /**
   * The Azure Connector&#39;s display name in DSM. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "The Azure Connector's display name in DSM. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public AzureConnector azureTenantID(String azureTenantID) {
    this.azureTenantID = azureTenantID;
    return this;
  }

   /**
   * The Microsoft Entra tenant ID (formly Azure Tenant/Active Directory ID). Searchable as String.
   * @return azureTenantID
  **/
  @ApiModelProperty(value = "The Microsoft Entra tenant ID (formly Azure Tenant/Active Directory ID). Searchable as String.")
  public String getAzureTenantID() {
    return azureTenantID;
  }

  public void setAzureTenantID(String azureTenantID) {
    this.azureTenantID = azureTenantID;
  }

  public AzureConnector subscriptionID(String subscriptionID) {
    this.subscriptionID = subscriptionID;
    return this;
  }

   /**
   * The Azure Subscription ID. Searchable as String.
   * @return subscriptionID
  **/
  @ApiModelProperty(value = "The Azure Subscription ID. Searchable as String.")
  public String getSubscriptionID() {
    return subscriptionID;
  }

  public void setSubscriptionID(String subscriptionID) {
    this.subscriptionID = subscriptionID;
  }

  public AzureConnector azureAdApplicationID(String azureAdApplicationID) {
    this.azureAdApplicationID = azureAdApplicationID;
    return this;
  }

   /**
   * The Microsoft Entra ID (formerly Azure Active Directory) Application ID. Searchable as String.
   * @return azureAdApplicationID
  **/
  @ApiModelProperty(value = "The Microsoft Entra ID (formerly Azure Active Directory) Application ID. Searchable as String.")
  public String getAzureAdApplicationID() {
    return azureAdApplicationID;
  }

  public void setAzureAdApplicationID(String azureAdApplicationID) {
    this.azureAdApplicationID = azureAdApplicationID;
  }

  public AzureConnector azureAdApplicationSecret(String azureAdApplicationSecret) {
    this.azureAdApplicationSecret = azureAdApplicationSecret;
    return this;
  }

   /**
   * The Microsoft Entra ID (formerly Azure Active Directory) Application secret/password. Not present in returned objects.
   * @return azureAdApplicationSecret
  **/
  @ApiModelProperty(value = "The Microsoft Entra ID (formerly Azure Active Directory) Application secret/password. Not present in returned objects.")
  public String getAzureAdApplicationSecret() {
    return azureAdApplicationSecret;
  }

  public void setAzureAdApplicationSecret(String azureAdApplicationSecret) {
    this.azureAdApplicationSecret = azureAdApplicationSecret;
  }

  public AzureConnector azureAdApplicationCertificate(String azureAdApplicationCertificate) {
    this.azureAdApplicationCertificate = azureAdApplicationCertificate;
    return this;
  }

   /**
   * The Microsoft Entra ID (formerly Azure Active Directory) Application certificate for authentication. The certificate should be in X.509 PEM format and encoded in Base64. Not present in returned objects.
   * @return azureAdApplicationCertificate
  **/
  @ApiModelProperty(value = "The Microsoft Entra ID (formerly Azure Active Directory) Application certificate for authentication. The certificate should be in X.509 PEM format and encoded in Base64. Not present in returned objects.")
  public String getAzureAdApplicationCertificate() {
    return azureAdApplicationCertificate;
  }

  public void setAzureAdApplicationCertificate(String azureAdApplicationCertificate) {
    this.azureAdApplicationCertificate = azureAdApplicationCertificate;
  }

  public AzureConnector azureAdApplicationPrivateKey(String azureAdApplicationPrivateKey) {
    this.azureAdApplicationPrivateKey = azureAdApplicationPrivateKey;
    return this;
  }

   /**
   * The Microsoft Entra ID (formerly Azure Active Directory) Application private key of azureAdApplicationCertificate. The private key should be in PEM format and encoded in Base64. Not present in returned objects.
   * @return azureAdApplicationPrivateKey
  **/
  @ApiModelProperty(value = "The Microsoft Entra ID (formerly Azure Active Directory) Application private key of azureAdApplicationCertificate. The private key should be in PEM format and encoded in Base64. Not present in returned objects.")
  public String getAzureAdApplicationPrivateKey() {
    return azureAdApplicationPrivateKey;
  }

  public void setAzureAdApplicationPrivateKey(String azureAdApplicationPrivateKey) {
    this.azureAdApplicationPrivateKey = azureAdApplicationPrivateKey;
  }

  public AzureConnector azureAdApplicationPrivateKeySecret(String azureAdApplicationPrivateKeySecret) {
    this.azureAdApplicationPrivateKeySecret = azureAdApplicationPrivateKeySecret;
    return this;
  }

   /**
   * The optional secret of Microsoft Entra ID (formerly Azure Active Directory) Application private key if the private key is protected with secret/password.
   * @return azureAdApplicationPrivateKeySecret
  **/
  @ApiModelProperty(value = "The optional secret of Microsoft Entra ID (formerly Azure Active Directory) Application private key if the private key is protected with secret/password.")
  public String getAzureAdApplicationPrivateKeySecret() {
    return azureAdApplicationPrivateKeySecret;
  }

  public void setAzureAdApplicationPrivateKeySecret(String azureAdApplicationPrivateKeySecret) {
    this.azureAdApplicationPrivateKeySecret = azureAdApplicationPrivateKeySecret;
  }

   /**
   * Expiration timestamp of the the Microsoft Entra ID (formerly Azure Active Directory) Application certificate, in milliseconds since epoch.
   * @return azureAdApplicationCertificateExpirationDate
  **/
  @ApiModelProperty(value = "Expiration timestamp of the the Microsoft Entra ID (formerly Azure Active Directory) Application certificate, in milliseconds since epoch.")
  public Long getAzureAdApplicationCertificateExpirationDate() {
    return azureAdApplicationCertificateExpirationDate;
  }

  public AzureConnector resourceApiEndPoint(String resourceApiEndPoint) {
    this.resourceApiEndPoint = resourceApiEndPoint;
    return this;
  }

   /**
   * The optional Azure Resource REST API endpoint. Will auto detect by DSM VM location if not provided. This is an advanced option used if you want to access private or confidential cloud. Be aware that managing Azure Government computers outside Azure Government would break ITAR compliance.
   * @return resourceApiEndPoint
  **/
  @ApiModelProperty(value = "The optional Azure Resource REST API endpoint. Will auto detect by DSM VM location if not provided. This is an advanced option used if you want to access private or confidential cloud. Be aware that managing Azure Government computers outside Azure Government would break ITAR compliance.")
  public String getResourceApiEndPoint() {
    return resourceApiEndPoint;
  }

  public void setResourceApiEndPoint(String resourceApiEndPoint) {
    this.resourceApiEndPoint = resourceApiEndPoint;
  }

  public AzureConnector loginApiEndPoint(String loginApiEndPoint) {
    this.loginApiEndPoint = loginApiEndPoint;
    return this;
  }

   /**
   * The optional Microsoft Entra ID (formerly Azure Active Directory) Login/Authentication API endpoint. Will auto detect by DSM VM location if not provided. This is an advanced option used if you want to access private or confidential cloud. Be aware that managing Azure Government computers outside Azure Government would break ITAR compliance.
   * @return loginApiEndPoint
  **/
  @ApiModelProperty(value = "The optional Microsoft Entra ID (formerly Azure Active Directory) Login/Authentication API endpoint. Will auto detect by DSM VM location if not provided. This is an advanced option used if you want to access private or confidential cloud. Be aware that managing Azure Government computers outside Azure Government would break ITAR compliance.")
  public String getLoginApiEndPoint() {
    return loginApiEndPoint;
  }

  public void setLoginApiEndPoint(String loginApiEndPoint) {
    this.loginApiEndPoint = loginApiEndPoint;
  }

   /**
   * Timestamp of the last time the Azure Connector was successfully synchronized, in milliseconds since epoch.
   * @return lastSyncTime
  **/
  @ApiModelProperty(value = "Timestamp of the last time the Azure Connector was successfully synchronized, in milliseconds since epoch.")
  public Long getLastSyncTime() {
    return lastSyncTime;
  }

   /**
   * Azure Connector ID. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "Azure Connector ID. Searchable as ID.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    AzureConnector azureConnector = (AzureConnector) o;
    return Objects.equals(this.name, azureConnector.name) &&
        Objects.equals(this.azureTenantID, azureConnector.azureTenantID) &&
        Objects.equals(this.subscriptionID, azureConnector.subscriptionID) &&
        Objects.equals(this.azureAdApplicationID, azureConnector.azureAdApplicationID) &&
        Objects.equals(this.azureAdApplicationSecret, azureConnector.azureAdApplicationSecret) &&
        Objects.equals(this.azureAdApplicationCertificate, azureConnector.azureAdApplicationCertificate) &&
        Objects.equals(this.azureAdApplicationPrivateKey, azureConnector.azureAdApplicationPrivateKey) &&
        Objects.equals(this.azureAdApplicationPrivateKeySecret, azureConnector.azureAdApplicationPrivateKeySecret) &&
        Objects.equals(this.azureAdApplicationCertificateExpirationDate, azureConnector.azureAdApplicationCertificateExpirationDate) &&
        Objects.equals(this.resourceApiEndPoint, azureConnector.resourceApiEndPoint) &&
        Objects.equals(this.loginApiEndPoint, azureConnector.loginApiEndPoint) &&
        Objects.equals(this.lastSyncTime, azureConnector.lastSyncTime) &&
        Objects.equals(this.ID, azureConnector.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, azureTenantID, subscriptionID, azureAdApplicationID, azureAdApplicationSecret, azureAdApplicationCertificate, azureAdApplicationPrivateKey, azureAdApplicationPrivateKeySecret, azureAdApplicationCertificateExpirationDate, resourceApiEndPoint, loginApiEndPoint, lastSyncTime, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class AzureConnector {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    azureTenantID: ").append(toIndentedString(azureTenantID)).append("\n");
    sb.append("    subscriptionID: ").append(toIndentedString(subscriptionID)).append("\n");
    sb.append("    azureAdApplicationID: ").append(toIndentedString(azureAdApplicationID)).append("\n");
    sb.append("    azureAdApplicationSecret: ").append(toIndentedString(azureAdApplicationSecret)).append("\n");
    sb.append("    azureAdApplicationCertificate: ").append(toIndentedString(azureAdApplicationCertificate)).append("\n");
    sb.append("    azureAdApplicationPrivateKey: ").append(toIndentedString(azureAdApplicationPrivateKey)).append("\n");
    sb.append("    azureAdApplicationPrivateKeySecret: ").append(toIndentedString(azureAdApplicationPrivateKeySecret)).append("\n");
    sb.append("    azureAdApplicationCertificateExpirationDate: ").append(toIndentedString(azureAdApplicationCertificateExpirationDate)).append("\n");
    sb.append("    resourceApiEndPoint: ").append(toIndentedString(resourceApiEndPoint)).append("\n");
    sb.append("    loginApiEndPoint: ").append(toIndentedString(loginApiEndPoint)).append("\n");
    sb.append("    lastSyncTime: ").append(toIndentedString(lastSyncTime)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

