/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.WorkloadSecurityProxy;
import com.trendmicro.deepsecurity.model.WorkloadSecurityRelayProxy;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Batch move computers task
 */
@ApiModel(description = "Batch move computers task")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class BatchComputerMoveTask {
  @JsonProperty("workloadSecurityPolicyID")
  private Long workloadSecurityPolicyID = null;

  @JsonProperty("workloadSecurityComputerGroupID")
  private Long workloadSecurityComputerGroupID = null;

  @JsonProperty("workloadSecurityRelayGroupID")
  private Long workloadSecurityRelayGroupID = null;

  @JsonProperty("workloadSecurityProxy")
  private WorkloadSecurityProxy workloadSecurityProxy = null;

  @JsonProperty("proxyIDToContactWorkloadSecurity")
  private Integer proxyIDToContactWorkloadSecurity = null;

  @JsonProperty("workloadSecurityRelayProxy")
  private WorkloadSecurityRelayProxy workloadSecurityRelayProxy = null;

  @JsonProperty("proxyIDToContactWorkloadSecurityRelay")
  private Integer proxyIDToContactWorkloadSecurityRelay = null;

  @JsonProperty("includeComputerOverrides")
  private Boolean includeComputerOverrides = null;

  @JsonProperty("includeComputerDescription")
  private Boolean includeComputerDescription = null;

  @JsonProperty("referToLatestMigratedPolicy")
  private Boolean referToLatestMigratedPolicy = null;

  @JsonProperty("computerIDs")
  private List<Integer> computerIDs = new ArrayList<>();

  public BatchComputerMoveTask workloadSecurityPolicyID(Long workloadSecurityPolicyID) {
    this.workloadSecurityPolicyID = workloadSecurityPolicyID;
    return this;
  }

   /**
   * Policy ID in Workload Security.
   * @return workloadSecurityPolicyID
  **/
  @ApiModelProperty(value = "Policy ID in Workload Security.")
  public Long getWorkloadSecurityPolicyID() {
    return workloadSecurityPolicyID;
  }

  public void setWorkloadSecurityPolicyID(Long workloadSecurityPolicyID) {
    this.workloadSecurityPolicyID = workloadSecurityPolicyID;
  }

  public BatchComputerMoveTask workloadSecurityComputerGroupID(Long workloadSecurityComputerGroupID) {
    this.workloadSecurityComputerGroupID = workloadSecurityComputerGroupID;
    return this;
  }

   /**
   * Computer Group ID in Workload Security.
   * @return workloadSecurityComputerGroupID
  **/
  @ApiModelProperty(value = "Computer Group ID in Workload Security.")
  public Long getWorkloadSecurityComputerGroupID() {
    return workloadSecurityComputerGroupID;
  }

  public void setWorkloadSecurityComputerGroupID(Long workloadSecurityComputerGroupID) {
    this.workloadSecurityComputerGroupID = workloadSecurityComputerGroupID;
  }

  public BatchComputerMoveTask workloadSecurityRelayGroupID(Long workloadSecurityRelayGroupID) {
    this.workloadSecurityRelayGroupID = workloadSecurityRelayGroupID;
    return this;
  }

   /**
   * Relay Group ID in Workload Security.
   * @return workloadSecurityRelayGroupID
  **/
  @ApiModelProperty(value = "Relay Group ID in Workload Security.")
  public Long getWorkloadSecurityRelayGroupID() {
    return workloadSecurityRelayGroupID;
  }

  public void setWorkloadSecurityRelayGroupID(Long workloadSecurityRelayGroupID) {
    this.workloadSecurityRelayGroupID = workloadSecurityRelayGroupID;
  }

  public BatchComputerMoveTask workloadSecurityProxy(WorkloadSecurityProxy workloadSecurityProxy) {
    this.workloadSecurityProxy = workloadSecurityProxy;
    return this;
  }

   /**
   * Workload Security proxy for agent.
   * @return workloadSecurityProxy
  **/
  @ApiModelProperty(value = "Workload Security proxy for agent.")
  public WorkloadSecurityProxy getWorkloadSecurityProxy() {
    return workloadSecurityProxy;
  }

  public void setWorkloadSecurityProxy(WorkloadSecurityProxy workloadSecurityProxy) {
    this.workloadSecurityProxy = workloadSecurityProxy;
  }

  public BatchComputerMoveTask proxyIDToContactWorkloadSecurity(Integer proxyIDToContactWorkloadSecurity) {
    this.proxyIDToContactWorkloadSecurity = proxyIDToContactWorkloadSecurity;
    return this;
  }

   /**
   * Deep Security proxy ID for the computer to contact to Workload Security.
   * @return proxyIDToContactWorkloadSecurity
  **/
  @ApiModelProperty(value = "Deep Security proxy ID for the computer to contact to Workload Security.")
  public Integer getProxyIDToContactWorkloadSecurity() {
    return proxyIDToContactWorkloadSecurity;
  }

  public void setProxyIDToContactWorkloadSecurity(Integer proxyIDToContactWorkloadSecurity) {
    this.proxyIDToContactWorkloadSecurity = proxyIDToContactWorkloadSecurity;
  }

  public BatchComputerMoveTask workloadSecurityRelayProxy(WorkloadSecurityRelayProxy workloadSecurityRelayProxy) {
    this.workloadSecurityRelayProxy = workloadSecurityRelayProxy;
    return this;
  }

   /**
   * Workload Security relay proxy of agent.
   * @return workloadSecurityRelayProxy
  **/
  @ApiModelProperty(value = "Workload Security relay proxy of agent.")
  public WorkloadSecurityRelayProxy getWorkloadSecurityRelayProxy() {
    return workloadSecurityRelayProxy;
  }

  public void setWorkloadSecurityRelayProxy(WorkloadSecurityRelayProxy workloadSecurityRelayProxy) {
    this.workloadSecurityRelayProxy = workloadSecurityRelayProxy;
  }

  public BatchComputerMoveTask proxyIDToContactWorkloadSecurityRelay(Integer proxyIDToContactWorkloadSecurityRelay) {
    this.proxyIDToContactWorkloadSecurityRelay = proxyIDToContactWorkloadSecurityRelay;
    return this;
  }

   /**
   * Deep Security proxy ID for the computer to contact to Workload Security relays.
   * @return proxyIDToContactWorkloadSecurityRelay
  **/
  @ApiModelProperty(value = "Deep Security proxy ID for the computer to contact to Workload Security relays.")
  public Integer getProxyIDToContactWorkloadSecurityRelay() {
    return proxyIDToContactWorkloadSecurityRelay;
  }

  public void setProxyIDToContactWorkloadSecurityRelay(Integer proxyIDToContactWorkloadSecurityRelay) {
    this.proxyIDToContactWorkloadSecurityRelay = proxyIDToContactWorkloadSecurityRelay;
  }

  public BatchComputerMoveTask includeComputerOverrides(Boolean includeComputerOverrides) {
    this.includeComputerOverrides = includeComputerOverrides;
    return this;
  }

   /**
   * Controls whether the Computer Move Task moves setting is overridden at the computer level. Defaults to &#x60;true&#x60;.
   * @return includeComputerOverrides
  **/
  @ApiModelProperty(value = "Controls whether the Computer Move Task moves setting is overridden at the computer level. Defaults to `true`.")
  public Boolean isIncludeComputerOverrides() {
    return includeComputerOverrides;
  }

  public void setIncludeComputerOverrides(Boolean includeComputerOverrides) {
    this.includeComputerOverrides = includeComputerOverrides;
  }

  public BatchComputerMoveTask includeComputerDescription(Boolean includeComputerDescription) {
    this.includeComputerDescription = includeComputerDescription;
    return this;
  }

   /**
   * Controls whether the Computer Move Task moves the hostname, display name, and description. Defaults to &#x60;true&#x60;.
   * @return includeComputerDescription
  **/
  @ApiModelProperty(value = "Controls whether the Computer Move Task moves the hostname, display name, and description. Defaults to `true`.")
  public Boolean isIncludeComputerDescription() {
    return includeComputerDescription;
  }

  public void setIncludeComputerDescription(Boolean includeComputerDescription) {
    this.includeComputerDescription = includeComputerDescription;
  }

  public BatchComputerMoveTask referToLatestMigratedPolicy(Boolean referToLatestMigratedPolicy) {
    this.referToLatestMigratedPolicy = referToLatestMigratedPolicy;
    return this;
  }

   /**
   * Controls whether the last successfully migrated policies are assigned to the computers.
   * @return referToLatestMigratedPolicy
  **/
  @ApiModelProperty(value = "Controls whether the last successfully migrated policies are assigned to the computers.")
  public Boolean isReferToLatestMigratedPolicy() {
    return referToLatestMigratedPolicy;
  }

  public void setReferToLatestMigratedPolicy(Boolean referToLatestMigratedPolicy) {
    this.referToLatestMigratedPolicy = referToLatestMigratedPolicy;
  }

  public BatchComputerMoveTask computerIDs(List<Integer> computerIDs) {
    this.computerIDs = computerIDs;
    return this;
  }

  public BatchComputerMoveTask addComputerIDsItem(Integer computerIDsItem) {
    this.computerIDs.add(computerIDsItem);
    return this;
  }

   /**
   * Target computers to move.
   * @return computerIDs
  **/
  @ApiModelProperty(required = true, value = "Target computers to move.")
  public List<Integer> getComputerIDs() {
    return computerIDs;
  }

  public void setComputerIDs(List<Integer> computerIDs) {
    this.computerIDs = computerIDs;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    BatchComputerMoveTask batchComputerMoveTask = (BatchComputerMoveTask) o;
    return Objects.equals(this.workloadSecurityPolicyID, batchComputerMoveTask.workloadSecurityPolicyID) &&
        Objects.equals(this.workloadSecurityComputerGroupID, batchComputerMoveTask.workloadSecurityComputerGroupID) &&
        Objects.equals(this.workloadSecurityRelayGroupID, batchComputerMoveTask.workloadSecurityRelayGroupID) &&
        Objects.equals(this.workloadSecurityProxy, batchComputerMoveTask.workloadSecurityProxy) &&
        Objects.equals(this.proxyIDToContactWorkloadSecurity, batchComputerMoveTask.proxyIDToContactWorkloadSecurity) &&
        Objects.equals(this.workloadSecurityRelayProxy, batchComputerMoveTask.workloadSecurityRelayProxy) &&
        Objects.equals(this.proxyIDToContactWorkloadSecurityRelay, batchComputerMoveTask.proxyIDToContactWorkloadSecurityRelay) &&
        Objects.equals(this.includeComputerOverrides, batchComputerMoveTask.includeComputerOverrides) &&
        Objects.equals(this.includeComputerDescription, batchComputerMoveTask.includeComputerDescription) &&
        Objects.equals(this.referToLatestMigratedPolicy, batchComputerMoveTask.referToLatestMigratedPolicy) &&
        Objects.equals(this.computerIDs, batchComputerMoveTask.computerIDs);
  }

  @Override
  public int hashCode() {
    return Objects.hash(workloadSecurityPolicyID, workloadSecurityComputerGroupID, workloadSecurityRelayGroupID, workloadSecurityProxy, proxyIDToContactWorkloadSecurity, workloadSecurityRelayProxy, proxyIDToContactWorkloadSecurityRelay, includeComputerOverrides, includeComputerDescription, referToLatestMigratedPolicy, computerIDs);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class BatchComputerMoveTask {\n");
    
    sb.append("    workloadSecurityPolicyID: ").append(toIndentedString(workloadSecurityPolicyID)).append("\n");
    sb.append("    workloadSecurityComputerGroupID: ").append(toIndentedString(workloadSecurityComputerGroupID)).append("\n");
    sb.append("    workloadSecurityRelayGroupID: ").append(toIndentedString(workloadSecurityRelayGroupID)).append("\n");
    sb.append("    workloadSecurityProxy: ").append(toIndentedString(workloadSecurityProxy)).append("\n");
    sb.append("    proxyIDToContactWorkloadSecurity: ").append(toIndentedString(proxyIDToContactWorkloadSecurity)).append("\n");
    sb.append("    workloadSecurityRelayProxy: ").append(toIndentedString(workloadSecurityRelayProxy)).append("\n");
    sb.append("    proxyIDToContactWorkloadSecurityRelay: ").append(toIndentedString(proxyIDToContactWorkloadSecurityRelay)).append("\n");
    sb.append("    includeComputerOverrides: ").append(toIndentedString(includeComputerOverrides)).append("\n");
    sb.append("    includeComputerDescription: ").append(toIndentedString(includeComputerDescription)).append("\n");
    sb.append("    referToLatestMigratedPolicy: ").append(toIndentedString(referToLatestMigratedPolicy)).append("\n");
    sb.append("    computerIDs: ").append(toIndentedString(computerIDs)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

