/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.ComputerMoveTask;
import com.trendmicro.deepsecurity.model.ComputerUnableToMove;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Result of batchComputerMoveTask for each computer ID.
 */
@ApiModel(description = "Result of batchComputerMoveTask for each computer ID.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class BatchComputerMoveTaskList {
  @JsonProperty("createdComputerMoveTasks")
  private List<ComputerMoveTask> createdComputerMoveTasks = null;

  @JsonProperty("computersUnableToMove")
  private List<ComputerUnableToMove> computersUnableToMove = null;

   /**
   * ComputerMoveTask created.
   * @return createdComputerMoveTasks
  **/
  @ApiModelProperty(value = "ComputerMoveTask created.")
  public List<ComputerMoveTask> getCreatedComputerMoveTasks() {
    return createdComputerMoveTasks;
  }

   /**
   * The computers that cannot be moved.
   * @return computersUnableToMove
  **/
  @ApiModelProperty(value = "The computers that cannot be moved.")
  public List<ComputerUnableToMove> getComputersUnableToMove() {
    return computersUnableToMove;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    BatchComputerMoveTaskList batchComputerMoveTaskList = (BatchComputerMoveTaskList) o;
    return Objects.equals(this.createdComputerMoveTasks, batchComputerMoveTaskList.createdComputerMoveTasks) &&
        Objects.equals(this.computersUnableToMove, batchComputerMoveTaskList.computersUnableToMove);
  }

  @Override
  public int hashCode() {
    return Objects.hash(createdComputerMoveTasks, computersUnableToMove);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class BatchComputerMoveTaskList {\n");
    
    sb.append("    createdComputerMoveTasks: ").append(toIndentedString(createdComputerMoveTasks)).append("\n");
    sb.append("    computersUnableToMove: ").append(toIndentedString(computersUnableToMove)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

