/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.CertificateDetails;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Certificate
 */
@ApiModel(description = "Certificate")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class Certificate {
  @JsonProperty("ID")
  private Integer ID = null;

  @JsonProperty("certificate")
  private String certificate = null;

  @JsonProperty("certificateDetails")
  private CertificateDetails certificateDetails = null;

  @JsonProperty("trusted")
  private Boolean trusted = null;

  /**
   * The type of connections for which the certificate is to be used.
   */
  public enum PurposeEnum {
    SSL("SSL"),
    
    EXCEPTION("EXCEPTION");

    private String value;

    PurposeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static PurposeEnum fromValue(String text) {
      for (PurposeEnum b : PurposeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("purpose")
  private PurposeEnum purpose = null;

   /**
   * ID of the SSL certificate. This ID is set automatically.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the SSL certificate. This ID is set automatically.")
  public Integer getID() {
    return ID;
  }

  public Certificate certificate(String certificate) {
    this.certificate = certificate;
    return this;
  }

   /**
   * The certificate. It&#39;s a PEM formatted string
   * @return certificate
  **/
  @ApiModelProperty(value = "The certificate. It's a PEM formatted string")
  public String getCertificate() {
    return certificate;
  }

  public void setCertificate(String certificate) {
    this.certificate = certificate;
  }

   /**
   * Detailed information about the certificate.
   * @return certificateDetails
  **/
  @ApiModelProperty(value = "Detailed information about the certificate.")
  public CertificateDetails getCertificateDetails() {
    return certificateDetails;
  }

   /**
   * True if the certificate is trusted by Deep Security Manager or verified by a CA.
   * @return trusted
  **/
  @ApiModelProperty(value = "True if the certificate is trusted by Deep Security Manager or verified by a CA.")
  public Boolean isTrusted() {
    return trusted;
  }

  public Certificate purpose(PurposeEnum purpose) {
    this.purpose = purpose;
    return this;
  }

   /**
   * The type of connections for which the certificate is to be used.
   * @return purpose
  **/
  @ApiModelProperty(value = "The type of connections for which the certificate is to be used.")
  public PurposeEnum getPurpose() {
    return purpose;
  }

  public void setPurpose(PurposeEnum purpose) {
    this.purpose = purpose;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Certificate certificate = (Certificate) o;
    return Objects.equals(this.ID, certificate.ID) &&
        Objects.equals(this.certificate, certificate.certificate) &&
        Objects.equals(this.certificateDetails, certificate.certificateDetails) &&
        Objects.equals(this.trusted, certificate.trusted) &&
        Objects.equals(this.purpose, certificate.purpose);
  }

  @Override
  public int hashCode() {
    return Objects.hash(ID, certificate, certificateDetails, trusted, purpose);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Certificate {\n");
    
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("    certificate: ").append(toIndentedString(certificate)).append("\n");
    sb.append("    certificateDetails: ").append(toIndentedString(certificateDetails)).append("\n");
    sb.append("    trusted: ").append(toIndentedString(trusted)).append("\n");
    sb.append("    purpose: ").append(toIndentedString(purpose)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

