/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.CommonObjectInfo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * The mapping of a common object between this Deep Security Manager and Workload Security.
 */
@ApiModel(description = "The mapping of a common object between this Deep Security Manager and Workload Security.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class CommonObjectMapping {
  @JsonProperty("migrateTo")
  private CommonObjectInfo migrateTo = null;

  @JsonProperty("migrateFrom")
  private CommonObjectInfo migrateFrom = null;

   /**
   * The common object in Workload Security.
   * @return migrateTo
  **/
  @ApiModelProperty(value = "The common object in Workload Security.")
  public CommonObjectInfo getMigrateTo() {
    return migrateTo;
  }

   /**
   * The common object in this Deep Security Manager.
   * @return migrateFrom
  **/
  @ApiModelProperty(value = "The common object in this Deep Security Manager.")
  public CommonObjectInfo getMigrateFrom() {
    return migrateFrom;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CommonObjectMapping commonObjectMapping = (CommonObjectMapping) o;
    return Objects.equals(this.migrateTo, commonObjectMapping.migrateTo) &&
        Objects.equals(this.migrateFrom, commonObjectMapping.migrateFrom);
  }

  @Override
  public int hashCode() {
    return Objects.hash(migrateTo, migrateFrom);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CommonObjectMapping {\n");
    
    sb.append("    migrateTo: ").append(toIndentedString(migrateTo)).append("\n");
    sb.append("    migrateFrom: ").append(toIndentedString(migrateFrom)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

