/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.CommonObjectMapping;
import com.trendmicro.deepsecurity.model.CommonObjectUnableToMigrate;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Task to migrate common objects
 */
@ApiModel(description = "Task to migrate common objects")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class CommonObjectMigrationTask {
  /**
   * Target type to move. Searchable as Choice.
   */
  public enum TypeEnum {
    DIRECTORY_LISTS("directory-lists"),
    
    FILE_EXTENSION_LISTS("file-extension-lists"),
    
    FILE_LISTS("file-lists"),
    
    IP_LISTS("ip-lists"),
    
    MAC_LISTS("mac-lists"),
    
    PORT_LISTS("port-lists"),
    
    CONTEXTS("contexts"),
    
    STATEFUL_CONFIGURATIONS("stateful-configurations"),
    
    SCHEDULES("schedules");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TypeEnum fromValue(String text) {
      for (TypeEnum b : TypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("type")
  private TypeEnum type = null;

  @JsonProperty("objectIDs")
  private List<Integer> objectIDs = new ArrayList<>();

  @JsonProperty("taskGUID")
  private String taskGUID = null;

  /**
   * The migration status.
   */
  public enum StatusEnum {
    REQUESTED("requested"),
    
    IN_PROGRESS("in-progress"),
    
    COMPLETE("complete"),
    
    FAILED("failed");

    private String value;

    StatusEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StatusEnum fromValue(String text) {
      for (StatusEnum b : StatusEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("status")
  private StatusEnum status = null;

  @JsonProperty("created")
  private Long created = null;

  @JsonProperty("lastUpdated")
  private Long lastUpdated = null;

  @JsonProperty("commonObjectMappings")
  private List<CommonObjectMapping> commonObjectMappings = null;

  @JsonProperty("errorCode")
  private Integer errorCode = null;

  @JsonProperty("commonObjectsUnableToMigrate")
  private List<CommonObjectUnableToMigrate> commonObjectsUnableToMigrate = null;

  @JsonProperty("ID")
  private Integer ID = null;

  public CommonObjectMigrationTask type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * Target type to move. Searchable as Choice.
   * @return type
  **/
  @ApiModelProperty(required = true, value = "Target type to move. Searchable as Choice.")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }

  public CommonObjectMigrationTask objectIDs(List<Integer> objectIDs) {
    this.objectIDs = objectIDs;
    return this;
  }

  public CommonObjectMigrationTask addObjectIDsItem(Integer objectIDsItem) {
    this.objectIDs.add(objectIDsItem);
    return this;
  }

   /**
   * Target IDs to move from type.
   * @return objectIDs
  **/
  @ApiModelProperty(required = true, value = "Target IDs to move from type.")
  public List<Integer> getObjectIDs() {
    return objectIDs;
  }

  public void setObjectIDs(List<Integer> objectIDs) {
    this.objectIDs = objectIDs;
  }

   /**
   * Task GUID on Workload Security. Searchable as String.
   * @return taskGUID
  **/
  @ApiModelProperty(value = "Task GUID on Workload Security. Searchable as String.")
  public String getTaskGUID() {
    return taskGUID;
  }

   /**
   * The migration status.
   * @return status
  **/
  @ApiModelProperty(value = "The migration status.")
  public StatusEnum getStatus() {
    return status;
  }

   /**
   * Timestamp when the CommonObjectMigrationTask was created, in milliseconds since epoch. Searchable as Date.
   * @return created
  **/
  @ApiModelProperty(value = "Timestamp when the CommonObjectMigrationTask was created, in milliseconds since epoch. Searchable as Date.")
  public Long getCreated() {
    return created;
  }

   /**
   * Timestamp when the CommonObjectMigrationTask was updated, in milliseconds since epoch. Searchable as Date.
   * @return lastUpdated
  **/
  @ApiModelProperty(value = "Timestamp when the CommonObjectMigrationTask was updated, in milliseconds since epoch. Searchable as Date.")
  public Long getLastUpdated() {
    return lastUpdated;
  }

   /**
   * The mapping table of common objects on this Deep Security Manager and the Workload Security.
   * @return commonObjectMappings
  **/
  @ApiModelProperty(value = "The mapping table of common objects on this Deep Security Manager and the Workload Security.")
  public List<CommonObjectMapping> getCommonObjectMappings() {
    return commonObjectMappings;
  }

   /**
   * The error code of the failed task.
   * @return errorCode
  **/
  @ApiModelProperty(value = "The error code of the failed task.")
  public Integer getErrorCode() {
    return errorCode;
  }

   /**
   * The common objects that cannot be migrated.
   * @return commonObjectsUnableToMigrate
  **/
  @ApiModelProperty(value = "The common objects that cannot be migrated.")
  public List<CommonObjectUnableToMigrate> getCommonObjectsUnableToMigrate() {
    return commonObjectsUnableToMigrate;
  }

   /**
   * ID of the common object migration task.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the common object migration task.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CommonObjectMigrationTask commonObjectMigrationTask = (CommonObjectMigrationTask) o;
    return Objects.equals(this.type, commonObjectMigrationTask.type) &&
        Objects.equals(this.objectIDs, commonObjectMigrationTask.objectIDs) &&
        Objects.equals(this.taskGUID, commonObjectMigrationTask.taskGUID) &&
        Objects.equals(this.status, commonObjectMigrationTask.status) &&
        Objects.equals(this.created, commonObjectMigrationTask.created) &&
        Objects.equals(this.lastUpdated, commonObjectMigrationTask.lastUpdated) &&
        Objects.equals(this.commonObjectMappings, commonObjectMigrationTask.commonObjectMappings) &&
        Objects.equals(this.errorCode, commonObjectMigrationTask.errorCode) &&
        Objects.equals(this.commonObjectsUnableToMigrate, commonObjectMigrationTask.commonObjectsUnableToMigrate) &&
        Objects.equals(this.ID, commonObjectMigrationTask.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(type, objectIDs, taskGUID, status, created, lastUpdated, commonObjectMappings, errorCode, commonObjectsUnableToMigrate, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CommonObjectMigrationTask {\n");
    
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    objectIDs: ").append(toIndentedString(objectIDs)).append("\n");
    sb.append("    taskGUID: ").append(toIndentedString(taskGUID)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    lastUpdated: ").append(toIndentedString(lastUpdated)).append("\n");
    sb.append("    commonObjectMappings: ").append(toIndentedString(commonObjectMappings)).append("\n");
    sb.append("    errorCode: ").append(toIndentedString(errorCode)).append("\n");
    sb.append("    commonObjectsUnableToMigrate: ").append(toIndentedString(commonObjectsUnableToMigrate)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

