/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * USB Storage Device exception rule with basic computer information.
 */
@ApiModel(description = "USB Storage Device exception rule with basic computer information.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class ComputerExceptionRule {
  @JsonProperty("computerID")
  private Integer computerID = null;

  @JsonProperty("hostName")
  private String hostName = null;

  @JsonProperty("displayName")
  private String displayName = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("ID")
  private Long ID = null;

  /**
   * Gets or Sets action
   */
  public enum ActionEnum {
    FULL_ACCESS("full-access");

    private String value;

    ActionEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ActionEnum fromValue(String text) {
      for (ActionEnum b : ActionEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("action")
  private ActionEnum action = null;

   /**
   * ID of the computer.
   * @return computerID
  **/
  @ApiModelProperty(value = "ID of the computer.")
  public Integer getComputerID() {
    return computerID;
  }

   /**
   * Hostname of the computer.
   * @return hostName
  **/
  @ApiModelProperty(value = "Hostname of the computer.")
  public String getHostName() {
    return hostName;
  }

   /**
   * Display name of the computer.
   * @return displayName
  **/
  @ApiModelProperty(value = "Display name of the computer.")
  public String getDisplayName() {
    return displayName;
  }

   /**
   * Description of the computer.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the computer.")
  public String getDescription() {
    return description;
  }

   /**
   * ID of the USB Storage Device Exception Rule.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the USB Storage Device Exception Rule.")
  public Long getID() {
    return ID;
  }

  public ComputerExceptionRule action(ActionEnum action) {
    this.action = action;
    return this;
  }

   /**
   * Get action
   * @return action
  **/
  @ApiModelProperty(value = "")
  public ActionEnum getAction() {
    return action;
  }

  public void setAction(ActionEnum action) {
    this.action = action;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ComputerExceptionRule computerExceptionRule = (ComputerExceptionRule) o;
    return Objects.equals(this.computerID, computerExceptionRule.computerID) &&
        Objects.equals(this.hostName, computerExceptionRule.hostName) &&
        Objects.equals(this.displayName, computerExceptionRule.displayName) &&
        Objects.equals(this.description, computerExceptionRule.description) &&
        Objects.equals(this.ID, computerExceptionRule.ID) &&
        Objects.equals(this.action, computerExceptionRule.action);
  }

  @Override
  public int hashCode() {
    return Objects.hash(computerID, hostName, displayName, description, ID, action);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ComputerExceptionRule {\n");
    
    sb.append("    computerID: ").append(toIndentedString(computerID)).append("\n");
    sb.append("    hostName: ").append(toIndentedString(hostName)).append("\n");
    sb.append("    displayName: ").append(toIndentedString(displayName)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("    action: ").append(toIndentedString(action)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

