/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.WorkloadSecurityProxy;
import com.trendmicro.deepsecurity.model.WorkloadSecurityRelayProxy;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Task to move a computer
 */
@ApiModel(description = "Task to move a computer")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class ComputerMoveTask {
  @JsonProperty("workloadSecurityPolicyID")
  private Long workloadSecurityPolicyID = null;

  @JsonProperty("workloadSecurityComputerGroupID")
  private Long workloadSecurityComputerGroupID = null;

  @JsonProperty("workloadSecurityRelayGroupID")
  private Long workloadSecurityRelayGroupID = null;

  @JsonProperty("workloadSecurityProxy")
  private WorkloadSecurityProxy workloadSecurityProxy = null;

  @JsonProperty("proxyIDToContactWorkloadSecurity")
  private Integer proxyIDToContactWorkloadSecurity = null;

  @JsonProperty("workloadSecurityRelayProxy")
  private WorkloadSecurityRelayProxy workloadSecurityRelayProxy = null;

  @JsonProperty("proxyIDToContactWorkloadSecurityRelay")
  private Integer proxyIDToContactWorkloadSecurityRelay = null;

  @JsonProperty("includeComputerOverrides")
  private Boolean includeComputerOverrides = null;

  @JsonProperty("includeComputerDescription")
  private Boolean includeComputerDescription = null;

  @JsonProperty("referToLatestMigratedPolicy")
  private Boolean referToLatestMigratedPolicy = null;

  @JsonProperty("computerID")
  private Integer computerID = null;

  /**
   * Move status
   */
  public enum MoveStateEnum {
    MOVE_REQUESTED("move-requested"),
    
    MOVING("moving"),
    
    MOVE_COMPLETE("move-complete"),
    
    MOVE_FAILED("move-failed"),
    
    MOVE_FAILED_NO_RESPONSE("move-failed-no-response"),
    
    MOVE_FAILED_ACTIVATION_FAILED("move-failed-activation-failed"),
    
    MOVE_FAILED_UNMANAGED("move-failed-unmanaged");

    private String value;

    MoveStateEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static MoveStateEnum fromValue(String text) {
      for (MoveStateEnum b : MoveStateEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("moveState")
  private MoveStateEnum moveState = null;

  @JsonProperty("created")
  private Long created = null;

  @JsonProperty("lastUpdated")
  private Long lastUpdated = null;

  @JsonProperty("ID")
  private Long ID = null;

  public ComputerMoveTask workloadSecurityPolicyID(Long workloadSecurityPolicyID) {
    this.workloadSecurityPolicyID = workloadSecurityPolicyID;
    return this;
  }

   /**
   * Policy ID in Workload Security.
   * @return workloadSecurityPolicyID
  **/
  @ApiModelProperty(value = "Policy ID in Workload Security.")
  public Long getWorkloadSecurityPolicyID() {
    return workloadSecurityPolicyID;
  }

  public void setWorkloadSecurityPolicyID(Long workloadSecurityPolicyID) {
    this.workloadSecurityPolicyID = workloadSecurityPolicyID;
  }

  public ComputerMoveTask workloadSecurityComputerGroupID(Long workloadSecurityComputerGroupID) {
    this.workloadSecurityComputerGroupID = workloadSecurityComputerGroupID;
    return this;
  }

   /**
   * Computer Group ID in Workload Security.
   * @return workloadSecurityComputerGroupID
  **/
  @ApiModelProperty(value = "Computer Group ID in Workload Security.")
  public Long getWorkloadSecurityComputerGroupID() {
    return workloadSecurityComputerGroupID;
  }

  public void setWorkloadSecurityComputerGroupID(Long workloadSecurityComputerGroupID) {
    this.workloadSecurityComputerGroupID = workloadSecurityComputerGroupID;
  }

  public ComputerMoveTask workloadSecurityRelayGroupID(Long workloadSecurityRelayGroupID) {
    this.workloadSecurityRelayGroupID = workloadSecurityRelayGroupID;
    return this;
  }

   /**
   * Relay Group ID in Workload Security.
   * @return workloadSecurityRelayGroupID
  **/
  @ApiModelProperty(value = "Relay Group ID in Workload Security.")
  public Long getWorkloadSecurityRelayGroupID() {
    return workloadSecurityRelayGroupID;
  }

  public void setWorkloadSecurityRelayGroupID(Long workloadSecurityRelayGroupID) {
    this.workloadSecurityRelayGroupID = workloadSecurityRelayGroupID;
  }

  public ComputerMoveTask workloadSecurityProxy(WorkloadSecurityProxy workloadSecurityProxy) {
    this.workloadSecurityProxy = workloadSecurityProxy;
    return this;
  }

   /**
   * Workload Security proxy for agent.
   * @return workloadSecurityProxy
  **/
  @ApiModelProperty(value = "Workload Security proxy for agent.")
  public WorkloadSecurityProxy getWorkloadSecurityProxy() {
    return workloadSecurityProxy;
  }

  public void setWorkloadSecurityProxy(WorkloadSecurityProxy workloadSecurityProxy) {
    this.workloadSecurityProxy = workloadSecurityProxy;
  }

  public ComputerMoveTask proxyIDToContactWorkloadSecurity(Integer proxyIDToContactWorkloadSecurity) {
    this.proxyIDToContactWorkloadSecurity = proxyIDToContactWorkloadSecurity;
    return this;
  }

   /**
   * Deep Security proxy ID for the computer to contact to Workload Security.
   * @return proxyIDToContactWorkloadSecurity
  **/
  @ApiModelProperty(value = "Deep Security proxy ID for the computer to contact to Workload Security.")
  public Integer getProxyIDToContactWorkloadSecurity() {
    return proxyIDToContactWorkloadSecurity;
  }

  public void setProxyIDToContactWorkloadSecurity(Integer proxyIDToContactWorkloadSecurity) {
    this.proxyIDToContactWorkloadSecurity = proxyIDToContactWorkloadSecurity;
  }

  public ComputerMoveTask workloadSecurityRelayProxy(WorkloadSecurityRelayProxy workloadSecurityRelayProxy) {
    this.workloadSecurityRelayProxy = workloadSecurityRelayProxy;
    return this;
  }

   /**
   * Workload Security relay proxy of agent.
   * @return workloadSecurityRelayProxy
  **/
  @ApiModelProperty(value = "Workload Security relay proxy of agent.")
  public WorkloadSecurityRelayProxy getWorkloadSecurityRelayProxy() {
    return workloadSecurityRelayProxy;
  }

  public void setWorkloadSecurityRelayProxy(WorkloadSecurityRelayProxy workloadSecurityRelayProxy) {
    this.workloadSecurityRelayProxy = workloadSecurityRelayProxy;
  }

  public ComputerMoveTask proxyIDToContactWorkloadSecurityRelay(Integer proxyIDToContactWorkloadSecurityRelay) {
    this.proxyIDToContactWorkloadSecurityRelay = proxyIDToContactWorkloadSecurityRelay;
    return this;
  }

   /**
   * Deep Security proxy ID for the computer to contact to Workload Security relays.
   * @return proxyIDToContactWorkloadSecurityRelay
  **/
  @ApiModelProperty(value = "Deep Security proxy ID for the computer to contact to Workload Security relays.")
  public Integer getProxyIDToContactWorkloadSecurityRelay() {
    return proxyIDToContactWorkloadSecurityRelay;
  }

  public void setProxyIDToContactWorkloadSecurityRelay(Integer proxyIDToContactWorkloadSecurityRelay) {
    this.proxyIDToContactWorkloadSecurityRelay = proxyIDToContactWorkloadSecurityRelay;
  }

  public ComputerMoveTask includeComputerOverrides(Boolean includeComputerOverrides) {
    this.includeComputerOverrides = includeComputerOverrides;
    return this;
  }

   /**
   * Controls whether the Computer Move Task moves setting is overridden at the computer level. Defaults to &#x60;true&#x60;.
   * @return includeComputerOverrides
  **/
  @ApiModelProperty(value = "Controls whether the Computer Move Task moves setting is overridden at the computer level. Defaults to `true`.")
  public Boolean isIncludeComputerOverrides() {
    return includeComputerOverrides;
  }

  public void setIncludeComputerOverrides(Boolean includeComputerOverrides) {
    this.includeComputerOverrides = includeComputerOverrides;
  }

  public ComputerMoveTask includeComputerDescription(Boolean includeComputerDescription) {
    this.includeComputerDescription = includeComputerDescription;
    return this;
  }

   /**
   * Controls whether the Computer Move Task moves the hostname, display name, and description. Defaults to &#x60;true&#x60;.
   * @return includeComputerDescription
  **/
  @ApiModelProperty(value = "Controls whether the Computer Move Task moves the hostname, display name, and description. Defaults to `true`.")
  public Boolean isIncludeComputerDescription() {
    return includeComputerDescription;
  }

  public void setIncludeComputerDescription(Boolean includeComputerDescription) {
    this.includeComputerDescription = includeComputerDescription;
  }

  public ComputerMoveTask referToLatestMigratedPolicy(Boolean referToLatestMigratedPolicy) {
    this.referToLatestMigratedPolicy = referToLatestMigratedPolicy;
    return this;
  }

   /**
   * Controls whether the last successfully migrated policies are assigned to the computers.
   * @return referToLatestMigratedPolicy
  **/
  @ApiModelProperty(value = "Controls whether the last successfully migrated policies are assigned to the computers.")
  public Boolean isReferToLatestMigratedPolicy() {
    return referToLatestMigratedPolicy;
  }

  public void setReferToLatestMigratedPolicy(Boolean referToLatestMigratedPolicy) {
    this.referToLatestMigratedPolicy = referToLatestMigratedPolicy;
  }

  public ComputerMoveTask computerID(Integer computerID) {
    this.computerID = computerID;
    return this;
  }

   /**
   * Target computer to move. Searchable as Numeric.
   * @return computerID
  **/
  @ApiModelProperty(required = true, value = "Target computer to move. Searchable as Numeric.")
  public Integer getComputerID() {
    return computerID;
  }

  public void setComputerID(Integer computerID) {
    this.computerID = computerID;
  }

   /**
   * Move status
   * @return moveState
  **/
  @ApiModelProperty(value = "Move status")
  public MoveStateEnum getMoveState() {
    return moveState;
  }

   /**
   * Timestamp when the ComputerMoveTask was created, in milliseconds since epoch. Searchable as Date.
   * @return created
  **/
  @ApiModelProperty(value = "Timestamp when the ComputerMoveTask was created, in milliseconds since epoch. Searchable as Date.")
  public Long getCreated() {
    return created;
  }

   /**
   * Timestamp when the ComputerMoveTask was updated, in milliseconds since epoch. Searchable as Date.
   * @return lastUpdated
  **/
  @ApiModelProperty(value = "Timestamp when the ComputerMoveTask was updated, in milliseconds since epoch. Searchable as Date.")
  public Long getLastUpdated() {
    return lastUpdated;
  }

   /**
   * ID of the ComputerMoveTask.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the ComputerMoveTask.")
  public Long getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ComputerMoveTask computerMoveTask = (ComputerMoveTask) o;
    return Objects.equals(this.workloadSecurityPolicyID, computerMoveTask.workloadSecurityPolicyID) &&
        Objects.equals(this.workloadSecurityComputerGroupID, computerMoveTask.workloadSecurityComputerGroupID) &&
        Objects.equals(this.workloadSecurityRelayGroupID, computerMoveTask.workloadSecurityRelayGroupID) &&
        Objects.equals(this.workloadSecurityProxy, computerMoveTask.workloadSecurityProxy) &&
        Objects.equals(this.proxyIDToContactWorkloadSecurity, computerMoveTask.proxyIDToContactWorkloadSecurity) &&
        Objects.equals(this.workloadSecurityRelayProxy, computerMoveTask.workloadSecurityRelayProxy) &&
        Objects.equals(this.proxyIDToContactWorkloadSecurityRelay, computerMoveTask.proxyIDToContactWorkloadSecurityRelay) &&
        Objects.equals(this.includeComputerOverrides, computerMoveTask.includeComputerOverrides) &&
        Objects.equals(this.includeComputerDescription, computerMoveTask.includeComputerDescription) &&
        Objects.equals(this.referToLatestMigratedPolicy, computerMoveTask.referToLatestMigratedPolicy) &&
        Objects.equals(this.computerID, computerMoveTask.computerID) &&
        Objects.equals(this.moveState, computerMoveTask.moveState) &&
        Objects.equals(this.created, computerMoveTask.created) &&
        Objects.equals(this.lastUpdated, computerMoveTask.lastUpdated) &&
        Objects.equals(this.ID, computerMoveTask.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(workloadSecurityPolicyID, workloadSecurityComputerGroupID, workloadSecurityRelayGroupID, workloadSecurityProxy, proxyIDToContactWorkloadSecurity, workloadSecurityRelayProxy, proxyIDToContactWorkloadSecurityRelay, includeComputerOverrides, includeComputerDescription, referToLatestMigratedPolicy, computerID, moveState, created, lastUpdated, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ComputerMoveTask {\n");
    
    sb.append("    workloadSecurityPolicyID: ").append(toIndentedString(workloadSecurityPolicyID)).append("\n");
    sb.append("    workloadSecurityComputerGroupID: ").append(toIndentedString(workloadSecurityComputerGroupID)).append("\n");
    sb.append("    workloadSecurityRelayGroupID: ").append(toIndentedString(workloadSecurityRelayGroupID)).append("\n");
    sb.append("    workloadSecurityProxy: ").append(toIndentedString(workloadSecurityProxy)).append("\n");
    sb.append("    proxyIDToContactWorkloadSecurity: ").append(toIndentedString(proxyIDToContactWorkloadSecurity)).append("\n");
    sb.append("    workloadSecurityRelayProxy: ").append(toIndentedString(workloadSecurityRelayProxy)).append("\n");
    sb.append("    proxyIDToContactWorkloadSecurityRelay: ").append(toIndentedString(proxyIDToContactWorkloadSecurityRelay)).append("\n");
    sb.append("    includeComputerOverrides: ").append(toIndentedString(includeComputerOverrides)).append("\n");
    sb.append("    includeComputerDescription: ").append(toIndentedString(includeComputerDescription)).append("\n");
    sb.append("    referToLatestMigratedPolicy: ").append(toIndentedString(referToLatestMigratedPolicy)).append("\n");
    sb.append("    computerID: ").append(toIndentedString(computerID)).append("\n");
    sb.append("    moveState: ").append(toIndentedString(moveState)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    lastUpdated: ").append(toIndentedString(lastUpdated)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

