/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Computer right details.
 */
@ApiModel(description = "Computer right details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class ComputerRights {
  @JsonProperty("canAddAndRemoveComputerGroups")
  private Boolean canAddAndRemoveComputerGroups = null;

  @JsonProperty("canClearWarningsAndErrors")
  private Boolean canClearWarningsAndErrors = null;

  @JsonProperty("canCreateNewComputers")
  private Boolean canCreateNewComputers = null;

  @JsonProperty("canDeleteComputers")
  private Boolean canDeleteComputers = null;

  @JsonProperty("canDismissAlerts")
  private Boolean canDismissAlerts = null;

  @JsonProperty("canEditComputerProperties")
  private Boolean canEditComputerProperties = null;

  @JsonProperty("canImportComputers")
  private Boolean canImportComputers = null;

  @JsonProperty("canManageCloudAccounts")
  private Boolean canManageCloudAccounts = null;

  @JsonProperty("canManageDirectories")
  private Boolean canManageDirectories = null;

  @JsonProperty("canManageVCenters")
  private Boolean canManageVCenters = null;

  @JsonProperty("canTagComputers")
  private Boolean canTagComputers = null;

  @JsonProperty("canViewNotRelatedToComputers")
  private Boolean canViewNotRelatedToComputers = null;

  @JsonProperty("canViewOtherComputers")
  private Boolean canViewOtherComputers = null;

  public ComputerRights canAddAndRemoveComputerGroups(Boolean canAddAndRemoveComputerGroups) {
    this.canAddAndRemoveComputerGroups = canAddAndRemoveComputerGroups;
    return this;
  }

   /**
   * Right to add and remove computer groups.
   * @return canAddAndRemoveComputerGroups
  **/
  @ApiModelProperty(value = "Right to add and remove computer groups.")
  public Boolean isCanAddAndRemoveComputerGroups() {
    return canAddAndRemoveComputerGroups;
  }

  public void setCanAddAndRemoveComputerGroups(Boolean canAddAndRemoveComputerGroups) {
    this.canAddAndRemoveComputerGroups = canAddAndRemoveComputerGroups;
  }

  public ComputerRights canClearWarningsAndErrors(Boolean canClearWarningsAndErrors) {
    this.canClearWarningsAndErrors = canClearWarningsAndErrors;
    return this;
  }

   /**
   * Right to clear computers warnings and errors.
   * @return canClearWarningsAndErrors
  **/
  @ApiModelProperty(value = "Right to clear computers warnings and errors.")
  public Boolean isCanClearWarningsAndErrors() {
    return canClearWarningsAndErrors;
  }

  public void setCanClearWarningsAndErrors(Boolean canClearWarningsAndErrors) {
    this.canClearWarningsAndErrors = canClearWarningsAndErrors;
  }

  public ComputerRights canCreateNewComputers(Boolean canCreateNewComputers) {
    this.canCreateNewComputers = canCreateNewComputers;
    return this;
  }

   /**
   * Right to create new computers.
   * @return canCreateNewComputers
  **/
  @ApiModelProperty(value = "Right to create new computers.")
  public Boolean isCanCreateNewComputers() {
    return canCreateNewComputers;
  }

  public void setCanCreateNewComputers(Boolean canCreateNewComputers) {
    this.canCreateNewComputers = canCreateNewComputers;
  }

  public ComputerRights canDeleteComputers(Boolean canDeleteComputers) {
    this.canDeleteComputers = canDeleteComputers;
    return this;
  }

   /**
   * Right to delete computers.
   * @return canDeleteComputers
  **/
  @ApiModelProperty(value = "Right to delete computers.")
  public Boolean isCanDeleteComputers() {
    return canDeleteComputers;
  }

  public void setCanDeleteComputers(Boolean canDeleteComputers) {
    this.canDeleteComputers = canDeleteComputers;
  }

  public ComputerRights canDismissAlerts(Boolean canDismissAlerts) {
    this.canDismissAlerts = canDismissAlerts;
    return this;
  }

   /**
   * Right to dismiss computer alerts.
   * @return canDismissAlerts
  **/
  @ApiModelProperty(value = "Right to dismiss computer alerts.")
  public Boolean isCanDismissAlerts() {
    return canDismissAlerts;
  }

  public void setCanDismissAlerts(Boolean canDismissAlerts) {
    this.canDismissAlerts = canDismissAlerts;
  }

  public ComputerRights canEditComputerProperties(Boolean canEditComputerProperties) {
    this.canEditComputerProperties = canEditComputerProperties;
    return this;
  }

   /**
   * Right to edit computer properties.
   * @return canEditComputerProperties
  **/
  @ApiModelProperty(value = "Right to edit computer properties.")
  public Boolean isCanEditComputerProperties() {
    return canEditComputerProperties;
  }

  public void setCanEditComputerProperties(Boolean canEditComputerProperties) {
    this.canEditComputerProperties = canEditComputerProperties;
  }

  public ComputerRights canImportComputers(Boolean canImportComputers) {
    this.canImportComputers = canImportComputers;
    return this;
  }

   /**
   * Right to import computers.
   * @return canImportComputers
  **/
  @ApiModelProperty(value = "Right to import computers.")
  public Boolean isCanImportComputers() {
    return canImportComputers;
  }

  public void setCanImportComputers(Boolean canImportComputers) {
    this.canImportComputers = canImportComputers;
  }

  public ComputerRights canManageCloudAccounts(Boolean canManageCloudAccounts) {
    this.canManageCloudAccounts = canManageCloudAccounts;
    return this;
  }

   /**
   * Right to manage cloud accounts.
   * @return canManageCloudAccounts
  **/
  @ApiModelProperty(value = "Right to manage cloud accounts.")
  public Boolean isCanManageCloudAccounts() {
    return canManageCloudAccounts;
  }

  public void setCanManageCloudAccounts(Boolean canManageCloudAccounts) {
    this.canManageCloudAccounts = canManageCloudAccounts;
  }

  public ComputerRights canManageDirectories(Boolean canManageDirectories) {
    this.canManageDirectories = canManageDirectories;
    return this;
  }

   /**
   * Right to manage directories.
   * @return canManageDirectories
  **/
  @ApiModelProperty(value = "Right to manage directories.")
  public Boolean isCanManageDirectories() {
    return canManageDirectories;
  }

  public void setCanManageDirectories(Boolean canManageDirectories) {
    this.canManageDirectories = canManageDirectories;
  }

  public ComputerRights canManageVCenters(Boolean canManageVCenters) {
    this.canManageVCenters = canManageVCenters;
    return this;
  }

   /**
   * Right to manage VMware vCenters.
   * @return canManageVCenters
  **/
  @ApiModelProperty(value = "Right to manage VMware vCenters.")
  public Boolean isCanManageVCenters() {
    return canManageVCenters;
  }

  public void setCanManageVCenters(Boolean canManageVCenters) {
    this.canManageVCenters = canManageVCenters;
  }

  public ComputerRights canTagComputers(Boolean canTagComputers) {
    this.canTagComputers = canTagComputers;
    return this;
  }

   /**
   * Right to tag computers.
   * @return canTagComputers
  **/
  @ApiModelProperty(value = "Right to tag computers.")
  public Boolean isCanTagComputers() {
    return canTagComputers;
  }

  public void setCanTagComputers(Boolean canTagComputers) {
    this.canTagComputers = canTagComputers;
  }

  public ComputerRights canViewNotRelatedToComputers(Boolean canViewNotRelatedToComputers) {
    this.canViewNotRelatedToComputers = canViewNotRelatedToComputers;
    return this;
  }

   /**
   * Right to view events and alerts not related to computers.
   * @return canViewNotRelatedToComputers
  **/
  @ApiModelProperty(value = "Right to view events and alerts not related to computers.")
  public Boolean isCanViewNotRelatedToComputers() {
    return canViewNotRelatedToComputers;
  }

  public void setCanViewNotRelatedToComputers(Boolean canViewNotRelatedToComputers) {
    this.canViewNotRelatedToComputers = canViewNotRelatedToComputers;
  }

  public ComputerRights canViewOtherComputers(Boolean canViewOtherComputers) {
    this.canViewOtherComputers = canViewOtherComputers;
    return this;
  }

   /**
   * Right to view non-selected computers.
   * @return canViewOtherComputers
  **/
  @ApiModelProperty(value = "Right to view non-selected computers.")
  public Boolean isCanViewOtherComputers() {
    return canViewOtherComputers;
  }

  public void setCanViewOtherComputers(Boolean canViewOtherComputers) {
    this.canViewOtherComputers = canViewOtherComputers;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ComputerRights computerRights = (ComputerRights) o;
    return Objects.equals(this.canAddAndRemoveComputerGroups, computerRights.canAddAndRemoveComputerGroups) &&
        Objects.equals(this.canClearWarningsAndErrors, computerRights.canClearWarningsAndErrors) &&
        Objects.equals(this.canCreateNewComputers, computerRights.canCreateNewComputers) &&
        Objects.equals(this.canDeleteComputers, computerRights.canDeleteComputers) &&
        Objects.equals(this.canDismissAlerts, computerRights.canDismissAlerts) &&
        Objects.equals(this.canEditComputerProperties, computerRights.canEditComputerProperties) &&
        Objects.equals(this.canImportComputers, computerRights.canImportComputers) &&
        Objects.equals(this.canManageCloudAccounts, computerRights.canManageCloudAccounts) &&
        Objects.equals(this.canManageDirectories, computerRights.canManageDirectories) &&
        Objects.equals(this.canManageVCenters, computerRights.canManageVCenters) &&
        Objects.equals(this.canTagComputers, computerRights.canTagComputers) &&
        Objects.equals(this.canViewNotRelatedToComputers, computerRights.canViewNotRelatedToComputers) &&
        Objects.equals(this.canViewOtherComputers, computerRights.canViewOtherComputers);
  }

  @Override
  public int hashCode() {
    return Objects.hash(canAddAndRemoveComputerGroups, canClearWarningsAndErrors, canCreateNewComputers, canDeleteComputers, canDismissAlerts, canEditComputerProperties, canImportComputers, canManageCloudAccounts, canManageDirectories, canManageVCenters, canTagComputers, canViewNotRelatedToComputers, canViewOtherComputers);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ComputerRights {\n");
    
    sb.append("    canAddAndRemoveComputerGroups: ").append(toIndentedString(canAddAndRemoveComputerGroups)).append("\n");
    sb.append("    canClearWarningsAndErrors: ").append(toIndentedString(canClearWarningsAndErrors)).append("\n");
    sb.append("    canCreateNewComputers: ").append(toIndentedString(canCreateNewComputers)).append("\n");
    sb.append("    canDeleteComputers: ").append(toIndentedString(canDeleteComputers)).append("\n");
    sb.append("    canDismissAlerts: ").append(toIndentedString(canDismissAlerts)).append("\n");
    sb.append("    canEditComputerProperties: ").append(toIndentedString(canEditComputerProperties)).append("\n");
    sb.append("    canImportComputers: ").append(toIndentedString(canImportComputers)).append("\n");
    sb.append("    canManageCloudAccounts: ").append(toIndentedString(canManageCloudAccounts)).append("\n");
    sb.append("    canManageDirectories: ").append(toIndentedString(canManageDirectories)).append("\n");
    sb.append("    canManageVCenters: ").append(toIndentedString(canManageVCenters)).append("\n");
    sb.append("    canTagComputers: ").append(toIndentedString(canTagComputers)).append("\n");
    sb.append("    canViewNotRelatedToComputers: ").append(toIndentedString(canViewNotRelatedToComputers)).append("\n");
    sb.append("    canViewOtherComputers: ").append(toIndentedString(canViewOtherComputers)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

