/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDateTime;


/**
 * Task to migrate a connector
 */
@ApiModel(description = "Task to migrate a connector")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class ConnectorMigrationTask {
  @JsonProperty("ID")
  private Long ID = null;

  @JsonProperty("connectorID")
  private Integer connectorID = null;

  /**
   * Migration status.
   */
  public enum StatusEnum {
    REQUESTED("requested"),
    
    IN_PROGRESS("in-progress"),
    
    COMPLETE("complete"),
    
    FAILED("failed");

    private String value;

    StatusEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StatusEnum fromValue(String text) {
      for (StatusEnum b : StatusEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("status")
  private StatusEnum status = null;

  @JsonProperty("errorCode")
  private Integer errorCode = null;

  @JsonProperty("created")
  private LocalDateTime created = null;

  @JsonProperty("lastUpdated")
  private LocalDateTime lastUpdated = null;

   /**
   * ID of the ConnectorMigrationTask.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the ConnectorMigrationTask.")
  public Long getID() {
    return ID;
  }

  public ConnectorMigrationTask connectorID(Integer connectorID) {
    this.connectorID = connectorID;
    return this;
  }

   /**
   * ID of the Connector.
   * @return connectorID
  **/
  @ApiModelProperty(value = "ID of the Connector.")
  public Integer getConnectorID() {
    return connectorID;
  }

  public void setConnectorID(Integer connectorID) {
    this.connectorID = connectorID;
  }

   /**
   * Migration status.
   * @return status
  **/
  @ApiModelProperty(value = "Migration status.")
  public StatusEnum getStatus() {
    return status;
  }

   /**
   * The error code of the failed task.
   * @return errorCode
  **/
  @ApiModelProperty(value = "The error code of the failed task.")
  public Integer getErrorCode() {
    return errorCode;
  }

   /**
   * Timestamp when the ConnectorMigrationTask was created, in milliseconds since epoch. Searchable as Date.
   * @return created
  **/
  @ApiModelProperty(value = "Timestamp when the ConnectorMigrationTask was created, in milliseconds since epoch. Searchable as Date.")
  public LocalDateTime getCreated() {
    return created;
  }

   /**
   * Timestamp when the ConnectorMigrationTask was updated, in milliseconds since epoch. Searchable as Date.
   * @return lastUpdated
  **/
  @ApiModelProperty(value = "Timestamp when the ConnectorMigrationTask was updated, in milliseconds since epoch. Searchable as Date.")
  public LocalDateTime getLastUpdated() {
    return lastUpdated;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ConnectorMigrationTask connectorMigrationTask = (ConnectorMigrationTask) o;
    return Objects.equals(this.ID, connectorMigrationTask.ID) &&
        Objects.equals(this.connectorID, connectorMigrationTask.connectorID) &&
        Objects.equals(this.status, connectorMigrationTask.status) &&
        Objects.equals(this.errorCode, connectorMigrationTask.errorCode) &&
        Objects.equals(this.created, connectorMigrationTask.created) &&
        Objects.equals(this.lastUpdated, connectorMigrationTask.lastUpdated);
  }

  @Override
  public int hashCode() {
    return Objects.hash(ID, connectorID, status, errorCode, created, lastUpdated);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ConnectorMigrationTask {\n");
    
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("    connectorID: ").append(toIndentedString(connectorID)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    errorCode: ").append(toIndentedString(errorCode)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    lastUpdated: ").append(toIndentedString(lastUpdated)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

