/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Details of a Contact. A contact is a user who cannot sign into Deep Security Manager but can be sent reports via scheduled tasks.
 */
@ApiModel(description = "Details of a Contact. A contact is a user who cannot sign into Deep Security Manager but can be sent reports via scheduled tasks.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class Contact {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("phoneNumber")
  private String phoneNumber = null;

  @JsonProperty("mobileNumber")
  private String mobileNumber = null;

  @JsonProperty("pagerNumber")
  private String pagerNumber = null;

  @JsonProperty("emailAddress")
  private String emailAddress = null;

  /**
   * Locale of the Contact.
   */
  public enum LocaleEnum {
    EN_US("en-US"),
    
    JA_JP("ja-JP");

    private String value;

    LocaleEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static LocaleEnum fromValue(String text) {
      for (LocaleEnum b : LocaleEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("locale")
  private LocaleEnum locale = null;

  @JsonProperty("roleID")
  private Integer roleID = null;

  @JsonProperty("reportPDFPasswordEnabled")
  private Boolean reportPDFPasswordEnabled = null;

  @JsonProperty("reportPDFPassword")
  private String reportPDFPassword = null;

  @JsonProperty("ID")
  private Integer ID = null;

  public Contact name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the Contact. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the Contact. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public Contact description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the Contact. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the Contact. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public Contact phoneNumber(String phoneNumber) {
    this.phoneNumber = phoneNumber;
    return this;
  }

   /**
   * Phone number of the Contact. Searchable as String.
   * @return phoneNumber
  **/
  @ApiModelProperty(value = "Phone number of the Contact. Searchable as String.")
  public String getPhoneNumber() {
    return phoneNumber;
  }

  public void setPhoneNumber(String phoneNumber) {
    this.phoneNumber = phoneNumber;
  }

  public Contact mobileNumber(String mobileNumber) {
    this.mobileNumber = mobileNumber;
    return this;
  }

   /**
   * Mobile number of the Contact. Searchable as String.
   * @return mobileNumber
  **/
  @ApiModelProperty(value = "Mobile number of the Contact. Searchable as String.")
  public String getMobileNumber() {
    return mobileNumber;
  }

  public void setMobileNumber(String mobileNumber) {
    this.mobileNumber = mobileNumber;
  }

  public Contact pagerNumber(String pagerNumber) {
    this.pagerNumber = pagerNumber;
    return this;
  }

   /**
   * Pager number of the Contact. Searchable as String.
   * @return pagerNumber
  **/
  @ApiModelProperty(value = "Pager number of the Contact. Searchable as String.")
  public String getPagerNumber() {
    return pagerNumber;
  }

  public void setPagerNumber(String pagerNumber) {
    this.pagerNumber = pagerNumber;
  }

  public Contact emailAddress(String emailAddress) {
    this.emailAddress = emailAddress;
    return this;
  }

   /**
   * Email address of the Contact. Searchable as String.
   * @return emailAddress
  **/
  @ApiModelProperty(value = "Email address of the Contact. Searchable as String.")
  public String getEmailAddress() {
    return emailAddress;
  }

  public void setEmailAddress(String emailAddress) {
    this.emailAddress = emailAddress;
  }

  public Contact locale(LocaleEnum locale) {
    this.locale = locale;
    return this;
  }

   /**
   * Locale of the Contact.
   * @return locale
  **/
  @ApiModelProperty(value = "Locale of the Contact.")
  public LocaleEnum getLocale() {
    return locale;
  }

  public void setLocale(LocaleEnum locale) {
    this.locale = locale;
  }

  public Contact roleID(Integer roleID) {
    this.roleID = roleID;
    return this;
  }

   /**
   * ID of the role assigned to the Contact. Searchable as Numeric.
   * @return roleID
  **/
  @ApiModelProperty(value = "ID of the role assigned to the Contact. Searchable as Numeric.")
  public Integer getRoleID() {
    return roleID;
  }

  public void setRoleID(Integer roleID) {
    this.roleID = roleID;
  }

  public Contact reportPDFPasswordEnabled(Boolean reportPDFPasswordEnabled) {
    this.reportPDFPasswordEnabled = reportPDFPasswordEnabled;
    return this;
  }

   /**
   * Controls whether the reports that the Contact generates are password-protected. Set to true to password-protect, and false otherwise. Defaults to false. Searchable as Boolean.
   * @return reportPDFPasswordEnabled
  **/
  @ApiModelProperty(value = "Controls whether the reports that the Contact generates are password-protected. Set to true to password-protect, and false otherwise. Defaults to false. Searchable as Boolean.")
  public Boolean isReportPDFPasswordEnabled() {
    return reportPDFPasswordEnabled;
  }

  public void setReportPDFPasswordEnabled(Boolean reportPDFPasswordEnabled) {
    this.reportPDFPasswordEnabled = reportPDFPasswordEnabled;
  }

  public Contact reportPDFPassword(String reportPDFPassword) {
    this.reportPDFPassword = reportPDFPassword;
    return this;
  }

   /**
   * Password that protects the reports that the Contact generates. Ignored when reportPDFPasswordEnabled is false.
   * @return reportPDFPassword
  **/
  @ApiModelProperty(value = "Password that protects the reports that the Contact generates. Ignored when reportPDFPasswordEnabled is false.")
  public String getReportPDFPassword() {
    return reportPDFPassword;
  }

  public void setReportPDFPassword(String reportPDFPassword) {
    this.reportPDFPassword = reportPDFPassword;
  }

   /**
   * ID of the Contact. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the Contact. Searchable as ID.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Contact contact = (Contact) o;
    return Objects.equals(this.name, contact.name) &&
        Objects.equals(this.description, contact.description) &&
        Objects.equals(this.phoneNumber, contact.phoneNumber) &&
        Objects.equals(this.mobileNumber, contact.mobileNumber) &&
        Objects.equals(this.pagerNumber, contact.pagerNumber) &&
        Objects.equals(this.emailAddress, contact.emailAddress) &&
        Objects.equals(this.locale, contact.locale) &&
        Objects.equals(this.roleID, contact.roleID) &&
        Objects.equals(this.reportPDFPasswordEnabled, contact.reportPDFPasswordEnabled) &&
        Objects.equals(this.reportPDFPassword, contact.reportPDFPassword) &&
        Objects.equals(this.ID, contact.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, phoneNumber, mobileNumber, pagerNumber, emailAddress, locale, roleID, reportPDFPasswordEnabled, reportPDFPassword, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Contact {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    phoneNumber: ").append(toIndentedString(phoneNumber)).append("\n");
    sb.append("    mobileNumber: ").append(toIndentedString(mobileNumber)).append("\n");
    sb.append("    pagerNumber: ").append(toIndentedString(pagerNumber)).append("\n");
    sb.append("    emailAddress: ").append(toIndentedString(emailAddress)).append("\n");
    sb.append("    locale: ").append(toIndentedString(locale)).append("\n");
    sb.append("    roleID: ").append(toIndentedString(roleID)).append("\n");
    sb.append("    reportPDFPasswordEnabled: ").append(toIndentedString(reportPDFPasswordEnabled)).append("\n");
    sb.append("    reportPDFPassword: ").append(toIndentedString(reportPDFPassword)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

