/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Firewall context information.
 */
@ApiModel(description = "Firewall context information.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class Context {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("minimumAgentVersion")
  private String minimumAgentVersion = null;

  @JsonProperty("localConnectionsEnabled")
  private Boolean localConnectionsEnabled = null;

  @JsonProperty("remoteConnectionsEnabled")
  private Boolean remoteConnectionsEnabled = null;

  @JsonProperty("noConnectionEnabled")
  private Boolean noConnectionEnabled = null;

  @JsonProperty("noInternetEnabled")
  private Boolean noInternetEnabled = null;

  @JsonProperty("restrictedInterfacesEnabled")
  private Boolean restrictedInterfacesEnabled = null;

  @JsonProperty("ID")
  private Integer ID = null;

  public Context name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the context. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the context. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public Context description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the context. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the context. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public Context minimumAgentVersion(String minimumAgentVersion) {
    this.minimumAgentVersion = minimumAgentVersion;
    return this;
  }

   /**
   * Minimum supported agent version.
   * @return minimumAgentVersion
  **/
  @ApiModelProperty(value = "Minimum supported agent version.")
  public String getMinimumAgentVersion() {
    return minimumAgentVersion;
  }

  public void setMinimumAgentVersion(String minimumAgentVersion) {
    this.minimumAgentVersion = minimumAgentVersion;
  }

  public Context localConnectionsEnabled(Boolean localConnectionsEnabled) {
    this.localConnectionsEnabled = localConnectionsEnabled;
    return this;
  }

   /**
   * Specifies whether the context applies to connections that are locally conntected to a domain. Set to true to apply to locally connected.
   * @return localConnectionsEnabled
  **/
  @ApiModelProperty(value = "Specifies whether the context applies to connections that are locally conntected to a domain. Set to true to apply to locally connected.")
  public Boolean isLocalConnectionsEnabled() {
    return localConnectionsEnabled;
  }

  public void setLocalConnectionsEnabled(Boolean localConnectionsEnabled) {
    this.localConnectionsEnabled = localConnectionsEnabled;
  }

  public Context remoteConnectionsEnabled(Boolean remoteConnectionsEnabled) {
    this.remoteConnectionsEnabled = remoteConnectionsEnabled;
    return this;
  }

   /**
   * Specifies whether the context applies to connections that are remotely conntected to a domain. Set to true to apply to remotely connected.
   * @return remoteConnectionsEnabled
  **/
  @ApiModelProperty(value = "Specifies whether the context applies to connections that are remotely conntected to a domain. Set to true to apply to remotely connected.")
  public Boolean isRemoteConnectionsEnabled() {
    return remoteConnectionsEnabled;
  }

  public void setRemoteConnectionsEnabled(Boolean remoteConnectionsEnabled) {
    this.remoteConnectionsEnabled = remoteConnectionsEnabled;
  }

  public Context noConnectionEnabled(Boolean noConnectionEnabled) {
    this.noConnectionEnabled = noConnectionEnabled;
    return this;
  }

   /**
   * Specifies whether the context applies to connections that are no connection enabled. Set to true to apply to no connection enabled.
   * @return noConnectionEnabled
  **/
  @ApiModelProperty(value = "Specifies whether the context applies to connections that are no connection enabled. Set to true to apply to no connection enabled.")
  public Boolean isNoConnectionEnabled() {
    return noConnectionEnabled;
  }

  public void setNoConnectionEnabled(Boolean noConnectionEnabled) {
    this.noConnectionEnabled = noConnectionEnabled;
  }

  public Context noInternetEnabled(Boolean noInternetEnabled) {
    this.noInternetEnabled = noInternetEnabled;
    return this;
  }

   /**
   * Specifies whether the context applies to connections that are neither connection nor Internet enabled. Set to true to apply.
   * @return noInternetEnabled
  **/
  @ApiModelProperty(value = "Specifies whether the context applies to connections that are neither connection nor Internet enabled. Set to true to apply.")
  public Boolean isNoInternetEnabled() {
    return noInternetEnabled;
  }

  public void setNoInternetEnabled(Boolean noInternetEnabled) {
    this.noInternetEnabled = noInternetEnabled;
  }

  public Context restrictedInterfacesEnabled(Boolean restrictedInterfacesEnabled) {
    this.restrictedInterfacesEnabled = restrictedInterfacesEnabled;
    return this;
  }

   /**
   * Controls if the firewall contents are restricted from view and duplication. Set to true if it&#39;s restricted. Searchable as Boolean.
   * @return restrictedInterfacesEnabled
  **/
  @ApiModelProperty(value = "Controls if the firewall contents are restricted from view and duplication. Set to true if it's restricted. Searchable as Boolean.")
  public Boolean isRestrictedInterfacesEnabled() {
    return restrictedInterfacesEnabled;
  }

  public void setRestrictedInterfacesEnabled(Boolean restrictedInterfacesEnabled) {
    this.restrictedInterfacesEnabled = restrictedInterfacesEnabled;
  }

   /**
   * ID of the context. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the context. Searchable as ID.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Context context = (Context) o;
    return Objects.equals(this.name, context.name) &&
        Objects.equals(this.description, context.description) &&
        Objects.equals(this.minimumAgentVersion, context.minimumAgentVersion) &&
        Objects.equals(this.localConnectionsEnabled, context.localConnectionsEnabled) &&
        Objects.equals(this.remoteConnectionsEnabled, context.remoteConnectionsEnabled) &&
        Objects.equals(this.noConnectionEnabled, context.noConnectionEnabled) &&
        Objects.equals(this.noInternetEnabled, context.noInternetEnabled) &&
        Objects.equals(this.restrictedInterfacesEnabled, context.restrictedInterfacesEnabled) &&
        Objects.equals(this.ID, context.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, minimumAgentVersion, localConnectionsEnabled, remoteConnectionsEnabled, noConnectionEnabled, noInternetEnabled, restrictedInterfacesEnabled, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Context {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    minimumAgentVersion: ").append(toIndentedString(minimumAgentVersion)).append("\n");
    sb.append("    localConnectionsEnabled: ").append(toIndentedString(localConnectionsEnabled)).append("\n");
    sb.append("    remoteConnectionsEnabled: ").append(toIndentedString(remoteConnectionsEnabled)).append("\n");
    sb.append("    noConnectionEnabled: ").append(toIndentedString(noConnectionEnabled)).append("\n");
    sb.append("    noInternetEnabled: ").append(toIndentedString(noInternetEnabled)).append("\n");
    sb.append("    restrictedInterfacesEnabled: ").append(toIndentedString(restrictedInterfacesEnabled)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

