/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Details for the daily schedule of a scheduled task.
 */
@ApiModel(description = "Details for the daily schedule of a scheduled task.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class DailyScheduleParameters {
  @JsonProperty("startTime")
  private Long startTime = null;

  /**
   * Frequency type.
   */
  public enum FrequencyTypeEnum {
    EVERYDAY("everyday"),
    
    WEEKDAYS("weekdays"),
    
    CUSTOM("custom");

    private String value;

    FrequencyTypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static FrequencyTypeEnum fromValue(String text) {
      for (FrequencyTypeEnum b : FrequencyTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("frequencyType")
  private FrequencyTypeEnum frequencyType = null;

  @JsonProperty("customInterval")
  private Integer customInterval = null;

  public DailyScheduleParameters startTime(Long startTime) {
    this.startTime = startTime;
    return this;
  }

   /**
   * Date/Time when the task should run.
   * @return startTime
  **/
  @ApiModelProperty(value = "Date/Time when the task should run.")
  public Long getStartTime() {
    return startTime;
  }

  public void setStartTime(Long startTime) {
    this.startTime = startTime;
  }

  public DailyScheduleParameters frequencyType(FrequencyTypeEnum frequencyType) {
    this.frequencyType = frequencyType;
    return this;
  }

   /**
   * Frequency type.
   * @return frequencyType
  **/
  @ApiModelProperty(value = "Frequency type.")
  public FrequencyTypeEnum getFrequencyType() {
    return frequencyType;
  }

  public void setFrequencyType(FrequencyTypeEnum frequencyType) {
    this.frequencyType = frequencyType;
  }

  public DailyScheduleParameters customInterval(Integer customInterval) {
    this.customInterval = customInterval;
    return this;
  }

   /**
   * Custom interval.
   * @return customInterval
  **/
  @ApiModelProperty(value = "Custom interval.")
  public Integer getCustomInterval() {
    return customInterval;
  }

  public void setCustomInterval(Integer customInterval) {
    this.customInterval = customInterval;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DailyScheduleParameters dailyScheduleParameters = (DailyScheduleParameters) o;
    return Objects.equals(this.startTime, dailyScheduleParameters.startTime) &&
        Objects.equals(this.frequencyType, dailyScheduleParameters.frequencyType) &&
        Objects.equals(this.customInterval, dailyScheduleParameters.customInterval);
  }

  @Override
  public int hashCode() {
    return Objects.hash(startTime, frequencyType, customInterval);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DailyScheduleParameters {\n");
    
    sb.append("    startTime: ").append(toIndentedString(startTime)).append("\n");
    sb.append("    frequencyType: ").append(toIndentedString(frequencyType)).append("\n");
    sb.append("    customInterval: ").append(toIndentedString(customInterval)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

