/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.CustomAttribute;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * VMware ESX Host Information.
 */
@ApiModel(description = "VMware ESX Host Information.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class ESXSummary {
  @JsonProperty("manufacturer")
  private String manufacturer = null;

  @JsonProperty("model")
  private String model = null;

  @JsonProperty("processors")
  private String processors = null;

  @JsonProperty("processorType")
  private String processorType = null;

  @JsonProperty("numberOfNICs")
  private String numberOfNICs = null;

  @JsonProperty("state")
  private String state = null;

  @JsonProperty("virtualMachines")
  private String virtualMachines = null;

  @JsonProperty("vMotionEnabled")
  private String vMotionEnabled = null;

  @JsonProperty("customAttributes")
  private List<CustomAttribute> customAttributes = null;

  @JsonProperty("TPMEnabled")
  private Boolean tpMEnabled = null;

  @JsonProperty("TPMAlertsEnabled")
  private Boolean tpMAlertsEnabled = null;

  @JsonProperty("TPMHasData")
  private Boolean tpMHasData = null;

  @JsonProperty("TPMLastChecked")
  private Long tpMLastChecked = null;

   /**
   * Manufacturer of the ESX. Searchable as String.
   * @return manufacturer
  **/
  @ApiModelProperty(value = "Manufacturer of the ESX. Searchable as String.")
  public String getManufacturer() {
    return manufacturer;
  }

   /**
   * Model of the ESX. Searchable as String.
   * @return model
  **/
  @ApiModelProperty(value = "Model of the ESX. Searchable as String.")
  public String getModel() {
    return model;
  }

   /**
   * Quantity and processor speed of the ESX&#39;s processors. Searchable as Numeric.
   * @return processors
  **/
  @ApiModelProperty(value = "Quantity and processor speed of the ESX's processors. Searchable as Numeric.")
  public String getProcessors() {
    return processors;
  }

   /**
   * Detailed information on the make and model of the ESX&#39;s processor. Searchable as String.
   * @return processorType
  **/
  @ApiModelProperty(value = "Detailed information on the make and model of the ESX's processor. Searchable as String.")
  public String getProcessorType() {
    return processorType;
  }

   /**
   * Number of Network interface controllers the ESX has. Searchable as Numeric.
   * @return numberOfNICs
  **/
  @ApiModelProperty(value = "Number of Network interface controllers the ESX has. Searchable as Numeric.")
  public String getNumberOfNICs() {
    return numberOfNICs;
  }

   /**
   * State of the ESX.
   * @return state
  **/
  @ApiModelProperty(value = "State of the ESX.")
  public String getState() {
    return state;
  }

   /**
   * Number of virtual machines hosted on the ESX.
   * @return virtualMachines
  **/
  @ApiModelProperty(value = "Number of virtual machines hosted on the ESX.")
  public String getVirtualMachines() {
    return virtualMachines;
  }

   /**
   * Indicates whether vMotion is enabled on the ESX. The is value is true if enabled. Searchable as Boolean.
   * @return vMotionEnabled
  **/
  @ApiModelProperty(value = "Indicates whether vMotion is enabled on the ESX. The is value is true if enabled. Searchable as Boolean.")
  public String getVMotionEnabled() {
    return vMotionEnabled;
  }

   /**
   * List of name/value pairs of ESX Custom Attributes
   * @return customAttributes
  **/
  @ApiModelProperty(value = "List of name/value pairs of ESX Custom Attributes")
  public List<CustomAttribute> getCustomAttributes() {
    return customAttributes;
  }

  public ESXSummary tpMEnabled(Boolean tpMEnabled) {
    this.tpMEnabled = tpMEnabled;
    return this;
  }

   /**
   * Get tpMEnabled
   * @return tpMEnabled
  **/
  @ApiModelProperty(value = "")
  public Boolean isTpMEnabled() {
    return tpMEnabled;
  }

  public void setTpMEnabled(Boolean tpMEnabled) {
    this.tpMEnabled = tpMEnabled;
  }

  public ESXSummary tpMAlertsEnabled(Boolean tpMAlertsEnabled) {
    this.tpMAlertsEnabled = tpMAlertsEnabled;
    return this;
  }

   /**
   * Get tpMAlertsEnabled
   * @return tpMAlertsEnabled
  **/
  @ApiModelProperty(value = "")
  public Boolean isTpMAlertsEnabled() {
    return tpMAlertsEnabled;
  }

  public void setTpMAlertsEnabled(Boolean tpMAlertsEnabled) {
    this.tpMAlertsEnabled = tpMAlertsEnabled;
  }

  public ESXSummary tpMHasData(Boolean tpMHasData) {
    this.tpMHasData = tpMHasData;
    return this;
  }

   /**
   * Get tpMHasData
   * @return tpMHasData
  **/
  @ApiModelProperty(value = "")
  public Boolean isTpMHasData() {
    return tpMHasData;
  }

  public void setTpMHasData(Boolean tpMHasData) {
    this.tpMHasData = tpMHasData;
  }

  public ESXSummary tpMLastChecked(Long tpMLastChecked) {
    this.tpMLastChecked = tpMLastChecked;
    return this;
  }

   /**
   * Get tpMLastChecked
   * @return tpMLastChecked
  **/
  @ApiModelProperty(value = "")
  public Long getTpMLastChecked() {
    return tpMLastChecked;
  }

  public void setTpMLastChecked(Long tpMLastChecked) {
    this.tpMLastChecked = tpMLastChecked;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ESXSummary esXSummary = (ESXSummary) o;
    return Objects.equals(this.manufacturer, esXSummary.manufacturer) &&
        Objects.equals(this.model, esXSummary.model) &&
        Objects.equals(this.processors, esXSummary.processors) &&
        Objects.equals(this.processorType, esXSummary.processorType) &&
        Objects.equals(this.numberOfNICs, esXSummary.numberOfNICs) &&
        Objects.equals(this.state, esXSummary.state) &&
        Objects.equals(this.virtualMachines, esXSummary.virtualMachines) &&
        Objects.equals(this.vMotionEnabled, esXSummary.vMotionEnabled) &&
        Objects.equals(this.customAttributes, esXSummary.customAttributes) &&
        Objects.equals(this.tpMEnabled, esXSummary.tpMEnabled) &&
        Objects.equals(this.tpMAlertsEnabled, esXSummary.tpMAlertsEnabled) &&
        Objects.equals(this.tpMHasData, esXSummary.tpMHasData) &&
        Objects.equals(this.tpMLastChecked, esXSummary.tpMLastChecked);
  }

  @Override
  public int hashCode() {
    return Objects.hash(manufacturer, model, processors, processorType, numberOfNICs, state, virtualMachines, vMotionEnabled, customAttributes, tpMEnabled, tpMAlertsEnabled, tpMHasData, tpMLastChecked);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ESXSummary {\n");
    
    sb.append("    manufacturer: ").append(toIndentedString(manufacturer)).append("\n");
    sb.append("    model: ").append(toIndentedString(model)).append("\n");
    sb.append("    processors: ").append(toIndentedString(processors)).append("\n");
    sb.append("    processorType: ").append(toIndentedString(processorType)).append("\n");
    sb.append("    numberOfNICs: ").append(toIndentedString(numberOfNICs)).append("\n");
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("    virtualMachines: ").append(toIndentedString(virtualMachines)).append("\n");
    sb.append("    vMotionEnabled: ").append(toIndentedString(vMotionEnabled)).append("\n");
    sb.append("    customAttributes: ").append(toIndentedString(customAttributes)).append("\n");
    sb.append("    tpMEnabled: ").append(toIndentedString(tpMEnabled)).append("\n");
    sb.append("    tpMAlertsEnabled: ").append(toIndentedString(tpMAlertsEnabled)).append("\n");
    sb.append("    tpMHasData: ").append(toIndentedString(tpMHasData)).append("\n");
    sb.append("    tpMLastChecked: ").append(toIndentedString(tpMLastChecked)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

