/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Endpoint Basecamp Agent deployment script.
 */
@ApiModel(description = "Endpoint Basecamp Agent deployment script.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class EndpointBasecampAgentDeploymentScript {
  /**
   * Platform type for Endpoint Basecamp Agent deployment.
   */
  public enum PlatformEnum {
    LINUX("linux"),
    
    WINDOWS("windows");

    private String value;

    PlatformEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static PlatformEnum fromValue(String text) {
      for (PlatformEnum b : PlatformEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("platform")
  private PlatformEnum platform = null;

  @JsonProperty("scriptBody")
  private String scriptBody = null;

  public EndpointBasecampAgentDeploymentScript platform(PlatformEnum platform) {
    this.platform = platform;
    return this;
  }

   /**
   * Platform type for Endpoint Basecamp Agent deployment.
   * @return platform
  **/
  @ApiModelProperty(value = "Platform type for Endpoint Basecamp Agent deployment.")
  public PlatformEnum getPlatform() {
    return platform;
  }

  public void setPlatform(PlatformEnum platform) {
    this.platform = platform;
  }

   /**
   * Endpoint Basecamp Agent deployment script.
   * @return scriptBody
  **/
  @ApiModelProperty(value = "Endpoint Basecamp Agent deployment script.")
  public String getScriptBody() {
    return scriptBody;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    EndpointBasecampAgentDeploymentScript endpointBasecampAgentDeploymentScript = (EndpointBasecampAgentDeploymentScript) o;
    return Objects.equals(this.platform, endpointBasecampAgentDeploymentScript.platform) &&
        Objects.equals(this.scriptBody, endpointBasecampAgentDeploymentScript.scriptBody);
  }

  @Override
  public int hashCode() {
    return Objects.hash(platform, scriptBody);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class EndpointBasecampAgentDeploymentScript {\n");
    
    sb.append("    platform: ").append(toIndentedString(platform)).append("\n");
    sb.append("    scriptBody: ").append(toIndentedString(scriptBody)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

