/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Defines an action to perform when an event based task condition is met.
 */
@ApiModel(description = "Defines an action to perform when an event based task condition is met.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class EventBasedTaskAction {
  /**
   * Type of action taken by the event based task.
   */
  public enum TypeEnum {
    ACTIVATE("activate"),
    
    ASSIGN_POLICY("assign-policy"),
    
    ASSIGN_RELAY("assign-relay"),
    
    ASSIGN_GROUP("assign-group"),
    
    DEACTIVATE("deactivate");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TypeEnum fromValue(String text) {
      for (TypeEnum b : TypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("type")
  private TypeEnum type = null;

  @JsonProperty("parameterValue")
  private Integer parameterValue = null;

  public EventBasedTaskAction type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * Type of action taken by the event based task.
   * @return type
  **/
  @ApiModelProperty(value = "Type of action taken by the event based task.")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }

  public EventBasedTaskAction parameterValue(Integer parameterValue) {
    this.parameterValue = parameterValue;
    return this;
  }

   /**
   * The parameter value for actions that require a parameter.  activate : activation delay in minutes  assign-policy : ID of the policy to assign  assign-relay : ID of the relay group to assign  assign-group : ID of the computer group to assign
   * @return parameterValue
  **/
  @ApiModelProperty(value = "The parameter value for actions that require a parameter.  activate : activation delay in minutes  assign-policy : ID of the policy to assign  assign-relay : ID of the relay group to assign  assign-group : ID of the computer group to assign")
  public Integer getParameterValue() {
    return parameterValue;
  }

  public void setParameterValue(Integer parameterValue) {
    this.parameterValue = parameterValue;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    EventBasedTaskAction eventBasedTaskAction = (EventBasedTaskAction) o;
    return Objects.equals(this.type, eventBasedTaskAction.type) &&
        Objects.equals(this.parameterValue, eventBasedTaskAction.parameterValue);
  }

  @Override
  public int hashCode() {
    return Objects.hash(type, parameterValue);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class EventBasedTaskAction {\n");
    
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    parameterValue: ").append(toIndentedString(parameterValue)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

