/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Defines a condition that must be met in order for an event based task to run its actions.
 */
@ApiModel(description = "Defines a condition that must be met in order for an event based task to run its actions.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class EventBasedTaskCondition {
  /**
   * The event field to match against when evaluating this condition. Use &#x60;tag&#x60; enum to specify \&quot;Cloud Instance Metadata\&quot; which correspond to \&quot;AWS Tags\&quot;, \&quot;Azure Tags\&quot; or \&quot;GCP Labels\&quot;.
   */
  public enum FieldEnum {
    HOSTNAME("hostname"),
    
    VCENTER("vcenter"),
    
    CLOUD_PROVIDER("cloudProvider"),
    
    SECURITY_GROUP("securityGroup"),
    
    IMAGE_ID("imageId"),
    
    ESX("esx"),
    
    FOLDER("folder"),
    
    PLATFORM("platform"),
    
    APPLIANCE_PROTECTION_AVAILABLE("applianceProtectionAvailable"),
    
    APPLIANCE_PROTECTION_ACTIVATED("applianceProtectionActivated"),
    
    LAST_USED_IP("lastUsedIP"),
    
    TAG("tag"),
    
    NSX_SECURITY_GROUP("nsxSecurityGroup"),
    
    CLOUD_VENDOR("cloudVendor"),
    
    GCP_NETWORK_TAG("gcpNetworkTag");

    private String value;

    FieldEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static FieldEnum fromValue(String text) {
      for (FieldEnum b : FieldEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("field")
  private FieldEnum field = null;

  @JsonProperty("key")
  private String key = null;

  @JsonProperty("value")
  private String value = null;

  public EventBasedTaskCondition field(FieldEnum field) {
    this.field = field;
    return this;
  }

   /**
   * The event field to match against when evaluating this condition. Use &#x60;tag&#x60; enum to specify \&quot;Cloud Instance Metadata\&quot; which correspond to \&quot;AWS Tags\&quot;, \&quot;Azure Tags\&quot; or \&quot;GCP Labels\&quot;.
   * @return field
  **/
  @ApiModelProperty(value = "The event field to match against when evaluating this condition. Use `tag` enum to specify \"Cloud Instance Metadata\" which correspond to \"AWS Tags\", \"Azure Tags\" or \"GCP Labels\".")
  public FieldEnum getField() {
    return field;
  }

  public void setField(FieldEnum field) {
    this.field = field;
  }

  public EventBasedTaskCondition key(String key) {
    this.key = key;
    return this;
  }

   /**
   * If matching against a key/value field, then the key to match when evaluating this condition.
   * @return key
  **/
  @ApiModelProperty(value = "If matching against a key/value field, then the key to match when evaluating this condition.")
  public String getKey() {
    return key;
  }

  public void setKey(String key) {
    this.key = key;
  }

  public EventBasedTaskCondition value(String value) {
    this.value = value;
    return this;
  }

   /**
   * The value to match when evaluating this condition.
   * @return value
  **/
  @ApiModelProperty(value = "The value to match when evaluating this condition.")
  public String getValue() {
    return value;
  }

  public void setValue(String value) {
    this.value = value;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    EventBasedTaskCondition eventBasedTaskCondition = (EventBasedTaskCondition) o;
    return Objects.equals(this.field, eventBasedTaskCondition.field) &&
        Objects.equals(this.key, eventBasedTaskCondition.key) &&
        Objects.equals(this.value, eventBasedTaskCondition.value);
  }

  @Override
  public int hashCode() {
    return Objects.hash(field, key, value);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class EventBasedTaskCondition {\n");
    
    sb.append("    field: ").append(toIndentedString(field)).append("\n");
    sb.append("    key: ").append(toIndentedString(key)).append("\n");
    sb.append("    value: ").append(toIndentedString(value)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

