/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;

import java.util.HashSet;
import java.util.Set;

/**
 * The expand parameter for a Computer.
 */
@ApiModel(description = "The expand parameter for a Computer.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class Expand {
  /**
   * Gets or Sets options
   */
  public enum OptionsEnum {
    NONE("none"),
    
    ALL("all"),
    
    COMPUTER_STATUS("computerStatus"),
    
    TASKS("tasks"),
    
    SECURITY_UPDATES("securityUpdates"),
    
    COMPUTER_SETTINGS("computerSettings"),
    
    ALL_SECURITY_MODULES("allSecurityModules"),
    
    ANTI_MALWARE("antiMalware"),
    
    WEB_REPUTATION("webReputation"),
    
    ACTIVITY_MONITORING("activityMonitoring"),
    
    DEVICE_CONTROL("deviceControl"),
    
    FIREWALL("firewall"),
    
    INTRUSION_PREVENTION("intrusionPrevention"),
    
    INTEGRITY_MONITORING("integrityMonitoring"),
    
    LOG_INSPECTION("logInspection"),
    
    APPLICATION_CONTROL("applicationControl"),
    
    SAP("SAP"),
    
    INTERFACES("interfaces"),
    
    ESX_SUMMARY("ESXSummary"),
    
    ALL_VIRTUAL_MACHINE_SUMMARIES("allVirtualMachineSummaries"),
    
    AZURE_ARM_VIRTUAL_MACHINE_SUMMARY("azureARMVirtualMachineSummary"),
    
    AZURE_VM_VIRTUAL_MACHINE_SUMMARY("azureVMVirtualMachineSummary"),
    
    EC2_VIRTUAL_MACHINE_SUMMARY("ec2VirtualMachineSummary"),
    
    NO_CONNECTOR_VIRTUAL_MACHINE_SUMMARY("noConnectorVirtualMachineSummary"),
    
    VMWARE_VM_VIRTUAL_MACHINE_SUMMARY("vmwareVMVirtualMachineSummary"),
    
    VCLOUD_VM_VIRTUAL_MACHINE_SUMMARY("vcloudVMVirtualMachineSummary"),
    
    WORKSPACE_VIRTUAL_MACHINE_SUMMARY("workspaceVirtualMachineSummary"),
    
    GCP_VIRTUAL_MACHINE_SUMMARY("gcpVirtualMachineSummary");

    private String value;

    OptionsEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static OptionsEnum fromValue(String text) {
      for (OptionsEnum b : OptionsEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("Options")
  private List<OptionsEnum> options = null;

  public Expand options(List<OptionsEnum> options) {
    this.options = options;
    return this;
  }

  public Expand addOptionsItem(OptionsEnum optionsItem) {
    if (this.options == null) {
      this.options = new ArrayList<>();
    }
    this.options.add(optionsItem);
    return this;
  }

   /**
   * The options of expand parameter.
   * @return options
  **/
  @ApiModelProperty(value = "The options of expand parameter.")
  public List<OptionsEnum> getOptions() {
    return options;
  }

  public void setOptions(List<OptionsEnum> options) {
    this.options = options;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Expand expand = (Expand) o;
    return Objects.equals(this.options, expand.options);
  }

  @Override
  public int hashCode() {
    return Objects.hash(options);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Expand {\n");
    
    sb.append("    options: ").append(toIndentedString(options)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

  private Set<String> expandSet = new HashSet<String>();

  public Expand(OptionsEnum... options) {
    add(options);

  }

  public void add(OptionsEnum... options) {
    for (OptionsEnum o : options) {
    expandSet.add(o.getValue());
    }
  }

  public void delete(OptionsEnum... options) {
    for (OptionsEnum o : options) {
      expandSet.remove(o.getValue());
    }
  }

  public void clear() {
    expandSet.clear();
  }

  public List<String> list() {
    return new ArrayList<String>(expandSet);
  }
}

