/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Firewall rule details.
 */
@ApiModel(description = "Firewall rule details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class FirewallRule {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  /**
   * Action of the packet filter. Searchable as Choice.
   */
  public enum ActionEnum {
    LOG_ONLY("log-only"),
    
    ALLOW("allow"),
    
    DENY("deny"),
    
    FORCE_ALLOW("force-allow"),
    
    BYPASS("bypass");

    private String value;

    ActionEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ActionEnum fromValue(String text) {
      for (ActionEnum b : ActionEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("action")
  private ActionEnum action = null;

  /**
   * Priority of the packet filter. Searchable as Choice.
   */
  public enum PriorityEnum {
    _0("0"),
    
    _1("1"),
    
    _2("2"),
    
    _3("3"),
    
    _4("4");

    private String value;

    PriorityEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static PriorityEnum fromValue(String text) {
      for (PriorityEnum b : PriorityEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("priority")
  private PriorityEnum priority = null;

  /**
   * Packet direction. Searchable as Choice.
   */
  public enum DirectionEnum {
    INCOMING("incoming"),
    
    OUTGOING("outgoing");

    private String value;

    DirectionEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static DirectionEnum fromValue(String text) {
      for (DirectionEnum b : DirectionEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("direction")
  private DirectionEnum direction = null;

  /**
   * Supported frame types. Searchable as Choice.
   */
  public enum FrameTypeEnum {
    ANY("any"),
    
    IP("ip"),
    
    ARP("arp"),
    
    REVARP("revarp"),
    
    IPV4("ipv4"),
    
    IPV6("ipv6"),
    
    OTHER("other");

    private String value;

    FrameTypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static FrameTypeEnum fromValue(String text) {
      for (FrameTypeEnum b : FrameTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("frameType")
  private FrameTypeEnum frameType = null;

  @JsonProperty("frameNumber")
  private Integer frameNumber = null;

  @JsonProperty("frameNot")
  private Boolean frameNot = null;

  /**
   * Protocol. Searchable as Choice.
   */
  public enum ProtocolEnum {
    ANY("any"),
    
    ICMP("icmp"),
    
    IGMP("igmp"),
    
    GGP("ggp"),
    
    TCP("tcp"),
    
    PUP("pup"),
    
    UDP("udp"),
    
    IDP("idp"),
    
    ND("nd"),
    
    RAW("raw"),
    
    TCP_UDP("tcp-udp"),
    
    ICMPV6("icmpv6"),
    
    OTHER("other");

    private String value;

    ProtocolEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ProtocolEnum fromValue(String text) {
      for (ProtocolEnum b : ProtocolEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("protocol")
  private ProtocolEnum protocol = null;

  @JsonProperty("protocolNumber")
  private Integer protocolNumber = null;

  @JsonProperty("protocolNot")
  private Boolean protocolNot = null;

  /**
   * Source IP type. Default is \&quot;any\&quot;. Searchable as Choice.
   */
  public enum SourceIPTypeEnum {
    ANY("any"),
    
    MASKED_IP("masked-ip"),
    
    RANGE("range"),
    
    IP_LIST("ip-list"),
    
    SINGLE("single"),
    
    MULTIPLE("multiple");

    private String value;

    SourceIPTypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static SourceIPTypeEnum fromValue(String text) {
      for (SourceIPTypeEnum b : SourceIPTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("sourceIPType")
  private SourceIPTypeEnum sourceIPType = null;

  @JsonProperty("sourceIPValue")
  private String sourceIPValue = null;

  @JsonProperty("sourceIPMask")
  private String sourceIPMask = null;

  @JsonProperty("sourceIPRangeFrom")
  private String sourceIPRangeFrom = null;

  @JsonProperty("sourceIPRangeTo")
  private String sourceIPRangeTo = null;

  @JsonProperty("sourceIPMultiple")
  private List<String> sourceIPMultiple = null;

  @JsonProperty("sourceIPListID")
  private Integer sourceIPListID = null;

  @JsonProperty("sourceIPNot")
  private Boolean sourceIPNot = null;

  /**
   * Source MAC type. Default is \&quot;any\&quot;. Searchable as Choice.
   */
  public enum SourceMACTypeEnum {
    ANY("any"),
    
    SINGLE("single"),
    
    MAC_LIST("mac-list"),
    
    MULTIPLE("multiple");

    private String value;

    SourceMACTypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static SourceMACTypeEnum fromValue(String text) {
      for (SourceMACTypeEnum b : SourceMACTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("sourceMACType")
  private SourceMACTypeEnum sourceMACType = null;

  @JsonProperty("sourceMACValue")
  private String sourceMACValue = null;

  @JsonProperty("sourceMACMultiple")
  private List<String> sourceMACMultiple = null;

  @JsonProperty("sourceMACListID")
  private Integer sourceMACListID = null;

  @JsonProperty("sourceMACNot")
  private Boolean sourceMACNot = null;

  /**
   * The type of source port. Searchable as Choice.
   */
  public enum SourcePortTypeEnum {
    ANY("any"),
    
    MULTIPLE("multiple"),
    
    PORT_LIST("port-list");

    private String value;

    SourcePortTypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static SourcePortTypeEnum fromValue(String text) {
      for (SourcePortTypeEnum b : SourcePortTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("sourcePortType")
  private SourcePortTypeEnum sourcePortType = null;

  @JsonProperty("sourcePortMultiple")
  private List<String> sourcePortMultiple = null;

  @JsonProperty("sourcePortListID")
  private Integer sourcePortListID = null;

  @JsonProperty("sourcePortNot")
  private Boolean sourcePortNot = null;

  /**
   * Destination IP type. Default is \&quot;any\&quot;. Searchable as Choice.
   */
  public enum DestinationIPTypeEnum {
    ANY("any"),
    
    MASKED_IP("masked-ip"),
    
    RANGE("range"),
    
    IP_LIST("ip-list"),
    
    SINGLE("single"),
    
    MULTIPLE("multiple");

    private String value;

    DestinationIPTypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static DestinationIPTypeEnum fromValue(String text) {
      for (DestinationIPTypeEnum b : DestinationIPTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("destinationIPType")
  private DestinationIPTypeEnum destinationIPType = null;

  @JsonProperty("destinationIPValue")
  private String destinationIPValue = null;

  @JsonProperty("destinationIPMask")
  private String destinationIPMask = null;

  @JsonProperty("destinationIPRangeFrom")
  private String destinationIPRangeFrom = null;

  @JsonProperty("destinationIPRangeTo")
  private String destinationIPRangeTo = null;

  @JsonProperty("destinationIPMultiple")
  private List<String> destinationIPMultiple = null;

  @JsonProperty("destinationIPListID")
  private Integer destinationIPListID = null;

  @JsonProperty("destinationIPNot")
  private Boolean destinationIPNot = null;

  /**
   * Destination MAC type. Default is \&quot;any\&quot;. Searchable as Choice.
   */
  public enum DestinationMACTypeEnum {
    ANY("any"),
    
    SINGLE("single"),
    
    MAC_LIST("mac-list"),
    
    MULTIPLE("multiple");

    private String value;

    DestinationMACTypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static DestinationMACTypeEnum fromValue(String text) {
      for (DestinationMACTypeEnum b : DestinationMACTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("destinationMACType")
  private DestinationMACTypeEnum destinationMACType = null;

  @JsonProperty("destinationMACValue")
  private String destinationMACValue = null;

  @JsonProperty("destinationMACMultiple")
  private List<String> destinationMACMultiple = null;

  @JsonProperty("destinationMACListID")
  private Integer destinationMACListID = null;

  @JsonProperty("destinationMACNot")
  private Boolean destinationMACNot = null;

  /**
   * The type of destination port. Searchable as Choice.
   */
  public enum DestinationPortTypeEnum {
    ANY("any"),
    
    MULTIPLE("multiple"),
    
    PORT_LIST("port-list");

    private String value;

    DestinationPortTypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static DestinationPortTypeEnum fromValue(String text) {
      for (DestinationPortTypeEnum b : DestinationPortTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("destinationPortType")
  private DestinationPortTypeEnum destinationPortType = null;

  @JsonProperty("destinationPortMultiple")
  private List<String> destinationPortMultiple = null;

  @JsonProperty("destinationPortListID")
  private Integer destinationPortListID = null;

  @JsonProperty("destinationPortNot")
  private Boolean destinationPortNot = null;

  @JsonProperty("anyFlags")
  private Boolean anyFlags = null;

  @JsonProperty("logDisabled")
  private Boolean logDisabled = null;

  @JsonProperty("includePacketData")
  private Boolean includePacketData = null;

  @JsonProperty("alertEnabled")
  private Boolean alertEnabled = null;

  @JsonProperty("scheduleID")
  private Integer scheduleID = null;

  @JsonProperty("contextID")
  private Integer contextID = null;

  /**
   * Gets or Sets tcpflags
   */
  public enum TcpflagsEnum {
    FIN("fin"),
    
    SYN("syn"),
    
    RST("rst"),
    
    PSH("psh"),
    
    ACK("ack"),
    
    URG("urg");

    private String value;

    TcpflagsEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TcpflagsEnum fromValue(String text) {
      for (TcpflagsEnum b : TcpflagsEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("tcpflags")
  private List<TcpflagsEnum> tcpflags = null;

  @JsonProperty("ID")
  private Integer ID = null;

  @JsonProperty("TCPNot")
  private Boolean tcPNot = null;

  @JsonProperty("ICMPType")
  private Integer icMPType = null;

  @JsonProperty("ICMPCode")
  private Integer icMPCode = null;

  @JsonProperty("ICMPNot")
  private Boolean icMPNot = null;

  public FirewallRule name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the firewall rule. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the firewall rule. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public FirewallRule description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the firewall rule. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the firewall rule. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public FirewallRule action(ActionEnum action) {
    this.action = action;
    return this;
  }

   /**
   * Action of the packet filter. Searchable as Choice.
   * @return action
  **/
  @ApiModelProperty(value = "Action of the packet filter. Searchable as Choice.")
  public ActionEnum getAction() {
    return action;
  }

  public void setAction(ActionEnum action) {
    this.action = action;
  }

  public FirewallRule priority(PriorityEnum priority) {
    this.priority = priority;
    return this;
  }

   /**
   * Priority of the packet filter. Searchable as Choice.
   * @return priority
  **/
  @ApiModelProperty(value = "Priority of the packet filter. Searchable as Choice.")
  public PriorityEnum getPriority() {
    return priority;
  }

  public void setPriority(PriorityEnum priority) {
    this.priority = priority;
  }

  public FirewallRule direction(DirectionEnum direction) {
    this.direction = direction;
    return this;
  }

   /**
   * Packet direction. Searchable as Choice.
   * @return direction
  **/
  @ApiModelProperty(value = "Packet direction. Searchable as Choice.")
  public DirectionEnum getDirection() {
    return direction;
  }

  public void setDirection(DirectionEnum direction) {
    this.direction = direction;
  }

  public FirewallRule frameType(FrameTypeEnum frameType) {
    this.frameType = frameType;
    return this;
  }

   /**
   * Supported frame types. Searchable as Choice.
   * @return frameType
  **/
  @ApiModelProperty(value = "Supported frame types. Searchable as Choice.")
  public FrameTypeEnum getFrameType() {
    return frameType;
  }

  public void setFrameType(FrameTypeEnum frameType) {
    this.frameType = frameType;
  }

  public FirewallRule frameNumber(Integer frameNumber) {
    this.frameNumber = frameNumber;
    return this;
  }

   /**
   * Ethernet frame number. Only required for FrameType \&quot;other\&quot;. Searchable as Numeric.
   * @return frameNumber
  **/
  @ApiModelProperty(value = "Ethernet frame number. Only required for FrameType \"other\". Searchable as Numeric.")
  public Integer getFrameNumber() {
    return frameNumber;
  }

  public void setFrameNumber(Integer frameNumber) {
    this.frameNumber = frameNumber;
  }

  public FirewallRule frameNot(Boolean frameNot) {
    this.frameNot = frameNot;
    return this;
  }

   /**
   * Controls if the frame setting should be inverted. Set to true to invert. Searchable as Boolean.
   * @return frameNot
  **/
  @ApiModelProperty(value = "Controls if the frame setting should be inverted. Set to true to invert. Searchable as Boolean.")
  public Boolean isFrameNot() {
    return frameNot;
  }

  public void setFrameNot(Boolean frameNot) {
    this.frameNot = frameNot;
  }

  public FirewallRule protocol(ProtocolEnum protocol) {
    this.protocol = protocol;
    return this;
  }

   /**
   * Protocol. Searchable as Choice.
   * @return protocol
  **/
  @ApiModelProperty(value = "Protocol. Searchable as Choice.")
  public ProtocolEnum getProtocol() {
    return protocol;
  }

  public void setProtocol(ProtocolEnum protocol) {
    this.protocol = protocol;
  }

  public FirewallRule protocolNumber(Integer protocolNumber) {
    this.protocolNumber = protocolNumber;
    return this;
  }

   /**
   * Two-byte protocol number. Searchable as Numeric.
   * @return protocolNumber
  **/
  @ApiModelProperty(value = "Two-byte protocol number. Searchable as Numeric.")
  public Integer getProtocolNumber() {
    return protocolNumber;
  }

  public void setProtocolNumber(Integer protocolNumber) {
    this.protocolNumber = protocolNumber;
  }

  public FirewallRule protocolNot(Boolean protocolNot) {
    this.protocolNot = protocolNot;
    return this;
  }

   /**
   * Controls if the protocol setting should be inverted. Set to true to invert. Searchable as Boolean.
   * @return protocolNot
  **/
  @ApiModelProperty(value = "Controls if the protocol setting should be inverted. Set to true to invert. Searchable as Boolean.")
  public Boolean isProtocolNot() {
    return protocolNot;
  }

  public void setProtocolNot(Boolean protocolNot) {
    this.protocolNot = protocolNot;
  }

  public FirewallRule sourceIPType(SourceIPTypeEnum sourceIPType) {
    this.sourceIPType = sourceIPType;
    return this;
  }

   /**
   * Source IP type. Default is \&quot;any\&quot;. Searchable as Choice.
   * @return sourceIPType
  **/
  @ApiModelProperty(value = "Source IP type. Default is \"any\". Searchable as Choice.")
  public SourceIPTypeEnum getSourceIPType() {
    return sourceIPType;
  }

  public void setSourceIPType(SourceIPTypeEnum sourceIPType) {
    this.sourceIPType = sourceIPType;
  }

  public FirewallRule sourceIPValue(String sourceIPValue) {
    this.sourceIPValue = sourceIPValue;
    return this;
  }

   /**
   * Source IP. Only applies to source IP type \&quot;masked-ip\&quot; or \&quot;single\&quot;. Searchable as String.
   * @return sourceIPValue
  **/
  @ApiModelProperty(value = "Source IP. Only applies to source IP type \"masked-ip\" or \"single\". Searchable as String.")
  public String getSourceIPValue() {
    return sourceIPValue;
  }

  public void setSourceIPValue(String sourceIPValue) {
    this.sourceIPValue = sourceIPValue;
  }

  public FirewallRule sourceIPMask(String sourceIPMask) {
    this.sourceIPMask = sourceIPMask;
    return this;
  }

   /**
   * Source IP mask. Only applies to source IP type \&quot;masked-ip\&quot;. Searchable as String.
   * @return sourceIPMask
  **/
  @ApiModelProperty(value = "Source IP mask. Only applies to source IP type \"masked-ip\". Searchable as String.")
  public String getSourceIPMask() {
    return sourceIPMask;
  }

  public void setSourceIPMask(String sourceIPMask) {
    this.sourceIPMask = sourceIPMask;
  }

  public FirewallRule sourceIPRangeFrom(String sourceIPRangeFrom) {
    this.sourceIPRangeFrom = sourceIPRangeFrom;
    return this;
  }

   /**
   * The first value for a range of source IP addresses. Only applies to source IP type \&quot;range\&quot;. Searchable as String.
   * @return sourceIPRangeFrom
  **/
  @ApiModelProperty(value = "The first value for a range of source IP addresses. Only applies to source IP type \"range\". Searchable as String.")
  public String getSourceIPRangeFrom() {
    return sourceIPRangeFrom;
  }

  public void setSourceIPRangeFrom(String sourceIPRangeFrom) {
    this.sourceIPRangeFrom = sourceIPRangeFrom;
  }

  public FirewallRule sourceIPRangeTo(String sourceIPRangeTo) {
    this.sourceIPRangeTo = sourceIPRangeTo;
    return this;
  }

   /**
   * The last value for a range of source IP addresses. Only applies to source IP type \&quot;range\&quot;. Searchable as String.
   * @return sourceIPRangeTo
  **/
  @ApiModelProperty(value = "The last value for a range of source IP addresses. Only applies to source IP type \"range\". Searchable as String.")
  public String getSourceIPRangeTo() {
    return sourceIPRangeTo;
  }

  public void setSourceIPRangeTo(String sourceIPRangeTo) {
    this.sourceIPRangeTo = sourceIPRangeTo;
  }

  public FirewallRule sourceIPMultiple(List<String> sourceIPMultiple) {
    this.sourceIPMultiple = sourceIPMultiple;
    return this;
  }

  public FirewallRule addSourceIPMultipleItem(String sourceIPMultipleItem) {
    if (this.sourceIPMultiple == null) {
      this.sourceIPMultiple = new ArrayList<>();
    }
    this.sourceIPMultiple.add(sourceIPMultipleItem);
    return this;
  }

   /**
   * List of source IP addresses. Only applies to source IP type \&quot;multiple\&quot;. Searchable as String.
   * @return sourceIPMultiple
  **/
  @ApiModelProperty(value = "List of source IP addresses. Only applies to source IP type \"multiple\". Searchable as String.")
  public List<String> getSourceIPMultiple() {
    return sourceIPMultiple;
  }

  public void setSourceIPMultiple(List<String> sourceIPMultiple) {
    this.sourceIPMultiple = sourceIPMultiple;
  }

  public FirewallRule sourceIPListID(Integer sourceIPListID) {
    this.sourceIPListID = sourceIPListID;
    return this;
  }

   /**
   * ID of source IP list. Only applies to source IP type \&quot;ip-list\&quot;. Set to 0 to remove any assignment. Searchable as Numeric.
   * @return sourceIPListID
  **/
  @ApiModelProperty(value = "ID of source IP list. Only applies to source IP type \"ip-list\". Set to 0 to remove any assignment. Searchable as Numeric.")
  public Integer getSourceIPListID() {
    return sourceIPListID;
  }

  public void setSourceIPListID(Integer sourceIPListID) {
    this.sourceIPListID = sourceIPListID;
  }

  public FirewallRule sourceIPNot(Boolean sourceIPNot) {
    this.sourceIPNot = sourceIPNot;
    return this;
  }

   /**
   * Controls if the source IP setting should be inverted. Set to true to invert. Searchable as Boolean.
   * @return sourceIPNot
  **/
  @ApiModelProperty(value = "Controls if the source IP setting should be inverted. Set to true to invert. Searchable as Boolean.")
  public Boolean isSourceIPNot() {
    return sourceIPNot;
  }

  public void setSourceIPNot(Boolean sourceIPNot) {
    this.sourceIPNot = sourceIPNot;
  }

  public FirewallRule sourceMACType(SourceMACTypeEnum sourceMACType) {
    this.sourceMACType = sourceMACType;
    return this;
  }

   /**
   * Source MAC type. Default is \&quot;any\&quot;. Searchable as Choice.
   * @return sourceMACType
  **/
  @ApiModelProperty(value = "Source MAC type. Default is \"any\". Searchable as Choice.")
  public SourceMACTypeEnum getSourceMACType() {
    return sourceMACType;
  }

  public void setSourceMACType(SourceMACTypeEnum sourceMACType) {
    this.sourceMACType = sourceMACType;
  }

  public FirewallRule sourceMACValue(String sourceMACValue) {
    this.sourceMACValue = sourceMACValue;
    return this;
  }

   /**
   * Source MAC address. Only applies to MAC type \&quot;single\&quot;. Searchable as String.
   * @return sourceMACValue
  **/
  @ApiModelProperty(value = "Source MAC address. Only applies to MAC type \"single\". Searchable as String.")
  public String getSourceMACValue() {
    return sourceMACValue;
  }

  public void setSourceMACValue(String sourceMACValue) {
    this.sourceMACValue = sourceMACValue;
  }

  public FirewallRule sourceMACMultiple(List<String> sourceMACMultiple) {
    this.sourceMACMultiple = sourceMACMultiple;
    return this;
  }

  public FirewallRule addSourceMACMultipleItem(String sourceMACMultipleItem) {
    if (this.sourceMACMultiple == null) {
      this.sourceMACMultiple = new ArrayList<>();
    }
    this.sourceMACMultiple.add(sourceMACMultipleItem);
    return this;
  }

   /**
   * List of MAC addresses. Only applies to MAC type \&quot;multiple\&quot;. Searchable as String.
   * @return sourceMACMultiple
  **/
  @ApiModelProperty(value = "List of MAC addresses. Only applies to MAC type \"multiple\". Searchable as String.")
  public List<String> getSourceMACMultiple() {
    return sourceMACMultiple;
  }

  public void setSourceMACMultiple(List<String> sourceMACMultiple) {
    this.sourceMACMultiple = sourceMACMultiple;
  }

  public FirewallRule sourceMACListID(Integer sourceMACListID) {
    this.sourceMACListID = sourceMACListID;
    return this;
  }

   /**
   * ID of MAC address list. Only applies to MAC type \&quot;mac-list\&quot;. Set to 0 to remove any assignment. Searchable as Numeric.
   * @return sourceMACListID
  **/
  @ApiModelProperty(value = "ID of MAC address list. Only applies to MAC type \"mac-list\". Set to 0 to remove any assignment. Searchable as Numeric.")
  public Integer getSourceMACListID() {
    return sourceMACListID;
  }

  public void setSourceMACListID(Integer sourceMACListID) {
    this.sourceMACListID = sourceMACListID;
  }

  public FirewallRule sourceMACNot(Boolean sourceMACNot) {
    this.sourceMACNot = sourceMACNot;
    return this;
  }

   /**
   * Controls if the source MAC setting should be inverted. Set to true to invert. Searchable as Boolean.
   * @return sourceMACNot
  **/
  @ApiModelProperty(value = "Controls if the source MAC setting should be inverted. Set to true to invert. Searchable as Boolean.")
  public Boolean isSourceMACNot() {
    return sourceMACNot;
  }

  public void setSourceMACNot(Boolean sourceMACNot) {
    this.sourceMACNot = sourceMACNot;
  }

  public FirewallRule sourcePortType(SourcePortTypeEnum sourcePortType) {
    this.sourcePortType = sourcePortType;
    return this;
  }

   /**
   * The type of source port. Searchable as Choice.
   * @return sourcePortType
  **/
  @ApiModelProperty(value = "The type of source port. Searchable as Choice.")
  public SourcePortTypeEnum getSourcePortType() {
    return sourcePortType;
  }

  public void setSourcePortType(SourcePortTypeEnum sourcePortType) {
    this.sourcePortType = sourcePortType;
  }

  public FirewallRule sourcePortMultiple(List<String> sourcePortMultiple) {
    this.sourcePortMultiple = sourcePortMultiple;
    return this;
  }

  public FirewallRule addSourcePortMultipleItem(String sourcePortMultipleItem) {
    if (this.sourcePortMultiple == null) {
      this.sourcePortMultiple = new ArrayList<>();
    }
    this.sourcePortMultiple.add(sourcePortMultipleItem);
    return this;
  }

   /**
   * List of comma-delimited source ports. Only applies to source type \&quot;multiple\&quot;. Searchable as String.
   * @return sourcePortMultiple
  **/
  @ApiModelProperty(value = "List of comma-delimited source ports. Only applies to source type \"multiple\". Searchable as String.")
  public List<String> getSourcePortMultiple() {
    return sourcePortMultiple;
  }

  public void setSourcePortMultiple(List<String> sourcePortMultiple) {
    this.sourcePortMultiple = sourcePortMultiple;
  }

  public FirewallRule sourcePortListID(Integer sourcePortListID) {
    this.sourcePortListID = sourcePortListID;
    return this;
  }

   /**
   * ID of source port list. Only applies to source type \&quot;port-list\&quot;. Set to 0 to remove any assignment. Searchable as Numeric.
   * @return sourcePortListID
  **/
  @ApiModelProperty(value = "ID of source port list. Only applies to source type \"port-list\". Set to 0 to remove any assignment. Searchable as Numeric.")
  public Integer getSourcePortListID() {
    return sourcePortListID;
  }

  public void setSourcePortListID(Integer sourcePortListID) {
    this.sourcePortListID = sourcePortListID;
  }

  public FirewallRule sourcePortNot(Boolean sourcePortNot) {
    this.sourcePortNot = sourcePortNot;
    return this;
  }

   /**
   * Controls if the source port setting should be inverted. Set to true to invert. Searchable as Boolean.
   * @return sourcePortNot
  **/
  @ApiModelProperty(value = "Controls if the source port setting should be inverted. Set to true to invert. Searchable as Boolean.")
  public Boolean isSourcePortNot() {
    return sourcePortNot;
  }

  public void setSourcePortNot(Boolean sourcePortNot) {
    this.sourcePortNot = sourcePortNot;
  }

  public FirewallRule destinationIPType(DestinationIPTypeEnum destinationIPType) {
    this.destinationIPType = destinationIPType;
    return this;
  }

   /**
   * Destination IP type. Default is \&quot;any\&quot;. Searchable as Choice.
   * @return destinationIPType
  **/
  @ApiModelProperty(value = "Destination IP type. Default is \"any\". Searchable as Choice.")
  public DestinationIPTypeEnum getDestinationIPType() {
    return destinationIPType;
  }

  public void setDestinationIPType(DestinationIPTypeEnum destinationIPType) {
    this.destinationIPType = destinationIPType;
  }

  public FirewallRule destinationIPValue(String destinationIPValue) {
    this.destinationIPValue = destinationIPValue;
    return this;
  }

   /**
   * Destination IP. Only applies to destination IP type \&quot;masked-ip\&quot; or \&quot;single\&quot;. Searchable as String.
   * @return destinationIPValue
  **/
  @ApiModelProperty(value = "Destination IP. Only applies to destination IP type \"masked-ip\" or \"single\". Searchable as String.")
  public String getDestinationIPValue() {
    return destinationIPValue;
  }

  public void setDestinationIPValue(String destinationIPValue) {
    this.destinationIPValue = destinationIPValue;
  }

  public FirewallRule destinationIPMask(String destinationIPMask) {
    this.destinationIPMask = destinationIPMask;
    return this;
  }

   /**
   * Destination IP mask. Only applies to destination IP type \&quot;masked-ip\&quot;. Searchable as String.
   * @return destinationIPMask
  **/
  @ApiModelProperty(value = "Destination IP mask. Only applies to destination IP type \"masked-ip\". Searchable as String.")
  public String getDestinationIPMask() {
    return destinationIPMask;
  }

  public void setDestinationIPMask(String destinationIPMask) {
    this.destinationIPMask = destinationIPMask;
  }

  public FirewallRule destinationIPRangeFrom(String destinationIPRangeFrom) {
    this.destinationIPRangeFrom = destinationIPRangeFrom;
    return this;
  }

   /**
   * The first value for a range of destination IP addresses. Only applies to estination IP type \&quot;range\&quot;. Searchable as String.
   * @return destinationIPRangeFrom
  **/
  @ApiModelProperty(value = "The first value for a range of destination IP addresses. Only applies to estination IP type \"range\". Searchable as String.")
  public String getDestinationIPRangeFrom() {
    return destinationIPRangeFrom;
  }

  public void setDestinationIPRangeFrom(String destinationIPRangeFrom) {
    this.destinationIPRangeFrom = destinationIPRangeFrom;
  }

  public FirewallRule destinationIPRangeTo(String destinationIPRangeTo) {
    this.destinationIPRangeTo = destinationIPRangeTo;
    return this;
  }

   /**
   * The last value for a range of destination IP addresses. Only applies to destination IP type \&quot;range\&quot;. Searchable as String.
   * @return destinationIPRangeTo
  **/
  @ApiModelProperty(value = "The last value for a range of destination IP addresses. Only applies to destination IP type \"range\". Searchable as String.")
  public String getDestinationIPRangeTo() {
    return destinationIPRangeTo;
  }

  public void setDestinationIPRangeTo(String destinationIPRangeTo) {
    this.destinationIPRangeTo = destinationIPRangeTo;
  }

  public FirewallRule destinationIPMultiple(List<String> destinationIPMultiple) {
    this.destinationIPMultiple = destinationIPMultiple;
    return this;
  }

  public FirewallRule addDestinationIPMultipleItem(String destinationIPMultipleItem) {
    if (this.destinationIPMultiple == null) {
      this.destinationIPMultiple = new ArrayList<>();
    }
    this.destinationIPMultiple.add(destinationIPMultipleItem);
    return this;
  }

   /**
   * List of comma-delimited destination IP addresses. Only applies to destination IP type \&quot;multiple\&quot;. Searchable as String.
   * @return destinationIPMultiple
  **/
  @ApiModelProperty(value = "List of comma-delimited destination IP addresses. Only applies to destination IP type \"multiple\". Searchable as String.")
  public List<String> getDestinationIPMultiple() {
    return destinationIPMultiple;
  }

  public void setDestinationIPMultiple(List<String> destinationIPMultiple) {
    this.destinationIPMultiple = destinationIPMultiple;
  }

  public FirewallRule destinationIPListID(Integer destinationIPListID) {
    this.destinationIPListID = destinationIPListID;
    return this;
  }

   /**
   * ID of destination IP list. Only applies to destination IP type \&quot;ip-list\&quot;. Set to 0 to remove any assignment. Searchable as Numeric.
   * @return destinationIPListID
  **/
  @ApiModelProperty(value = "ID of destination IP list. Only applies to destination IP type \"ip-list\". Set to 0 to remove any assignment. Searchable as Numeric.")
  public Integer getDestinationIPListID() {
    return destinationIPListID;
  }

  public void setDestinationIPListID(Integer destinationIPListID) {
    this.destinationIPListID = destinationIPListID;
  }

  public FirewallRule destinationIPNot(Boolean destinationIPNot) {
    this.destinationIPNot = destinationIPNot;
    return this;
  }

   /**
   * Controls if the destination IP setting should be inverted. Set to true to invert. Searchable as Boolean.
   * @return destinationIPNot
  **/
  @ApiModelProperty(value = "Controls if the destination IP setting should be inverted. Set to true to invert. Searchable as Boolean.")
  public Boolean isDestinationIPNot() {
    return destinationIPNot;
  }

  public void setDestinationIPNot(Boolean destinationIPNot) {
    this.destinationIPNot = destinationIPNot;
  }

  public FirewallRule destinationMACType(DestinationMACTypeEnum destinationMACType) {
    this.destinationMACType = destinationMACType;
    return this;
  }

   /**
   * Destination MAC type. Default is \&quot;any\&quot;. Searchable as Choice.
   * @return destinationMACType
  **/
  @ApiModelProperty(value = "Destination MAC type. Default is \"any\". Searchable as Choice.")
  public DestinationMACTypeEnum getDestinationMACType() {
    return destinationMACType;
  }

  public void setDestinationMACType(DestinationMACTypeEnum destinationMACType) {
    this.destinationMACType = destinationMACType;
  }

  public FirewallRule destinationMACValue(String destinationMACValue) {
    this.destinationMACValue = destinationMACValue;
    return this;
  }

   /**
   * Destination MAC address. Only applies to MAC type \&quot;single\&quot;. Searchable as String.
   * @return destinationMACValue
  **/
  @ApiModelProperty(value = "Destination MAC address. Only applies to MAC type \"single\". Searchable as String.")
  public String getDestinationMACValue() {
    return destinationMACValue;
  }

  public void setDestinationMACValue(String destinationMACValue) {
    this.destinationMACValue = destinationMACValue;
  }

  public FirewallRule destinationMACMultiple(List<String> destinationMACMultiple) {
    this.destinationMACMultiple = destinationMACMultiple;
    return this;
  }

  public FirewallRule addDestinationMACMultipleItem(String destinationMACMultipleItem) {
    if (this.destinationMACMultiple == null) {
      this.destinationMACMultiple = new ArrayList<>();
    }
    this.destinationMACMultiple.add(destinationMACMultipleItem);
    return this;
  }

   /**
   * List of comma-delimited MAC addresses. Only applies to MAC type \&quot;multiple\&quot;. Searchable as String.
   * @return destinationMACMultiple
  **/
  @ApiModelProperty(value = "List of comma-delimited MAC addresses. Only applies to MAC type \"multiple\". Searchable as String.")
  public List<String> getDestinationMACMultiple() {
    return destinationMACMultiple;
  }

  public void setDestinationMACMultiple(List<String> destinationMACMultiple) {
    this.destinationMACMultiple = destinationMACMultiple;
  }

  public FirewallRule destinationMACListID(Integer destinationMACListID) {
    this.destinationMACListID = destinationMACListID;
    return this;
  }

   /**
   * ID of MAC address list. Only applies to MAC type \&quot;mac-list\&quot;. Set to 0 to remove any assignment. Searchable as Numeric.
   * @return destinationMACListID
  **/
  @ApiModelProperty(value = "ID of MAC address list. Only applies to MAC type \"mac-list\". Set to 0 to remove any assignment. Searchable as Numeric.")
  public Integer getDestinationMACListID() {
    return destinationMACListID;
  }

  public void setDestinationMACListID(Integer destinationMACListID) {
    this.destinationMACListID = destinationMACListID;
  }

  public FirewallRule destinationMACNot(Boolean destinationMACNot) {
    this.destinationMACNot = destinationMACNot;
    return this;
  }

   /**
   * Controls if the destination MAC setting should be inverted. Set to true to invert. Searchable as Boolean.
   * @return destinationMACNot
  **/
  @ApiModelProperty(value = "Controls if the destination MAC setting should be inverted. Set to true to invert. Searchable as Boolean.")
  public Boolean isDestinationMACNot() {
    return destinationMACNot;
  }

  public void setDestinationMACNot(Boolean destinationMACNot) {
    this.destinationMACNot = destinationMACNot;
  }

  public FirewallRule destinationPortType(DestinationPortTypeEnum destinationPortType) {
    this.destinationPortType = destinationPortType;
    return this;
  }

   /**
   * The type of destination port. Searchable as Choice.
   * @return destinationPortType
  **/
  @ApiModelProperty(value = "The type of destination port. Searchable as Choice.")
  public DestinationPortTypeEnum getDestinationPortType() {
    return destinationPortType;
  }

  public void setDestinationPortType(DestinationPortTypeEnum destinationPortType) {
    this.destinationPortType = destinationPortType;
  }

  public FirewallRule destinationPortMultiple(List<String> destinationPortMultiple) {
    this.destinationPortMultiple = destinationPortMultiple;
    return this;
  }

  public FirewallRule addDestinationPortMultipleItem(String destinationPortMultipleItem) {
    if (this.destinationPortMultiple == null) {
      this.destinationPortMultiple = new ArrayList<>();
    }
    this.destinationPortMultiple.add(destinationPortMultipleItem);
    return this;
  }

   /**
   * List of comma-delimited destination ports. Only applies to destination type \&quot;multiple\&quot;. Searchable as String.
   * @return destinationPortMultiple
  **/
  @ApiModelProperty(value = "List of comma-delimited destination ports. Only applies to destination type \"multiple\". Searchable as String.")
  public List<String> getDestinationPortMultiple() {
    return destinationPortMultiple;
  }

  public void setDestinationPortMultiple(List<String> destinationPortMultiple) {
    this.destinationPortMultiple = destinationPortMultiple;
  }

  public FirewallRule destinationPortListID(Integer destinationPortListID) {
    this.destinationPortListID = destinationPortListID;
    return this;
  }

   /**
   * ID of destination port list. Only applies to destination type \&quot;port-list\&quot;. Set to 0 to remove any assignment. Searchable as Numeric.
   * @return destinationPortListID
  **/
  @ApiModelProperty(value = "ID of destination port list. Only applies to destination type \"port-list\". Set to 0 to remove any assignment. Searchable as Numeric.")
  public Integer getDestinationPortListID() {
    return destinationPortListID;
  }

  public void setDestinationPortListID(Integer destinationPortListID) {
    this.destinationPortListID = destinationPortListID;
  }

  public FirewallRule destinationPortNot(Boolean destinationPortNot) {
    this.destinationPortNot = destinationPortNot;
    return this;
  }

   /**
   * Controls if the destination port setting should be inverted. Set to true to invert. Searchable as Boolean.
   * @return destinationPortNot
  **/
  @ApiModelProperty(value = "Controls if the destination port setting should be inverted. Set to true to invert. Searchable as Boolean.")
  public Boolean isDestinationPortNot() {
    return destinationPortNot;
  }

  public void setDestinationPortNot(Boolean destinationPortNot) {
    this.destinationPortNot = destinationPortNot;
  }

  public FirewallRule anyFlags(Boolean anyFlags) {
    this.anyFlags = anyFlags;
    return this;
  }

   /**
   * True if any flags are used. Searchable as Boolean.
   * @return anyFlags
  **/
  @ApiModelProperty(value = "True if any flags are used. Searchable as Boolean.")
  public Boolean isAnyFlags() {
    return anyFlags;
  }

  public void setAnyFlags(Boolean anyFlags) {
    this.anyFlags = anyFlags;
  }

  public FirewallRule logDisabled(Boolean logDisabled) {
    this.logDisabled = logDisabled;
    return this;
  }

   /**
   * Controls if logging for this filter is disabled. Only applies to filter action \&quot;log-only\&quot; or \&quot;deny\&quot;. Searchable as Boolean.
   * @return logDisabled
  **/
  @ApiModelProperty(value = "Controls if logging for this filter is disabled. Only applies to filter action \"log-only\" or \"deny\". Searchable as Boolean.")
  public Boolean isLogDisabled() {
    return logDisabled;
  }

  public void setLogDisabled(Boolean logDisabled) {
    this.logDisabled = logDisabled;
  }

  public FirewallRule includePacketData(Boolean includePacketData) {
    this.includePacketData = includePacketData;
    return this;
  }

   /**
   * Controls if this filter should capture data for every log. Searchable as Boolean.
   * @return includePacketData
  **/
  @ApiModelProperty(value = "Controls if this filter should capture data for every log. Searchable as Boolean.")
  public Boolean isIncludePacketData() {
    return includePacketData;
  }

  public void setIncludePacketData(Boolean includePacketData) {
    this.includePacketData = includePacketData;
  }

  public FirewallRule alertEnabled(Boolean alertEnabled) {
    this.alertEnabled = alertEnabled;
    return this;
  }

   /**
   * Controls if this filter should be alerted on. Searchable as Boolean.
   * @return alertEnabled
  **/
  @ApiModelProperty(value = "Controls if this filter should be alerted on. Searchable as Boolean.")
  public Boolean isAlertEnabled() {
    return alertEnabled;
  }

  public void setAlertEnabled(Boolean alertEnabled) {
    this.alertEnabled = alertEnabled;
  }

  public FirewallRule scheduleID(Integer scheduleID) {
    this.scheduleID = scheduleID;
    return this;
  }

   /**
   * ID of the schedule to control when this filter is \&quot;on\&quot;. Set to 0 to remove any assignment. Searchable as Numeric.
   * @return scheduleID
  **/
  @ApiModelProperty(value = "ID of the schedule to control when this filter is \"on\". Set to 0 to remove any assignment. Searchable as Numeric.")
  public Integer getScheduleID() {
    return scheduleID;
  }

  public void setScheduleID(Integer scheduleID) {
    this.scheduleID = scheduleID;
  }

  public FirewallRule contextID(Integer contextID) {
    this.contextID = contextID;
    return this;
  }

   /**
   * RuleContext that is applied to this filter. Set to 0 to remove any assignment. Searchable as Numeric.
   * @return contextID
  **/
  @ApiModelProperty(value = "RuleContext that is applied to this filter. Set to 0 to remove any assignment. Searchable as Numeric.")
  public Integer getContextID() {
    return contextID;
  }

  public void setContextID(Integer contextID) {
    this.contextID = contextID;
  }

  public FirewallRule tcpflags(List<TcpflagsEnum> tcpflags) {
    this.tcpflags = tcpflags;
    return this;
  }

  public FirewallRule addTcpflagsItem(TcpflagsEnum tcpflagsItem) {
    if (this.tcpflags == null) {
      this.tcpflags = new ArrayList<>();
    }
    this.tcpflags.add(tcpflagsItem);
    return this;
  }

   /**
   * Get tcpflags
   * @return tcpflags
  **/
  @ApiModelProperty(value = "")
  public List<TcpflagsEnum> getTcpflags() {
    return tcpflags;
  }

  public void setTcpflags(List<TcpflagsEnum> tcpflags) {
    this.tcpflags = tcpflags;
  }

   /**
   * ID of the firewall rule. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the firewall rule. Searchable as ID.")
  public Integer getID() {
    return ID;
  }

  public FirewallRule tcPNot(Boolean tcPNot) {
    this.tcPNot = tcPNot;
    return this;
  }

   /**
   * Get tcPNot
   * @return tcPNot
  **/
  @ApiModelProperty(value = "")
  public Boolean isTcPNot() {
    return tcPNot;
  }

  public void setTcPNot(Boolean tcPNot) {
    this.tcPNot = tcPNot;
  }

  public FirewallRule icMPType(Integer icMPType) {
    this.icMPType = icMPType;
    return this;
  }

   /**
   * Get icMPType
   * @return icMPType
  **/
  @ApiModelProperty(value = "")
  public Integer getIcMPType() {
    return icMPType;
  }

  public void setIcMPType(Integer icMPType) {
    this.icMPType = icMPType;
  }

  public FirewallRule icMPCode(Integer icMPCode) {
    this.icMPCode = icMPCode;
    return this;
  }

   /**
   * Get icMPCode
   * @return icMPCode
  **/
  @ApiModelProperty(value = "")
  public Integer getIcMPCode() {
    return icMPCode;
  }

  public void setIcMPCode(Integer icMPCode) {
    this.icMPCode = icMPCode;
  }

  public FirewallRule icMPNot(Boolean icMPNot) {
    this.icMPNot = icMPNot;
    return this;
  }

   /**
   * Get icMPNot
   * @return icMPNot
  **/
  @ApiModelProperty(value = "")
  public Boolean isIcMPNot() {
    return icMPNot;
  }

  public void setIcMPNot(Boolean icMPNot) {
    this.icMPNot = icMPNot;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    FirewallRule firewallRule = (FirewallRule) o;
    return Objects.equals(this.name, firewallRule.name) &&
        Objects.equals(this.description, firewallRule.description) &&
        Objects.equals(this.action, firewallRule.action) &&
        Objects.equals(this.priority, firewallRule.priority) &&
        Objects.equals(this.direction, firewallRule.direction) &&
        Objects.equals(this.frameType, firewallRule.frameType) &&
        Objects.equals(this.frameNumber, firewallRule.frameNumber) &&
        Objects.equals(this.frameNot, firewallRule.frameNot) &&
        Objects.equals(this.protocol, firewallRule.protocol) &&
        Objects.equals(this.protocolNumber, firewallRule.protocolNumber) &&
        Objects.equals(this.protocolNot, firewallRule.protocolNot) &&
        Objects.equals(this.sourceIPType, firewallRule.sourceIPType) &&
        Objects.equals(this.sourceIPValue, firewallRule.sourceIPValue) &&
        Objects.equals(this.sourceIPMask, firewallRule.sourceIPMask) &&
        Objects.equals(this.sourceIPRangeFrom, firewallRule.sourceIPRangeFrom) &&
        Objects.equals(this.sourceIPRangeTo, firewallRule.sourceIPRangeTo) &&
        Objects.equals(this.sourceIPMultiple, firewallRule.sourceIPMultiple) &&
        Objects.equals(this.sourceIPListID, firewallRule.sourceIPListID) &&
        Objects.equals(this.sourceIPNot, firewallRule.sourceIPNot) &&
        Objects.equals(this.sourceMACType, firewallRule.sourceMACType) &&
        Objects.equals(this.sourceMACValue, firewallRule.sourceMACValue) &&
        Objects.equals(this.sourceMACMultiple, firewallRule.sourceMACMultiple) &&
        Objects.equals(this.sourceMACListID, firewallRule.sourceMACListID) &&
        Objects.equals(this.sourceMACNot, firewallRule.sourceMACNot) &&
        Objects.equals(this.sourcePortType, firewallRule.sourcePortType) &&
        Objects.equals(this.sourcePortMultiple, firewallRule.sourcePortMultiple) &&
        Objects.equals(this.sourcePortListID, firewallRule.sourcePortListID) &&
        Objects.equals(this.sourcePortNot, firewallRule.sourcePortNot) &&
        Objects.equals(this.destinationIPType, firewallRule.destinationIPType) &&
        Objects.equals(this.destinationIPValue, firewallRule.destinationIPValue) &&
        Objects.equals(this.destinationIPMask, firewallRule.destinationIPMask) &&
        Objects.equals(this.destinationIPRangeFrom, firewallRule.destinationIPRangeFrom) &&
        Objects.equals(this.destinationIPRangeTo, firewallRule.destinationIPRangeTo) &&
        Objects.equals(this.destinationIPMultiple, firewallRule.destinationIPMultiple) &&
        Objects.equals(this.destinationIPListID, firewallRule.destinationIPListID) &&
        Objects.equals(this.destinationIPNot, firewallRule.destinationIPNot) &&
        Objects.equals(this.destinationMACType, firewallRule.destinationMACType) &&
        Objects.equals(this.destinationMACValue, firewallRule.destinationMACValue) &&
        Objects.equals(this.destinationMACMultiple, firewallRule.destinationMACMultiple) &&
        Objects.equals(this.destinationMACListID, firewallRule.destinationMACListID) &&
        Objects.equals(this.destinationMACNot, firewallRule.destinationMACNot) &&
        Objects.equals(this.destinationPortType, firewallRule.destinationPortType) &&
        Objects.equals(this.destinationPortMultiple, firewallRule.destinationPortMultiple) &&
        Objects.equals(this.destinationPortListID, firewallRule.destinationPortListID) &&
        Objects.equals(this.destinationPortNot, firewallRule.destinationPortNot) &&
        Objects.equals(this.anyFlags, firewallRule.anyFlags) &&
        Objects.equals(this.logDisabled, firewallRule.logDisabled) &&
        Objects.equals(this.includePacketData, firewallRule.includePacketData) &&
        Objects.equals(this.alertEnabled, firewallRule.alertEnabled) &&
        Objects.equals(this.scheduleID, firewallRule.scheduleID) &&
        Objects.equals(this.contextID, firewallRule.contextID) &&
        Objects.equals(this.tcpflags, firewallRule.tcpflags) &&
        Objects.equals(this.ID, firewallRule.ID) &&
        Objects.equals(this.tcPNot, firewallRule.tcPNot) &&
        Objects.equals(this.icMPType, firewallRule.icMPType) &&
        Objects.equals(this.icMPCode, firewallRule.icMPCode) &&
        Objects.equals(this.icMPNot, firewallRule.icMPNot);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, action, priority, direction, frameType, frameNumber, frameNot, protocol, protocolNumber, protocolNot, sourceIPType, sourceIPValue, sourceIPMask, sourceIPRangeFrom, sourceIPRangeTo, sourceIPMultiple, sourceIPListID, sourceIPNot, sourceMACType, sourceMACValue, sourceMACMultiple, sourceMACListID, sourceMACNot, sourcePortType, sourcePortMultiple, sourcePortListID, sourcePortNot, destinationIPType, destinationIPValue, destinationIPMask, destinationIPRangeFrom, destinationIPRangeTo, destinationIPMultiple, destinationIPListID, destinationIPNot, destinationMACType, destinationMACValue, destinationMACMultiple, destinationMACListID, destinationMACNot, destinationPortType, destinationPortMultiple, destinationPortListID, destinationPortNot, anyFlags, logDisabled, includePacketData, alertEnabled, scheduleID, contextID, tcpflags, ID, tcPNot, icMPType, icMPCode, icMPNot);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class FirewallRule {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    action: ").append(toIndentedString(action)).append("\n");
    sb.append("    priority: ").append(toIndentedString(priority)).append("\n");
    sb.append("    direction: ").append(toIndentedString(direction)).append("\n");
    sb.append("    frameType: ").append(toIndentedString(frameType)).append("\n");
    sb.append("    frameNumber: ").append(toIndentedString(frameNumber)).append("\n");
    sb.append("    frameNot: ").append(toIndentedString(frameNot)).append("\n");
    sb.append("    protocol: ").append(toIndentedString(protocol)).append("\n");
    sb.append("    protocolNumber: ").append(toIndentedString(protocolNumber)).append("\n");
    sb.append("    protocolNot: ").append(toIndentedString(protocolNot)).append("\n");
    sb.append("    sourceIPType: ").append(toIndentedString(sourceIPType)).append("\n");
    sb.append("    sourceIPValue: ").append(toIndentedString(sourceIPValue)).append("\n");
    sb.append("    sourceIPMask: ").append(toIndentedString(sourceIPMask)).append("\n");
    sb.append("    sourceIPRangeFrom: ").append(toIndentedString(sourceIPRangeFrom)).append("\n");
    sb.append("    sourceIPRangeTo: ").append(toIndentedString(sourceIPRangeTo)).append("\n");
    sb.append("    sourceIPMultiple: ").append(toIndentedString(sourceIPMultiple)).append("\n");
    sb.append("    sourceIPListID: ").append(toIndentedString(sourceIPListID)).append("\n");
    sb.append("    sourceIPNot: ").append(toIndentedString(sourceIPNot)).append("\n");
    sb.append("    sourceMACType: ").append(toIndentedString(sourceMACType)).append("\n");
    sb.append("    sourceMACValue: ").append(toIndentedString(sourceMACValue)).append("\n");
    sb.append("    sourceMACMultiple: ").append(toIndentedString(sourceMACMultiple)).append("\n");
    sb.append("    sourceMACListID: ").append(toIndentedString(sourceMACListID)).append("\n");
    sb.append("    sourceMACNot: ").append(toIndentedString(sourceMACNot)).append("\n");
    sb.append("    sourcePortType: ").append(toIndentedString(sourcePortType)).append("\n");
    sb.append("    sourcePortMultiple: ").append(toIndentedString(sourcePortMultiple)).append("\n");
    sb.append("    sourcePortListID: ").append(toIndentedString(sourcePortListID)).append("\n");
    sb.append("    sourcePortNot: ").append(toIndentedString(sourcePortNot)).append("\n");
    sb.append("    destinationIPType: ").append(toIndentedString(destinationIPType)).append("\n");
    sb.append("    destinationIPValue: ").append(toIndentedString(destinationIPValue)).append("\n");
    sb.append("    destinationIPMask: ").append(toIndentedString(destinationIPMask)).append("\n");
    sb.append("    destinationIPRangeFrom: ").append(toIndentedString(destinationIPRangeFrom)).append("\n");
    sb.append("    destinationIPRangeTo: ").append(toIndentedString(destinationIPRangeTo)).append("\n");
    sb.append("    destinationIPMultiple: ").append(toIndentedString(destinationIPMultiple)).append("\n");
    sb.append("    destinationIPListID: ").append(toIndentedString(destinationIPListID)).append("\n");
    sb.append("    destinationIPNot: ").append(toIndentedString(destinationIPNot)).append("\n");
    sb.append("    destinationMACType: ").append(toIndentedString(destinationMACType)).append("\n");
    sb.append("    destinationMACValue: ").append(toIndentedString(destinationMACValue)).append("\n");
    sb.append("    destinationMACMultiple: ").append(toIndentedString(destinationMACMultiple)).append("\n");
    sb.append("    destinationMACListID: ").append(toIndentedString(destinationMACListID)).append("\n");
    sb.append("    destinationMACNot: ").append(toIndentedString(destinationMACNot)).append("\n");
    sb.append("    destinationPortType: ").append(toIndentedString(destinationPortType)).append("\n");
    sb.append("    destinationPortMultiple: ").append(toIndentedString(destinationPortMultiple)).append("\n");
    sb.append("    destinationPortListID: ").append(toIndentedString(destinationPortListID)).append("\n");
    sb.append("    destinationPortNot: ").append(toIndentedString(destinationPortNot)).append("\n");
    sb.append("    anyFlags: ").append(toIndentedString(anyFlags)).append("\n");
    sb.append("    logDisabled: ").append(toIndentedString(logDisabled)).append("\n");
    sb.append("    includePacketData: ").append(toIndentedString(includePacketData)).append("\n");
    sb.append("    alertEnabled: ").append(toIndentedString(alertEnabled)).append("\n");
    sb.append("    scheduleID: ").append(toIndentedString(scheduleID)).append("\n");
    sb.append("    contextID: ").append(toIndentedString(contextID)).append("\n");
    sb.append("    tcpflags: ").append(toIndentedString(tcpflags)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("    tcPNot: ").append(toIndentedString(tcPNot)).append("\n");
    sb.append("    icMPType: ").append(toIndentedString(icMPType)).append("\n");
    sb.append("    icMPCode: ").append(toIndentedString(icMPCode)).append("\n");
    sb.append("    icMPNot: ").append(toIndentedString(icMPNot)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

