/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.ComputerFilter;
import com.trendmicro.deepsecurity.model.CustomClassification;
import com.trendmicro.deepsecurity.model.Recipients;
import com.trendmicro.deepsecurity.model.TagFilter;
import com.trendmicro.deepsecurity.model.TimeRange;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Controls the behavior of a scheduled task of type generate-report.
 */
@ApiModel(description = "Controls the behavior of a scheduled task of type generate-report.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class GenerateReportTaskParameters {
  @JsonProperty("reportTemplateID")
  private Integer reportTemplateID = null;

  /**
   * Report format.
   */
  public enum FormatEnum {
    PDF("pdf"),
    
    CSV("csv"),
    
    HTML("html"),
    
    PLAINTEXT("plaintext"),
    
    RTF("rtf"),
    
    XLS("xls"),
    
    XML("xml");

    private String value;

    FormatEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static FormatEnum fromValue(String text) {
      for (FormatEnum b : FormatEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("format")
  private FormatEnum format = null;

  /**
   * Report classification.
   */
  public enum ClassificationEnum {
    BLANK("blank"),
    
    TOPSECRET("topsecret"),
    
    SECRET("secret"),
    
    CONFIDENTIAL("confidential"),
    
    OFFICIAL("official"),
    
    LES("les"),
    
    LIMITED("limited"),
    
    UNCLASSIFIED("unclassified"),
    
    INTERNAL("internal"),
    
    CUSTOM("custom");

    private String value;

    ClassificationEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ClassificationEnum fromValue(String text) {
      for (ClassificationEnum b : ClassificationEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("classification")
  private ClassificationEnum classification = null;

  @JsonProperty("customClassification")
  private CustomClassification customClassification = null;

  @JsonProperty("recipients")
  private Recipients recipients = null;

  @JsonProperty("timeRange")
  private TimeRange timeRange = null;

  @JsonProperty("tagFilter")
  private TagFilter tagFilter = null;

  @JsonProperty("computerFilter")
  private ComputerFilter computerFilter = null;

  public GenerateReportTaskParameters reportTemplateID(Integer reportTemplateID) {
    this.reportTemplateID = reportTemplateID;
    return this;
  }

   /**
   * Report template identifier.
   * @return reportTemplateID
  **/
  @ApiModelProperty(value = "Report template identifier.")
  public Integer getReportTemplateID() {
    return reportTemplateID;
  }

  public void setReportTemplateID(Integer reportTemplateID) {
    this.reportTemplateID = reportTemplateID;
  }

  public GenerateReportTaskParameters format(FormatEnum format) {
    this.format = format;
    return this;
  }

   /**
   * Report format.
   * @return format
  **/
  @ApiModelProperty(value = "Report format.")
  public FormatEnum getFormat() {
    return format;
  }

  public void setFormat(FormatEnum format) {
    this.format = format;
  }

  public GenerateReportTaskParameters classification(ClassificationEnum classification) {
    this.classification = classification;
    return this;
  }

   /**
   * Report classification.
   * @return classification
  **/
  @ApiModelProperty(value = "Report classification.")
  public ClassificationEnum getClassification() {
    return classification;
  }

  public void setClassification(ClassificationEnum classification) {
    this.classification = classification;
  }

  public GenerateReportTaskParameters customClassification(CustomClassification customClassification) {
    this.customClassification = customClassification;
    return this;
  }

   /**
   * Custom report classification.
   * @return customClassification
  **/
  @ApiModelProperty(value = "Custom report classification.")
  public CustomClassification getCustomClassification() {
    return customClassification;
  }

  public void setCustomClassification(CustomClassification customClassification) {
    this.customClassification = customClassification;
  }

  public GenerateReportTaskParameters recipients(Recipients recipients) {
    this.recipients = recipients;
    return this;
  }

   /**
   * Get recipients
   * @return recipients
  **/
  @ApiModelProperty(value = "")
  public Recipients getRecipients() {
    return recipients;
  }

  public void setRecipients(Recipients recipients) {
    this.recipients = recipients;
  }

  public GenerateReportTaskParameters timeRange(TimeRange timeRange) {
    this.timeRange = timeRange;
    return this;
  }

   /**
   * Get timeRange
   * @return timeRange
  **/
  @ApiModelProperty(value = "")
  public TimeRange getTimeRange() {
    return timeRange;
  }

  public void setTimeRange(TimeRange timeRange) {
    this.timeRange = timeRange;
  }

  public GenerateReportTaskParameters tagFilter(TagFilter tagFilter) {
    this.tagFilter = tagFilter;
    return this;
  }

   /**
   * Get tagFilter
   * @return tagFilter
  **/
  @ApiModelProperty(value = "")
  public TagFilter getTagFilter() {
    return tagFilter;
  }

  public void setTagFilter(TagFilter tagFilter) {
    this.tagFilter = tagFilter;
  }

  public GenerateReportTaskParameters computerFilter(ComputerFilter computerFilter) {
    this.computerFilter = computerFilter;
    return this;
  }

   /**
   * Get computerFilter
   * @return computerFilter
  **/
  @ApiModelProperty(value = "")
  public ComputerFilter getComputerFilter() {
    return computerFilter;
  }

  public void setComputerFilter(ComputerFilter computerFilter) {
    this.computerFilter = computerFilter;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GenerateReportTaskParameters generateReportTaskParameters = (GenerateReportTaskParameters) o;
    return Objects.equals(this.reportTemplateID, generateReportTaskParameters.reportTemplateID) &&
        Objects.equals(this.format, generateReportTaskParameters.format) &&
        Objects.equals(this.classification, generateReportTaskParameters.classification) &&
        Objects.equals(this.customClassification, generateReportTaskParameters.customClassification) &&
        Objects.equals(this.recipients, generateReportTaskParameters.recipients) &&
        Objects.equals(this.timeRange, generateReportTaskParameters.timeRange) &&
        Objects.equals(this.tagFilter, generateReportTaskParameters.tagFilter) &&
        Objects.equals(this.computerFilter, generateReportTaskParameters.computerFilter);
  }

  @Override
  public int hashCode() {
    return Objects.hash(reportTemplateID, format, classification, customClassification, recipients, timeRange, tagFilter, computerFilter);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GenerateReportTaskParameters {\n");
    
    sb.append("    reportTemplateID: ").append(toIndentedString(reportTemplateID)).append("\n");
    sb.append("    format: ").append(toIndentedString(format)).append("\n");
    sb.append("    classification: ").append(toIndentedString(classification)).append("\n");
    sb.append("    customClassification: ").append(toIndentedString(customClassification)).append("\n");
    sb.append("    recipients: ").append(toIndentedString(recipients)).append("\n");
    sb.append("    timeRange: ").append(toIndentedString(timeRange)).append("\n");
    sb.append("    tagFilter: ").append(toIndentedString(tagFilter)).append("\n");
    sb.append("    computerFilter: ").append(toIndentedString(computerFilter)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

