/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Identified file right details.
 */
@ApiModel(description = "Identified file right details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class IdentifiedFileRights {
  @JsonProperty("canDeleteIdentifiedFiles")
  private Boolean canDeleteIdentifiedFiles = null;

  @JsonProperty("canDownloadIdentifiedFiles")
  private Boolean canDownloadIdentifiedFiles = null;

  @JsonProperty("canRestoreIdentifiedFiles")
  private Boolean canRestoreIdentifiedFiles = null;

  @JsonProperty("canSubmitIdentifiedFiles")
  private Boolean canSubmitIdentifiedFiles = null;

  public IdentifiedFileRights canDeleteIdentifiedFiles(Boolean canDeleteIdentifiedFiles) {
    this.canDeleteIdentifiedFiles = canDeleteIdentifiedFiles;
    return this;
  }

   /**
   * Right to delete identified files.
   * @return canDeleteIdentifiedFiles
  **/
  @ApiModelProperty(value = "Right to delete identified files.")
  public Boolean isCanDeleteIdentifiedFiles() {
    return canDeleteIdentifiedFiles;
  }

  public void setCanDeleteIdentifiedFiles(Boolean canDeleteIdentifiedFiles) {
    this.canDeleteIdentifiedFiles = canDeleteIdentifiedFiles;
  }

  public IdentifiedFileRights canDownloadIdentifiedFiles(Boolean canDownloadIdentifiedFiles) {
    this.canDownloadIdentifiedFiles = canDownloadIdentifiedFiles;
    return this;
  }

   /**
   * Right to download identified files.
   * @return canDownloadIdentifiedFiles
  **/
  @ApiModelProperty(value = "Right to download identified files.")
  public Boolean isCanDownloadIdentifiedFiles() {
    return canDownloadIdentifiedFiles;
  }

  public void setCanDownloadIdentifiedFiles(Boolean canDownloadIdentifiedFiles) {
    this.canDownloadIdentifiedFiles = canDownloadIdentifiedFiles;
  }

  public IdentifiedFileRights canRestoreIdentifiedFiles(Boolean canRestoreIdentifiedFiles) {
    this.canRestoreIdentifiedFiles = canRestoreIdentifiedFiles;
    return this;
  }

   /**
   * Right to restore identified files.
   * @return canRestoreIdentifiedFiles
  **/
  @ApiModelProperty(value = "Right to restore identified files.")
  public Boolean isCanRestoreIdentifiedFiles() {
    return canRestoreIdentifiedFiles;
  }

  public void setCanRestoreIdentifiedFiles(Boolean canRestoreIdentifiedFiles) {
    this.canRestoreIdentifiedFiles = canRestoreIdentifiedFiles;
  }

  public IdentifiedFileRights canSubmitIdentifiedFiles(Boolean canSubmitIdentifiedFiles) {
    this.canSubmitIdentifiedFiles = canSubmitIdentifiedFiles;
    return this;
  }

   /**
   * Right to submit identified files to Sandbox Analysis.
   * @return canSubmitIdentifiedFiles
  **/
  @ApiModelProperty(value = "Right to submit identified files to Sandbox Analysis.")
  public Boolean isCanSubmitIdentifiedFiles() {
    return canSubmitIdentifiedFiles;
  }

  public void setCanSubmitIdentifiedFiles(Boolean canSubmitIdentifiedFiles) {
    this.canSubmitIdentifiedFiles = canSubmitIdentifiedFiles;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    IdentifiedFileRights identifiedFileRights = (IdentifiedFileRights) o;
    return Objects.equals(this.canDeleteIdentifiedFiles, identifiedFileRights.canDeleteIdentifiedFiles) &&
        Objects.equals(this.canDownloadIdentifiedFiles, identifiedFileRights.canDownloadIdentifiedFiles) &&
        Objects.equals(this.canRestoreIdentifiedFiles, identifiedFileRights.canRestoreIdentifiedFiles) &&
        Objects.equals(this.canSubmitIdentifiedFiles, identifiedFileRights.canSubmitIdentifiedFiles);
  }

  @Override
  public int hashCode() {
    return Objects.hash(canDeleteIdentifiedFiles, canDownloadIdentifiedFiles, canRestoreIdentifiedFiles, canSubmitIdentifiedFiles);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class IdentifiedFileRights {\n");
    
    sb.append("    canDeleteIdentifiedFiles: ").append(toIndentedString(canDeleteIdentifiedFiles)).append("\n");
    sb.append("    canDownloadIdentifiedFiles: ").append(toIndentedString(canDownloadIdentifiedFiles)).append("\n");
    sb.append("    canRestoreIdentifiedFiles: ").append(toIndentedString(canRestoreIdentifiedFiles)).append("\n");
    sb.append("    canSubmitIdentifiedFiles: ").append(toIndentedString(canSubmitIdentifiedFiles)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

