/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.ComputerModuleStatus;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Computer-level configuration for the Integrity Monitoring module. Null for tenants for whom Integrity Monitoring is hidden.
 */
@ApiModel(description = "Computer-level configuration for the Integrity Monitoring module. Null for tenants for whom Integrity Monitoring is hidden.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class IntegrityMonitoringComputerExtension {
  /**
   * Module state. The &#39;inherited&#39; value is write-only.
   */
  public enum StateEnum {
    INHERITED("inherited"),
    
    REAL_TIME("real-time"),
    
    ON("on"),
    
    OFF("off");

    private String value;

    StateEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StateEnum fromValue(String text) {
      for (StateEnum b : StateEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("state")
  private StateEnum state = null;

  @JsonProperty("moduleStatus")
  private ComputerModuleStatus moduleStatus = null;

  @JsonProperty("lastIntegrityScan")
  private Long lastIntegrityScan = null;

  @JsonProperty("lastBaselineCreated")
  private Long lastBaselineCreated = null;

  @JsonProperty("ruleIDs")
  private List<Integer> ruleIDs = null;

  public IntegrityMonitoringComputerExtension state(StateEnum state) {
    this.state = state;
    return this;
  }

   /**
   * Module state. The &#39;inherited&#39; value is write-only.
   * @return state
  **/
  @ApiModelProperty(value = "Module state. The 'inherited' value is write-only.")
  public StateEnum getState() {
    return state;
  }

  public void setState(StateEnum state) {
    this.state = state;
  }

  public IntegrityMonitoringComputerExtension moduleStatus(ComputerModuleStatus moduleStatus) {
    this.moduleStatus = moduleStatus;
    return this;
  }

   /**
   * Get moduleStatus
   * @return moduleStatus
  **/
  @ApiModelProperty(value = "")
  public ComputerModuleStatus getModuleStatus() {
    return moduleStatus;
  }

  public void setModuleStatus(ComputerModuleStatus moduleStatus) {
    this.moduleStatus = moduleStatus;
  }

   /**
   * Timestamp of the last full scan for integrity, in milliseconds since epoch.
   * @return lastIntegrityScan
  **/
  @ApiModelProperty(value = "Timestamp of the last full scan for integrity, in milliseconds since epoch.")
  public Long getLastIntegrityScan() {
    return lastIntegrityScan;
  }

   /**
   * Timestamp of the last integrity baseline, in milliseconds since epoch.
   * @return lastBaselineCreated
  **/
  @ApiModelProperty(value = "Timestamp of the last integrity baseline, in milliseconds since epoch.")
  public Long getLastBaselineCreated() {
    return lastBaselineCreated;
  }

  public IntegrityMonitoringComputerExtension ruleIDs(List<Integer> ruleIDs) {
    this.ruleIDs = ruleIDs;
    return this;
  }

  public IntegrityMonitoringComputerExtension addRuleIDsItem(Integer ruleIDsItem) {
    if (this.ruleIDs == null) {
      this.ruleIDs = new ArrayList<>();
    }
    this.ruleIDs.add(ruleIDsItem);
    return this;
  }

   /**
   * IDs of the assigned Integrity Monitoring rules.
   * @return ruleIDs
  **/
  @ApiModelProperty(value = "IDs of the assigned Integrity Monitoring rules.")
  public List<Integer> getRuleIDs() {
    return ruleIDs;
  }

  public void setRuleIDs(List<Integer> ruleIDs) {
    this.ruleIDs = ruleIDs;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    IntegrityMonitoringComputerExtension integrityMonitoringComputerExtension = (IntegrityMonitoringComputerExtension) o;
    return Objects.equals(this.state, integrityMonitoringComputerExtension.state) &&
        Objects.equals(this.moduleStatus, integrityMonitoringComputerExtension.moduleStatus) &&
        Objects.equals(this.lastIntegrityScan, integrityMonitoringComputerExtension.lastIntegrityScan) &&
        Objects.equals(this.lastBaselineCreated, integrityMonitoringComputerExtension.lastBaselineCreated) &&
        Objects.equals(this.ruleIDs, integrityMonitoringComputerExtension.ruleIDs);
  }

  @Override
  public int hashCode() {
    return Objects.hash(state, moduleStatus, lastIntegrityScan, lastBaselineCreated, ruleIDs);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class IntegrityMonitoringComputerExtension {\n");
    
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("    moduleStatus: ").append(toIndentedString(moduleStatus)).append("\n");
    sb.append("    lastIntegrityScan: ").append(toIndentedString(lastIntegrityScan)).append("\n");
    sb.append("    lastBaselineCreated: ").append(toIndentedString(lastBaselineCreated)).append("\n");
    sb.append("    ruleIDs: ").append(toIndentedString(ruleIDs)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

