/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Intrusion Prevention rule details. Intrusion prevention rules define a set of conditions that are compared to the payload session and application layers of network packets (such as DNS, HTTP, SSL, and SMTP), as well as the sequence of those packets according to those higher-layer protocols.
 */
@ApiModel(description = "Intrusion Prevention rule details. Intrusion prevention rules define a set of conditions that are compared to the payload session and application layers of network packets (such as DNS, HTTP, SSL, and SMTP), as well as the sequence of those packets according to those higher-layer protocols.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class IntrusionPreventionRule {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("minimumAgentVersion")
  private String minimumAgentVersion = null;

  @JsonProperty("applicationTypeID")
  private Integer applicationTypeID = null;

  /**
   * Priority level of the rule. Higher priority rules are applied before lower priority rules. Searchable as Choice.
   */
  public enum PriorityEnum {
    LOWEST("lowest"),
    
    LOW("low"),
    
    NORMAL("normal"),
    
    HIGH("high"),
    
    HIGHEST("highest");

    private String value;

    PriorityEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static PriorityEnum fromValue(String text) {
      for (PriorityEnum b : PriorityEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("priority")
  private PriorityEnum priority = null;

  /**
   * Severity level of the rule. Severity levels can be used as sorting criteria and affect event rankings. Searchable as Choice.
   */
  public enum SeverityEnum {
    LOW("low"),
    
    MEDIUM("medium"),
    
    HIGH("high"),
    
    CRITICAL("critical");

    private String value;

    SeverityEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static SeverityEnum fromValue(String text) {
      for (SeverityEnum b : SeverityEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("severity")
  private SeverityEnum severity = null;

  @JsonProperty("detectOnly")
  private Boolean detectOnly = null;

  @JsonProperty("eventLoggingDisabled")
  private Boolean eventLoggingDisabled = null;

  @JsonProperty("generateEventOnPacketDrop")
  private Boolean generateEventOnPacketDrop = null;

  @JsonProperty("alwaysIncludePacketData")
  private Boolean alwaysIncludePacketData = null;

  @JsonProperty("debugModeEnabled")
  private Boolean debugModeEnabled = null;

  /**
   * Type of IntrusionPreventionRule. Searchable as Choice.
   */
  public enum TypeEnum {
    CUSTOM("custom"),
    
    SMART("smart"),
    
    VULNERABILITY("vulnerability"),
    
    EXPLOIT("exploit"),
    
    HIDDEN("hidden"),
    
    POLICY("policy"),
    
    INFO("info");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TypeEnum fromValue(String text) {
      for (TypeEnum b : TypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("type")
  private TypeEnum type = null;

  @JsonProperty("originalIssue")
  private Long originalIssue = null;

  @JsonProperty("lastUpdated")
  private Long lastUpdated = null;

  @JsonProperty("identifier")
  private String identifier = null;

  /**
   * Type of template for the IntrusionPreventionRule. Applicable only to custom rules.
   */
  public enum TemplateEnum {
    SIGNATURE("signature"),
    
    START_END_PATTERNS("start-end-patterns"),
    
    CUSTOM("custom");

    private String value;

    TemplateEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TemplateEnum fromValue(String text) {
      for (TemplateEnum b : TemplateEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("template")
  private TemplateEnum template = null;

  @JsonProperty("signature")
  private String signature = null;

  @JsonProperty("start")
  private String start = null;

  @JsonProperty("patterns")
  private List<String> patterns = null;

  @JsonProperty("end")
  private String end = null;

  @JsonProperty("caseSensitive")
  private Boolean caseSensitive = null;

  /**
   * Condition to determine if the rule is triggered. Applicable to custom rules with template type start-end-patterns.
   */
  public enum ConditionEnum {
    ALL("all"),
    
    ANY("any"),
    
    NONE("none");

    private String value;

    ConditionEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ConditionEnum fromValue(String text) {
      for (ConditionEnum b : ConditionEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("condition")
  private ConditionEnum condition = null;

  /**
   * Action to apply if the rule is triggered. Applicable to custom rules with template type signature or start-end-patterns.
   */
  public enum ActionEnum {
    DROP("drop"),
    
    LOG_ONLY("log-only");

    private String value;

    ActionEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ActionEnum fromValue(String text) {
      for (ActionEnum b : ActionEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("action")
  private ActionEnum action = null;

  @JsonProperty("customXML")
  private String customXML = null;

  @JsonProperty("alertEnabled")
  private Boolean alertEnabled = null;

  @JsonProperty("scheduleID")
  private Integer scheduleID = null;

  @JsonProperty("contextID")
  private Integer contextID = null;

  /**
   * Indicates whether recommendation scans consider the IntrusionPreventionRule. Can be set to enabled or ignored. Custom rules cannot be recommended. Searchable as Choice.
   */
  public enum RecommendationsModeEnum {
    ENABLED("enabled"),
    
    IGNORED("ignored"),
    
    UNKNOWN("unknown"),
    
    DISABLED("disabled");

    private String value;

    RecommendationsModeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static RecommendationsModeEnum fromValue(String text) {
      for (RecommendationsModeEnum b : RecommendationsModeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("recommendationsMode")
  private RecommendationsModeEnum recommendationsMode = null;

  @JsonProperty("canBeAssignedAlone")
  private Boolean canBeAssignedAlone = null;

  @JsonProperty("dependsOnRuleIDs")
  private List<Integer> dependsOnRuleIDs = null;

  @JsonProperty("ID")
  private Integer ID = null;

  @JsonProperty("CVSSScore")
  private String cvSSScore = null;

  @JsonProperty("CVE")
  private List<String> CVE = null;

  public IntrusionPreventionRule name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the IntrusionPreventionRule. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the IntrusionPreventionRule. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public IntrusionPreventionRule description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the IntrusionPreventionRule. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the IntrusionPreventionRule. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public IntrusionPreventionRule minimumAgentVersion(String minimumAgentVersion) {
    this.minimumAgentVersion = minimumAgentVersion;
    return this;
  }

   /**
   * Version of the Deep Security agent or appliance required to support the rule. Searchable as String.
   * @return minimumAgentVersion
  **/
  @ApiModelProperty(value = "Version of the Deep Security agent or appliance required to support the rule. Searchable as String.")
  public String getMinimumAgentVersion() {
    return minimumAgentVersion;
  }

  public void setMinimumAgentVersion(String minimumAgentVersion) {
    this.minimumAgentVersion = minimumAgentVersion;
  }

  public IntrusionPreventionRule applicationTypeID(Integer applicationTypeID) {
    this.applicationTypeID = applicationTypeID;
    return this;
  }

   /**
   * ID of the application type for the IntrusionPreventionRule. Searchable as Numeric.
   * @return applicationTypeID
  **/
  @ApiModelProperty(value = "ID of the application type for the IntrusionPreventionRule. Searchable as Numeric.")
  public Integer getApplicationTypeID() {
    return applicationTypeID;
  }

  public void setApplicationTypeID(Integer applicationTypeID) {
    this.applicationTypeID = applicationTypeID;
  }

  public IntrusionPreventionRule priority(PriorityEnum priority) {
    this.priority = priority;
    return this;
  }

   /**
   * Priority level of the rule. Higher priority rules are applied before lower priority rules. Searchable as Choice.
   * @return priority
  **/
  @ApiModelProperty(value = "Priority level of the rule. Higher priority rules are applied before lower priority rules. Searchable as Choice.")
  public PriorityEnum getPriority() {
    return priority;
  }

  public void setPriority(PriorityEnum priority) {
    this.priority = priority;
  }

  public IntrusionPreventionRule severity(SeverityEnum severity) {
    this.severity = severity;
    return this;
  }

   /**
   * Severity level of the rule. Severity levels can be used as sorting criteria and affect event rankings. Searchable as Choice.
   * @return severity
  **/
  @ApiModelProperty(value = "Severity level of the rule. Severity levels can be used as sorting criteria and affect event rankings. Searchable as Choice.")
  public SeverityEnum getSeverity() {
    return severity;
  }

  public void setSeverity(SeverityEnum severity) {
    this.severity = severity;
  }

  public IntrusionPreventionRule detectOnly(Boolean detectOnly) {
    this.detectOnly = detectOnly;
    return this;
  }

   /**
   * In detect mode, the rule creates an event log and does not interfere with traffic.
   * @return detectOnly
  **/
  @ApiModelProperty(value = "In detect mode, the rule creates an event log and does not interfere with traffic.")
  public Boolean isDetectOnly() {
    return detectOnly;
  }

  public void setDetectOnly(Boolean detectOnly) {
    this.detectOnly = detectOnly;
  }

  public IntrusionPreventionRule eventLoggingDisabled(Boolean eventLoggingDisabled) {
    this.eventLoggingDisabled = eventLoggingDisabled;
    return this;
  }

   /**
   * Enable to prevent event logs from being created when the rule is triggered. Not available if detectOnly is true. Searchable as Boolean.
   * @return eventLoggingDisabled
  **/
  @ApiModelProperty(value = "Enable to prevent event logs from being created when the rule is triggered. Not available if detectOnly is true. Searchable as Boolean.")
  public Boolean isEventLoggingDisabled() {
    return eventLoggingDisabled;
  }

  public void setEventLoggingDisabled(Boolean eventLoggingDisabled) {
    this.eventLoggingDisabled = eventLoggingDisabled;
  }

  public IntrusionPreventionRule generateEventOnPacketDrop(Boolean generateEventOnPacketDrop) {
    this.generateEventOnPacketDrop = generateEventOnPacketDrop;
    return this;
  }

   /**
   * Generate an event every time a packet is dropped for the rule. Not available if eventLoggingDisabled is true. Searchable as Boolean.
   * @return generateEventOnPacketDrop
  **/
  @ApiModelProperty(value = "Generate an event every time a packet is dropped for the rule. Not available if eventLoggingDisabled is true. Searchable as Boolean.")
  public Boolean isGenerateEventOnPacketDrop() {
    return generateEventOnPacketDrop;
  }

  public void setGenerateEventOnPacketDrop(Boolean generateEventOnPacketDrop) {
    this.generateEventOnPacketDrop = generateEventOnPacketDrop;
  }

  public IntrusionPreventionRule alwaysIncludePacketData(Boolean alwaysIncludePacketData) {
    this.alwaysIncludePacketData = alwaysIncludePacketData;
    return this;
  }

   /**
   * Enabled to include package data in the event logs. Not available if eventLoggingDisabled is true. Searchable as Boolean.
   * @return alwaysIncludePacketData
  **/
  @ApiModelProperty(value = "Enabled to include package data in the event logs. Not available if eventLoggingDisabled is true. Searchable as Boolean.")
  public Boolean isAlwaysIncludePacketData() {
    return alwaysIncludePacketData;
  }

  public void setAlwaysIncludePacketData(Boolean alwaysIncludePacketData) {
    this.alwaysIncludePacketData = alwaysIncludePacketData;
  }

  public IntrusionPreventionRule debugModeEnabled(Boolean debugModeEnabled) {
    this.debugModeEnabled = debugModeEnabled;
    return this;
  }

   /**
   * Enable to log additional packets preceeding and following the packet that the rule detected. Not available if eventLoggingDisabled is true. Searchable as Boolean.
   * @return debugModeEnabled
  **/
  @ApiModelProperty(value = "Enable to log additional packets preceeding and following the packet that the rule detected. Not available if eventLoggingDisabled is true. Searchable as Boolean.")
  public Boolean isDebugModeEnabled() {
    return debugModeEnabled;
  }

  public void setDebugModeEnabled(Boolean debugModeEnabled) {
    this.debugModeEnabled = debugModeEnabled;
  }

  public IntrusionPreventionRule type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * Type of IntrusionPreventionRule. Searchable as Choice.
   * @return type
  **/
  @ApiModelProperty(value = "Type of IntrusionPreventionRule. Searchable as Choice.")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }

  public IntrusionPreventionRule originalIssue(Long originalIssue) {
    this.originalIssue = originalIssue;
    return this;
  }

   /**
   * Timestamp of the date the rule was released, in milliseconds since epoch. Searchable as Date.
   * @return originalIssue
  **/
  @ApiModelProperty(value = "Timestamp of the date the rule was released, in milliseconds since epoch. Searchable as Date.")
  public Long getOriginalIssue() {
    return originalIssue;
  }

  public void setOriginalIssue(Long originalIssue) {
    this.originalIssue = originalIssue;
  }

  public IntrusionPreventionRule lastUpdated(Long lastUpdated) {
    this.lastUpdated = lastUpdated;
    return this;
  }

   /**
   * Timestamp of the last rule modification, in milliseconds since epoch. Searchable as Date.
   * @return lastUpdated
  **/
  @ApiModelProperty(value = "Timestamp of the last rule modification, in milliseconds since epoch. Searchable as Date.")
  public Long getLastUpdated() {
    return lastUpdated;
  }

  public void setLastUpdated(Long lastUpdated) {
    this.lastUpdated = lastUpdated;
  }

   /**
   * Unique identification tag of the rule. Searchable as String.
   * @return identifier
  **/
  @ApiModelProperty(value = "Unique identification tag of the rule. Searchable as String.")
  public String getIdentifier() {
    return identifier;
  }

  public IntrusionPreventionRule template(TemplateEnum template) {
    this.template = template;
    return this;
  }

   /**
   * Type of template for the IntrusionPreventionRule. Applicable only to custom rules.
   * @return template
  **/
  @ApiModelProperty(value = "Type of template for the IntrusionPreventionRule. Applicable only to custom rules.")
  public TemplateEnum getTemplate() {
    return template;
  }

  public void setTemplate(TemplateEnum template) {
    this.template = template;
  }

  public IntrusionPreventionRule signature(String signature) {
    this.signature = signature;
    return this;
  }

   /**
   * Signature of the rule. Applicable to custom rules with template type signature.
   * @return signature
  **/
  @ApiModelProperty(value = "Signature of the rule. Applicable to custom rules with template type signature.")
  public String getSignature() {
    return signature;
  }

  public void setSignature(String signature) {
    this.signature = signature;
  }

  public IntrusionPreventionRule start(String start) {
    this.start = start;
    return this;
  }

   /**
   * Start pattern of the rule. Applicable to custom rules with template type start-end-patterns.
   * @return start
  **/
  @ApiModelProperty(value = "Start pattern of the rule. Applicable to custom rules with template type start-end-patterns.")
  public String getStart() {
    return start;
  }

  public void setStart(String start) {
    this.start = start;
  }

  public IntrusionPreventionRule patterns(List<String> patterns) {
    this.patterns = patterns;
    return this;
  }

  public IntrusionPreventionRule addPatternsItem(String patternsItem) {
    if (this.patterns == null) {
      this.patterns = new ArrayList<>();
    }
    this.patterns.add(patternsItem);
    return this;
  }

   /**
   * Body patterns of the rule, which must be found between start and end patterns. Applicable to custom rules with template type start-end-patterns.
   * @return patterns
  **/
  @ApiModelProperty(value = "Body patterns of the rule, which must be found between start and end patterns. Applicable to custom rules with template type start-end-patterns.")
  public List<String> getPatterns() {
    return patterns;
  }

  public void setPatterns(List<String> patterns) {
    this.patterns = patterns;
  }

  public IntrusionPreventionRule end(String end) {
    this.end = end;
    return this;
  }

   /**
   * End pattern of the rule. Applicable to custom rules with template type start-end-patterns.
   * @return end
  **/
  @ApiModelProperty(value = "End pattern of the rule. Applicable to custom rules with template type start-end-patterns.")
  public String getEnd() {
    return end;
  }

  public void setEnd(String end) {
    this.end = end;
  }

  public IntrusionPreventionRule caseSensitive(Boolean caseSensitive) {
    this.caseSensitive = caseSensitive;
    return this;
  }

   /**
   * Enable to make signatures and patterns case sensitive. Applicable to custom rules with template type signature or start-end-patterns.
   * @return caseSensitive
  **/
  @ApiModelProperty(value = "Enable to make signatures and patterns case sensitive. Applicable to custom rules with template type signature or start-end-patterns.")
  public Boolean isCaseSensitive() {
    return caseSensitive;
  }

  public void setCaseSensitive(Boolean caseSensitive) {
    this.caseSensitive = caseSensitive;
  }

  public IntrusionPreventionRule condition(ConditionEnum condition) {
    this.condition = condition;
    return this;
  }

   /**
   * Condition to determine if the rule is triggered. Applicable to custom rules with template type start-end-patterns.
   * @return condition
  **/
  @ApiModelProperty(value = "Condition to determine if the rule is triggered. Applicable to custom rules with template type start-end-patterns.")
  public ConditionEnum getCondition() {
    return condition;
  }

  public void setCondition(ConditionEnum condition) {
    this.condition = condition;
  }

  public IntrusionPreventionRule action(ActionEnum action) {
    this.action = action;
    return this;
  }

   /**
   * Action to apply if the rule is triggered. Applicable to custom rules with template type signature or start-end-patterns.
   * @return action
  **/
  @ApiModelProperty(value = "Action to apply if the rule is triggered. Applicable to custom rules with template type signature or start-end-patterns.")
  public ActionEnum getAction() {
    return action;
  }

  public void setAction(ActionEnum action) {
    this.action = action;
  }

  public IntrusionPreventionRule customXML(String customXML) {
    this.customXML = customXML;
    return this;
  }

   /**
   * The custom XML used to define the rule. Applicable to custom rules with template type custom.
   * @return customXML
  **/
  @ApiModelProperty(value = "The custom XML used to define the rule. Applicable to custom rules with template type custom.")
  public String getCustomXML() {
    return customXML;
  }

  public void setCustomXML(String customXML) {
    this.customXML = customXML;
  }

  public IntrusionPreventionRule alertEnabled(Boolean alertEnabled) {
    this.alertEnabled = alertEnabled;
    return this;
  }

   /**
   * Enable to raise an alert when the rule logs an event. Searchable as Boolean.
   * @return alertEnabled
  **/
  @ApiModelProperty(value = "Enable to raise an alert when the rule logs an event. Searchable as Boolean.")
  public Boolean isAlertEnabled() {
    return alertEnabled;
  }

  public void setAlertEnabled(Boolean alertEnabled) {
    this.alertEnabled = alertEnabled;
  }

  public IntrusionPreventionRule scheduleID(Integer scheduleID) {
    this.scheduleID = scheduleID;
    return this;
  }

   /**
   * ID of the schedule which defines times during which the rule is active. Set to 0 to remove any assignment. Searchable as Numeric.
   * @return scheduleID
  **/
  @ApiModelProperty(value = "ID of the schedule which defines times during which the rule is active. Set to 0 to remove any assignment. Searchable as Numeric.")
  public Integer getScheduleID() {
    return scheduleID;
  }

  public void setScheduleID(Integer scheduleID) {
    this.scheduleID = scheduleID;
  }

  public IntrusionPreventionRule contextID(Integer contextID) {
    this.contextID = contextID;
    return this;
  }

   /**
   * ID of the context in which the rule is applied. Set to 0 to remove any assignment. Searchable as Numeric.
   * @return contextID
  **/
  @ApiModelProperty(value = "ID of the context in which the rule is applied. Set to 0 to remove any assignment. Searchable as Numeric.")
  public Integer getContextID() {
    return contextID;
  }

  public void setContextID(Integer contextID) {
    this.contextID = contextID;
  }

  public IntrusionPreventionRule recommendationsMode(RecommendationsModeEnum recommendationsMode) {
    this.recommendationsMode = recommendationsMode;
    return this;
  }

   /**
   * Indicates whether recommendation scans consider the IntrusionPreventionRule. Can be set to enabled or ignored. Custom rules cannot be recommended. Searchable as Choice.
   * @return recommendationsMode
  **/
  @ApiModelProperty(value = "Indicates whether recommendation scans consider the IntrusionPreventionRule. Can be set to enabled or ignored. Custom rules cannot be recommended. Searchable as Choice.")
  public RecommendationsModeEnum getRecommendationsMode() {
    return recommendationsMode;
  }

  public void setRecommendationsMode(RecommendationsModeEnum recommendationsMode) {
    this.recommendationsMode = recommendationsMode;
  }

   /**
   * True when the rule has no dependencies.
   * @return canBeAssignedAlone
  **/
  @ApiModelProperty(value = "True when the rule has no dependencies.")
  public Boolean isCanBeAssignedAlone() {
    return canBeAssignedAlone;
  }

  public IntrusionPreventionRule dependsOnRuleIDs(List<Integer> dependsOnRuleIDs) {
    this.dependsOnRuleIDs = dependsOnRuleIDs;
    return this;
  }

  public IntrusionPreventionRule addDependsOnRuleIDsItem(Integer dependsOnRuleIDsItem) {
    if (this.dependsOnRuleIDs == null) {
      this.dependsOnRuleIDs = new ArrayList<>();
    }
    this.dependsOnRuleIDs.add(dependsOnRuleIDsItem);
    return this;
  }

   /**
   * IDs of intrusion prevention rules the rule depends on, which will be automatically assigned if this rule is assigned.
   * @return dependsOnRuleIDs
  **/
  @ApiModelProperty(value = "IDs of intrusion prevention rules the rule depends on, which will be automatically assigned if this rule is assigned.")
  public List<Integer> getDependsOnRuleIDs() {
    return dependsOnRuleIDs;
  }

  public void setDependsOnRuleIDs(List<Integer> dependsOnRuleIDs) {
    this.dependsOnRuleIDs = dependsOnRuleIDs;
  }

   /**
   * ID of the IntrusionPreventionRule. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the IntrusionPreventionRule. Searchable as ID.")
  public Integer getID() {
    return ID;
  }

  public IntrusionPreventionRule cvSSScore(String cvSSScore) {
    this.cvSSScore = cvSSScore;
    return this;
  }

   /**
   * A measure of the severity of the vulnerability according the National Vulnerability Database. Searchable as String or as Numeric.
   * @return cvSSScore
  **/
  @ApiModelProperty(value = "A measure of the severity of the vulnerability according the National Vulnerability Database. Searchable as String or as Numeric.")
  public String getCvSSScore() {
    return cvSSScore;
  }

  public void setCvSSScore(String cvSSScore) {
    this.cvSSScore = cvSSScore;
  }

  public IntrusionPreventionRule CVE(List<String> CVE) {
    this.CVE = CVE;
    return this;
  }

  public IntrusionPreventionRule addCVEItem(String CVEItem) {
    if (this.CVE == null) {
      this.CVE = new ArrayList<>();
    }
    this.CVE.add(CVEItem);
    return this;
  }

   /**
   * List of CVEs associated with the IntrusionPreventionRule. Searchable as String.
   * @return CVE
  **/
  @ApiModelProperty(value = "List of CVEs associated with the IntrusionPreventionRule. Searchable as String.")
  public List<String> getCVE() {
    return CVE;
  }

  public void setCVE(List<String> CVE) {
    this.CVE = CVE;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    IntrusionPreventionRule intrusionPreventionRule = (IntrusionPreventionRule) o;
    return Objects.equals(this.name, intrusionPreventionRule.name) &&
        Objects.equals(this.description, intrusionPreventionRule.description) &&
        Objects.equals(this.minimumAgentVersion, intrusionPreventionRule.minimumAgentVersion) &&
        Objects.equals(this.applicationTypeID, intrusionPreventionRule.applicationTypeID) &&
        Objects.equals(this.priority, intrusionPreventionRule.priority) &&
        Objects.equals(this.severity, intrusionPreventionRule.severity) &&
        Objects.equals(this.detectOnly, intrusionPreventionRule.detectOnly) &&
        Objects.equals(this.eventLoggingDisabled, intrusionPreventionRule.eventLoggingDisabled) &&
        Objects.equals(this.generateEventOnPacketDrop, intrusionPreventionRule.generateEventOnPacketDrop) &&
        Objects.equals(this.alwaysIncludePacketData, intrusionPreventionRule.alwaysIncludePacketData) &&
        Objects.equals(this.debugModeEnabled, intrusionPreventionRule.debugModeEnabled) &&
        Objects.equals(this.type, intrusionPreventionRule.type) &&
        Objects.equals(this.originalIssue, intrusionPreventionRule.originalIssue) &&
        Objects.equals(this.lastUpdated, intrusionPreventionRule.lastUpdated) &&
        Objects.equals(this.identifier, intrusionPreventionRule.identifier) &&
        Objects.equals(this.template, intrusionPreventionRule.template) &&
        Objects.equals(this.signature, intrusionPreventionRule.signature) &&
        Objects.equals(this.start, intrusionPreventionRule.start) &&
        Objects.equals(this.patterns, intrusionPreventionRule.patterns) &&
        Objects.equals(this.end, intrusionPreventionRule.end) &&
        Objects.equals(this.caseSensitive, intrusionPreventionRule.caseSensitive) &&
        Objects.equals(this.condition, intrusionPreventionRule.condition) &&
        Objects.equals(this.action, intrusionPreventionRule.action) &&
        Objects.equals(this.customXML, intrusionPreventionRule.customXML) &&
        Objects.equals(this.alertEnabled, intrusionPreventionRule.alertEnabled) &&
        Objects.equals(this.scheduleID, intrusionPreventionRule.scheduleID) &&
        Objects.equals(this.contextID, intrusionPreventionRule.contextID) &&
        Objects.equals(this.recommendationsMode, intrusionPreventionRule.recommendationsMode) &&
        Objects.equals(this.canBeAssignedAlone, intrusionPreventionRule.canBeAssignedAlone) &&
        Objects.equals(this.dependsOnRuleIDs, intrusionPreventionRule.dependsOnRuleIDs) &&
        Objects.equals(this.ID, intrusionPreventionRule.ID) &&
        Objects.equals(this.cvSSScore, intrusionPreventionRule.cvSSScore) &&
        Objects.equals(this.CVE, intrusionPreventionRule.CVE);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, minimumAgentVersion, applicationTypeID, priority, severity, detectOnly, eventLoggingDisabled, generateEventOnPacketDrop, alwaysIncludePacketData, debugModeEnabled, type, originalIssue, lastUpdated, identifier, template, signature, start, patterns, end, caseSensitive, condition, action, customXML, alertEnabled, scheduleID, contextID, recommendationsMode, canBeAssignedAlone, dependsOnRuleIDs, ID, cvSSScore, CVE);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class IntrusionPreventionRule {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    minimumAgentVersion: ").append(toIndentedString(minimumAgentVersion)).append("\n");
    sb.append("    applicationTypeID: ").append(toIndentedString(applicationTypeID)).append("\n");
    sb.append("    priority: ").append(toIndentedString(priority)).append("\n");
    sb.append("    severity: ").append(toIndentedString(severity)).append("\n");
    sb.append("    detectOnly: ").append(toIndentedString(detectOnly)).append("\n");
    sb.append("    eventLoggingDisabled: ").append(toIndentedString(eventLoggingDisabled)).append("\n");
    sb.append("    generateEventOnPacketDrop: ").append(toIndentedString(generateEventOnPacketDrop)).append("\n");
    sb.append("    alwaysIncludePacketData: ").append(toIndentedString(alwaysIncludePacketData)).append("\n");
    sb.append("    debugModeEnabled: ").append(toIndentedString(debugModeEnabled)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    originalIssue: ").append(toIndentedString(originalIssue)).append("\n");
    sb.append("    lastUpdated: ").append(toIndentedString(lastUpdated)).append("\n");
    sb.append("    identifier: ").append(toIndentedString(identifier)).append("\n");
    sb.append("    template: ").append(toIndentedString(template)).append("\n");
    sb.append("    signature: ").append(toIndentedString(signature)).append("\n");
    sb.append("    start: ").append(toIndentedString(start)).append("\n");
    sb.append("    patterns: ").append(toIndentedString(patterns)).append("\n");
    sb.append("    end: ").append(toIndentedString(end)).append("\n");
    sb.append("    caseSensitive: ").append(toIndentedString(caseSensitive)).append("\n");
    sb.append("    condition: ").append(toIndentedString(condition)).append("\n");
    sb.append("    action: ").append(toIndentedString(action)).append("\n");
    sb.append("    customXML: ").append(toIndentedString(customXML)).append("\n");
    sb.append("    alertEnabled: ").append(toIndentedString(alertEnabled)).append("\n");
    sb.append("    scheduleID: ").append(toIndentedString(scheduleID)).append("\n");
    sb.append("    contextID: ").append(toIndentedString(contextID)).append("\n");
    sb.append("    recommendationsMode: ").append(toIndentedString(recommendationsMode)).append("\n");
    sb.append("    canBeAssignedAlone: ").append(toIndentedString(canBeAssignedAlone)).append("\n");
    sb.append("    dependsOnRuleIDs: ").append(toIndentedString(dependsOnRuleIDs)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("    cvSSScore: ").append(toIndentedString(cvSSScore)).append("\n");
    sb.append("    CVE: ").append(toIndentedString(CVE)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

