/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Software inventory item details.
 */
@ApiModel(description = "Software inventory item details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class InventoryItem {
  @JsonProperty("vendorName")
  private String vendorName = null;

  @JsonProperty("productName")
  private String productName = null;

  @JsonProperty("productVersion")
  private String productVersion = null;

  @JsonProperty("fileVersion")
  private String fileVersion = null;

  @JsonProperty("fileDescription")
  private String fileDescription = null;

  @JsonProperty("category")
  private String category = null;

  @JsonProperty("sha256")
  private String sha256 = null;

  @JsonProperty("sha1")
  private String sha1 = null;

  @JsonProperty("md5")
  private String md5 = null;

  @JsonProperty("fileName")
  private String fileName = null;

  @JsonProperty("path")
  private String path = null;

  @JsonProperty("size")
  private Long size = null;

  @JsonProperty("ID")
  private Long ID = null;

  public InventoryItem vendorName(String vendorName) {
    this.vendorName = vendorName;
    return this;
  }

   /**
   * Vendor name of the inventory item as reported by the package management system on the computer. Searchable as String.
   * @return vendorName
  **/
  @ApiModelProperty(value = "Vendor name of the inventory item as reported by the package management system on the computer. Searchable as String.")
  public String getVendorName() {
    return vendorName;
  }

  public void setVendorName(String vendorName) {
    this.vendorName = vendorName;
  }

  public InventoryItem productName(String productName) {
    this.productName = productName;
    return this;
  }

   /**
   * Product name of the inventory item as reported by the package management system on the computer. Searchable as String.
   * @return productName
  **/
  @ApiModelProperty(value = "Product name of the inventory item as reported by the package management system on the computer. Searchable as String.")
  public String getProductName() {
    return productName;
  }

  public void setProductName(String productName) {
    this.productName = productName;
  }

  public InventoryItem productVersion(String productVersion) {
    this.productVersion = productVersion;
    return this;
  }

   /**
   * Product version of the inventory item as reported by the package management system on the computer. Searchable as String.
   * @return productVersion
  **/
  @ApiModelProperty(value = "Product version of the inventory item as reported by the package management system on the computer. Searchable as String.")
  public String getProductVersion() {
    return productVersion;
  }

  public void setProductVersion(String productVersion) {
    this.productVersion = productVersion;
  }

  public InventoryItem fileVersion(String fileVersion) {
    this.fileVersion = fileVersion;
    return this;
  }

   /**
   * File version of the inventory item as reported by the package management system on the computer. Searchable as String.
   * @return fileVersion
  **/
  @ApiModelProperty(value = "File version of the inventory item as reported by the package management system on the computer. Searchable as String.")
  public String getFileVersion() {
    return fileVersion;
  }

  public void setFileVersion(String fileVersion) {
    this.fileVersion = fileVersion;
  }

  public InventoryItem fileDescription(String fileDescription) {
    this.fileDescription = fileDescription;
    return this;
  }

   /**
   * File description of the inventory item as reported by the package management system on the computer. Searchable as String.
   * @return fileDescription
  **/
  @ApiModelProperty(value = "File description of the inventory item as reported by the package management system on the computer. Searchable as String.")
  public String getFileDescription() {
    return fileDescription;
  }

  public void setFileDescription(String fileDescription) {
    this.fileDescription = fileDescription;
  }

  public InventoryItem category(String category) {
    this.category = category;
    return this;
  }

   /**
   * File category of the inventory item as reported by the package management system on the computer. Searchable as String.
   * @return category
  **/
  @ApiModelProperty(value = "File category of the inventory item as reported by the package management system on the computer. Searchable as String.")
  public String getCategory() {
    return category;
  }

  public void setCategory(String category) {
    this.category = category;
  }

  public InventoryItem sha256(String sha256) {
    this.sha256 = sha256;
    return this;
  }

   /**
   * SHA-256 hash of the inventory item. Searchable as String.
   * @return sha256
  **/
  @ApiModelProperty(value = "SHA-256 hash of the inventory item. Searchable as String.")
  public String getSha256() {
    return sha256;
  }

  public void setSha256(String sha256) {
    this.sha256 = sha256;
  }

  public InventoryItem sha1(String sha1) {
    this.sha1 = sha1;
    return this;
  }

   /**
   * SHA-1 hash of the inventory item. Searchable as String.
   * @return sha1
  **/
  @ApiModelProperty(value = "SHA-1 hash of the inventory item. Searchable as String.")
  public String getSha1() {
    return sha1;
  }

  public void setSha1(String sha1) {
    this.sha1 = sha1;
  }

  public InventoryItem md5(String md5) {
    this.md5 = md5;
    return this;
  }

   /**
   * MD5 hash of the inventory item. Searchable as String.
   * @return md5
  **/
  @ApiModelProperty(value = "MD5 hash of the inventory item. Searchable as String.")
  public String getMd5() {
    return md5;
  }

  public void setMd5(String md5) {
    this.md5 = md5;
  }

  public InventoryItem fileName(String fileName) {
    this.fileName = fileName;
    return this;
  }

   /**
   * File name of the inventory item. Searchable as String.
   * @return fileName
  **/
  @ApiModelProperty(value = "File name of the inventory item. Searchable as String.")
  public String getFileName() {
    return fileName;
  }

  public void setFileName(String fileName) {
    this.fileName = fileName;
  }

  public InventoryItem path(String path) {
    this.path = path;
    return this;
  }

   /**
   * File path of the inventory item. Searchable as String.
   * @return path
  **/
  @ApiModelProperty(value = "File path of the inventory item. Searchable as String.")
  public String getPath() {
    return path;
  }

  public void setPath(String path) {
    this.path = path;
  }

  public InventoryItem size(Long size) {
    this.size = size;
    return this;
  }

   /**
   * File size of the inventory item in bytes. Searchable as Numeric.
   * @return size
  **/
  @ApiModelProperty(value = "File size of the inventory item in bytes. Searchable as Numeric.")
  public Long getSize() {
    return size;
  }

  public void setSize(Long size) {
    this.size = size;
  }

  public InventoryItem ID(Long ID) {
    this.ID = ID;
    return this;
  }

   /**
   * ID of the inventory item. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the inventory item. Searchable as ID.")
  public Long getID() {
    return ID;
  }

  public void setID(Long ID) {
    this.ID = ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    InventoryItem inventoryItem = (InventoryItem) o;
    return Objects.equals(this.vendorName, inventoryItem.vendorName) &&
        Objects.equals(this.productName, inventoryItem.productName) &&
        Objects.equals(this.productVersion, inventoryItem.productVersion) &&
        Objects.equals(this.fileVersion, inventoryItem.fileVersion) &&
        Objects.equals(this.fileDescription, inventoryItem.fileDescription) &&
        Objects.equals(this.category, inventoryItem.category) &&
        Objects.equals(this.sha256, inventoryItem.sha256) &&
        Objects.equals(this.sha1, inventoryItem.sha1) &&
        Objects.equals(this.md5, inventoryItem.md5) &&
        Objects.equals(this.fileName, inventoryItem.fileName) &&
        Objects.equals(this.path, inventoryItem.path) &&
        Objects.equals(this.size, inventoryItem.size) &&
        Objects.equals(this.ID, inventoryItem.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(vendorName, productName, productVersion, fileVersion, fileDescription, category, sha256, sha1, md5, fileName, path, size, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class InventoryItem {\n");
    
    sb.append("    vendorName: ").append(toIndentedString(vendorName)).append("\n");
    sb.append("    productName: ").append(toIndentedString(productName)).append("\n");
    sb.append("    productVersion: ").append(toIndentedString(productVersion)).append("\n");
    sb.append("    fileVersion: ").append(toIndentedString(fileVersion)).append("\n");
    sb.append("    fileDescription: ").append(toIndentedString(fileDescription)).append("\n");
    sb.append("    category: ").append(toIndentedString(category)).append("\n");
    sb.append("    sha256: ").append(toIndentedString(sha256)).append("\n");
    sb.append("    sha1: ").append(toIndentedString(sha1)).append("\n");
    sb.append("    md5: ").append(toIndentedString(md5)).append("\n");
    sb.append("    fileName: ").append(toIndentedString(fileName)).append("\n");
    sb.append("    path: ").append(toIndentedString(path)).append("\n");
    sb.append("    size: ").append(toIndentedString(size)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

