/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Describes the file path and format of the log file.
 */
@ApiModel(description = "Describes the file path and format of the log file.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class LogFile {
  @JsonProperty("location")
  private String location = null;

  /**
   * Structure of the data in the log file. The application that generates the log file defines the structure of the data.
   */
  public enum FormatEnum {
    SYSLOG("syslog"),
    
    SNORT_FULL("snort-full"),
    
    SNORT_FAST("snort-fast"),
    
    APACHE("apache"),
    
    IIS("iis"),
    
    SQUID("squid"),
    
    NMAPG("nmapg"),
    
    MYSQL_LOG("mysql-log"),
    
    POSTGRESQL_LOG("postgresql-log"),
    
    DBJ_MULTILOG("dbj-multilog"),
    
    EVENTLOG("eventlog"),
    
    SINGLE_LINE_TEXT_LOG("single-line-text-log");

    private String value;

    FormatEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static FormatEnum fromValue(String text) {
      for (FormatEnum b : FormatEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("format")
  private FormatEnum format = null;

  public LogFile location(String location) {
    this.location = location;
    return this;
  }

   /**
   * File path of the log file.
   * @return location
  **/
  @ApiModelProperty(value = "File path of the log file.")
  public String getLocation() {
    return location;
  }

  public void setLocation(String location) {
    this.location = location;
  }

  public LogFile format(FormatEnum format) {
    this.format = format;
    return this;
  }

   /**
   * Structure of the data in the log file. The application that generates the log file defines the structure of the data.
   * @return format
  **/
  @ApiModelProperty(value = "Structure of the data in the log file. The application that generates the log file defines the structure of the data.")
  public FormatEnum getFormat() {
    return format;
  }

  public void setFormat(FormatEnum format) {
    this.format = format;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    LogFile logFile = (LogFile) o;
    return Objects.equals(this.location, logFile.location) &&
        Objects.equals(this.format, logFile.format);
  }

  @Override
  public int hashCode() {
    return Objects.hash(location, format);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class LogFile {\n");
    
    sb.append("    location: ").append(toIndentedString(location)).append("\n");
    sb.append("    format: ").append(toIndentedString(format)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

