/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Result of a log inspection recommendation.
 */
@ApiModel(description = "Result of a log inspection recommendation.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class LogInspectionAssignments {
  @JsonProperty("assignedRuleIDs")
  private List<Integer> assignedRuleIDs = null;

  /**
   * Status of the last recommendation scan.
   */
  public enum RecommendationScanStatusEnum {
    NONE("none"),
    
    VALID("valid"),
    
    OUT_OF_DATE("out-of-date"),
    
    UNKNOWN("unknown");

    private String value;

    RecommendationScanStatusEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static RecommendationScanStatusEnum fromValue(String text) {
      for (RecommendationScanStatusEnum b : RecommendationScanStatusEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("recommendationScanStatus")
  private RecommendationScanStatusEnum recommendationScanStatus = null;

  @JsonProperty("lastRecommendationScanDate")
  private Long lastRecommendationScanDate = null;

  @JsonProperty("recommendedToAssignRuleIDs")
  private List<Integer> recommendedToAssignRuleIDs = null;

  @JsonProperty("recommendedToUnassignRuleIDs")
  private List<Integer> recommendedToUnassignRuleIDs = null;

  public LogInspectionAssignments assignedRuleIDs(List<Integer> assignedRuleIDs) {
    this.assignedRuleIDs = assignedRuleIDs;
    return this;
  }

  public LogInspectionAssignments addAssignedRuleIDsItem(Integer assignedRuleIDsItem) {
    if (this.assignedRuleIDs == null) {
      this.assignedRuleIDs = new ArrayList<>();
    }
    this.assignedRuleIDs.add(assignedRuleIDsItem);
    return this;
  }

   /**
   * IDs of the log inspection rules currently assigned.
   * @return assignedRuleIDs
  **/
  @ApiModelProperty(value = "IDs of the log inspection rules currently assigned.")
  public List<Integer> getAssignedRuleIDs() {
    return assignedRuleIDs;
  }

  public void setAssignedRuleIDs(List<Integer> assignedRuleIDs) {
    this.assignedRuleIDs = assignedRuleIDs;
  }

  public LogInspectionAssignments recommendationScanStatus(RecommendationScanStatusEnum recommendationScanStatus) {
    this.recommendationScanStatus = recommendationScanStatus;
    return this;
  }

   /**
   * Status of the last recommendation scan.
   * @return recommendationScanStatus
  **/
  @ApiModelProperty(value = "Status of the last recommendation scan.")
  public RecommendationScanStatusEnum getRecommendationScanStatus() {
    return recommendationScanStatus;
  }

  public void setRecommendationScanStatus(RecommendationScanStatusEnum recommendationScanStatus) {
    this.recommendationScanStatus = recommendationScanStatus;
  }

  public LogInspectionAssignments lastRecommendationScanDate(Long lastRecommendationScanDate) {
    this.lastRecommendationScanDate = lastRecommendationScanDate;
    return this;
  }

   /**
   * Timestamp of the last recommendation scan, in milliseconds since epoch.
   * @return lastRecommendationScanDate
  **/
  @ApiModelProperty(value = "Timestamp of the last recommendation scan, in milliseconds since epoch.")
  public Long getLastRecommendationScanDate() {
    return lastRecommendationScanDate;
  }

  public void setLastRecommendationScanDate(Long lastRecommendationScanDate) {
    this.lastRecommendationScanDate = lastRecommendationScanDate;
  }

  public LogInspectionAssignments recommendedToAssignRuleIDs(List<Integer> recommendedToAssignRuleIDs) {
    this.recommendedToAssignRuleIDs = recommendedToAssignRuleIDs;
    return this;
  }

  public LogInspectionAssignments addRecommendedToAssignRuleIDsItem(Integer recommendedToAssignRuleIDsItem) {
    if (this.recommendedToAssignRuleIDs == null) {
      this.recommendedToAssignRuleIDs = new ArrayList<>();
    }
    this.recommendedToAssignRuleIDs.add(recommendedToAssignRuleIDsItem);
    return this;
  }

   /**
   * IDs of the log inspection rules recommended for assignment.
   * @return recommendedToAssignRuleIDs
  **/
  @ApiModelProperty(value = "IDs of the log inspection rules recommended for assignment.")
  public List<Integer> getRecommendedToAssignRuleIDs() {
    return recommendedToAssignRuleIDs;
  }

  public void setRecommendedToAssignRuleIDs(List<Integer> recommendedToAssignRuleIDs) {
    this.recommendedToAssignRuleIDs = recommendedToAssignRuleIDs;
  }

  public LogInspectionAssignments recommendedToUnassignRuleIDs(List<Integer> recommendedToUnassignRuleIDs) {
    this.recommendedToUnassignRuleIDs = recommendedToUnassignRuleIDs;
    return this;
  }

  public LogInspectionAssignments addRecommendedToUnassignRuleIDsItem(Integer recommendedToUnassignRuleIDsItem) {
    if (this.recommendedToUnassignRuleIDs == null) {
      this.recommendedToUnassignRuleIDs = new ArrayList<>();
    }
    this.recommendedToUnassignRuleIDs.add(recommendedToUnassignRuleIDsItem);
    return this;
  }

   /**
   * IDs of the log inspection rules recommended for unassignment.
   * @return recommendedToUnassignRuleIDs
  **/
  @ApiModelProperty(value = "IDs of the log inspection rules recommended for unassignment.")
  public List<Integer> getRecommendedToUnassignRuleIDs() {
    return recommendedToUnassignRuleIDs;
  }

  public void setRecommendedToUnassignRuleIDs(List<Integer> recommendedToUnassignRuleIDs) {
    this.recommendedToUnassignRuleIDs = recommendedToUnassignRuleIDs;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    LogInspectionAssignments logInspectionAssignments = (LogInspectionAssignments) o;
    return Objects.equals(this.assignedRuleIDs, logInspectionAssignments.assignedRuleIDs) &&
        Objects.equals(this.recommendationScanStatus, logInspectionAssignments.recommendationScanStatus) &&
        Objects.equals(this.lastRecommendationScanDate, logInspectionAssignments.lastRecommendationScanDate) &&
        Objects.equals(this.recommendedToAssignRuleIDs, logInspectionAssignments.recommendedToAssignRuleIDs) &&
        Objects.equals(this.recommendedToUnassignRuleIDs, logInspectionAssignments.recommendedToUnassignRuleIDs);
  }

  @Override
  public int hashCode() {
    return Objects.hash(assignedRuleIDs, recommendationScanStatus, lastRecommendationScanDate, recommendedToAssignRuleIDs, recommendedToUnassignRuleIDs);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class LogInspectionAssignments {\n");
    
    sb.append("    assignedRuleIDs: ").append(toIndentedString(assignedRuleIDs)).append("\n");
    sb.append("    recommendationScanStatus: ").append(toIndentedString(recommendationScanStatus)).append("\n");
    sb.append("    lastRecommendationScanDate: ").append(toIndentedString(lastRecommendationScanDate)).append("\n");
    sb.append("    recommendedToAssignRuleIDs: ").append(toIndentedString(recommendedToAssignRuleIDs)).append("\n");
    sb.append("    recommendedToUnassignRuleIDs: ").append(toIndentedString(recommendedToUnassignRuleIDs)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

