/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * MAC address list details.
 */
@ApiModel(description = "MAC address list details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class MacList {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("items")
  private List<String> items = null;

  @JsonProperty("ID")
  private Integer ID = null;

  public MacList name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the MAC address list. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the MAC address list. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public MacList description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the MAC address list. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the MAC address list. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public MacList items(List<String> items) {
    this.items = items;
    return this;
  }

  public MacList addItemsItem(String itemsItem) {
    if (this.items == null) {
      this.items = new ArrayList<>();
    }
    this.items.add(itemsItem);
    return this;
  }

   /**
   * List of comma-delimited MAC addresses. The list can also contain comments and other information that is parsed out.
   * @return items
  **/
  @ApiModelProperty(value = "List of comma-delimited MAC addresses. The list can also contain comments and other information that is parsed out.")
  public List<String> getItems() {
    return items;
  }

  public void setItems(List<String> items) {
    this.items = items;
  }

   /**
   * ID of the MAC address list. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the MAC address list. Searchable as ID.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    MacList macList = (MacList) o;
    return Objects.equals(this.name, macList.name) &&
        Objects.equals(this.description, macList.description) &&
        Objects.equals(this.items, macList.items) &&
        Objects.equals(this.ID, macList.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, items, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class MacList {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    items: ").append(toIndentedString(items)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

