/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * NSXManagerInfo
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class NSXManagerInfo {
  @JsonProperty("host")
  private String host = null;

  @JsonProperty("port")
  private Integer port = null;

  @JsonProperty("username")
  private String username = null;

  @JsonProperty("password")
  private String password = null;

  @JsonProperty("webserverUrl")
  private String webserverUrl = null;

  @JsonProperty("nsxPolicySync")
  private Boolean nsxPolicySync = null;

  @JsonProperty("createDefaultEBT")
  private Boolean createDefaultEBT = null;

  public NSXManagerInfo host(String host) {
    this.host = host;
    return this;
  }

   /**
   * NSX Manager IP address or hostname.
   * @return host
  **/
  @ApiModelProperty(value = "NSX Manager IP address or hostname.")
  public String getHost() {
    return host;
  }

  public void setHost(String host) {
    this.host = host;
  }

  public NSXManagerInfo port(Integer port) {
    this.port = port;
    return this;
  }

   /**
   * NSX Manager port.
   * @return port
  **/
  @ApiModelProperty(value = "NSX Manager port.")
  public Integer getPort() {
    return port;
  }

  public void setPort(Integer port) {
    this.port = port;
  }

  public NSXManagerInfo username(String username) {
    this.username = username;
    return this;
  }

   /**
   * Username that the connector will use to authenticate to NSX Manager.
   * @return username
  **/
  @ApiModelProperty(value = "Username that the connector will use to authenticate to NSX Manager.")
  public String getUsername() {
    return username;
  }

  public void setUsername(String username) {
    this.username = username;
  }

  public NSXManagerInfo password(String password) {
    this.password = password;
    return this;
  }

   /**
   * Password of the NSX Manager user. Must be base64-encoded.
   * @return password
  **/
  @ApiModelProperty(value = "Password of the NSX Manager user. Must be base64-encoded.")
  public String getPassword() {
    return password;
  }

  public void setPassword(String password) {
    this.password = password;
  }

  public NSXManagerInfo webserverUrl(String webserverUrl) {
    this.webserverUrl = webserverUrl;
    return this;
  }

   /**
   * URL to the appliance OVF file.
   * @return webserverUrl
  **/
  @ApiModelProperty(value = "URL to the appliance OVF file.")
  public String getWebserverUrl() {
    return webserverUrl;
  }

  public void setWebserverUrl(String webserverUrl) {
    this.webserverUrl = webserverUrl;
  }

  public NSXManagerInfo nsxPolicySync(Boolean nsxPolicySync) {
    this.nsxPolicySync = nsxPolicySync;
    return this;
  }

   /**
   * Enable or disable the NSX policy sync feature.
   * @return nsxPolicySync
  **/
  @ApiModelProperty(value = "Enable or disable the NSX policy sync feature.")
  public Boolean isNsxPolicySync() {
    return nsxPolicySync;
  }

  public void setNsxPolicySync(Boolean nsxPolicySync) {
    this.nsxPolicySync = nsxPolicySync;
  }

  public NSXManagerInfo createDefaultEBT(Boolean createDefaultEBT) {
    this.createDefaultEBT = createDefaultEBT;
    return this;
  }

   /**
   * Create the default event-based task (also called the &#39;default EBT&#39;).
   * @return createDefaultEBT
  **/
  @ApiModelProperty(value = "Create the default event-based task (also called the 'default EBT').")
  public Boolean isCreateDefaultEBT() {
    return createDefaultEBT;
  }

  public void setCreateDefaultEBT(Boolean createDefaultEBT) {
    this.createDefaultEBT = createDefaultEBT;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    NSXManagerInfo nsXManagerInfo = (NSXManagerInfo) o;
    return Objects.equals(this.host, nsXManagerInfo.host) &&
        Objects.equals(this.port, nsXManagerInfo.port) &&
        Objects.equals(this.username, nsXManagerInfo.username) &&
        Objects.equals(this.password, nsXManagerInfo.password) &&
        Objects.equals(this.webserverUrl, nsXManagerInfo.webserverUrl) &&
        Objects.equals(this.nsxPolicySync, nsXManagerInfo.nsxPolicySync) &&
        Objects.equals(this.createDefaultEBT, nsXManagerInfo.createDefaultEBT);
  }

  @Override
  public int hashCode() {
    return Objects.hash(host, port, username, password, webserverUrl, nsxPolicySync, createDefaultEBT);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class NSXManagerInfo {\n");
    
    sb.append("    host: ").append(toIndentedString(host)).append("\n");
    sb.append("    port: ").append(toIndentedString(port)).append("\n");
    sb.append("    username: ").append(toIndentedString(username)).append("\n");
    sb.append("    password: ").append(toIndentedString(password)).append("\n");
    sb.append("    webserverUrl: ").append(toIndentedString(webserverUrl)).append("\n");
    sb.append("    nsxPolicySync: ").append(toIndentedString(nsxPolicySync)).append("\n");
    sb.append("    createDefaultEBT: ").append(toIndentedString(createDefaultEBT)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

