/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Details of an AWS virtual machine that was added to Deep Security Manager using the legacy Add Cloud Account wizard.
 */
@ApiModel(description = "Details of an AWS virtual machine that was added to Deep Security Manager using the legacy Add Cloud Account wizard.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class NoConnectorVirtualMachineSummary {
  @JsonProperty("accountID")
  private String accountID = null;

  @JsonProperty("directoryID")
  private String directoryID = null;

  @JsonProperty("userName")
  private String userName = null;

  @JsonProperty("instanceID")
  private String instanceID = null;

  @JsonProperty("region")
  private String region = null;

  public NoConnectorVirtualMachineSummary accountID(String accountID) {
    this.accountID = accountID;
    return this;
  }

   /**
   * Agent-reported account ID. Searchable as String.
   * @return accountID
  **/
  @ApiModelProperty(value = "Agent-reported account ID. Searchable as String.")
  public String getAccountID() {
    return accountID;
  }

  public void setAccountID(String accountID) {
    this.accountID = accountID;
  }

  public NoConnectorVirtualMachineSummary directoryID(String directoryID) {
    this.directoryID = directoryID;
    return this;
  }

   /**
   * Agent-reported directory ID. Searchable as String.
   * @return directoryID
  **/
  @ApiModelProperty(value = "Agent-reported directory ID. Searchable as String.")
  public String getDirectoryID() {
    return directoryID;
  }

  public void setDirectoryID(String directoryID) {
    this.directoryID = directoryID;
  }

  public NoConnectorVirtualMachineSummary userName(String userName) {
    this.userName = userName;
    return this;
  }

   /**
   * Agent-reported user ID. Searchable as String.
   * @return userName
  **/
  @ApiModelProperty(value = "Agent-reported user ID. Searchable as String.")
  public String getUserName() {
    return userName;
  }

  public void setUserName(String userName) {
    this.userName = userName;
  }

  public NoConnectorVirtualMachineSummary instanceID(String instanceID) {
    this.instanceID = instanceID;
    return this;
  }

   /**
   * Agent-reported instance ID. Searchable as String.
   * @return instanceID
  **/
  @ApiModelProperty(value = "Agent-reported instance ID. Searchable as String.")
  public String getInstanceID() {
    return instanceID;
  }

  public void setInstanceID(String instanceID) {
    this.instanceID = instanceID;
  }

  public NoConnectorVirtualMachineSummary region(String region) {
    this.region = region;
    return this;
  }

   /**
   * Agent-reported region. Searchable as String.
   * @return region
  **/
  @ApiModelProperty(value = "Agent-reported region. Searchable as String.")
  public String getRegion() {
    return region;
  }

  public void setRegion(String region) {
    this.region = region;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    NoConnectorVirtualMachineSummary noConnectorVirtualMachineSummary = (NoConnectorVirtualMachineSummary) o;
    return Objects.equals(this.accountID, noConnectorVirtualMachineSummary.accountID) &&
        Objects.equals(this.directoryID, noConnectorVirtualMachineSummary.directoryID) &&
        Objects.equals(this.userName, noConnectorVirtualMachineSummary.userName) &&
        Objects.equals(this.instanceID, noConnectorVirtualMachineSummary.instanceID) &&
        Objects.equals(this.region, noConnectorVirtualMachineSummary.region);
  }

  @Override
  public int hashCode() {
    return Objects.hash(accountID, directoryID, userName, instanceID, region);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class NoConnectorVirtualMachineSummary {\n");
    
    sb.append("    accountID: ").append(toIndentedString(accountID)).append("\n");
    sb.append("    directoryID: ").append(toIndentedString(directoryID)).append("\n");
    sb.append("    userName: ").append(toIndentedString(userName)).append("\n");
    sb.append("    instanceID: ").append(toIndentedString(instanceID)).append("\n");
    sb.append("    region: ").append(toIndentedString(region)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

