/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.PolicyMapping;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Task to migrate policies
 */
@ApiModel(description = "Task to migrate policies")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class PolicyMigrationTask {
  @JsonProperty("taskGUID")
  private String taskGUID = null;

  /**
   * The migration status.
   */
  public enum StatusEnum {
    REQUESTED("requested"),
    
    IN_PROGRESS("in-progress"),
    
    COMPLETE("complete"),
    
    FAILED("failed");

    private String value;

    StatusEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StatusEnum fromValue(String text) {
      for (StatusEnum b : StatusEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("status")
  private StatusEnum status = null;

  @JsonProperty("created")
  private Long created = null;

  @JsonProperty("lastUpdated")
  private Long lastUpdated = null;

  @JsonProperty("policyMappings")
  private List<PolicyMapping> policyMappings = null;

  @JsonProperty("errorCode")
  private Integer errorCode = null;

  @JsonProperty("ID")
  private Integer ID = null;

   /**
   * Task GUID on Workload Security. Searchable as String.
   * @return taskGUID
  **/
  @ApiModelProperty(value = "Task GUID on Workload Security. Searchable as String.")
  public String getTaskGUID() {
    return taskGUID;
  }

   /**
   * The migration status.
   * @return status
  **/
  @ApiModelProperty(value = "The migration status.")
  public StatusEnum getStatus() {
    return status;
  }

   /**
   * Timestamp when the PolicyMigrationTask was created, in milliseconds since epoch. Searchable as Date.
   * @return created
  **/
  @ApiModelProperty(value = "Timestamp when the PolicyMigrationTask was created, in milliseconds since epoch. Searchable as Date.")
  public Long getCreated() {
    return created;
  }

   /**
   * Timestamp when the PolicyMigrationTask was updated, in milliseconds since epoch. Searchable as Date.
   * @return lastUpdated
  **/
  @ApiModelProperty(value = "Timestamp when the PolicyMigrationTask was updated, in milliseconds since epoch. Searchable as Date.")
  public Long getLastUpdated() {
    return lastUpdated;
  }

   /**
   * The mapping table of policies on this Deep Security Manager and the Workload Security.
   * @return policyMappings
  **/
  @ApiModelProperty(value = "The mapping table of policies on this Deep Security Manager and the Workload Security.")
  public List<PolicyMapping> getPolicyMappings() {
    return policyMappings;
  }

   /**
   * The error code of the failed task.
   * @return errorCode
  **/
  @ApiModelProperty(value = "The error code of the failed task.")
  public Integer getErrorCode() {
    return errorCode;
  }

   /**
   * ID of the policy migration task.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the policy migration task.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PolicyMigrationTask policyMigrationTask = (PolicyMigrationTask) o;
    return Objects.equals(this.taskGUID, policyMigrationTask.taskGUID) &&
        Objects.equals(this.status, policyMigrationTask.status) &&
        Objects.equals(this.created, policyMigrationTask.created) &&
        Objects.equals(this.lastUpdated, policyMigrationTask.lastUpdated) &&
        Objects.equals(this.policyMappings, policyMigrationTask.policyMappings) &&
        Objects.equals(this.errorCode, policyMigrationTask.errorCode) &&
        Objects.equals(this.ID, policyMigrationTask.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(taskGUID, status, created, lastUpdated, policyMappings, errorCode, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PolicyMigrationTask {\n");
    
    sb.append("    taskGUID: ").append(toIndentedString(taskGUID)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    lastUpdated: ").append(toIndentedString(lastUpdated)).append("\n");
    sb.append("    policyMappings: ").append(toIndentedString(policyMappings)).append("\n");
    sb.append("    errorCode: ").append(toIndentedString(errorCode)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

