/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Details of a proxy.
 */
@ApiModel(description = "Details of a proxy.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class Proxy {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("hostName")
  private String hostName = null;

  @JsonProperty("port")
  private Integer port = null;

  /**
   * Protocol of the proxy. Default is \&quot;http\&quot;.
   */
  public enum ProtocolEnum {
    HTTP("http"),
    
    SOCKS4("socks4"),
    
    SOCKS5("socks5");

    private String value;

    ProtocolEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ProtocolEnum fromValue(String text) {
      for (ProtocolEnum b : ProtocolEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("protocol")
  private ProtocolEnum protocol = null;

  @JsonProperty("authenticated")
  private Boolean authenticated = null;

  @JsonProperty("username")
  private String username = null;

  @JsonProperty("password")
  private String password = null;

  @JsonProperty("proxyType")
  private String proxyType = null;

  @JsonProperty("sgproxy")
  private Boolean sgproxy = null;

  @JsonProperty("ID")
  private Integer ID = null;

  public Proxy name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the proxy. The maximum length is 254 characters. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(required = true, value = "Name of the proxy. The maximum length is 254 characters. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public Proxy description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the proxy. The maximum length is 2000 characters. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the proxy. The maximum length is 2000 characters. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public Proxy hostName(String hostName) {
    this.hostName = hostName;
    return this;
  }

   /**
   * Host name of the proxy. The maximum length is 254 characters. Searchable as String.
   * @return hostName
  **/
  @ApiModelProperty(required = true, value = "Host name of the proxy. The maximum length is 254 characters. Searchable as String.")
  public String getHostName() {
    return hostName;
  }

  public void setHostName(String hostName) {
    this.hostName = hostName;
  }

  public Proxy port(Integer port) {
    this.port = port;
    return this;
  }

   /**
   * Port of the proxy.
   * @return port
  **/
  @ApiModelProperty(required = true, value = "Port of the proxy.")
  public Integer getPort() {
    return port;
  }

  public void setPort(Integer port) {
    this.port = port;
  }

  public Proxy protocol(ProtocolEnum protocol) {
    this.protocol = protocol;
    return this;
  }

   /**
   * Protocol of the proxy. Default is \&quot;http\&quot;.
   * @return protocol
  **/
  @ApiModelProperty(value = "Protocol of the proxy. Default is \"http\".")
  public ProtocolEnum getProtocol() {
    return protocol;
  }

  public void setProtocol(ProtocolEnum protocol) {
    this.protocol = protocol;
  }

  public Proxy authenticated(Boolean authenticated) {
    this.authenticated = authenticated;
    return this;
  }

   /**
   * Flag indicating whether access to the proxy is authenticated. Default is \&quot;false\&quot;.
   * @return authenticated
  **/
  @ApiModelProperty(value = "Flag indicating whether access to the proxy is authenticated. Default is \"false\".")
  public Boolean isAuthenticated() {
    return authenticated;
  }

  public void setAuthenticated(Boolean authenticated) {
    this.authenticated = authenticated;
  }

  public Proxy username(String username) {
    this.username = username;
    return this;
  }

   /**
   * Username of the proxy. The maximum length is 254 characters.
   * @return username
  **/
  @ApiModelProperty(value = "Username of the proxy. The maximum length is 254 characters.")
  public String getUsername() {
    return username;
  }

  public void setUsername(String username) {
    this.username = username;
  }

  public Proxy password(String password) {
    this.password = password;
    return this;
  }

   /**
   * Password of the proxy, write only. The maximum length is 254 characters.
   * @return password
  **/
  @ApiModelProperty(value = "Password of the proxy, write only. The maximum length is 254 characters.")
  public String getPassword() {
    return password;
  }

  public void setPassword(String password) {
    this.password = password;
  }

  public Proxy proxyType(String proxyType) {
    this.proxyType = proxyType;
    return this;
  }

   /**
   * Type of proxy. support: &#39;userAssignedProxy&#39;, &#39;serviceGatewayProxy&#39;
   * @return proxyType
  **/
  @ApiModelProperty(value = "Type of proxy. support: 'userAssignedProxy', 'serviceGatewayProxy'")
  public String getProxyType() {
    return proxyType;
  }

  public void setProxyType(String proxyType) {
    this.proxyType = proxyType;
  }

  public Proxy sgproxy(Boolean sgproxy) {
    this.sgproxy = sgproxy;
    return this;
  }

   /**
   * Get sgproxy
   * @return sgproxy
  **/
  @ApiModelProperty(value = "")
  public Boolean isSgproxy() {
    return sgproxy;
  }

  public void setSgproxy(Boolean sgproxy) {
    this.sgproxy = sgproxy;
  }

   /**
   * ID of the proxy. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the proxy. Searchable as ID.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Proxy proxy = (Proxy) o;
    return Objects.equals(this.name, proxy.name) &&
        Objects.equals(this.description, proxy.description) &&
        Objects.equals(this.hostName, proxy.hostName) &&
        Objects.equals(this.port, proxy.port) &&
        Objects.equals(this.protocol, proxy.protocol) &&
        Objects.equals(this.authenticated, proxy.authenticated) &&
        Objects.equals(this.username, proxy.username) &&
        Objects.equals(this.password, proxy.password) &&
        Objects.equals(this.proxyType, proxy.proxyType) &&
        Objects.equals(this.sgproxy, proxy.sgproxy) &&
        Objects.equals(this.ID, proxy.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, hostName, port, protocol, authenticated, username, password, proxyType, sgproxy, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Proxy {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    hostName: ").append(toIndentedString(hostName)).append("\n");
    sb.append("    port: ").append(toIndentedString(port)).append("\n");
    sb.append("    protocol: ").append(toIndentedString(protocol)).append("\n");
    sb.append("    authenticated: ").append(toIndentedString(authenticated)).append("\n");
    sb.append("    username: ").append(toIndentedString(username)).append("\n");
    sb.append("    password: ").append(toIndentedString(password)).append("\n");
    sb.append("    proxyType: ").append(toIndentedString(proxyType)).append("\n");
    sb.append("    sgproxy: ").append(toIndentedString(sgproxy)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

