/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Details of the recipients for a scheduled task. A recipiant is an administrator or contact who recieves reports or event summaries via scheduled tasks.
 */
@ApiModel(description = "Details of the recipients for a scheduled task. A recipiant is an administrator or contact who recieves reports or event summaries via scheduled tasks.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class Recipients {
  @JsonProperty("allAdministratorsAndContacts")
  private Boolean allAdministratorsAndContacts = null;

  @JsonProperty("administratorIDs")
  private List<Integer> administratorIDs = null;

  @JsonProperty("contactIDs")
  private List<Integer> contactIDs = null;

  public Recipients allAdministratorsAndContacts(Boolean allAdministratorsAndContacts) {
    this.allAdministratorsAndContacts = allAdministratorsAndContacts;
    return this;
  }

   /**
   * Send to all administrators and contacts with a valid email address.
   * @return allAdministratorsAndContacts
  **/
  @ApiModelProperty(value = "Send to all administrators and contacts with a valid email address.")
  public Boolean isAllAdministratorsAndContacts() {
    return allAdministratorsAndContacts;
  }

  public void setAllAdministratorsAndContacts(Boolean allAdministratorsAndContacts) {
    this.allAdministratorsAndContacts = allAdministratorsAndContacts;
  }

  public Recipients administratorIDs(List<Integer> administratorIDs) {
    this.administratorIDs = administratorIDs;
    return this;
  }

  public Recipients addAdministratorIDsItem(Integer administratorIDsItem) {
    if (this.administratorIDs == null) {
      this.administratorIDs = new ArrayList<>();
    }
    this.administratorIDs.add(administratorIDsItem);
    return this;
  }

   /**
   * List of recipient administrators IDs.
   * @return administratorIDs
  **/
  @ApiModelProperty(value = "List of recipient administrators IDs.")
  public List<Integer> getAdministratorIDs() {
    return administratorIDs;
  }

  public void setAdministratorIDs(List<Integer> administratorIDs) {
    this.administratorIDs = administratorIDs;
  }

  public Recipients contactIDs(List<Integer> contactIDs) {
    this.contactIDs = contactIDs;
    return this;
  }

  public Recipients addContactIDsItem(Integer contactIDsItem) {
    if (this.contactIDs == null) {
      this.contactIDs = new ArrayList<>();
    }
    this.contactIDs.add(contactIDsItem);
    return this;
  }

   /**
   * List of recipient contact IDs.
   * @return contactIDs
  **/
  @ApiModelProperty(value = "List of recipient contact IDs.")
  public List<Integer> getContactIDs() {
    return contactIDs;
  }

  public void setContactIDs(List<Integer> contactIDs) {
    this.contactIDs = contactIDs;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Recipients recipients = (Recipients) o;
    return Objects.equals(this.allAdministratorsAndContacts, recipients.allAdministratorsAndContacts) &&
        Objects.equals(this.administratorIDs, recipients.administratorIDs) &&
        Objects.equals(this.contactIDs, recipients.contactIDs);
  }

  @Override
  public int hashCode() {
    return Objects.hash(allAdministratorsAndContacts, administratorIDs, contactIDs);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Recipients {\n");
    
    sb.append("    allAdministratorsAndContacts: ").append(toIndentedString(allAdministratorsAndContacts)).append("\n");
    sb.append("    administratorIDs: ").append(toIndentedString(administratorIDs)).append("\n");
    sb.append("    contactIDs: ").append(toIndentedString(contactIDs)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

