/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.Rights;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Administrator role details.
 */
@ApiModel(description = "Administrator role details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class Role {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("urn")
  private String urn = null;

  @JsonProperty("immutable")
  private Boolean immutable = null;

  @JsonProperty("canOnlyManipulateUsersWithEqualOrLesserRights")
  private Boolean canOnlyManipulateUsersWithEqualOrLesserRights = null;

  @JsonProperty("allComputers")
  private Boolean allComputers = null;

  @JsonProperty("allPolicies")
  private Boolean allPolicies = null;

  @JsonProperty("allowUserInterface")
  private Boolean allowUserInterface = null;

  @JsonProperty("allowWebService")
  private Boolean allowWebService = null;

  @JsonProperty("allowManageWorkloadSecurityLink")
  private Boolean allowManageWorkloadSecurityLink = null;

  @JsonProperty("allowMigration")
  private Boolean allowMigration = null;

  @JsonProperty("rights")
  private Rights rights = null;

  @JsonProperty("computerIDs")
  private List<Integer> computerIDs = null;

  @JsonProperty("computerGroupIDs")
  private List<Integer> computerGroupIDs = null;

  @JsonProperty("policyIDs")
  private List<Integer> policyIDs = null;

  @JsonProperty("ID")
  private Integer ID = null;

  public Role name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the administrator role. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the administrator role. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public Role description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the administrator role. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the administrator role. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

   /**
   * Uniform resource name.
   * @return urn
  **/
  @ApiModelProperty(value = "Uniform resource name.")
  public String getUrn() {
    return urn;
  }

   /**
   * The default immutable role in Deep Security Manager.
   * @return immutable
  **/
  @ApiModelProperty(value = "The default immutable role in Deep Security Manager.")
  public Boolean isImmutable() {
    return immutable;
  }

  public Role canOnlyManipulateUsersWithEqualOrLesserRights(Boolean canOnlyManipulateUsersWithEqualOrLesserRights) {
    this.canOnlyManipulateUsersWithEqualOrLesserRights = canOnlyManipulateUsersWithEqualOrLesserRights;
    return this;
  }

   /**
   * Controls whether or not the role can only manipulate users with equal or lesser rights. Searchable as Boolean.
   * @return canOnlyManipulateUsersWithEqualOrLesserRights
  **/
  @ApiModelProperty(value = "Controls whether or not the role can only manipulate users with equal or lesser rights. Searchable as Boolean.")
  public Boolean isCanOnlyManipulateUsersWithEqualOrLesserRights() {
    return canOnlyManipulateUsersWithEqualOrLesserRights;
  }

  public void setCanOnlyManipulateUsersWithEqualOrLesserRights(Boolean canOnlyManipulateUsersWithEqualOrLesserRights) {
    this.canOnlyManipulateUsersWithEqualOrLesserRights = canOnlyManipulateUsersWithEqualOrLesserRights;
  }

  public Role allComputers(Boolean allComputers) {
    this.allComputers = allComputers;
    return this;
  }

   /**
   * Controls whether or not the role is allowed to access all computers. Searchable as Boolean.
   * @return allComputers
  **/
  @ApiModelProperty(value = "Controls whether or not the role is allowed to access all computers. Searchable as Boolean.")
  public Boolean isAllComputers() {
    return allComputers;
  }

  public void setAllComputers(Boolean allComputers) {
    this.allComputers = allComputers;
  }

  public Role allPolicies(Boolean allPolicies) {
    this.allPolicies = allPolicies;
    return this;
  }

   /**
   * Controls whether or not the role is allowed to access all policies. Searchable as Boolean.
   * @return allPolicies
  **/
  @ApiModelProperty(value = "Controls whether or not the role is allowed to access all policies. Searchable as Boolean.")
  public Boolean isAllPolicies() {
    return allPolicies;
  }

  public void setAllPolicies(Boolean allPolicies) {
    this.allPolicies = allPolicies;
  }

  public Role allowUserInterface(Boolean allowUserInterface) {
    this.allowUserInterface = allowUserInterface;
    return this;
  }

   /**
   * Controls whether or not the role is allowed to use the user interface. Searchable as Boolean.
   * @return allowUserInterface
  **/
  @ApiModelProperty(value = "Controls whether or not the role is allowed to use the user interface. Searchable as Boolean.")
  public Boolean isAllowUserInterface() {
    return allowUserInterface;
  }

  public void setAllowUserInterface(Boolean allowUserInterface) {
    this.allowUserInterface = allowUserInterface;
  }

  public Role allowWebService(Boolean allowWebService) {
    this.allowWebService = allowWebService;
    return this;
  }

   /**
   * Controls whether or not the role is allowed to use the web service API. Searchable as Boolean.
   * @return allowWebService
  **/
  @ApiModelProperty(value = "Controls whether or not the role is allowed to use the web service API. Searchable as Boolean.")
  public Boolean isAllowWebService() {
    return allowWebService;
  }

  public void setAllowWebService(Boolean allowWebService) {
    this.allowWebService = allowWebService;
  }

  public Role allowManageWorkloadSecurityLink(Boolean allowManageWorkloadSecurityLink) {
    this.allowManageWorkloadSecurityLink = allowManageWorkloadSecurityLink;
    return this;
  }

   /**
   * Controls whether or not the role is allowed management of Workload Security Link. Searchable as Boolean.
   * @return allowManageWorkloadSecurityLink
  **/
  @ApiModelProperty(value = "Controls whether or not the role is allowed management of Workload Security Link. Searchable as Boolean.")
  public Boolean isAllowManageWorkloadSecurityLink() {
    return allowManageWorkloadSecurityLink;
  }

  public void setAllowManageWorkloadSecurityLink(Boolean allowManageWorkloadSecurityLink) {
    this.allowManageWorkloadSecurityLink = allowManageWorkloadSecurityLink;
  }

  public Role allowMigration(Boolean allowMigration) {
    this.allowMigration = allowMigration;
    return this;
  }

   /**
   * Controls whether or not the role is allowed migration to Workload Security. Searchable as Boolean.
   * @return allowMigration
  **/
  @ApiModelProperty(value = "Controls whether or not the role is allowed migration to Workload Security. Searchable as Boolean.")
  public Boolean isAllowMigration() {
    return allowMigration;
  }

  public void setAllowMigration(Boolean allowMigration) {
    this.allowMigration = allowMigration;
  }

  public Role rights(Rights rights) {
    this.rights = rights;
    return this;
  }

   /**
   * Rights that the role is granted.
   * @return rights
  **/
  @ApiModelProperty(value = "Rights that the role is granted.")
  public Rights getRights() {
    return rights;
  }

  public void setRights(Rights rights) {
    this.rights = rights;
  }

  public Role computerIDs(List<Integer> computerIDs) {
    this.computerIDs = computerIDs;
    return this;
  }

  public Role addComputerIDsItem(Integer computerIDsItem) {
    if (this.computerIDs == null) {
      this.computerIDs = new ArrayList<>();
    }
    this.computerIDs.add(computerIDsItem);
    return this;
  }

   /**
   * List of computer IDs that the role can access. Ignored if &#39;allComputers&#39; is true.
   * @return computerIDs
  **/
  @ApiModelProperty(value = "List of computer IDs that the role can access. Ignored if 'allComputers' is true.")
  public List<Integer> getComputerIDs() {
    return computerIDs;
  }

  public void setComputerIDs(List<Integer> computerIDs) {
    this.computerIDs = computerIDs;
  }

  public Role computerGroupIDs(List<Integer> computerGroupIDs) {
    this.computerGroupIDs = computerGroupIDs;
    return this;
  }

  public Role addComputerGroupIDsItem(Integer computerGroupIDsItem) {
    if (this.computerGroupIDs == null) {
      this.computerGroupIDs = new ArrayList<>();
    }
    this.computerGroupIDs.add(computerGroupIDsItem);
    return this;
  }

   /**
   * List of computer group IDs that the role can access. A group ID of &#39;0&#39; allows access to computers not in a computer group. Note that groups must be identified individually and that access to sub-groups is not automatically granted. Ignored if &#39;allComputers&#39; is true.
   * @return computerGroupIDs
  **/
  @ApiModelProperty(value = "List of computer group IDs that the role can access. A group ID of '0' allows access to computers not in a computer group. Note that groups must be identified individually and that access to sub-groups is not automatically granted. Ignored if 'allComputers' is true.")
  public List<Integer> getComputerGroupIDs() {
    return computerGroupIDs;
  }

  public void setComputerGroupIDs(List<Integer> computerGroupIDs) {
    this.computerGroupIDs = computerGroupIDs;
  }

  public Role policyIDs(List<Integer> policyIDs) {
    this.policyIDs = policyIDs;
    return this;
  }

  public Role addPolicyIDsItem(Integer policyIDsItem) {
    if (this.policyIDs == null) {
      this.policyIDs = new ArrayList<>();
    }
    this.policyIDs.add(policyIDsItem);
    return this;
  }

   /**
   * List of policy IDs that the role can access. Ignored if &#39;allPolicies&#39; is true.
   * @return policyIDs
  **/
  @ApiModelProperty(value = "List of policy IDs that the role can access. Ignored if 'allPolicies' is true.")
  public List<Integer> getPolicyIDs() {
    return policyIDs;
  }

  public void setPolicyIDs(List<Integer> policyIDs) {
    this.policyIDs = policyIDs;
  }

   /**
   * ID of the administrator role. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the administrator role. Searchable as ID.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Role role = (Role) o;
    return Objects.equals(this.name, role.name) &&
        Objects.equals(this.description, role.description) &&
        Objects.equals(this.urn, role.urn) &&
        Objects.equals(this.immutable, role.immutable) &&
        Objects.equals(this.canOnlyManipulateUsersWithEqualOrLesserRights, role.canOnlyManipulateUsersWithEqualOrLesserRights) &&
        Objects.equals(this.allComputers, role.allComputers) &&
        Objects.equals(this.allPolicies, role.allPolicies) &&
        Objects.equals(this.allowUserInterface, role.allowUserInterface) &&
        Objects.equals(this.allowWebService, role.allowWebService) &&
        Objects.equals(this.allowManageWorkloadSecurityLink, role.allowManageWorkloadSecurityLink) &&
        Objects.equals(this.allowMigration, role.allowMigration) &&
        Objects.equals(this.rights, role.rights) &&
        Objects.equals(this.computerIDs, role.computerIDs) &&
        Objects.equals(this.computerGroupIDs, role.computerGroupIDs) &&
        Objects.equals(this.policyIDs, role.policyIDs) &&
        Objects.equals(this.ID, role.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, urn, immutable, canOnlyManipulateUsersWithEqualOrLesserRights, allComputers, allPolicies, allowUserInterface, allowWebService, allowManageWorkloadSecurityLink, allowMigration, rights, computerIDs, computerGroupIDs, policyIDs, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Role {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    urn: ").append(toIndentedString(urn)).append("\n");
    sb.append("    immutable: ").append(toIndentedString(immutable)).append("\n");
    sb.append("    canOnlyManipulateUsersWithEqualOrLesserRights: ").append(toIndentedString(canOnlyManipulateUsersWithEqualOrLesserRights)).append("\n");
    sb.append("    allComputers: ").append(toIndentedString(allComputers)).append("\n");
    sb.append("    allPolicies: ").append(toIndentedString(allPolicies)).append("\n");
    sb.append("    allowUserInterface: ").append(toIndentedString(allowUserInterface)).append("\n");
    sb.append("    allowWebService: ").append(toIndentedString(allowWebService)).append("\n");
    sb.append("    allowManageWorkloadSecurityLink: ").append(toIndentedString(allowManageWorkloadSecurityLink)).append("\n");
    sb.append("    allowMigration: ").append(toIndentedString(allowMigration)).append("\n");
    sb.append("    rights: ").append(toIndentedString(rights)).append("\n");
    sb.append("    computerIDs: ").append(toIndentedString(computerIDs)).append("\n");
    sb.append("    computerGroupIDs: ").append(toIndentedString(computerGroupIDs)).append("\n");
    sb.append("    policyIDs: ").append(toIndentedString(policyIDs)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

