/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * SAML Identity Provider right details.
 */
@ApiModel(description = "SAML Identity Provider right details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class SamlIdentityProviderRights {
  @JsonProperty("canCreateNewSAMLIdentityProviders")
  private Boolean canCreateNewSAMLIdentityProviders = null;

  @JsonProperty("canDeleteSAMLIdentityProviders")
  private Boolean canDeleteSAMLIdentityProviders = null;

  @JsonProperty("canEditSAMLIdentityProviders")
  private Boolean canEditSAMLIdentityProviders = null;

  @JsonProperty("canViewSAMLIdentityProviders")
  private Boolean canViewSAMLIdentityProviders = null;

  public SamlIdentityProviderRights canCreateNewSAMLIdentityProviders(Boolean canCreateNewSAMLIdentityProviders) {
    this.canCreateNewSAMLIdentityProviders = canCreateNewSAMLIdentityProviders;
    return this;
  }

   /**
   * Right to create new SAML identity providers.
   * @return canCreateNewSAMLIdentityProviders
  **/
  @ApiModelProperty(value = "Right to create new SAML identity providers.")
  public Boolean isCanCreateNewSAMLIdentityProviders() {
    return canCreateNewSAMLIdentityProviders;
  }

  public void setCanCreateNewSAMLIdentityProviders(Boolean canCreateNewSAMLIdentityProviders) {
    this.canCreateNewSAMLIdentityProviders = canCreateNewSAMLIdentityProviders;
  }

  public SamlIdentityProviderRights canDeleteSAMLIdentityProviders(Boolean canDeleteSAMLIdentityProviders) {
    this.canDeleteSAMLIdentityProviders = canDeleteSAMLIdentityProviders;
    return this;
  }

   /**
   * Right to delete SAML identity providers.
   * @return canDeleteSAMLIdentityProviders
  **/
  @ApiModelProperty(value = "Right to delete SAML identity providers.")
  public Boolean isCanDeleteSAMLIdentityProviders() {
    return canDeleteSAMLIdentityProviders;
  }

  public void setCanDeleteSAMLIdentityProviders(Boolean canDeleteSAMLIdentityProviders) {
    this.canDeleteSAMLIdentityProviders = canDeleteSAMLIdentityProviders;
  }

  public SamlIdentityProviderRights canEditSAMLIdentityProviders(Boolean canEditSAMLIdentityProviders) {
    this.canEditSAMLIdentityProviders = canEditSAMLIdentityProviders;
    return this;
  }

   /**
   * Right to edit SAML identity providers.
   * @return canEditSAMLIdentityProviders
  **/
  @ApiModelProperty(value = "Right to edit SAML identity providers.")
  public Boolean isCanEditSAMLIdentityProviders() {
    return canEditSAMLIdentityProviders;
  }

  public void setCanEditSAMLIdentityProviders(Boolean canEditSAMLIdentityProviders) {
    this.canEditSAMLIdentityProviders = canEditSAMLIdentityProviders;
  }

  public SamlIdentityProviderRights canViewSAMLIdentityProviders(Boolean canViewSAMLIdentityProviders) {
    this.canViewSAMLIdentityProviders = canViewSAMLIdentityProviders;
    return this;
  }

   /**
   * Right to view SAML identity providers.
   * @return canViewSAMLIdentityProviders
  **/
  @ApiModelProperty(value = "Right to view SAML identity providers.")
  public Boolean isCanViewSAMLIdentityProviders() {
    return canViewSAMLIdentityProviders;
  }

  public void setCanViewSAMLIdentityProviders(Boolean canViewSAMLIdentityProviders) {
    this.canViewSAMLIdentityProviders = canViewSAMLIdentityProviders;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SamlIdentityProviderRights samlIdentityProviderRights = (SamlIdentityProviderRights) o;
    return Objects.equals(this.canCreateNewSAMLIdentityProviders, samlIdentityProviderRights.canCreateNewSAMLIdentityProviders) &&
        Objects.equals(this.canDeleteSAMLIdentityProviders, samlIdentityProviderRights.canDeleteSAMLIdentityProviders) &&
        Objects.equals(this.canEditSAMLIdentityProviders, samlIdentityProviderRights.canEditSAMLIdentityProviders) &&
        Objects.equals(this.canViewSAMLIdentityProviders, samlIdentityProviderRights.canViewSAMLIdentityProviders);
  }

  @Override
  public int hashCode() {
    return Objects.hash(canCreateNewSAMLIdentityProviders, canDeleteSAMLIdentityProviders, canEditSAMLIdentityProviders, canViewSAMLIdentityProviders);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SamlIdentityProviderRights {\n");
    
    sb.append("    canCreateNewSAMLIdentityProviders: ").append(toIndentedString(canCreateNewSAMLIdentityProviders)).append("\n");
    sb.append("    canDeleteSAMLIdentityProviders: ").append(toIndentedString(canDeleteSAMLIdentityProviders)).append("\n");
    sb.append("    canEditSAMLIdentityProviders: ").append(toIndentedString(canEditSAMLIdentityProviders)).append("\n");
    sb.append("    canViewSAMLIdentityProviders: ").append(toIndentedString(canViewSAMLIdentityProviders)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

