/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.ComputerFilter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Controls the behavior of a scheduled task of type scan-for-integrity-changes.
 */
@ApiModel(description = "Controls the behavior of a scheduled task of type scan-for-integrity-changes.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class ScanForIntegrityChangesTaskParameters {
  @JsonProperty("computerFilter")
  private ComputerFilter computerFilter = null;

  /**
   * Include or exclude trusted computers during scan.
   */
  public enum TrustedComputersEnum {
    ALL_COMPUTERS("all-computers"),
    
    TRUSTED_COMPUTERS_ONLY("trusted-computers-only"),
    
    EXCLUDE_TRUSTED_COMPUTERS("exclude-trusted-computers");

    private String value;

    TrustedComputersEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TrustedComputersEnum fromValue(String text) {
      for (TrustedComputersEnum b : TrustedComputersEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("trustedComputers")
  private TrustedComputersEnum trustedComputers = null;

  public ScanForIntegrityChangesTaskParameters computerFilter(ComputerFilter computerFilter) {
    this.computerFilter = computerFilter;
    return this;
  }

   /**
   * Controls which computer(s) to scan.
   * @return computerFilter
  **/
  @ApiModelProperty(value = "Controls which computer(s) to scan.")
  public ComputerFilter getComputerFilter() {
    return computerFilter;
  }

  public void setComputerFilter(ComputerFilter computerFilter) {
    this.computerFilter = computerFilter;
  }

  public ScanForIntegrityChangesTaskParameters trustedComputers(TrustedComputersEnum trustedComputers) {
    this.trustedComputers = trustedComputers;
    return this;
  }

   /**
   * Include or exclude trusted computers during scan.
   * @return trustedComputers
  **/
  @ApiModelProperty(value = "Include or exclude trusted computers during scan.")
  public TrustedComputersEnum getTrustedComputers() {
    return trustedComputers;
  }

  public void setTrustedComputers(TrustedComputersEnum trustedComputers) {
    this.trustedComputers = trustedComputers;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ScanForIntegrityChangesTaskParameters scanForIntegrityChangesTaskParameters = (ScanForIntegrityChangesTaskParameters) o;
    return Objects.equals(this.computerFilter, scanForIntegrityChangesTaskParameters.computerFilter) &&
        Objects.equals(this.trustedComputers, scanForIntegrityChangesTaskParameters.trustedComputers);
  }

  @Override
  public int hashCode() {
    return Objects.hash(computerFilter, trustedComputers);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ScanForIntegrityChangesTaskParameters {\n");
    
    sb.append("    computerFilter: ").append(toIndentedString(computerFilter)).append("\n");
    sb.append("    trustedComputers: ").append(toIndentedString(trustedComputers)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

