/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Schedules are reusable timetables that you can assign to rules, agent upgrades, and more.
 */
@ApiModel(description = "Schedules are reusable timetables that you can assign to rules, agent upgrades, and more.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class Schedule {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("hoursOfWeek")
  private List<Boolean> hoursOfWeek = null;

  @JsonProperty("ID")
  private Integer ID = null;

  public Schedule name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Display name of the Schedule. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Display name of the Schedule. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public Schedule description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the Schedule. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the Schedule. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public Schedule hoursOfWeek(List<Boolean> hoursOfWeek) {
    this.hoursOfWeek = hoursOfWeek;
    return this;
  }

  public Schedule addHoursOfWeekItem(Boolean hoursOfWeekItem) {
    if (this.hoursOfWeek == null) {
      this.hoursOfWeek = new ArrayList<>();
    }
    this.hoursOfWeek.add(hoursOfWeekItem);
    return this;
  }

   /**
   * An array of 168 boolean values representing each hour in the week starting Sunday at 0:00. A value of &#39;true&#39; marks the given hour as &#39;on&#39;.
   * @return hoursOfWeek
  **/
  @ApiModelProperty(value = "An array of 168 boolean values representing each hour in the week starting Sunday at 0:00. A value of 'true' marks the given hour as 'on'.")
  public List<Boolean> getHoursOfWeek() {
    return hoursOfWeek;
  }

  public void setHoursOfWeek(List<Boolean> hoursOfWeek) {
    this.hoursOfWeek = hoursOfWeek;
  }

   /**
   * ID of the Schedule. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the Schedule. Searchable as ID.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Schedule schedule = (Schedule) o;
    return Objects.equals(this.name, schedule.name) &&
        Objects.equals(this.description, schedule.description) &&
        Objects.equals(this.hoursOfWeek, schedule.hoursOfWeek) &&
        Objects.equals(this.ID, schedule.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, hoursOfWeek, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Schedule {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    hoursOfWeek: ").append(toIndentedString(hoursOfWeek)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

