/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.DailyScheduleParameters;
import com.trendmicro.deepsecurity.model.HourlyScheduleParameters;
import com.trendmicro.deepsecurity.model.MonthlyScheduleParameters;
import com.trendmicro.deepsecurity.model.OnceOnlyScheduleParameters;
import com.trendmicro.deepsecurity.model.WeeklyScheduleParameters;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Controls when a scheduled task runs.
 */
@ApiModel(description = "Controls when a scheduled task runs.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class ScheduleDetails {
  @JsonProperty("timeZone")
  private String timeZone = null;

  /**
   * Recurrence type.
   */
  public enum RecurrenceTypeEnum {
    NONE("none"),
    
    HOURLY("hourly"),
    
    DAILY("daily"),
    
    WEEKLY("weekly"),
    
    MONTHLY("monthly");

    private String value;

    RecurrenceTypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static RecurrenceTypeEnum fromValue(String text) {
      for (RecurrenceTypeEnum b : RecurrenceTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("recurrenceType")
  private RecurrenceTypeEnum recurrenceType = null;

  @JsonProperty("recurrenceCount")
  private Integer recurrenceCount = null;

  @JsonProperty("hourlyScheduleParameters")
  private HourlyScheduleParameters hourlyScheduleParameters = null;

  @JsonProperty("dailyScheduleParameters")
  private DailyScheduleParameters dailyScheduleParameters = null;

  @JsonProperty("weeklyScheduleParameters")
  private WeeklyScheduleParameters weeklyScheduleParameters = null;

  @JsonProperty("monthlyScheduleParameters")
  private MonthlyScheduleParameters monthlyScheduleParameters = null;

  @JsonProperty("onceOnlyScheduleParameters")
  private OnceOnlyScheduleParameters onceOnlyScheduleParameters = null;

  public ScheduleDetails timeZone(String timeZone) {
    this.timeZone = timeZone;
    return this;
  }

   /**
   * The timezone used to interpret the scheduled task schedule.
   * @return timeZone
  **/
  @ApiModelProperty(value = "The timezone used to interpret the scheduled task schedule.")
  public String getTimeZone() {
    return timeZone;
  }

  public void setTimeZone(String timeZone) {
    this.timeZone = timeZone;
  }

  public ScheduleDetails recurrenceType(RecurrenceTypeEnum recurrenceType) {
    this.recurrenceType = recurrenceType;
    return this;
  }

   /**
   * Recurrence type.
   * @return recurrenceType
  **/
  @ApiModelProperty(value = "Recurrence type.")
  public RecurrenceTypeEnum getRecurrenceType() {
    return recurrenceType;
  }

  public void setRecurrenceType(RecurrenceTypeEnum recurrenceType) {
    this.recurrenceType = recurrenceType;
  }

  public ScheduleDetails recurrenceCount(Integer recurrenceCount) {
    this.recurrenceCount = recurrenceCount;
    return this;
  }

   /**
   * Number of times the task should execute.
   * @return recurrenceCount
  **/
  @ApiModelProperty(value = "Number of times the task should execute.")
  public Integer getRecurrenceCount() {
    return recurrenceCount;
  }

  public void setRecurrenceCount(Integer recurrenceCount) {
    this.recurrenceCount = recurrenceCount;
  }

  public ScheduleDetails hourlyScheduleParameters(HourlyScheduleParameters hourlyScheduleParameters) {
    this.hourlyScheduleParameters = hourlyScheduleParameters;
    return this;
  }

   /**
   * Details for an hourly schedule.
   * @return hourlyScheduleParameters
  **/
  @ApiModelProperty(value = "Details for an hourly schedule.")
  public HourlyScheduleParameters getHourlyScheduleParameters() {
    return hourlyScheduleParameters;
  }

  public void setHourlyScheduleParameters(HourlyScheduleParameters hourlyScheduleParameters) {
    this.hourlyScheduleParameters = hourlyScheduleParameters;
  }

  public ScheduleDetails dailyScheduleParameters(DailyScheduleParameters dailyScheduleParameters) {
    this.dailyScheduleParameters = dailyScheduleParameters;
    return this;
  }

   /**
   * Details for a daily schedule.
   * @return dailyScheduleParameters
  **/
  @ApiModelProperty(value = "Details for a daily schedule.")
  public DailyScheduleParameters getDailyScheduleParameters() {
    return dailyScheduleParameters;
  }

  public void setDailyScheduleParameters(DailyScheduleParameters dailyScheduleParameters) {
    this.dailyScheduleParameters = dailyScheduleParameters;
  }

  public ScheduleDetails weeklyScheduleParameters(WeeklyScheduleParameters weeklyScheduleParameters) {
    this.weeklyScheduleParameters = weeklyScheduleParameters;
    return this;
  }

   /**
   * Details for a weekly schedule.
   * @return weeklyScheduleParameters
  **/
  @ApiModelProperty(value = "Details for a weekly schedule.")
  public WeeklyScheduleParameters getWeeklyScheduleParameters() {
    return weeklyScheduleParameters;
  }

  public void setWeeklyScheduleParameters(WeeklyScheduleParameters weeklyScheduleParameters) {
    this.weeklyScheduleParameters = weeklyScheduleParameters;
  }

  public ScheduleDetails monthlyScheduleParameters(MonthlyScheduleParameters monthlyScheduleParameters) {
    this.monthlyScheduleParameters = monthlyScheduleParameters;
    return this;
  }

   /**
   * Details for a monthly schedule.
   * @return monthlyScheduleParameters
  **/
  @ApiModelProperty(value = "Details for a monthly schedule.")
  public MonthlyScheduleParameters getMonthlyScheduleParameters() {
    return monthlyScheduleParameters;
  }

  public void setMonthlyScheduleParameters(MonthlyScheduleParameters monthlyScheduleParameters) {
    this.monthlyScheduleParameters = monthlyScheduleParameters;
  }

  public ScheduleDetails onceOnlyScheduleParameters(OnceOnlyScheduleParameters onceOnlyScheduleParameters) {
    this.onceOnlyScheduleParameters = onceOnlyScheduleParameters;
    return this;
  }

   /**
   * Details for a once only schedule.
   * @return onceOnlyScheduleParameters
  **/
  @ApiModelProperty(value = "Details for a once only schedule.")
  public OnceOnlyScheduleParameters getOnceOnlyScheduleParameters() {
    return onceOnlyScheduleParameters;
  }

  public void setOnceOnlyScheduleParameters(OnceOnlyScheduleParameters onceOnlyScheduleParameters) {
    this.onceOnlyScheduleParameters = onceOnlyScheduleParameters;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ScheduleDetails scheduleDetails = (ScheduleDetails) o;
    return Objects.equals(this.timeZone, scheduleDetails.timeZone) &&
        Objects.equals(this.recurrenceType, scheduleDetails.recurrenceType) &&
        Objects.equals(this.recurrenceCount, scheduleDetails.recurrenceCount) &&
        Objects.equals(this.hourlyScheduleParameters, scheduleDetails.hourlyScheduleParameters) &&
        Objects.equals(this.dailyScheduleParameters, scheduleDetails.dailyScheduleParameters) &&
        Objects.equals(this.weeklyScheduleParameters, scheduleDetails.weeklyScheduleParameters) &&
        Objects.equals(this.monthlyScheduleParameters, scheduleDetails.monthlyScheduleParameters) &&
        Objects.equals(this.onceOnlyScheduleParameters, scheduleDetails.onceOnlyScheduleParameters);
  }

  @Override
  public int hashCode() {
    return Objects.hash(timeZone, recurrenceType, recurrenceCount, hourlyScheduleParameters, dailyScheduleParameters, weeklyScheduleParameters, monthlyScheduleParameters, onceOnlyScheduleParameters);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ScheduleDetails {\n");
    
    sb.append("    timeZone: ").append(toIndentedString(timeZone)).append("\n");
    sb.append("    recurrenceType: ").append(toIndentedString(recurrenceType)).append("\n");
    sb.append("    recurrenceCount: ").append(toIndentedString(recurrenceCount)).append("\n");
    sb.append("    hourlyScheduleParameters: ").append(toIndentedString(hourlyScheduleParameters)).append("\n");
    sb.append("    dailyScheduleParameters: ").append(toIndentedString(dailyScheduleParameters)).append("\n");
    sb.append("    weeklyScheduleParameters: ").append(toIndentedString(weeklyScheduleParameters)).append("\n");
    sb.append("    monthlyScheduleParameters: ").append(toIndentedString(monthlyScheduleParameters)).append("\n");
    sb.append("    onceOnlyScheduleParameters: ").append(toIndentedString(onceOnlyScheduleParameters)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

