/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Scheduled task right details.
 */
@ApiModel(description = "Scheduled task right details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class ScheduledTaskRights {
  @JsonProperty("canCreateNewScheduledTasks")
  private Boolean canCreateNewScheduledTasks = null;

  @JsonProperty("canDeleteScheduledTasks")
  private Boolean canDeleteScheduledTasks = null;

  @JsonProperty("canEditScheduledTaskProperties")
  private Boolean canEditScheduledTaskProperties = null;

  @JsonProperty("canExecuteScheduledTasks")
  private Boolean canExecuteScheduledTasks = null;

  @JsonProperty("canViewScheduledTasks")
  private Boolean canViewScheduledTasks = null;

  public ScheduledTaskRights canCreateNewScheduledTasks(Boolean canCreateNewScheduledTasks) {
    this.canCreateNewScheduledTasks = canCreateNewScheduledTasks;
    return this;
  }

   /**
   * Right to create new scheduled tasks.
   * @return canCreateNewScheduledTasks
  **/
  @ApiModelProperty(value = "Right to create new scheduled tasks.")
  public Boolean isCanCreateNewScheduledTasks() {
    return canCreateNewScheduledTasks;
  }

  public void setCanCreateNewScheduledTasks(Boolean canCreateNewScheduledTasks) {
    this.canCreateNewScheduledTasks = canCreateNewScheduledTasks;
  }

  public ScheduledTaskRights canDeleteScheduledTasks(Boolean canDeleteScheduledTasks) {
    this.canDeleteScheduledTasks = canDeleteScheduledTasks;
    return this;
  }

   /**
   * Right to delete scheduled tasks.
   * @return canDeleteScheduledTasks
  **/
  @ApiModelProperty(value = "Right to delete scheduled tasks.")
  public Boolean isCanDeleteScheduledTasks() {
    return canDeleteScheduledTasks;
  }

  public void setCanDeleteScheduledTasks(Boolean canDeleteScheduledTasks) {
    this.canDeleteScheduledTasks = canDeleteScheduledTasks;
  }

  public ScheduledTaskRights canEditScheduledTaskProperties(Boolean canEditScheduledTaskProperties) {
    this.canEditScheduledTaskProperties = canEditScheduledTaskProperties;
    return this;
  }

   /**
   * Right to edit scheduled task properties.
   * @return canEditScheduledTaskProperties
  **/
  @ApiModelProperty(value = "Right to edit scheduled task properties.")
  public Boolean isCanEditScheduledTaskProperties() {
    return canEditScheduledTaskProperties;
  }

  public void setCanEditScheduledTaskProperties(Boolean canEditScheduledTaskProperties) {
    this.canEditScheduledTaskProperties = canEditScheduledTaskProperties;
  }

  public ScheduledTaskRights canExecuteScheduledTasks(Boolean canExecuteScheduledTasks) {
    this.canExecuteScheduledTasks = canExecuteScheduledTasks;
    return this;
  }

   /**
   * Right to execute scheduled tasks.
   * @return canExecuteScheduledTasks
  **/
  @ApiModelProperty(value = "Right to execute scheduled tasks.")
  public Boolean isCanExecuteScheduledTasks() {
    return canExecuteScheduledTasks;
  }

  public void setCanExecuteScheduledTasks(Boolean canExecuteScheduledTasks) {
    this.canExecuteScheduledTasks = canExecuteScheduledTasks;
  }

  public ScheduledTaskRights canViewScheduledTasks(Boolean canViewScheduledTasks) {
    this.canViewScheduledTasks = canViewScheduledTasks;
    return this;
  }

   /**
   * Right to view scheduled tasks.
   * @return canViewScheduledTasks
  **/
  @ApiModelProperty(value = "Right to view scheduled tasks.")
  public Boolean isCanViewScheduledTasks() {
    return canViewScheduledTasks;
  }

  public void setCanViewScheduledTasks(Boolean canViewScheduledTasks) {
    this.canViewScheduledTasks = canViewScheduledTasks;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ScheduledTaskRights scheduledTaskRights = (ScheduledTaskRights) o;
    return Objects.equals(this.canCreateNewScheduledTasks, scheduledTaskRights.canCreateNewScheduledTasks) &&
        Objects.equals(this.canDeleteScheduledTasks, scheduledTaskRights.canDeleteScheduledTasks) &&
        Objects.equals(this.canEditScheduledTaskProperties, scheduledTaskRights.canEditScheduledTaskProperties) &&
        Objects.equals(this.canExecuteScheduledTasks, scheduledTaskRights.canExecuteScheduledTasks) &&
        Objects.equals(this.canViewScheduledTasks, scheduledTaskRights.canViewScheduledTasks);
  }

  @Override
  public int hashCode() {
    return Objects.hash(canCreateNewScheduledTasks, canDeleteScheduledTasks, canEditScheduledTaskProperties, canExecuteScheduledTasks, canViewScheduledTasks);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ScheduledTaskRights {\n");
    
    sb.append("    canCreateNewScheduledTasks: ").append(toIndentedString(canCreateNewScheduledTasks)).append("\n");
    sb.append("    canDeleteScheduledTasks: ").append(toIndentedString(canDeleteScheduledTasks)).append("\n");
    sb.append("    canEditScheduledTaskProperties: ").append(toIndentedString(canEditScheduledTaskProperties)).append("\n");
    sb.append("    canExecuteScheduledTasks: ").append(toIndentedString(canExecuteScheduledTasks)).append("\n");
    sb.append("    canViewScheduledTasks: ").append(toIndentedString(canViewScheduledTasks)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

