/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.SearchCriteria;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Allows clients to obtain a filtered list of objects based on various search criteria.
 */
@ApiModel(description = "Allows clients to obtain a filtered list of objects based on various search criteria.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class SearchFilter {
  @JsonProperty("maxItems")
  private Integer maxItems = null;

  @JsonProperty("searchCriteria")
  private List<SearchCriteria> searchCriteria = null;

  @JsonProperty("sortByObjectID")
  private Boolean sortByObjectID = null;

  public SearchFilter maxItems(Integer maxItems) {
    this.maxItems = maxItems;
    return this;
  }

   /**
   * Limits the number of objects returned. Default 5000.
   * @return maxItems
  **/
  @ApiModelProperty(value = "Limits the number of objects returned. Default 5000.")
  public Integer getMaxItems() {
    return maxItems;
  }

  public void setMaxItems(Integer maxItems) {
    this.maxItems = maxItems;
  }

  public SearchFilter searchCriteria(List<SearchCriteria> searchCriteria) {
    this.searchCriteria = searchCriteria;
    return this;
  }

  public SearchFilter addSearchCriteriaItem(SearchCriteria searchCriteriaItem) {
    if (this.searchCriteria == null) {
      this.searchCriteria = new ArrayList<>();
    }
    this.searchCriteria.add(searchCriteriaItem);
    return this;
  }

   /**
   * Array of search critiera used to filter objects. Searching with multiple criteria returns results that satisfy all of the criteria. Searching with no criteria returns all objects.
   * @return searchCriteria
  **/
  @ApiModelProperty(value = "Array of search critiera used to filter objects. Searching with multiple criteria returns results that satisfy all of the criteria. Searching with no criteria returns all objects.")
  public List<SearchCriteria> getSearchCriteria() {
    return searchCriteria;
  }

  public void setSearchCriteria(List<SearchCriteria> searchCriteria) {
    this.searchCriteria = searchCriteria;
  }

  public SearchFilter sortByObjectID(Boolean sortByObjectID) {
    this.sortByObjectID = sortByObjectID;
    return this;
  }

   /**
   * If true, forces the response objects to be sorted by ID, overriding the default sort order. Default \&quot;false\&quot;.
   * @return sortByObjectID
  **/
  @ApiModelProperty(value = "If true, forces the response objects to be sorted by ID, overriding the default sort order. Default \"false\".")
  public Boolean isSortByObjectID() {
    return sortByObjectID;
  }

  public void setSortByObjectID(Boolean sortByObjectID) {
    this.sortByObjectID = sortByObjectID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SearchFilter searchFilter = (SearchFilter) o;
    return Objects.equals(this.maxItems, searchFilter.maxItems) &&
        Objects.equals(this.searchCriteria, searchFilter.searchCriteria) &&
        Objects.equals(this.sortByObjectID, searchFilter.sortByObjectID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(maxItems, searchCriteria, sortByObjectID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SearchFilter {\n");
    
    sb.append("    maxItems: ").append(toIndentedString(maxItems)).append("\n");
    sb.append("    searchCriteria: ").append(toIndentedString(searchCriteria)).append("\n");
    sb.append("    sortByObjectID: ").append(toIndentedString(sortByObjectID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

