/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.SmartFolderRuleGroup;
import com.trendmicro.deepsecurity.model.TagFolder;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Details of a smart folder.
 */
@ApiModel(description = "Details of a smart folder.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class SmartFolder {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("parentSmartFolderID")
  private Long parentSmartFolderID = null;

  /**
   * Type of the smart folder.
   */
  public enum TypeEnum {
    STANDARD("standard"),
    
    HIERARCHICAL_TAG_ROOT("hierarchical-tag-root"),
    
    HIERARCHICAL_TAG_CHILD("hierarchical-tag-child"),
    
    INDEPENDENT_CHILD("independent-child");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TypeEnum fromValue(String text) {
      for (TypeEnum b : TypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("type")
  private TypeEnum type = null;

  @JsonProperty("ruleGroups")
  private List<SmartFolderRuleGroup> ruleGroups = null;

  @JsonProperty("tagFolder")
  private TagFolder tagFolder = null;

  /**
   * Comparison of the smart folder.
   */
  public enum LogicalOperatorEnum {
    AND("and"),
    
    OR("or");

    private String value;

    LogicalOperatorEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static LogicalOperatorEnum fromValue(String text) {
      for (LogicalOperatorEnum b : LogicalOperatorEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("logicalOperator")
  private LogicalOperatorEnum logicalOperator = null;

  @JsonProperty("duplicateOf")
  private Long duplicateOf = null;

  @JsonProperty("ID")
  private Long ID = null;

  public SmartFolder name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the smart folder. The maximum length is 255 characters. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(required = true, value = "Name of the smart folder. The maximum length is 255 characters. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public SmartFolder parentSmartFolderID(Long parentSmartFolderID) {
    this.parentSmartFolderID = parentSmartFolderID;
    return this;
  }

   /**
   * ID of the parent smart folder. Searchable as Numeric.
   * @return parentSmartFolderID
  **/
  @ApiModelProperty(value = "ID of the parent smart folder. Searchable as Numeric.")
  public Long getParentSmartFolderID() {
    return parentSmartFolderID;
  }

  public void setParentSmartFolderID(Long parentSmartFolderID) {
    this.parentSmartFolderID = parentSmartFolderID;
  }

   /**
   * Type of the smart folder.
   * @return type
  **/
  @ApiModelProperty(value = "Type of the smart folder.")
  public TypeEnum getType() {
    return type;
  }

  public SmartFolder ruleGroups(List<SmartFolderRuleGroup> ruleGroups) {
    this.ruleGroups = ruleGroups;
    return this;
  }

  public SmartFolder addRuleGroupsItem(SmartFolderRuleGroup ruleGroupsItem) {
    if (this.ruleGroups == null) {
      this.ruleGroups = new ArrayList<>();
    }
    this.ruleGroups.add(ruleGroupsItem);
    return this;
  }

   /**
   * Rule groups of the smart folder.
   * @return ruleGroups
  **/
  @ApiModelProperty(value = "Rule groups of the smart folder.")
  public List<SmartFolderRuleGroup> getRuleGroups() {
    return ruleGroups;
  }

  public void setRuleGroups(List<SmartFolderRuleGroup> ruleGroups) {
    this.ruleGroups = ruleGroups;
  }

  public SmartFolder tagFolder(TagFolder tagFolder) {
    this.tagFolder = tagFolder;
    return this;
  }

   /**
   * AWS/GCP/Azure tag folder.
   * @return tagFolder
  **/
  @ApiModelProperty(value = "AWS/GCP/Azure tag folder.")
  public TagFolder getTagFolder() {
    return tagFolder;
  }

  public void setTagFolder(TagFolder tagFolder) {
    this.tagFolder = tagFolder;
  }

  public SmartFolder logicalOperator(LogicalOperatorEnum logicalOperator) {
    this.logicalOperator = logicalOperator;
    return this;
  }

   /**
   * Comparison of the smart folder.
   * @return logicalOperator
  **/
  @ApiModelProperty(value = "Comparison of the smart folder.")
  public LogicalOperatorEnum getLogicalOperator() {
    return logicalOperator;
  }

  public void setLogicalOperator(LogicalOperatorEnum logicalOperator) {
    this.logicalOperator = logicalOperator;
  }

  public SmartFolder duplicateOf(Long duplicateOf) {
    this.duplicateOf = duplicateOf;
    return this;
  }

   /**
   * The ID of the Smart Folder to duplicate. If this value is set, then all other parameters will be ignored.
   * @return duplicateOf
  **/
  @ApiModelProperty(value = "The ID of the Smart Folder to duplicate. If this value is set, then all other parameters will be ignored.")
  public Long getDuplicateOf() {
    return duplicateOf;
  }

  public void setDuplicateOf(Long duplicateOf) {
    this.duplicateOf = duplicateOf;
  }

   /**
   * ID of the smart folder. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the smart folder. Searchable as ID.")
  public Long getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SmartFolder smartFolder = (SmartFolder) o;
    return Objects.equals(this.name, smartFolder.name) &&
        Objects.equals(this.parentSmartFolderID, smartFolder.parentSmartFolderID) &&
        Objects.equals(this.type, smartFolder.type) &&
        Objects.equals(this.ruleGroups, smartFolder.ruleGroups) &&
        Objects.equals(this.tagFolder, smartFolder.tagFolder) &&
        Objects.equals(this.logicalOperator, smartFolder.logicalOperator) &&
        Objects.equals(this.duplicateOf, smartFolder.duplicateOf) &&
        Objects.equals(this.ID, smartFolder.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, parentSmartFolderID, type, ruleGroups, tagFolder, logicalOperator, duplicateOf, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SmartFolder {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    parentSmartFolderID: ").append(toIndentedString(parentSmartFolderID)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    ruleGroups: ").append(toIndentedString(ruleGroups)).append("\n");
    sb.append("    tagFolder: ").append(toIndentedString(tagFolder)).append("\n");
    sb.append("    logicalOperator: ").append(toIndentedString(logicalOperator)).append("\n");
    sb.append("    duplicateOf: ").append(toIndentedString(duplicateOf)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

