/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Details of rule for rule group in smart folder.
 */
@ApiModel(description = "Details of rule for rule group in smart folder.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class SmartFolderRule {
  /**
   * The key that specifies the type of rule.
   */
  public enum KeyEnum {
    GENERAL_HOST_NAME("general-host-name"),
    
    GENERAL_DISPLAY_NAME("general-display-name"),
    
    GENERAL_DESCRIPTION("general-description"),
    
    GENERAL_COMPUTER_GROUP("general-computer-group"),
    
    GENERAL_OS("general-os"),
    
    GENERAL_IP("general-ip"),
    
    GENERAL_POLICY("general-policy"),
    
    GENERAL_AGENT_ACTIVATED("general-agent-activated"),
    
    GENERAL_DOCKER_HOST("general-docker-host"),
    
    GENERAL_CRIO_HOST("general-crio-host"),
    
    GENERAL_COMPUTER_TYPE("general-computer-type"),
    
    GENERAL_LAST_RECOMMENDATION_SCAN_TIME("general-last-recommendation-scan-time"),
    
    GENERAL_LAST_AGENT_COMMUNICATION("general-last-agent-communication"),
    
    GENERAL_AGENT_OFFLINE("general-agent-offline"),
    
    GENERAL_HOST_CREATED_TIME("general-host-created-time"),
    
    GENERAL_HOST_TASKS("general-host-tasks"),
    
    GENERAL_AGENT_VERSION("general-agent-version"),
    
    AWS_TAG("aws-tag"),
    
    AWS_SECURITY_GROUP_NAME("aws-security-group-name"),
    
    AWS_SECURITY_GROUP_ID("aws-security-group-id"),
    
    AWS_AMI_ID("aws-ami-id"),
    
    AWS_ACCOUNT_ID("aws-account-id"),
    
    AWS_ACCOUNT_NAME("aws-account-name"),
    
    AWS_REGION_ID("aws-region-id"),
    
    AWS_REGION_NAME("aws-region-name"),
    
    AWS_VPC_ID("aws-vpc-id"),
    
    AWS_SUBNET_ID("aws-subnet-id"),
    
    AWS_DIRECTORY_ID("aws-directory-id"),
    
    AZURE_SUBSCRIPTION_NAME("azure-subscription-name"),
    
    AZURE_RESOURCE_GROUP("azure-resource-group"),
    
    AZURE_LOCATION("azure-location"),
    
    AZURE_TAG("azure-tag"),
    
    GCP_LABEL("gcp-label"),
    
    GCP_NETWORK_TAG("gcp-network-tag"),
    
    VCENTER_NAME("vcenter-name"),
    
    VCENTER_DATACENTER("vcenter-datacenter"),
    
    VCENTER_FOLDER("vcenter-folder"),
    
    VCENTER_ESX_HOSTNAME("vcenter-esx-hostname"),
    
    VCENTER_CUSTOM_ATTRIBUTE("vcenter-custom-attribute"),
    
    VCENTER_POWER_STATE("vcenter-power-state"),
    
    VCLOUD_NAME("vcloud-name"),
    
    VCLOUD_DATACENTER("vcloud-datacenter"),
    
    VCLOUD_VAPP("vcloud-vapp"),
    
    DIRECTORY_NAME("directory-name"),
    
    DIRECTORY_FOLDER("directory-folder");

    private String value;

    KeyEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static KeyEnum fromValue(String text) {
      for (KeyEnum b : KeyEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("key")
  private KeyEnum key = null;

  /**
   * The operator of the rule.
   */
  public enum ComparisonOperatorEnum {
    EQUALS("equals"),
    
    NOT_EQUALS("not-equals"),
    
    CONTAINS("contains"),
    
    DOES_NOT_CONTAIN("does-not-contain"),
    
    ANY_VALUE("any-value"),
    
    IN_RANGE("in-range"),
    
    NOT_IN_RANGE("not-in-range"),
    
    OLDER_THAN("older-than"),
    
    MORE_RECENTLY_THAN("more-recently-than"),
    
    NEVER("never"),
    
    BEFORE("before"),
    
    AFTER("after"),
    
    VERSION_OLDER_THAN("version-older-than"),
    
    VERSION_OLDER_THAN_OR_EQUAL_TO("version-older-than-or-equal-to"),
    
    VERSION_NEWER_THAN("version-newer-than"),
    
    VERSION_NEWER_THAN_OR_EQUAL_TO("version-newer-than-or-equal-to");

    private String value;

    ComparisonOperatorEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ComparisonOperatorEnum fromValue(String text) {
      for (ComparisonOperatorEnum b : ComparisonOperatorEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("comparisonOperator")
  private ComparisonOperatorEnum comparisonOperator = null;

  @JsonProperty("value")
  private String value = null;

  /**
   * The secondary operator of the rule if needed.
   */
  public enum SecondaryComparisonOperatorEnum {
    EQUALS("equals"),
    
    NOT_EQUALS("not-equals"),
    
    CONTAINS("contains"),
    
    DOES_NOT_CONTAIN("does-not-contain"),
    
    ANY_VALUE("any-value"),
    
    IN_RANGE("in-range"),
    
    NOT_IN_RANGE("not-in-range"),
    
    OLDER_THAN("older-than"),
    
    MORE_RECENTLY_THAN("more-recently-than"),
    
    NEVER("never"),
    
    BEFORE("before"),
    
    AFTER("after"),
    
    VERSION_OLDER_THAN("version-older-than"),
    
    VERSION_OLDER_THAN_OR_EQUAL_TO("version-older-than-or-equal-to"),
    
    VERSION_NEWER_THAN("version-newer-than"),
    
    VERSION_NEWER_THAN_OR_EQUAL_TO("version-newer-than-or-equal-to");

    private String value;

    SecondaryComparisonOperatorEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static SecondaryComparisonOperatorEnum fromValue(String text) {
      for (SecondaryComparisonOperatorEnum b : SecondaryComparisonOperatorEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("secondaryComparisonOperator")
  private SecondaryComparisonOperatorEnum secondaryComparisonOperator = null;

  @JsonProperty("secondaryValue")
  private String secondaryValue = null;

  /**
   * The time unit of the rule if the key is &lt;code&gt;general-last-recommendation-scan-time&lt;/code&gt;/&lt;code&gt;general-last-agent-communication&lt;/code&gt;.
   */
  public enum TimeUnitEnum {
    MINUTES("minutes"),
    
    HOURS("hours"),
    
    DAYS("days"),
    
    WEEKS("weeks");

    private String value;

    TimeUnitEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TimeUnitEnum fromValue(String text) {
      for (TimeUnitEnum b : TimeUnitEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("timeUnit")
  private TimeUnitEnum timeUnit = null;

  public SmartFolderRule key(KeyEnum key) {
    this.key = key;
    return this;
  }

   /**
   * The key that specifies the type of rule.
   * @return key
  **/
  @ApiModelProperty(value = "The key that specifies the type of rule.")
  public KeyEnum getKey() {
    return key;
  }

  public void setKey(KeyEnum key) {
    this.key = key;
  }

  public SmartFolderRule comparisonOperator(ComparisonOperatorEnum comparisonOperator) {
    this.comparisonOperator = comparisonOperator;
    return this;
  }

   /**
   * The operator of the rule.
   * @return comparisonOperator
  **/
  @ApiModelProperty(value = "The operator of the rule.")
  public ComparisonOperatorEnum getComparisonOperator() {
    return comparisonOperator;
  }

  public void setComparisonOperator(ComparisonOperatorEnum comparisonOperator) {
    this.comparisonOperator = comparisonOperator;
  }

  public SmartFolderRule value(String value) {
    this.value = value;
    return this;
  }

   /**
   * The value of the rule.&lt;br&gt;• The value for &lt;code&gt;general-agent-activated&lt;/code&gt;/&lt;code&gt;general-agent-offline&lt;/code&gt;/&lt;code&gt;general-crio-host&lt;/code&gt;/&lt;code&gt;general-docker-host&lt;/code&gt; would be &lt;code&gt;yes&lt;/code&gt;/&lt;code&gt;no&lt;/code&gt;.&lt;br&gt;• The value for &lt;code&gt;general-computer-type&lt;/code&gt; would be &lt;code&gt;physical-computer&lt;/code&gt;/&lt;code&gt;amazon-ec2-instance&lt;/code&gt;/&lt;code&gt;aws-workspace&lt;/code&gt;/&lt;code&gt;vcloud-virtual-machine&lt;/code&gt;/&lt;code&gt;azure-instance&lt;/code&gt;/&lt;code&gt;azure-arm-instance&lt;/code&gt;/&lt;code&gt;gcp-compute-instance&lt;/code&gt;.&lt;br&gt;• The value for &lt;code&gt;general-policy&lt;/code&gt; would be policy ID.
   * @return value
  **/
  @ApiModelProperty(value = "The value of the rule.<br>• The value for <code>general-agent-activated</code>/<code>general-agent-offline</code>/<code>general-crio-host</code>/<code>general-docker-host</code> would be <code>yes</code>/<code>no</code>.<br>• The value for <code>general-computer-type</code> would be <code>physical-computer</code>/<code>amazon-ec2-instance</code>/<code>aws-workspace</code>/<code>vcloud-virtual-machine</code>/<code>azure-instance</code>/<code>azure-arm-instance</code>/<code>gcp-compute-instance</code>.<br>• The value for <code>general-policy</code> would be policy ID.")
  public String getValue() {
    return value;
  }

  public void setValue(String value) {
    this.value = value;
  }

  public SmartFolderRule secondaryComparisonOperator(SecondaryComparisonOperatorEnum secondaryComparisonOperator) {
    this.secondaryComparisonOperator = secondaryComparisonOperator;
    return this;
  }

   /**
   * The secondary operator of the rule if needed.
   * @return secondaryComparisonOperator
  **/
  @ApiModelProperty(value = "The secondary operator of the rule if needed.")
  public SecondaryComparisonOperatorEnum getSecondaryComparisonOperator() {
    return secondaryComparisonOperator;
  }

  public void setSecondaryComparisonOperator(SecondaryComparisonOperatorEnum secondaryComparisonOperator) {
    this.secondaryComparisonOperator = secondaryComparisonOperator;
  }

  public SmartFolderRule secondaryValue(String secondaryValue) {
    this.secondaryValue = secondaryValue;
    return this;
  }

   /**
   * The secondary value of the rule if needed.
   * @return secondaryValue
  **/
  @ApiModelProperty(value = "The secondary value of the rule if needed.")
  public String getSecondaryValue() {
    return secondaryValue;
  }

  public void setSecondaryValue(String secondaryValue) {
    this.secondaryValue = secondaryValue;
  }

  public SmartFolderRule timeUnit(TimeUnitEnum timeUnit) {
    this.timeUnit = timeUnit;
    return this;
  }

   /**
   * The time unit of the rule if the key is &lt;code&gt;general-last-recommendation-scan-time&lt;/code&gt;/&lt;code&gt;general-last-agent-communication&lt;/code&gt;.
   * @return timeUnit
  **/
  @ApiModelProperty(value = "The time unit of the rule if the key is <code>general-last-recommendation-scan-time</code>/<code>general-last-agent-communication</code>.")
  public TimeUnitEnum getTimeUnit() {
    return timeUnit;
  }

  public void setTimeUnit(TimeUnitEnum timeUnit) {
    this.timeUnit = timeUnit;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SmartFolderRule smartFolderRule = (SmartFolderRule) o;
    return Objects.equals(this.key, smartFolderRule.key) &&
        Objects.equals(this.comparisonOperator, smartFolderRule.comparisonOperator) &&
        Objects.equals(this.value, smartFolderRule.value) &&
        Objects.equals(this.secondaryComparisonOperator, smartFolderRule.secondaryComparisonOperator) &&
        Objects.equals(this.secondaryValue, smartFolderRule.secondaryValue) &&
        Objects.equals(this.timeUnit, smartFolderRule.timeUnit);
  }

  @Override
  public int hashCode() {
    return Objects.hash(key, comparisonOperator, value, secondaryComparisonOperator, secondaryValue, timeUnit);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SmartFolderRule {\n");
    
    sb.append("    key: ").append(toIndentedString(key)).append("\n");
    sb.append("    comparisonOperator: ").append(toIndentedString(comparisonOperator)).append("\n");
    sb.append("    value: ").append(toIndentedString(value)).append("\n");
    sb.append("    secondaryComparisonOperator: ").append(toIndentedString(secondaryComparisonOperator)).append("\n");
    sb.append("    secondaryValue: ").append(toIndentedString(secondaryValue)).append("\n");
    sb.append("    timeUnit: ").append(toIndentedString(timeUnit)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

