/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.SmartFolderRule;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Details of rule group in smart folder.
 */
@ApiModel(description = "Details of rule group in smart folder.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class SmartFolderRuleGroup {
  @JsonProperty("rules")
  private List<SmartFolderRule> rules = null;

  /**
   * The comparator for combining the rules.
   */
  public enum LogicalOperatorEnum {
    AND("and"),
    
    OR("or");

    private String value;

    LogicalOperatorEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static LogicalOperatorEnum fromValue(String text) {
      for (LogicalOperatorEnum b : LogicalOperatorEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("logicalOperator")
  private LogicalOperatorEnum logicalOperator = null;

  public SmartFolderRuleGroup rules(List<SmartFolderRule> rules) {
    this.rules = rules;
    return this;
  }

  public SmartFolderRuleGroup addRulesItem(SmartFolderRule rulesItem) {
    if (this.rules == null) {
      this.rules = new ArrayList<>();
    }
    this.rules.add(rulesItem);
    return this;
  }

   /**
   * The list of rules in the group.
   * @return rules
  **/
  @ApiModelProperty(value = "The list of rules in the group.")
  public List<SmartFolderRule> getRules() {
    return rules;
  }

  public void setRules(List<SmartFolderRule> rules) {
    this.rules = rules;
  }

  public SmartFolderRuleGroup logicalOperator(LogicalOperatorEnum logicalOperator) {
    this.logicalOperator = logicalOperator;
    return this;
  }

   /**
   * The comparator for combining the rules.
   * @return logicalOperator
  **/
  @ApiModelProperty(value = "The comparator for combining the rules.")
  public LogicalOperatorEnum getLogicalOperator() {
    return logicalOperator;
  }

  public void setLogicalOperator(LogicalOperatorEnum logicalOperator) {
    this.logicalOperator = logicalOperator;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SmartFolderRuleGroup smartFolderRuleGroup = (SmartFolderRuleGroup) o;
    return Objects.equals(this.rules, smartFolderRuleGroup.rules) &&
        Objects.equals(this.logicalOperator, smartFolderRuleGroup.logicalOperator);
  }

  @Override
  public int hashCode() {
    return Objects.hash(rules, logicalOperator);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SmartFolderRuleGroup {\n");
    
    sb.append("    rules: ").append(toIndentedString(rules)).append("\n");
    sb.append("    logicalOperator: ").append(toIndentedString(logicalOperator)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

