/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Software inventory details.
 */
@ApiModel(description = "Software inventory details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class SoftwareInventory {
  @JsonProperty("computerID")
  private Integer computerID = null;

  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  /**
   * State of the inventory scan. Searchable as Choice.
   */
  public enum StateEnum {
    UNKNOWN("unknown"),
    
    BUILDING("building"),
    
    COMPLETE("complete"),
    
    FAILED("failed"),
    
    REQUESTED("requested");

    private String value;

    StateEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StateEnum fromValue(String text) {
      for (StateEnum b : StateEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("state")
  private StateEnum state = null;

  @JsonProperty("startDate")
  private Long startDate = null;

  @JsonProperty("completedDate")
  private Long completedDate = null;

  @JsonProperty("initiatorID")
  private Integer initiatorID = null;

  @JsonProperty("ID")
  private Long ID = null;

  public SoftwareInventory computerID(Integer computerID) {
    this.computerID = computerID;
    return this;
  }

   /**
   * ID of the computer that the inventory scan was performed on (or is being performed on). Searchable as Numeric.
   * @return computerID
  **/
  @ApiModelProperty(value = "ID of the computer that the inventory scan was performed on (or is being performed on). Searchable as Numeric.")
  public Integer getComputerID() {
    return computerID;
  }

  public void setComputerID(Integer computerID) {
    this.computerID = computerID;
  }

  public SoftwareInventory name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the inventory. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the inventory. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public SoftwareInventory description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the inventory. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the inventory. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

   /**
   * State of the inventory scan. Searchable as Choice.
   * @return state
  **/
  @ApiModelProperty(value = "State of the inventory scan. Searchable as Choice.")
  public StateEnum getState() {
    return state;
  }

   /**
   * Time the inventory scan was started, in milliseconds since epoch. Searchable as Date.
   * @return startDate
  **/
  @ApiModelProperty(value = "Time the inventory scan was started, in milliseconds since epoch. Searchable as Date.")
  public Long getStartDate() {
    return startDate;
  }

   /**
   * Time the inventory scan was completed, in milliseconds since epoch. Searchable as Date.
   * @return completedDate
  **/
  @ApiModelProperty(value = "Time the inventory scan was completed, in milliseconds since epoch. Searchable as Date.")
  public Long getCompletedDate() {
    return completedDate;
  }

   /**
   * Either the ID of the administrator that initiated the inventory scan or the ID of the API key if the inventory scan was initiated using an API Key. Searchable as Numeric.
   * @return initiatorID
  **/
  @ApiModelProperty(value = "Either the ID of the administrator that initiated the inventory scan or the ID of the API key if the inventory scan was initiated using an API Key. Searchable as Numeric.")
  public Integer getInitiatorID() {
    return initiatorID;
  }

   /**
   * ID of the software inventory. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the software inventory. Searchable as ID.")
  public Long getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SoftwareInventory softwareInventory = (SoftwareInventory) o;
    return Objects.equals(this.computerID, softwareInventory.computerID) &&
        Objects.equals(this.name, softwareInventory.name) &&
        Objects.equals(this.description, softwareInventory.description) &&
        Objects.equals(this.state, softwareInventory.state) &&
        Objects.equals(this.startDate, softwareInventory.startDate) &&
        Objects.equals(this.completedDate, softwareInventory.completedDate) &&
        Objects.equals(this.initiatorID, softwareInventory.initiatorID) &&
        Objects.equals(this.ID, softwareInventory.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(computerID, name, description, state, startDate, completedDate, initiatorID, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SoftwareInventory {\n");
    
    sb.append("    computerID: ").append(toIndentedString(computerID)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("    startDate: ").append(toIndentedString(startDate)).append("\n");
    sb.append("    completedDate: ").append(toIndentedString(completedDate)).append("\n");
    sb.append("    initiatorID: ").append(toIndentedString(initiatorID)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

