/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Stateful configurations of the interface.
 */
@ApiModel(description = "Stateful configurations of the interface.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class StatefulConfiguration {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("denyFragmentedPacketsEnabled")
  private Boolean denyFragmentedPacketsEnabled = null;

  @JsonProperty("denyPacketsContainingCwrOrEceEnabled")
  private Boolean denyPacketsContainingCwrOrEceEnabled = null;

  @JsonProperty("maxIncomingConnections")
  private Integer maxIncomingConnections = null;

  @JsonProperty("maxOutgoingConnections")
  private Integer maxOutgoingConnections = null;

  @JsonProperty("maxHalfOpenConnections")
  private Integer maxHalfOpenConnections = null;

  @JsonProperty("tcpstatefulInspectionEnabled")
  private Boolean tcpstatefulInspectionEnabled = null;

  @JsonProperty("tcpstatefulLoggingEnabled")
  private Boolean tcpstatefulLoggingEnabled = null;

  @JsonProperty("udpstatefulInspectionEnabled")
  private Boolean udpstatefulInspectionEnabled = null;

  @JsonProperty("udpstatefulLoggingEnabled")
  private Boolean udpstatefulLoggingEnabled = null;

  @JsonProperty("icmpstatefulInspectionEnabled")
  private Boolean icmpstatefulInspectionEnabled = null;

  @JsonProperty("icmpstatefulLoggingEnabled")
  private Boolean icmpstatefulLoggingEnabled = null;

  @JsonProperty("ID")
  private Integer ID = null;

  public StatefulConfiguration name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the stateful configuration. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the stateful configuration. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public StatefulConfiguration description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the stateful configuration. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the stateful configuration. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public StatefulConfiguration denyFragmentedPacketsEnabled(Boolean denyFragmentedPacketsEnabled) {
    this.denyFragmentedPacketsEnabled = denyFragmentedPacketsEnabled;
    return this;
  }

   /**
   * Controls if fragmented packets are denied. Set to true to deny fragmented packets. Searchable as Boolean.
   * @return denyFragmentedPacketsEnabled
  **/
  @ApiModelProperty(value = "Controls if fragmented packets are denied. Set to true to deny fragmented packets. Searchable as Boolean.")
  public Boolean isDenyFragmentedPacketsEnabled() {
    return denyFragmentedPacketsEnabled;
  }

  public void setDenyFragmentedPacketsEnabled(Boolean denyFragmentedPacketsEnabled) {
    this.denyFragmentedPacketsEnabled = denyFragmentedPacketsEnabled;
  }

  public StatefulConfiguration denyPacketsContainingCwrOrEceEnabled(Boolean denyPacketsContainingCwrOrEceEnabled) {
    this.denyPacketsContainingCwrOrEceEnabled = denyPacketsContainingCwrOrEceEnabled;
    return this;
  }

   /**
   * Controls if TCP CWR, ECE flags are denied. Set to true to enable CWR or ECE flags. Searchable as Boolean.
   * @return denyPacketsContainingCwrOrEceEnabled
  **/
  @ApiModelProperty(value = "Controls if TCP CWR, ECE flags are denied. Set to true to enable CWR or ECE flags. Searchable as Boolean.")
  public Boolean isDenyPacketsContainingCwrOrEceEnabled() {
    return denyPacketsContainingCwrOrEceEnabled;
  }

  public void setDenyPacketsContainingCwrOrEceEnabled(Boolean denyPacketsContainingCwrOrEceEnabled) {
    this.denyPacketsContainingCwrOrEceEnabled = denyPacketsContainingCwrOrEceEnabled;
  }

  public StatefulConfiguration maxIncomingConnections(Integer maxIncomingConnections) {
    this.maxIncomingConnections = maxIncomingConnections;
    return this;
  }

   /**
   * Maximum allowed incoming connections. Searchable as Numeric.
   * @return maxIncomingConnections
  **/
  @ApiModelProperty(value = "Maximum allowed incoming connections. Searchable as Numeric.")
  public Integer getMaxIncomingConnections() {
    return maxIncomingConnections;
  }

  public void setMaxIncomingConnections(Integer maxIncomingConnections) {
    this.maxIncomingConnections = maxIncomingConnections;
  }

  public StatefulConfiguration maxOutgoingConnections(Integer maxOutgoingConnections) {
    this.maxOutgoingConnections = maxOutgoingConnections;
    return this;
  }

   /**
   * Maximum allowed outgoing connections. Searchable as Numeric.
   * @return maxOutgoingConnections
  **/
  @ApiModelProperty(value = "Maximum allowed outgoing connections. Searchable as Numeric.")
  public Integer getMaxOutgoingConnections() {
    return maxOutgoingConnections;
  }

  public void setMaxOutgoingConnections(Integer maxOutgoingConnections) {
    this.maxOutgoingConnections = maxOutgoingConnections;
  }

  public StatefulConfiguration maxHalfOpenConnections(Integer maxHalfOpenConnections) {
    this.maxHalfOpenConnections = maxHalfOpenConnections;
    return this;
  }

   /**
   * Maximum allowed half open connections. Searchable as Numeric.
   * @return maxHalfOpenConnections
  **/
  @ApiModelProperty(value = "Maximum allowed half open connections. Searchable as Numeric.")
  public Integer getMaxHalfOpenConnections() {
    return maxHalfOpenConnections;
  }

  public void setMaxHalfOpenConnections(Integer maxHalfOpenConnections) {
    this.maxHalfOpenConnections = maxHalfOpenConnections;
  }

  public StatefulConfiguration tcpstatefulInspectionEnabled(Boolean tcpstatefulInspectionEnabled) {
    this.tcpstatefulInspectionEnabled = tcpstatefulInspectionEnabled;
    return this;
  }

   /**
   * Get tcpstatefulInspectionEnabled
   * @return tcpstatefulInspectionEnabled
  **/
  @ApiModelProperty(value = "")
  public Boolean isTcpstatefulInspectionEnabled() {
    return tcpstatefulInspectionEnabled;
  }

  public void setTcpstatefulInspectionEnabled(Boolean tcpstatefulInspectionEnabled) {
    this.tcpstatefulInspectionEnabled = tcpstatefulInspectionEnabled;
  }

  public StatefulConfiguration tcpstatefulLoggingEnabled(Boolean tcpstatefulLoggingEnabled) {
    this.tcpstatefulLoggingEnabled = tcpstatefulLoggingEnabled;
    return this;
  }

   /**
   * Get tcpstatefulLoggingEnabled
   * @return tcpstatefulLoggingEnabled
  **/
  @ApiModelProperty(value = "")
  public Boolean isTcpstatefulLoggingEnabled() {
    return tcpstatefulLoggingEnabled;
  }

  public void setTcpstatefulLoggingEnabled(Boolean tcpstatefulLoggingEnabled) {
    this.tcpstatefulLoggingEnabled = tcpstatefulLoggingEnabled;
  }

  public StatefulConfiguration udpstatefulInspectionEnabled(Boolean udpstatefulInspectionEnabled) {
    this.udpstatefulInspectionEnabled = udpstatefulInspectionEnabled;
    return this;
  }

   /**
   * Get udpstatefulInspectionEnabled
   * @return udpstatefulInspectionEnabled
  **/
  @ApiModelProperty(value = "")
  public Boolean isUdpstatefulInspectionEnabled() {
    return udpstatefulInspectionEnabled;
  }

  public void setUdpstatefulInspectionEnabled(Boolean udpstatefulInspectionEnabled) {
    this.udpstatefulInspectionEnabled = udpstatefulInspectionEnabled;
  }

  public StatefulConfiguration udpstatefulLoggingEnabled(Boolean udpstatefulLoggingEnabled) {
    this.udpstatefulLoggingEnabled = udpstatefulLoggingEnabled;
    return this;
  }

   /**
   * Get udpstatefulLoggingEnabled
   * @return udpstatefulLoggingEnabled
  **/
  @ApiModelProperty(value = "")
  public Boolean isUdpstatefulLoggingEnabled() {
    return udpstatefulLoggingEnabled;
  }

  public void setUdpstatefulLoggingEnabled(Boolean udpstatefulLoggingEnabled) {
    this.udpstatefulLoggingEnabled = udpstatefulLoggingEnabled;
  }

  public StatefulConfiguration icmpstatefulInspectionEnabled(Boolean icmpstatefulInspectionEnabled) {
    this.icmpstatefulInspectionEnabled = icmpstatefulInspectionEnabled;
    return this;
  }

   /**
   * Get icmpstatefulInspectionEnabled
   * @return icmpstatefulInspectionEnabled
  **/
  @ApiModelProperty(value = "")
  public Boolean isIcmpstatefulInspectionEnabled() {
    return icmpstatefulInspectionEnabled;
  }

  public void setIcmpstatefulInspectionEnabled(Boolean icmpstatefulInspectionEnabled) {
    this.icmpstatefulInspectionEnabled = icmpstatefulInspectionEnabled;
  }

  public StatefulConfiguration icmpstatefulLoggingEnabled(Boolean icmpstatefulLoggingEnabled) {
    this.icmpstatefulLoggingEnabled = icmpstatefulLoggingEnabled;
    return this;
  }

   /**
   * Get icmpstatefulLoggingEnabled
   * @return icmpstatefulLoggingEnabled
  **/
  @ApiModelProperty(value = "")
  public Boolean isIcmpstatefulLoggingEnabled() {
    return icmpstatefulLoggingEnabled;
  }

  public void setIcmpstatefulLoggingEnabled(Boolean icmpstatefulLoggingEnabled) {
    this.icmpstatefulLoggingEnabled = icmpstatefulLoggingEnabled;
  }

   /**
   * ID of the stateful configuration. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the stateful configuration. Searchable as ID.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    StatefulConfiguration statefulConfiguration = (StatefulConfiguration) o;
    return Objects.equals(this.name, statefulConfiguration.name) &&
        Objects.equals(this.description, statefulConfiguration.description) &&
        Objects.equals(this.denyFragmentedPacketsEnabled, statefulConfiguration.denyFragmentedPacketsEnabled) &&
        Objects.equals(this.denyPacketsContainingCwrOrEceEnabled, statefulConfiguration.denyPacketsContainingCwrOrEceEnabled) &&
        Objects.equals(this.maxIncomingConnections, statefulConfiguration.maxIncomingConnections) &&
        Objects.equals(this.maxOutgoingConnections, statefulConfiguration.maxOutgoingConnections) &&
        Objects.equals(this.maxHalfOpenConnections, statefulConfiguration.maxHalfOpenConnections) &&
        Objects.equals(this.tcpstatefulInspectionEnabled, statefulConfiguration.tcpstatefulInspectionEnabled) &&
        Objects.equals(this.tcpstatefulLoggingEnabled, statefulConfiguration.tcpstatefulLoggingEnabled) &&
        Objects.equals(this.udpstatefulInspectionEnabled, statefulConfiguration.udpstatefulInspectionEnabled) &&
        Objects.equals(this.udpstatefulLoggingEnabled, statefulConfiguration.udpstatefulLoggingEnabled) &&
        Objects.equals(this.icmpstatefulInspectionEnabled, statefulConfiguration.icmpstatefulInspectionEnabled) &&
        Objects.equals(this.icmpstatefulLoggingEnabled, statefulConfiguration.icmpstatefulLoggingEnabled) &&
        Objects.equals(this.ID, statefulConfiguration.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, denyFragmentedPacketsEnabled, denyPacketsContainingCwrOrEceEnabled, maxIncomingConnections, maxOutgoingConnections, maxHalfOpenConnections, tcpstatefulInspectionEnabled, tcpstatefulLoggingEnabled, udpstatefulInspectionEnabled, udpstatefulLoggingEnabled, icmpstatefulInspectionEnabled, icmpstatefulLoggingEnabled, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class StatefulConfiguration {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    denyFragmentedPacketsEnabled: ").append(toIndentedString(denyFragmentedPacketsEnabled)).append("\n");
    sb.append("    denyPacketsContainingCwrOrEceEnabled: ").append(toIndentedString(denyPacketsContainingCwrOrEceEnabled)).append("\n");
    sb.append("    maxIncomingConnections: ").append(toIndentedString(maxIncomingConnections)).append("\n");
    sb.append("    maxOutgoingConnections: ").append(toIndentedString(maxOutgoingConnections)).append("\n");
    sb.append("    maxHalfOpenConnections: ").append(toIndentedString(maxHalfOpenConnections)).append("\n");
    sb.append("    tcpstatefulInspectionEnabled: ").append(toIndentedString(tcpstatefulInspectionEnabled)).append("\n");
    sb.append("    tcpstatefulLoggingEnabled: ").append(toIndentedString(tcpstatefulLoggingEnabled)).append("\n");
    sb.append("    udpstatefulInspectionEnabled: ").append(toIndentedString(udpstatefulInspectionEnabled)).append("\n");
    sb.append("    udpstatefulLoggingEnabled: ").append(toIndentedString(udpstatefulLoggingEnabled)).append("\n");
    sb.append("    icmpstatefulInspectionEnabled: ").append(toIndentedString(icmpstatefulInspectionEnabled)).append("\n");
    sb.append("    icmpstatefulLoggingEnabled: ").append(toIndentedString(icmpstatefulLoggingEnabled)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

