/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Details of a tag folder for AWS/GCP/Azure.
 */
@ApiModel(description = "Details of a tag folder for AWS/GCP/Azure.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class TagFolder {
  /**
   * The cloud platform(aws/azure/gcp) of the tag folder.
   */
  public enum CloudPlatformEnum {
    AWS("aws"),
    
    AZURE("azure"),
    
    GCP("gcp");

    private String value;

    CloudPlatformEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static CloudPlatformEnum fromValue(String text) {
      for (CloudPlatformEnum b : CloudPlatformEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("cloudPlatform")
  private CloudPlatformEnum cloudPlatform = null;

  @JsonProperty("cloudTagOrLabelKey")
  private String cloudTagOrLabelKey = null;

  public TagFolder cloudPlatform(CloudPlatformEnum cloudPlatform) {
    this.cloudPlatform = cloudPlatform;
    return this;
  }

   /**
   * The cloud platform(aws/azure/gcp) of the tag folder.
   * @return cloudPlatform
  **/
  @ApiModelProperty(value = "The cloud platform(aws/azure/gcp) of the tag folder.")
  public CloudPlatformEnum getCloudPlatform() {
    return cloudPlatform;
  }

  public void setCloudPlatform(CloudPlatformEnum cloudPlatform) {
    this.cloudPlatform = cloudPlatform;
  }

  public TagFolder cloudTagOrLabelKey(String cloudTagOrLabelKey) {
    this.cloudTagOrLabelKey = cloudTagOrLabelKey;
    return this;
  }

   /**
   * Tag folders name key of cloud platform.
   * @return cloudTagOrLabelKey
  **/
  @ApiModelProperty(value = "Tag folders name key of cloud platform.")
  public String getCloudTagOrLabelKey() {
    return cloudTagOrLabelKey;
  }

  public void setCloudTagOrLabelKey(String cloudTagOrLabelKey) {
    this.cloudTagOrLabelKey = cloudTagOrLabelKey;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TagFolder tagFolder = (TagFolder) o;
    return Objects.equals(this.cloudPlatform, tagFolder.cloudPlatform) &&
        Objects.equals(this.cloudTagOrLabelKey, tagFolder.cloudTagOrLabelKey);
  }

  @Override
  public int hashCode() {
    return Objects.hash(cloudPlatform, cloudTagOrLabelKey);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TagFolder {\n");
    
    sb.append("    cloudPlatform: ").append(toIndentedString(cloudPlatform)).append("\n");
    sb.append("    cloudTagOrLabelKey: ").append(toIndentedString(cloudTagOrLabelKey)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

