/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.Administrator;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Tenant details.
 */
@ApiModel(description = "Tenant details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class Tenant {
  @JsonProperty("databaseServerID")
  private Long databaseServerID = null;

  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("agentInitiatedActivationPassword")
  private String agentInitiatedActivationPassword = null;

  @JsonProperty("timeZone")
  private String timeZone = null;

  /**
   * Locale of the tenant. Determines the language of the Deep Security Manager user interface.
   */
  public enum LocaleEnum {
    EN_US("en-US"),
    
    JA_JP("ja-JP");

    private String value;

    LocaleEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static LocaleEnum fromValue(String text) {
      for (LocaleEnum b : LocaleEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("locale")
  private LocaleEnum locale = null;

  @JsonProperty("demoMode")
  private Boolean demoMode = null;

  /**
   * Gets or Sets modulesVisible
   */
  public enum ModulesVisibleEnum {
    ALL("all"),
    
    ANTI_MALWARE("anti-malware"),
    
    WEB_REPUTATION("web-reputation"),
    
    FIREWALL("firewall"),
    
    INTRUSION_PREVENTION("intrusion-prevention"),
    
    INTEGRITY_MONITORING("integrity-monitoring"),
    
    LOG_INSPECTION("log-inspection"),
    
    APPLICATION_CONTROL("application-control"),
    
    SAP("SAP"),
    
    ACTIVITY_MONITORING("activity-monitoring"),
    
    CONTAINER_CONTROL("container-control");

    private String value;

    ModulesVisibleEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ModulesVisibleEnum fromValue(String text) {
      for (ModulesVisibleEnum b : ModulesVisibleEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("modulesVisible")
  private List<ModulesVisibleEnum> modulesVisible = null;

  @JsonProperty("hideUnlicensedModules")
  private Boolean hideUnlicensedModules = null;

  @JsonProperty("lastSigninTime")
  private Long lastSigninTime = null;

  /**
   * State of the tenant. Searchable as Choice.
   */
  public enum TenantStateEnum {
    UNDEFINED("undefined"),
    
    CREATED("created"),
    
    ACTIVE("active"),
    
    SUSPENDED("suspended"),
    
    SUSPENDED_DB_LOCKED("suspended-db-locked"),
    
    PENDING_DELETION("pending-deletion"),
    
    DB_UPGRADE_FAILURE("db-upgrade-failure"),
    
    CONFIRMATION_REQUIRED("confirmation-required"),
    
    CACHE_REQUIRES_INITIALIZATION("cache-requires-initialization"),
    
    CACHE_INITIALIZING("cache-initializing"),
    
    CACHE_READY_FOR_USE("cache-ready-for-use"),
    
    CACHE_ACTIVATING("cache-activating");

    private String value;

    TenantStateEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TenantStateEnum fromValue(String text) {
      for (TenantStateEnum b : TenantStateEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("tenantState")
  private TenantStateEnum tenantState = null;

  @JsonProperty("activationCodes")
  private List<String> activationCodes = null;

  @JsonProperty("administrator")
  private Administrator administrator = null;

  @JsonProperty("primaryContacts")
  private List<Administrator> primaryContacts = null;

  @JsonProperty("guid")
  private String guid = null;

  @JsonProperty("ID")
  private Integer ID = null;

  public Tenant databaseServerID(Long databaseServerID) {
    this.databaseServerID = databaseServerID;
    return this;
  }

   /**
   * ID of the tenant database server. Searchable as Numeric.
   * @return databaseServerID
  **/
  @ApiModelProperty(value = "ID of the tenant database server. Searchable as Numeric.")
  public Long getDatabaseServerID() {
    return databaseServerID;
  }

  public void setDatabaseServerID(Long databaseServerID) {
    this.databaseServerID = databaseServerID;
  }

  public Tenant name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Display name of the tenant. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Display name of the tenant. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public Tenant description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the tenant. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the tenant. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

   /**
   * Activation token required to invoke agent-initiated activation for non-primary tenant users.
   * @return agentInitiatedActivationPassword
  **/
  @ApiModelProperty(value = "Activation token required to invoke agent-initiated activation for non-primary tenant users.")
  public String getAgentInitiatedActivationPassword() {
    return agentInitiatedActivationPassword;
  }

  public Tenant timeZone(String timeZone) {
    this.timeZone = timeZone;
    return this;
  }

   /**
   * Time zone ID of the tenant (for example: \&quot;America/New_York\&quot;). Searchable as String.
   * @return timeZone
  **/
  @ApiModelProperty(value = "Time zone ID of the tenant (for example: \"America/New_York\"). Searchable as String.")
  public String getTimeZone() {
    return timeZone;
  }

  public void setTimeZone(String timeZone) {
    this.timeZone = timeZone;
  }

  public Tenant locale(LocaleEnum locale) {
    this.locale = locale;
    return this;
  }

   /**
   * Locale of the tenant. Determines the language of the Deep Security Manager user interface.
   * @return locale
  **/
  @ApiModelProperty(value = "Locale of the tenant. Determines the language of the Deep Security Manager user interface.")
  public LocaleEnum getLocale() {
    return locale;
  }

  public void setLocale(LocaleEnum locale) {
    this.locale = locale;
  }

  public Tenant demoMode(Boolean demoMode) {
    this.demoMode = demoMode;
    return this;
  }

   /**
   * Populates the Deep Security Manager database with simulated computers, events, alerts and other data. Useful for testing environments. Set to true to enable. Searchable as Boolean.
   * @return demoMode
  **/
  @ApiModelProperty(value = "Populates the Deep Security Manager database with simulated computers, events, alerts and other data. Useful for testing environments. Set to true to enable. Searchable as Boolean.")
  public Boolean isDemoMode() {
    return demoMode;
  }

  public void setDemoMode(Boolean demoMode) {
    this.demoMode = demoMode;
  }

  public Tenant modulesVisible(List<ModulesVisibleEnum> modulesVisible) {
    this.modulesVisible = modulesVisible;
    return this;
  }

  public Tenant addModulesVisibleItem(ModulesVisibleEnum modulesVisibleItem) {
    if (this.modulesVisible == null) {
      this.modulesVisible = new ArrayList<>();
    }
    this.modulesVisible.add(modulesVisibleItem);
    return this;
  }

   /**
   * Protection modules shown within the Deep Security Manager. All modules are visible by default.
   * @return modulesVisible
  **/
  @ApiModelProperty(value = "Protection modules shown within the Deep Security Manager. All modules are visible by default.")
  public List<ModulesVisibleEnum> getModulesVisible() {
    return modulesVisible;
  }

  public void setModulesVisible(List<ModulesVisibleEnum> modulesVisible) {
    this.modulesVisible = modulesVisible;
  }

  public Tenant hideUnlicensedModules(Boolean hideUnlicensedModules) {
    this.hideUnlicensedModules = hideUnlicensedModules;
    return this;
  }

   /**
   * Controls whether unlicensed protection modules appear in the Deep Security Manager for tenants. Set to true to hide all unlicensed protection modules. Searchable as Boolean.
   * @return hideUnlicensedModules
  **/
  @ApiModelProperty(value = "Controls whether unlicensed protection modules appear in the Deep Security Manager for tenants. Set to true to hide all unlicensed protection modules. Searchable as Boolean.")
  public Boolean isHideUnlicensedModules() {
    return hideUnlicensedModules;
  }

  public void setHideUnlicensedModules(Boolean hideUnlicensedModules) {
    this.hideUnlicensedModules = hideUnlicensedModules;
  }

  public Tenant lastSigninTime(Long lastSigninTime) {
    this.lastSigninTime = lastSigninTime;
    return this;
  }

   /**
   * Timestamp indicates the last time any tenant user signed in, in milliseconds since epoch. Searchable as Date.
   * @return lastSigninTime
  **/
  @ApiModelProperty(value = "Timestamp indicates the last time any tenant user signed in, in milliseconds since epoch. Searchable as Date.")
  public Long getLastSigninTime() {
    return lastSigninTime;
  }

  public void setLastSigninTime(Long lastSigninTime) {
    this.lastSigninTime = lastSigninTime;
  }

  public Tenant tenantState(TenantStateEnum tenantState) {
    this.tenantState = tenantState;
    return this;
  }

   /**
   * State of the tenant. Searchable as Choice.
   * @return tenantState
  **/
  @ApiModelProperty(value = "State of the tenant. Searchable as Choice.")
  public TenantStateEnum getTenantState() {
    return tenantState;
  }

  public void setTenantState(TenantStateEnum tenantState) {
    this.tenantState = tenantState;
  }

  public Tenant activationCodes(List<String> activationCodes) {
    this.activationCodes = activationCodes;
    return this;
  }

  public Tenant addActivationCodesItem(String activationCodesItem) {
    if (this.activationCodes == null) {
      this.activationCodes = new ArrayList<>();
    }
    this.activationCodes.add(activationCodesItem);
    return this;
  }

   /**
   * List of comma-delimited activation codes for the protection modules. Applicable only during the creation of a tenant in a &#39;Per-Tenant&#39; licensing environment.
   * @return activationCodes
  **/
  @ApiModelProperty(value = "List of comma-delimited activation codes for the protection modules. Applicable only during the creation of a tenant in a 'Per-Tenant' licensing environment.")
  public List<String> getActivationCodes() {
    return activationCodes;
  }

  public void setActivationCodes(List<String> activationCodes) {
    this.activationCodes = activationCodes;
  }

  public Tenant administrator(Administrator administrator) {
    this.administrator = administrator;
    return this;
  }

   /**
   * First administrator created for the tenant. Only the username, password and emailAddress fields will be used during creation.
   * @return administrator
  **/
  @ApiModelProperty(value = "First administrator created for the tenant. Only the username, password and emailAddress fields will be used during creation.")
  public Administrator getAdministrator() {
    return administrator;
  }

  public void setAdministrator(Administrator administrator) {
    this.administrator = administrator;
  }

   /**
   * Primary contacts of the tenant. Only the ID, roleID, username, and emailAddress fields are returned in responses.
   * @return primaryContacts
  **/
  @ApiModelProperty(value = "Primary contacts of the tenant. Only the ID, roleID, username, and emailAddress fields are returned in responses.")
  public List<Administrator> getPrimaryContacts() {
    return primaryContacts;
  }

  public Tenant guid(String guid) {
    this.guid = guid;
    return this;
  }

   /**
   * GUID of the tenant. Used for global identification of the tenant. Searchable as String.
   * @return guid
  **/
  @ApiModelProperty(value = "GUID of the tenant. Used for global identification of the tenant. Searchable as String.")
  public String getGuid() {
    return guid;
  }

  public void setGuid(String guid) {
    this.guid = guid;
  }

   /**
   * ID of the tenant. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the tenant. Searchable as ID.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Tenant tenant = (Tenant) o;
    return Objects.equals(this.databaseServerID, tenant.databaseServerID) &&
        Objects.equals(this.name, tenant.name) &&
        Objects.equals(this.description, tenant.description) &&
        Objects.equals(this.agentInitiatedActivationPassword, tenant.agentInitiatedActivationPassword) &&
        Objects.equals(this.timeZone, tenant.timeZone) &&
        Objects.equals(this.locale, tenant.locale) &&
        Objects.equals(this.demoMode, tenant.demoMode) &&
        Objects.equals(this.modulesVisible, tenant.modulesVisible) &&
        Objects.equals(this.hideUnlicensedModules, tenant.hideUnlicensedModules) &&
        Objects.equals(this.lastSigninTime, tenant.lastSigninTime) &&
        Objects.equals(this.tenantState, tenant.tenantState) &&
        Objects.equals(this.activationCodes, tenant.activationCodes) &&
        Objects.equals(this.administrator, tenant.administrator) &&
        Objects.equals(this.primaryContacts, tenant.primaryContacts) &&
        Objects.equals(this.guid, tenant.guid) &&
        Objects.equals(this.ID, tenant.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(databaseServerID, name, description, agentInitiatedActivationPassword, timeZone, locale, demoMode, modulesVisible, hideUnlicensedModules, lastSigninTime, tenantState, activationCodes, administrator, primaryContacts, guid, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Tenant {\n");
    
    sb.append("    databaseServerID: ").append(toIndentedString(databaseServerID)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    agentInitiatedActivationPassword: ").append(toIndentedString(agentInitiatedActivationPassword)).append("\n");
    sb.append("    timeZone: ").append(toIndentedString(timeZone)).append("\n");
    sb.append("    locale: ").append(toIndentedString(locale)).append("\n");
    sb.append("    demoMode: ").append(toIndentedString(demoMode)).append("\n");
    sb.append("    modulesVisible: ").append(toIndentedString(modulesVisible)).append("\n");
    sb.append("    hideUnlicensedModules: ").append(toIndentedString(hideUnlicensedModules)).append("\n");
    sb.append("    lastSigninTime: ").append(toIndentedString(lastSigninTime)).append("\n");
    sb.append("    tenantState: ").append(toIndentedString(tenantState)).append("\n");
    sb.append("    activationCodes: ").append(toIndentedString(activationCodes)).append("\n");
    sb.append("    administrator: ").append(toIndentedString(administrator)).append("\n");
    sb.append("    primaryContacts: ").append(toIndentedString(primaryContacts)).append("\n");
    sb.append("    guid: ").append(toIndentedString(guid)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

