/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Trust entity management details.
 */
@ApiModel(description = "Trust entity management details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class TrustEntityManagementRights {
  @JsonProperty("canCreateAppControlTrustEntities")
  private Boolean canCreateAppControlTrustEntities = null;

  @JsonProperty("canViewAppControlTrustEntities")
  private Boolean canViewAppControlTrustEntities = null;

  @JsonProperty("canEditAppControlTrustEntities")
  private Boolean canEditAppControlTrustEntities = null;

  @JsonProperty("canDeleteAppControlTrustEntities")
  private Boolean canDeleteAppControlTrustEntities = null;

  public TrustEntityManagementRights canCreateAppControlTrustEntities(Boolean canCreateAppControlTrustEntities) {
    this.canCreateAppControlTrustEntities = canCreateAppControlTrustEntities;
    return this;
  }

   /**
   * Right to create entities in the trust entity management.
   * @return canCreateAppControlTrustEntities
  **/
  @ApiModelProperty(value = "Right to create entities in the trust entity management.")
  public Boolean isCanCreateAppControlTrustEntities() {
    return canCreateAppControlTrustEntities;
  }

  public void setCanCreateAppControlTrustEntities(Boolean canCreateAppControlTrustEntities) {
    this.canCreateAppControlTrustEntities = canCreateAppControlTrustEntities;
  }

  public TrustEntityManagementRights canViewAppControlTrustEntities(Boolean canViewAppControlTrustEntities) {
    this.canViewAppControlTrustEntities = canViewAppControlTrustEntities;
    return this;
  }

   /**
   * Right to view entities in the trust entity management.
   * @return canViewAppControlTrustEntities
  **/
  @ApiModelProperty(value = "Right to view entities in the trust entity management.")
  public Boolean isCanViewAppControlTrustEntities() {
    return canViewAppControlTrustEntities;
  }

  public void setCanViewAppControlTrustEntities(Boolean canViewAppControlTrustEntities) {
    this.canViewAppControlTrustEntities = canViewAppControlTrustEntities;
  }

  public TrustEntityManagementRights canEditAppControlTrustEntities(Boolean canEditAppControlTrustEntities) {
    this.canEditAppControlTrustEntities = canEditAppControlTrustEntities;
    return this;
  }

   /**
   * Right to edit entities in the trust entity management.
   * @return canEditAppControlTrustEntities
  **/
  @ApiModelProperty(value = "Right to edit entities in the trust entity management.")
  public Boolean isCanEditAppControlTrustEntities() {
    return canEditAppControlTrustEntities;
  }

  public void setCanEditAppControlTrustEntities(Boolean canEditAppControlTrustEntities) {
    this.canEditAppControlTrustEntities = canEditAppControlTrustEntities;
  }

  public TrustEntityManagementRights canDeleteAppControlTrustEntities(Boolean canDeleteAppControlTrustEntities) {
    this.canDeleteAppControlTrustEntities = canDeleteAppControlTrustEntities;
    return this;
  }

   /**
   * Right to delete entities in the trust entity management.
   * @return canDeleteAppControlTrustEntities
  **/
  @ApiModelProperty(value = "Right to delete entities in the trust entity management.")
  public Boolean isCanDeleteAppControlTrustEntities() {
    return canDeleteAppControlTrustEntities;
  }

  public void setCanDeleteAppControlTrustEntities(Boolean canDeleteAppControlTrustEntities) {
    this.canDeleteAppControlTrustEntities = canDeleteAppControlTrustEntities;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TrustEntityManagementRights trustEntityManagementRights = (TrustEntityManagementRights) o;
    return Objects.equals(this.canCreateAppControlTrustEntities, trustEntityManagementRights.canCreateAppControlTrustEntities) &&
        Objects.equals(this.canViewAppControlTrustEntities, trustEntityManagementRights.canViewAppControlTrustEntities) &&
        Objects.equals(this.canEditAppControlTrustEntities, trustEntityManagementRights.canEditAppControlTrustEntities) &&
        Objects.equals(this.canDeleteAppControlTrustEntities, trustEntityManagementRights.canDeleteAppControlTrustEntities);
  }

  @Override
  public int hashCode() {
    return Objects.hash(canCreateAppControlTrustEntities, canViewAppControlTrustEntities, canEditAppControlTrustEntities, canDeleteAppControlTrustEntities);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TrustEntityManagementRights {\n");
    
    sb.append("    canCreateAppControlTrustEntities: ").append(toIndentedString(canCreateAppControlTrustEntities)).append("\n");
    sb.append("    canViewAppControlTrustEntities: ").append(toIndentedString(canViewAppControlTrustEntities)).append("\n");
    sb.append("    canEditAppControlTrustEntities: ").append(toIndentedString(canEditAppControlTrustEntities)).append("\n");
    sb.append("    canDeleteAppControlTrustEntities: ").append(toIndentedString(canDeleteAppControlTrustEntities)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

