/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.TrustRuleAttribute;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * TrustRuleUpdateRequest
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class TrustRuleUpdateRequest {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("attributes")
  private List<TrustRuleAttribute> attributes = null;

  public TrustRuleUpdateRequest name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the trust rule. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the trust rule. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public TrustRuleUpdateRequest description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the trust rule. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the trust rule. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public TrustRuleUpdateRequest attributes(List<TrustRuleAttribute> attributes) {
    this.attributes = attributes;
    return this;
  }

  public TrustRuleUpdateRequest addAttributesItem(TrustRuleAttribute attributesItem) {
    if (this.attributes == null) {
      this.attributes = new ArrayList<>();
    }
    this.attributes.add(attributesItem);
    return this;
  }

   /**
   * List of rule attributes.
   * @return attributes
  **/
  @ApiModelProperty(value = "List of rule attributes.")
  public List<TrustRuleAttribute> getAttributes() {
    return attributes;
  }

  public void setAttributes(List<TrustRuleAttribute> attributes) {
    this.attributes = attributes;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TrustRuleUpdateRequest trustRuleUpdateRequest = (TrustRuleUpdateRequest) o;
    return Objects.equals(this.name, trustRuleUpdateRequest.name) &&
        Objects.equals(this.description, trustRuleUpdateRequest.description) &&
        Objects.equals(this.attributes, trustRuleUpdateRequest.attributes);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, attributes);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TrustRuleUpdateRequest {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    attributes: ").append(toIndentedString(attributes)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

