/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * TrustRuleset
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class TrustRuleset {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("version")
  private Integer version = null;

  @JsonProperty("createdTime")
  private Long createdTime = null;

  @JsonProperty("lastUpdatedTime")
  private Long lastUpdatedTime = null;

  @JsonProperty("usageCount")
  private Integer usageCount = null;

  @JsonProperty("ID")
  private Long ID = null;

  public TrustRuleset name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the trust ruleset. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the trust ruleset. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public TrustRuleset description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the trust ruleset. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the trust ruleset. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

   /**
   * Version number of the trust ruleset. Incremented by one whenever the ruleset rules are modified. Searchable as Numeric.
   * @return version
  **/
  @ApiModelProperty(value = "Version number of the trust ruleset. Incremented by one whenever the ruleset rules are modified. Searchable as Numeric.")
  public Integer getVersion() {
    return version;
  }

   /**
   * Timestamp of the trust ruleset&#39;s creation, in milliseconds since epoch. Searchable as Date.
   * @return createdTime
  **/
  @ApiModelProperty(value = "Timestamp of the trust ruleset's creation, in milliseconds since epoch. Searchable as Date.")
  public Long getCreatedTime() {
    return createdTime;
  }

   /**
   * Timestamp of when the trust ruleset was last updated, in milliseconds since epoch. Searchable as Date.
   * @return lastUpdatedTime
  **/
  @ApiModelProperty(value = "Timestamp of when the trust ruleset was last updated, in milliseconds since epoch. Searchable as Date.")
  public Long getLastUpdatedTime() {
    return lastUpdatedTime;
  }

   /**
   * Count for trust ruleset usage.
   * @return usageCount
  **/
  @ApiModelProperty(value = "Count for trust ruleset usage.")
  public Integer getUsageCount() {
    return usageCount;
  }

   /**
   * ID of the trust ruleset. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the trust ruleset. Searchable as ID.")
  public Long getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TrustRuleset trustRuleset = (TrustRuleset) o;
    return Objects.equals(this.name, trustRuleset.name) &&
        Objects.equals(this.description, trustRuleset.description) &&
        Objects.equals(this.version, trustRuleset.version) &&
        Objects.equals(this.createdTime, trustRuleset.createdTime) &&
        Objects.equals(this.lastUpdatedTime, trustRuleset.lastUpdatedTime) &&
        Objects.equals(this.usageCount, trustRuleset.usageCount) &&
        Objects.equals(this.ID, trustRuleset.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, version, createdTime, lastUpdatedTime, usageCount, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TrustRuleset {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("    createdTime: ").append(toIndentedString(createdTime)).append("\n");
    sb.append("    lastUpdatedTime: ").append(toIndentedString(lastUpdatedTime)).append("\n");
    sb.append("    usageCount: ").append(toIndentedString(usageCount)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

