/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * TrustRulesetUpdateRequest
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class TrustRulesetUpdateRequest {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("ruleIds")
  private List<Long> ruleIds = null;

  public TrustRulesetUpdateRequest name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the trust ruleset. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the trust ruleset. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public TrustRulesetUpdateRequest description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the trust ruleset. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the trust ruleset. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public TrustRulesetUpdateRequest ruleIds(List<Long> ruleIds) {
    this.ruleIds = ruleIds;
    return this;
  }

  public TrustRulesetUpdateRequest addRuleIdsItem(Long ruleIdsItem) {
    if (this.ruleIds == null) {
      this.ruleIds = new ArrayList<>();
    }
    this.ruleIds.add(ruleIdsItem);
    return this;
  }

   /**
   * List of rule Ids.
   * @return ruleIds
  **/
  @ApiModelProperty(value = "List of rule Ids.")
  public List<Long> getRuleIds() {
    return ruleIds;
  }

  public void setRuleIds(List<Long> ruleIds) {
    this.ruleIds = ruleIds;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TrustRulesetUpdateRequest trustRulesetUpdateRequest = (TrustRulesetUpdateRequest) o;
    return Objects.equals(this.name, trustRulesetUpdateRequest.name) &&
        Objects.equals(this.description, trustRulesetUpdateRequest.description) &&
        Objects.equals(this.ruleIds, trustRulesetUpdateRequest.ruleIds);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, ruleIds);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TrustRulesetUpdateRequest {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    ruleIds: ").append(toIndentedString(ruleIds)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

