/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Update right details.
 */
@ApiModel(description = "Update right details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class UpdateRights {
  @JsonProperty("canImportSoftware")
  private Boolean canImportSoftware = null;

  @JsonProperty("canDeleteSoftware")
  private Boolean canDeleteSoftware = null;

  @JsonProperty("canEditSoftwareProperties")
  private Boolean canEditSoftwareProperties = null;

  @JsonProperty("canImportRuleUpdates")
  private Boolean canImportRuleUpdates = null;

  @JsonProperty("canDeleteRuleUpdates")
  private Boolean canDeleteRuleUpdates = null;

  @JsonProperty("canViewRuleUpdates")
  private Boolean canViewRuleUpdates = null;

  public UpdateRights canImportSoftware(Boolean canImportSoftware) {
    this.canImportSoftware = canImportSoftware;
    return this;
  }

   /**
   * Right to import software.
   * @return canImportSoftware
  **/
  @ApiModelProperty(value = "Right to import software.")
  public Boolean isCanImportSoftware() {
    return canImportSoftware;
  }

  public void setCanImportSoftware(Boolean canImportSoftware) {
    this.canImportSoftware = canImportSoftware;
  }

  public UpdateRights canDeleteSoftware(Boolean canDeleteSoftware) {
    this.canDeleteSoftware = canDeleteSoftware;
    return this;
  }

   /**
   * Right to delete software.
   * @return canDeleteSoftware
  **/
  @ApiModelProperty(value = "Right to delete software.")
  public Boolean isCanDeleteSoftware() {
    return canDeleteSoftware;
  }

  public void setCanDeleteSoftware(Boolean canDeleteSoftware) {
    this.canDeleteSoftware = canDeleteSoftware;
  }

  public UpdateRights canEditSoftwareProperties(Boolean canEditSoftwareProperties) {
    this.canEditSoftwareProperties = canEditSoftwareProperties;
    return this;
  }

   /**
   * Right to edit software properties.
   * @return canEditSoftwareProperties
  **/
  @ApiModelProperty(value = "Right to edit software properties.")
  public Boolean isCanEditSoftwareProperties() {
    return canEditSoftwareProperties;
  }

  public void setCanEditSoftwareProperties(Boolean canEditSoftwareProperties) {
    this.canEditSoftwareProperties = canEditSoftwareProperties;
  }

  public UpdateRights canImportRuleUpdates(Boolean canImportRuleUpdates) {
    this.canImportRuleUpdates = canImportRuleUpdates;
    return this;
  }

   /**
   * Right to import and apply rule updates.
   * @return canImportRuleUpdates
  **/
  @ApiModelProperty(value = "Right to import and apply rule updates.")
  public Boolean isCanImportRuleUpdates() {
    return canImportRuleUpdates;
  }

  public void setCanImportRuleUpdates(Boolean canImportRuleUpdates) {
    this.canImportRuleUpdates = canImportRuleUpdates;
  }

  public UpdateRights canDeleteRuleUpdates(Boolean canDeleteRuleUpdates) {
    this.canDeleteRuleUpdates = canDeleteRuleUpdates;
    return this;
  }

   /**
   * Right to delete rule updates.
   * @return canDeleteRuleUpdates
  **/
  @ApiModelProperty(value = "Right to delete rule updates.")
  public Boolean isCanDeleteRuleUpdates() {
    return canDeleteRuleUpdates;
  }

  public void setCanDeleteRuleUpdates(Boolean canDeleteRuleUpdates) {
    this.canDeleteRuleUpdates = canDeleteRuleUpdates;
  }

  public UpdateRights canViewRuleUpdates(Boolean canViewRuleUpdates) {
    this.canViewRuleUpdates = canViewRuleUpdates;
    return this;
  }

   /**
   * Right to view rule updates.
   * @return canViewRuleUpdates
  **/
  @ApiModelProperty(value = "Right to view rule updates.")
  public Boolean isCanViewRuleUpdates() {
    return canViewRuleUpdates;
  }

  public void setCanViewRuleUpdates(Boolean canViewRuleUpdates) {
    this.canViewRuleUpdates = canViewRuleUpdates;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UpdateRights updateRights = (UpdateRights) o;
    return Objects.equals(this.canImportSoftware, updateRights.canImportSoftware) &&
        Objects.equals(this.canDeleteSoftware, updateRights.canDeleteSoftware) &&
        Objects.equals(this.canEditSoftwareProperties, updateRights.canEditSoftwareProperties) &&
        Objects.equals(this.canImportRuleUpdates, updateRights.canImportRuleUpdates) &&
        Objects.equals(this.canDeleteRuleUpdates, updateRights.canDeleteRuleUpdates) &&
        Objects.equals(this.canViewRuleUpdates, updateRights.canViewRuleUpdates);
  }

  @Override
  public int hashCode() {
    return Objects.hash(canImportSoftware, canDeleteSoftware, canEditSoftwareProperties, canImportRuleUpdates, canDeleteRuleUpdates, canViewRuleUpdates);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UpdateRights {\n");
    
    sb.append("    canImportSoftware: ").append(toIndentedString(canImportSoftware)).append("\n");
    sb.append("    canDeleteSoftware: ").append(toIndentedString(canDeleteSoftware)).append("\n");
    sb.append("    canEditSoftwareProperties: ").append(toIndentedString(canEditSoftwareProperties)).append("\n");
    sb.append("    canImportRuleUpdates: ").append(toIndentedString(canImportRuleUpdates)).append("\n");
    sb.append("    canDeleteRuleUpdates: ").append(toIndentedString(canDeleteRuleUpdates)).append("\n");
    sb.append("    canViewRuleUpdates: ").append(toIndentedString(canViewRuleUpdates)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

