/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.NSXManagerInfo;
import com.trendmicro.deepsecurity.model.VCenterInfo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Everything about VCenter connector.
 */
@ApiModel(description = "Everything about VCenter connector.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class VCenterConnector {
  @JsonProperty("autoTrustCertificate")
  private Boolean autoTrustCertificate = null;

  @JsonProperty("id")
  private Integer id = null;

  @JsonProperty("vCenter")
  private VCenterInfo vCenter = null;

  @JsonProperty("NSXManager")
  private NSXManagerInfo nsXManager = null;

  public VCenterConnector autoTrustCertificate(Boolean autoTrustCertificate) {
    this.autoTrustCertificate = autoTrustCertificate;
    return this;
  }

   /**
   * Automatically trust detected certificate when trying to connect to vCenter connector or NSX Manager
   * @return autoTrustCertificate
  **/
  @ApiModelProperty(value = "Automatically trust detected certificate when trying to connect to vCenter connector or NSX Manager")
  public Boolean isAutoTrustCertificate() {
    return autoTrustCertificate;
  }

  public void setAutoTrustCertificate(Boolean autoTrustCertificate) {
    this.autoTrustCertificate = autoTrustCertificate;
  }

   /**
   * ID number of the vCenter connector.
   * @return id
  **/
  @ApiModelProperty(value = "ID number of the vCenter connector.")
  public Integer getId() {
    return id;
  }

  public VCenterConnector vCenter(VCenterInfo vCenter) {
    this.vCenter = vCenter;
    return this;
  }

   /**
   * vCenter settings.
   * @return vCenter
  **/
  @ApiModelProperty(value = "vCenter settings.")
  public VCenterInfo getVCenter() {
    return vCenter;
  }

  public void setVCenter(VCenterInfo vCenter) {
    this.vCenter = vCenter;
  }

  public VCenterConnector nsXManager(NSXManagerInfo nsXManager) {
    this.nsXManager = nsXManager;
    return this;
  }

   /**
   * Get nsXManager
   * @return nsXManager
  **/
  @ApiModelProperty(value = "")
  public NSXManagerInfo getNsXManager() {
    return nsXManager;
  }

  public void setNsXManager(NSXManagerInfo nsXManager) {
    this.nsXManager = nsXManager;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    VCenterConnector vcenterConnector = (VCenterConnector) o;
    return Objects.equals(this.autoTrustCertificate, vcenterConnector.autoTrustCertificate) &&
        Objects.equals(this.id, vcenterConnector.id) &&
        Objects.equals(this.vCenter, vcenterConnector.vCenter) &&
        Objects.equals(this.nsXManager, vcenterConnector.nsXManager);
  }

  @Override
  public int hashCode() {
    return Objects.hash(autoTrustCertificate, id, vCenter, nsXManager);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class VCenterConnector {\n");
    
    sb.append("    autoTrustCertificate: ").append(toIndentedString(autoTrustCertificate)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    vCenter: ").append(toIndentedString(vCenter)).append("\n");
    sb.append("    nsXManager: ").append(toIndentedString(nsXManager)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

