/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * The supported action of a vCenter connector.
 */
@ApiModel(description = "The supported action of a vCenter connector.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class VCenterConnectorAction {
  /**
   * Type of the VCenterConnectorAction.
   */
  public enum TypeEnum {
    SYNCHRONIZE("synchronize");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TypeEnum fromValue(String text) {
      for (TypeEnum b : TypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("type")
  private TypeEnum type = null;

  /**
   * Status of the VCenterConnectorAction.
   */
  public enum StatusEnum {
    SUBMITTED("SUBMITTED"),
    
    RUNNING("RUNNING"),
    
    SUCCESS("SUCCESS"),
    
    FAILED("FAILED");

    private String value;

    StatusEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StatusEnum fromValue(String text) {
      for (StatusEnum b : StatusEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("status")
  private StatusEnum status = null;

  @JsonProperty("submittedTime")
  private Long submittedTime = null;

  @JsonProperty("ID")
  private Long ID = null;

  public VCenterConnectorAction type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * Type of the VCenterConnectorAction.
   * @return type
  **/
  @ApiModelProperty(value = "Type of the VCenterConnectorAction.")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }

  public VCenterConnectorAction status(StatusEnum status) {
    this.status = status;
    return this;
  }

   /**
   * Status of the VCenterConnectorAction.
   * @return status
  **/
  @ApiModelProperty(value = "Status of the VCenterConnectorAction.")
  public StatusEnum getStatus() {
    return status;
  }

  public void setStatus(StatusEnum status) {
    this.status = status;
  }

  public VCenterConnectorAction submittedTime(Long submittedTime) {
    this.submittedTime = submittedTime;
    return this;
  }

   /**
   * Submitted time of the VCenterConnectorAction.
   * @return submittedTime
  **/
  @ApiModelProperty(value = "Submitted time of the VCenterConnectorAction.")
  public Long getSubmittedTime() {
    return submittedTime;
  }

  public void setSubmittedTime(Long submittedTime) {
    this.submittedTime = submittedTime;
  }

   /**
   * ID of the VCenterConnectorAction.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the VCenterConnectorAction.")
  public Long getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    VCenterConnectorAction vCenterConnectorAction = (VCenterConnectorAction) o;
    return Objects.equals(this.type, vCenterConnectorAction.type) &&
        Objects.equals(this.status, vCenterConnectorAction.status) &&
        Objects.equals(this.submittedTime, vCenterConnectorAction.submittedTime) &&
        Objects.equals(this.ID, vCenterConnectorAction.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(type, status, submittedTime, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class VCenterConnectorAction {\n");
    
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    submittedTime: ").append(toIndentedString(submittedTime)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

