/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * VCenterInfo
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class VCenterInfo {
  @JsonProperty("host")
  private String host = null;

  @JsonProperty("port")
  private Integer port = null;

  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("username")
  private String username = null;

  @JsonProperty("password")
  private String password = null;

  public VCenterInfo host(String host) {
    this.host = host;
    return this;
  }

   /**
   * vCenter server address.
   * @return host
  **/
  @ApiModelProperty(value = "vCenter server address.")
  public String getHost() {
    return host;
  }

  public void setHost(String host) {
    this.host = host;
  }

  public VCenterInfo port(Integer port) {
    this.port = port;
    return this;
  }

   /**
   * vCenter server port.
   * @return port
  **/
  @ApiModelProperty(value = "vCenter server port.")
  public Integer getPort() {
    return port;
  }

  public void setPort(Integer port) {
    this.port = port;
  }

  public VCenterInfo name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Display name of the connector.
   * @return name
  **/
  @ApiModelProperty(value = "Display name of the connector.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public VCenterInfo description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the connector.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the connector.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public VCenterInfo username(String username) {
    this.username = username;
    return this;
  }

   /**
   * Username that the connector will use to authenticate to vCenter.
   * @return username
  **/
  @ApiModelProperty(value = "Username that the connector will use to authenticate to vCenter.")
  public String getUsername() {
    return username;
  }

  public void setUsername(String username) {
    this.username = username;
  }

  public VCenterInfo password(String password) {
    this.password = password;
    return this;
  }

   /**
   * Password of the vCenter user. Must be base64-encoded.
   * @return password
  **/
  @ApiModelProperty(value = "Password of the vCenter user. Must be base64-encoded.")
  public String getPassword() {
    return password;
  }

  public void setPassword(String password) {
    this.password = password;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    VCenterInfo vcenterInfo = (VCenterInfo) o;
    return Objects.equals(this.host, vcenterInfo.host) &&
        Objects.equals(this.port, vcenterInfo.port) &&
        Objects.equals(this.name, vcenterInfo.name) &&
        Objects.equals(this.description, vcenterInfo.description) &&
        Objects.equals(this.username, vcenterInfo.username) &&
        Objects.equals(this.password, vcenterInfo.password);
  }

  @Override
  public int hashCode() {
    return Objects.hash(host, port, name, description, username, password);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class VCenterInfo {\n");
    
    sb.append("    host: ").append(toIndentedString(host)).append("\n");
    sb.append("    port: ").append(toIndentedString(port)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    username: ").append(toIndentedString(username)).append("\n");
    sb.append("    password: ").append(toIndentedString(password)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

