/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Workload security link details.
 */
@ApiModel(description = "Workload security link details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class WorkloadSecurityLink {
  @JsonProperty("workloadSecurityTenantGUID")
  private String workloadSecurityTenantGUID = null;

  @JsonProperty("workloadSecurityUrl")
  private String workloadSecurityUrl = null;

  @JsonProperty("workloadSecurityAPIKey")
  private String workloadSecurityAPIKey = null;

  @JsonProperty("cloudOneAPIKey")
  private String cloudOneAPIKey = null;

  @JsonProperty("workloadSecurityCA")
  private String workloadSecurityCA = null;

  @JsonProperty("ID")
  private Long ID = null;

   /**
   * Tenant GUID on Workload Security.
   * @return workloadSecurityTenantGUID
  **/
  @ApiModelProperty(value = "Tenant GUID on Workload Security.")
  public String getWorkloadSecurityTenantGUID() {
    return workloadSecurityTenantGUID;
  }

  public WorkloadSecurityLink workloadSecurityUrl(String workloadSecurityUrl) {
    this.workloadSecurityUrl = workloadSecurityUrl;
    return this;
  }

   /**
   * URL of Workload Security.
   * @return workloadSecurityUrl
  **/
  @ApiModelProperty(value = "URL of Workload Security.")
  public String getWorkloadSecurityUrl() {
    return workloadSecurityUrl;
  }

  public void setWorkloadSecurityUrl(String workloadSecurityUrl) {
    this.workloadSecurityUrl = workloadSecurityUrl;
  }

  public WorkloadSecurityLink workloadSecurityAPIKey(String workloadSecurityAPIKey) {
    this.workloadSecurityAPIKey = workloadSecurityAPIKey;
    return this;
  }

   /**
   * API key of Workload Security. Cannot be given together with cloudOneAPIKey.
   * @return workloadSecurityAPIKey
  **/
  @ApiModelProperty(value = "API key of Workload Security. Cannot be given together with cloudOneAPIKey.")
  public String getWorkloadSecurityAPIKey() {
    return workloadSecurityAPIKey;
  }

  public void setWorkloadSecurityAPIKey(String workloadSecurityAPIKey) {
    this.workloadSecurityAPIKey = workloadSecurityAPIKey;
  }

  public WorkloadSecurityLink cloudOneAPIKey(String cloudOneAPIKey) {
    this.cloudOneAPIKey = cloudOneAPIKey;
    return this;
  }

   /**
   * API key of Cloud One. Cannot be given together with workloadSecurityAPIKey.
   * @return cloudOneAPIKey
  **/
  @ApiModelProperty(value = "API key of Cloud One. Cannot be given together with workloadSecurityAPIKey.")
  public String getCloudOneAPIKey() {
    return cloudOneAPIKey;
  }

  public void setCloudOneAPIKey(String cloudOneAPIKey) {
    this.cloudOneAPIKey = cloudOneAPIKey;
  }

  public WorkloadSecurityLink workloadSecurityCA(String workloadSecurityCA) {
    this.workloadSecurityCA = workloadSecurityCA;
    return this;
  }

   /**
   * Pinned public certificate for agents of Workload Security.
   * @return workloadSecurityCA
  **/
  @ApiModelProperty(example = "-----BEGIN CERTIFICATE----- MIIEPjCCAyagAwIBAgIESlOMKDANBgkqhkiG9w0BAQsFADCBvjELMAkGA1UEBhMC VVMxFjAUBgNVBAoTDUVudHJ1c3QsIEluYy4xKDAmBgNVBAsTH1NlZSB3d3cuZW50 cnVzdC5uZXQvbGVnYWwtdGVybXMxOTA3BgNVBAsTMChjKSAyMDA5IEVudHJ1c3Qs IEluYy4gLSBmb3IgYXV0aG9yaXplZCB1c2Ugb25seTEyMDAGA1UEAxMpRW50cnVz dCBSb290IENlcnRpZmljYXRpb24gQXV0aG9yaXR5IC0gRzIwHhcNMDkwNzA3MTcy NTU0WhcNMzAxMjA3MTc1NTU0WjCBvjELMAkGA1UEBhMCVVMxFjAUBgNVBAoTDUVu dHJ1c3QsIEluYy4xKDAmBgNVBAsTH1NlZSB3d3cuZW50cnVzdC5uZXQvbGVnYWwt dGVybXMxOTA3BgNVBAsTMChjKSAyMDA5IEVudHJ1c3QsIEluYy4gLSBmb3IgYXV0 aG9yaXplZCB1c2Ugb25seTEyMDAGA1UEAxMpRW50cnVzdCBSb290IENlcnRpZmlj YXRpb24gQXV0aG9yaXR5IC0gRzIwggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEK AoIBAQC6hLZy254Ma+KZ6TABp3bqMriVQRrJ2mFOWHLP/vaCeb9zYQYKpSfYs1/T RU4cctZOMvJyig/3gxnQaoCAAEUesMfnmr8SVycco2gvCoe9amsOXmXzHHfV1IWN cCG0szLni6LVhjkCsbjSR87kyUnEO6fe+1R9V77w6G7CebI6C1XiUJgWMhNcL3hW wcKUs/Ja5CeanyTXxuzQmyWC48zCxEXFjJd6BmsqEZ+pCm5IO2/b1BEZQvePB7/1 U1+cPvQXLOZprE4yTGJ36rfo5bs0vBmLrpxR57d+tVOxMyLlbc9wPBr64ptntoP0 jaWvYkxN4FisZDQSA/i2jZRjJKRxAgMBAAGjQjBAMA4GA1UdDwEB/wQEAwIBBjAP BgNVHRMBAf8EBTADAQH/MB0GA1UdDgQWBBRqciZ60B7vfec7aVHUbI2fkBJmqzAN BgkqhkiG9w0BAQsFAAOCAQEAeZ8dlsa2eT8ijYfThwMEYGprmi5ZiXMRrEPR9RP/ jTkrwPK9T3CMqS/qF8QLVJ7UG5aYMzyorWKiAHarWWluBh1+xLlEjZivEtRh2woZ Rkfz6/djwUAFQKXSt/S1mja/qYh2iARVBCuch38aNzx+LaUa2NSJXsq9rD1s2G2v 1fN2D807iDginWyTmsQ9v4IbZT+mD12q/OWyFcq1rca8PdCE6OoGcrBNOTJ4vz4R nAuknZoh8/CbCzB428Hch0P+vGOaysXCHMnHjf87ElgI5rY97HosTvuDls4MPGmH VHOkc8KT/1EQrBVUAdj8BbGJoX90g5pJ19xOe4pIb4tF9g== -----END CERTIFICATE----- ", value = "Pinned public certificate for agents of Workload Security.")
  public String getWorkloadSecurityCA() {
    return workloadSecurityCA;
  }

  public void setWorkloadSecurityCA(String workloadSecurityCA) {
    this.workloadSecurityCA = workloadSecurityCA;
  }

   /**
   * ID of the Workload Security Link.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the Workload Security Link.")
  public Long getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    WorkloadSecurityLink workloadSecurityLink = (WorkloadSecurityLink) o;
    return Objects.equals(this.workloadSecurityTenantGUID, workloadSecurityLink.workloadSecurityTenantGUID) &&
        Objects.equals(this.workloadSecurityUrl, workloadSecurityLink.workloadSecurityUrl) &&
        Objects.equals(this.workloadSecurityAPIKey, workloadSecurityLink.workloadSecurityAPIKey) &&
        Objects.equals(this.cloudOneAPIKey, workloadSecurityLink.cloudOneAPIKey) &&
        Objects.equals(this.workloadSecurityCA, workloadSecurityLink.workloadSecurityCA) &&
        Objects.equals(this.ID, workloadSecurityLink.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(workloadSecurityTenantGUID, workloadSecurityUrl, workloadSecurityAPIKey, cloudOneAPIKey, workloadSecurityCA, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class WorkloadSecurityLink {\n");
    
    sb.append("    workloadSecurityTenantGUID: ").append(toIndentedString(workloadSecurityTenantGUID)).append("\n");
    sb.append("    workloadSecurityUrl: ").append(toIndentedString(workloadSecurityUrl)).append("\n");
    sb.append("    workloadSecurityAPIKey: ").append(toIndentedString(workloadSecurityAPIKey)).append("\n");
    sb.append("    cloudOneAPIKey: ").append(toIndentedString(cloudOneAPIKey)).append("\n");
    sb.append("    workloadSecurityCA: ").append(toIndentedString(workloadSecurityCA)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

