/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Details of a proxy for agent to connect to Workload Security.
 */
@ApiModel(description = "Details of a proxy for agent to connect to Workload Security.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class WorkloadSecurityProxy {
  @JsonProperty("host")
  private String host = null;

  @JsonProperty("port")
  private Integer port = null;

  @JsonProperty("user")
  private String user = null;

  @JsonProperty("password")
  private String password = null;

  public WorkloadSecurityProxy host(String host) {
    this.host = host;
    return this;
  }

   /**
   * The hostname of the proxy.
   * @return host
  **/
  @ApiModelProperty(value = "The hostname of the proxy.")
  public String getHost() {
    return host;
  }

  public void setHost(String host) {
    this.host = host;
  }

  public WorkloadSecurityProxy port(Integer port) {
    this.port = port;
    return this;
  }

   /**
   * The port of the proxy.
   * @return port
  **/
  @ApiModelProperty(value = "The port of the proxy.")
  public Integer getPort() {
    return port;
  }

  public void setPort(Integer port) {
    this.port = port;
  }

  public WorkloadSecurityProxy user(String user) {
    this.user = user;
    return this;
  }

   /**
   * The username for the proxy.
   * @return user
  **/
  @ApiModelProperty(value = "The username for the proxy.")
  public String getUser() {
    return user;
  }

  public void setUser(String user) {
    this.user = user;
  }

  public WorkloadSecurityProxy password(String password) {
    this.password = password;
    return this;
  }

   /**
   * The password for the proxy.
   * @return password
  **/
  @ApiModelProperty(value = "The password for the proxy.")
  public String getPassword() {
    return password;
  }

  public void setPassword(String password) {
    this.password = password;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    WorkloadSecurityProxy workloadSecurityProxy = (WorkloadSecurityProxy) o;
    return Objects.equals(this.host, workloadSecurityProxy.host) &&
        Objects.equals(this.port, workloadSecurityProxy.port) &&
        Objects.equals(this.user, workloadSecurityProxy.user) &&
        Objects.equals(this.password, workloadSecurityProxy.password);
  }

  @Override
  public int hashCode() {
    return Objects.hash(host, port, user, password);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class WorkloadSecurityProxy {\n");
    
    sb.append("    host: ").append(toIndentedString(host)).append("\n");
    sb.append("    port: ").append(toIndentedString(port)).append("\n");
    sb.append("    user: ").append(toIndentedString(user)).append("\n");
    sb.append("    password: ").append(toIndentedString(password)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

