/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.VirtualMachineMetadata;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Details of an AWS Workspace.
 */
@ApiModel(description = "Details of an AWS Workspace.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class WorkspaceVirtualMachineSummary {
  @JsonProperty("cloudProvider")
  private String cloudProvider = null;

  @JsonProperty("accountID")
  private String accountID = null;

  @JsonProperty("workspaceDirectory")
  private String workspaceDirectory = null;

  @JsonProperty("userName")
  private String userName = null;

  @JsonProperty("workspaceID")
  private String workspaceID = null;

  @JsonProperty("bundleID")
  private String bundleID = null;

  @JsonProperty("workspaceHardware")
  private String workspaceHardware = null;

  @JsonProperty("state")
  private String state = null;

  @JsonProperty("metadata")
  private List<VirtualMachineMetadata> metadata = null;

  @JsonProperty("IPAddress")
  private String ipAddress = null;

  public WorkspaceVirtualMachineSummary cloudProvider(String cloudProvider) {
    this.cloudProvider = cloudProvider;
    return this;
  }

   /**
   * Cloud provider: \&quot;AWS\&quot;.
   * @return cloudProvider
  **/
  @ApiModelProperty(value = "Cloud provider: \"AWS\".")
  public String getCloudProvider() {
    return cloudProvider;
  }

  public void setCloudProvider(String cloudProvider) {
    this.cloudProvider = cloudProvider;
  }

  public WorkspaceVirtualMachineSummary accountID(String accountID) {
    this.accountID = accountID;
    return this;
  }

   /**
   * Account ID. Searchable as String.
   * @return accountID
  **/
  @ApiModelProperty(value = "Account ID. Searchable as String.")
  public String getAccountID() {
    return accountID;
  }

  public void setAccountID(String accountID) {
    this.accountID = accountID;
  }

  public WorkspaceVirtualMachineSummary workspaceDirectory(String workspaceDirectory) {
    this.workspaceDirectory = workspaceDirectory;
    return this;
  }

   /**
   * Name of workspace directory.
   * @return workspaceDirectory
  **/
  @ApiModelProperty(value = "Name of workspace directory.")
  public String getWorkspaceDirectory() {
    return workspaceDirectory;
  }

  public void setWorkspaceDirectory(String workspaceDirectory) {
    this.workspaceDirectory = workspaceDirectory;
  }

  public WorkspaceVirtualMachineSummary userName(String userName) {
    this.userName = userName;
    return this;
  }

   /**
   * Name of workspace owner. Searchable as String.
   * @return userName
  **/
  @ApiModelProperty(value = "Name of workspace owner. Searchable as String.")
  public String getUserName() {
    return userName;
  }

  public void setUserName(String userName) {
    this.userName = userName;
  }

  public WorkspaceVirtualMachineSummary workspaceID(String workspaceID) {
    this.workspaceID = workspaceID;
    return this;
  }

   /**
   * Workspace ID, for example: \&quot;ws-hlt453cld\&quot;. Searchable as String.
   * @return workspaceID
  **/
  @ApiModelProperty(value = "Workspace ID, for example: \"ws-hlt453cld\". Searchable as String.")
  public String getWorkspaceID() {
    return workspaceID;
  }

  public void setWorkspaceID(String workspaceID) {
    this.workspaceID = workspaceID;
  }

  public WorkspaceVirtualMachineSummary bundleID(String bundleID) {
    this.bundleID = bundleID;
    return this;
  }

   /**
   * Bundle ID, for example: \&quot;wsb-92b9h49ds\&quot;. Searchable as String.
   * @return bundleID
  **/
  @ApiModelProperty(value = "Bundle ID, for example: \"wsb-92b9h49ds\". Searchable as String.")
  public String getBundleID() {
    return bundleID;
  }

  public void setBundleID(String bundleID) {
    this.bundleID = bundleID;
  }

  public WorkspaceVirtualMachineSummary workspaceHardware(String workspaceHardware) {
    this.workspaceHardware = workspaceHardware;
    return this;
  }

   /**
   * Hardware description, for example: \&quot;STANDARD\&quot;. Searchable as String.
   * @return workspaceHardware
  **/
  @ApiModelProperty(value = "Hardware description, for example: \"STANDARD\". Searchable as String.")
  public String getWorkspaceHardware() {
    return workspaceHardware;
  }

  public void setWorkspaceHardware(String workspaceHardware) {
    this.workspaceHardware = workspaceHardware;
  }

  public WorkspaceVirtualMachineSummary state(String state) {
    this.state = state;
    return this;
  }

   /**
   * Power state, for example, \&quot;POWER ON\&quot;.
   * @return state
  **/
  @ApiModelProperty(value = "Power state, for example, \"POWER ON\".")
  public String getState() {
    return state;
  }

  public void setState(String state) {
    this.state = state;
  }

  public WorkspaceVirtualMachineSummary metadata(List<VirtualMachineMetadata> metadata) {
    this.metadata = metadata;
    return this;
  }

  public WorkspaceVirtualMachineSummary addMetadataItem(VirtualMachineMetadata metadataItem) {
    if (this.metadata == null) {
      this.metadata = new ArrayList<>();
    }
    this.metadata.add(metadataItem);
    return this;
  }

   /**
   * List of name/value metadata pairs.
   * @return metadata
  **/
  @ApiModelProperty(value = "List of name/value metadata pairs.")
  public List<VirtualMachineMetadata> getMetadata() {
    return metadata;
  }

  public void setMetadata(List<VirtualMachineMetadata> metadata) {
    this.metadata = metadata;
  }

  public WorkspaceVirtualMachineSummary ipAddress(String ipAddress) {
    this.ipAddress = ipAddress;
    return this;
  }

   /**
   * Get ipAddress
   * @return ipAddress
  **/
  @ApiModelProperty(value = "")
  public String getIpAddress() {
    return ipAddress;
  }

  public void setIpAddress(String ipAddress) {
    this.ipAddress = ipAddress;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    WorkspaceVirtualMachineSummary workspaceVirtualMachineSummary = (WorkspaceVirtualMachineSummary) o;
    return Objects.equals(this.cloudProvider, workspaceVirtualMachineSummary.cloudProvider) &&
        Objects.equals(this.accountID, workspaceVirtualMachineSummary.accountID) &&
        Objects.equals(this.workspaceDirectory, workspaceVirtualMachineSummary.workspaceDirectory) &&
        Objects.equals(this.userName, workspaceVirtualMachineSummary.userName) &&
        Objects.equals(this.workspaceID, workspaceVirtualMachineSummary.workspaceID) &&
        Objects.equals(this.bundleID, workspaceVirtualMachineSummary.bundleID) &&
        Objects.equals(this.workspaceHardware, workspaceVirtualMachineSummary.workspaceHardware) &&
        Objects.equals(this.state, workspaceVirtualMachineSummary.state) &&
        Objects.equals(this.metadata, workspaceVirtualMachineSummary.metadata) &&
        Objects.equals(this.ipAddress, workspaceVirtualMachineSummary.ipAddress);
  }

  @Override
  public int hashCode() {
    return Objects.hash(cloudProvider, accountID, workspaceDirectory, userName, workspaceID, bundleID, workspaceHardware, state, metadata, ipAddress);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class WorkspaceVirtualMachineSummary {\n");
    
    sb.append("    cloudProvider: ").append(toIndentedString(cloudProvider)).append("\n");
    sb.append("    accountID: ").append(toIndentedString(accountID)).append("\n");
    sb.append("    workspaceDirectory: ").append(toIndentedString(workspaceDirectory)).append("\n");
    sb.append("    userName: ").append(toIndentedString(userName)).append("\n");
    sb.append("    workspaceID: ").append(toIndentedString(workspaceID)).append("\n");
    sb.append("    bundleID: ").append(toIndentedString(bundleID)).append("\n");
    sb.append("    workspaceHardware: ").append(toIndentedString(workspaceHardware)).append("\n");
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("    metadata: ").append(toIndentedString(metadata)).append("\n");
    sb.append("    ipAddress: ").append(toIndentedString(ipAddress)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

