/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Configure protection against malware, viruses, trojans and spyware.
 */
@ApiModel(description = "Configure protection against malware, viruses, trojans and spyware.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class AntiMalwareConfiguration {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  /**
   * The type of malware scan configuration. Searchable as Choice.
   */
  public enum ScanTypeEnum {
    REAL_TIME("real-time"),
    
    ON_DEMAND("on-demand");

    private String value;

    ScanTypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ScanTypeEnum fromValue(String text) {
      for (ScanTypeEnum b : ScanTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("scanType")
  private ScanTypeEnum scanType = null;

  @JsonProperty("documentExploitProtectionEnabled")
  private Boolean documentExploitProtectionEnabled = null;

  /**
   * Scan for exploits against known critical vulnerabilities only. Searchable as Choice.
   */
  public enum DocumentExploitProtectionEnum {
    ONLY("critical-only"),
    
    AND_HEURISTIC("critical-and-heuristic");

    private String value;

    DocumentExploitProtectionEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static DocumentExploitProtectionEnum fromValue(String text) {
      for (DocumentExploitProtectionEnum b : DocumentExploitProtectionEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("documentExploitProtection")
  private DocumentExploitProtectionEnum documentExploitProtection = null;

  /**
   * Controls whether to scan for exploits of known critical vulnerabilites as well as aggessively detect suspicious behaviour that could be an unknown exploit. Searchable as Choice.
   */
  public enum DocumentExploitHeuristicLevelEnum {
    DEFAULT("default"),
    
    DEFAULT_AND_AGRESSIVE("default-and-agressive"),
    
    LEVEL_THREE("LEVEL_THREE"),
    
    LEVEL_FOUR("LEVEL_FOUR");

    private String value;

    DocumentExploitHeuristicLevelEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static DocumentExploitHeuristicLevelEnum fromValue(String text) {
      for (DocumentExploitHeuristicLevelEnum b : DocumentExploitHeuristicLevelEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("documentExploitHeuristicLevel")
  private DocumentExploitHeuristicLevelEnum documentExploitHeuristicLevel = null;

  @JsonProperty("machineLearningEnabled")
  private Boolean machineLearningEnabled = null;

  @JsonProperty("behaviorMonitoringEnabled")
  private Boolean behaviorMonitoringEnabled = null;

  @JsonProperty("documentRecoveryEnabled")
  private Boolean documentRecoveryEnabled = null;

  @JsonProperty("intelliTrapEnabled")
  private Boolean intelliTrapEnabled = null;

  @JsonProperty("memoryScanEnabled")
  private Boolean memoryScanEnabled = null;

  @JsonProperty("spywareEnabled")
  private Boolean spywareEnabled = null;

  @JsonProperty("alertEnabled")
  private Boolean alertEnabled = null;

  /**
   * Specify if the scan will be peformed on all the directories or on a subset. Searchable as Choice.
   */
  public enum DirectoriesToScanEnum {
    ALL_DIRECTORIES("all-directories"),
    
    DIRECTORY_LIST("directory-list");

    private String value;

    DirectoriesToScanEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static DirectoriesToScanEnum fromValue(String text) {
      for (DirectoriesToScanEnum b : DirectoriesToScanEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("directoriesToScan")
  private DirectoriesToScanEnum directoriesToScan = null;

  @JsonProperty("directoryListID")
  private Integer directoryListID = null;

  /**
   * Specify if scan will be performed on all files, a subset or by using IntelliScan. Searchable as Choice.
   */
  public enum FilesToScanEnum {
    ALL_FILES("all-files"),
    
    INTELLISCAN_FILE_TYPES("intelliscan-file-types"),
    
    FILE_EXTENSION_LIST("file-extension-list");

    private String value;

    FilesToScanEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static FilesToScanEnum fromValue(String text) {
      for (FilesToScanEnum b : FilesToScanEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("filesToScan")
  private FilesToScanEnum filesToScan = null;

  @JsonProperty("fileExtensionListID")
  private Integer fileExtensionListID = null;

  @JsonProperty("excludedDirectoryListID")
  private Integer excludedDirectoryListID = null;

  @JsonProperty("excludedFileListID")
  private Integer excludedFileListID = null;

  @JsonProperty("excludedFileExtensionListID")
  private Integer excludedFileExtensionListID = null;

  @JsonProperty("excludedProcessImageFileListID")
  private Integer excludedProcessImageFileListID = null;

  /**
   * Specify when to perform the real-time scan. Searchable as Choice.
   */
  public enum RealTimeScanEnum {
    READ_ONLY("read-only"),
    
    WRITE_ONLY("write-only"),
    
    READ_WRITE("read-write");

    private String value;

    RealTimeScanEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static RealTimeScanEnum fromValue(String text) {
      for (RealTimeScanEnum b : RealTimeScanEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("realTimeScan")
  private RealTimeScanEnum realTimeScan = null;

  @JsonProperty("scanCompressedEnabled")
  private Boolean scanCompressedEnabled = null;

  @JsonProperty("scanCompressedMaximumSize")
  private Integer scanCompressedMaximumSize = null;

  @JsonProperty("scanCompressedMaximumLevels")
  private Integer scanCompressedMaximumLevels = null;

  @JsonProperty("scanCompressedMaximumFiles")
  private Integer scanCompressedMaximumFiles = null;

  @JsonProperty("microsoftOfficeEnabled")
  private Boolean microsoftOfficeEnabled = null;

  @JsonProperty("microsoftOfficeLayers")
  private Integer microsoftOfficeLayers = null;

  @JsonProperty("networkDirectoriesEnabled")
  private Boolean networkDirectoriesEnabled = null;

  @JsonProperty("customRemediationActionsEnabled")
  private Boolean customRemediationActionsEnabled = null;

  @JsonProperty("customScanActionsEnabled")
  private Boolean customScanActionsEnabled = null;

  /**
   * The action to perform when a virus is detected. Searchable as Choice. Available when &#39;customScanActionsEnabled&#39; is true.
   */
  public enum ScanActionForVirusEnum {
    PASS("pass"),
    
    DELETE("delete"),
    
    QUARANTINE("quarantine"),
    
    CLEAN("clean"),
    
    DENY_ACCESS("deny-access");

    private String value;

    ScanActionForVirusEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ScanActionForVirusEnum fromValue(String text) {
      for (ScanActionForVirusEnum b : ScanActionForVirusEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("scanActionForVirus")
  private ScanActionForVirusEnum scanActionForVirus = null;

  /**
   * The action to perform when a trojan is detected. Searchable as Choice. Available when &#39;customScanActionsEnabled&#39; is true.
   */
  public enum ScanActionForTrojansEnum {
    PASS("pass"),
    
    DELETE("delete"),
    
    QUARANTINE("quarantine"),
    
    DENY_ACCESS("deny-access");

    private String value;

    ScanActionForTrojansEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ScanActionForTrojansEnum fromValue(String text) {
      for (ScanActionForTrojansEnum b : ScanActionForTrojansEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("scanActionForTrojans")
  private ScanActionForTrojansEnum scanActionForTrojans = null;

  /**
   * The action to perform when a packer is detected. Searchable as Choice. Available when &#39;customScanActionsEnabled&#39; is true.
   */
  public enum ScanActionForPackerEnum {
    PASS("pass"),
    
    DELETE("delete"),
    
    QUARANTINE("quarantine"),
    
    DENY_ACCESS("deny-access");

    private String value;

    ScanActionForPackerEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ScanActionForPackerEnum fromValue(String text) {
      for (ScanActionForPackerEnum b : ScanActionForPackerEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("scanActionForPacker")
  private ScanActionForPackerEnum scanActionForPacker = null;

  /**
   * The action to perform when spyware is detected. Searchable as Choice. Available when &#39;customScanActionsEnabled&#39; is true.
   */
  public enum ScanActionForSpywareEnum {
    PASS("pass"),
    
    DELETE("delete"),
    
    QUARANTINE("quarantine"),
    
    DENY_ACCESS("deny-access");

    private String value;

    ScanActionForSpywareEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ScanActionForSpywareEnum fromValue(String text) {
      for (ScanActionForSpywareEnum b : ScanActionForSpywareEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("scanActionForSpyware")
  private ScanActionForSpywareEnum scanActionForSpyware = null;

  /**
   * The action to take when other threats are detected. Searchable as Choice. Available when &#39;customScanActionsEnabled&#39; is true.
   */
  public enum ScanActionForOtherThreatsEnum {
    PASS("pass"),
    
    DELETE("delete"),
    
    QUARANTINE("quarantine"),
    
    CLEAN("clean"),
    
    DENY_ACCESS("deny-access");

    private String value;

    ScanActionForOtherThreatsEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ScanActionForOtherThreatsEnum fromValue(String text) {
      for (ScanActionForOtherThreatsEnum b : ScanActionForOtherThreatsEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("scanActionForOtherThreats")
  private ScanActionForOtherThreatsEnum scanActionForOtherThreats = null;

  /**
   * The action to take when cookies are detected. Searchable as Choice. Available when &#39;customScanActionsEnabled&#39; is true.
   */
  public enum ScanActionForCookiesEnum {
    PASS("pass"),
    
    DELETE("delete");

    private String value;

    ScanActionForCookiesEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ScanActionForCookiesEnum fromValue(String text) {
      for (ScanActionForCookiesEnum b : ScanActionForCookiesEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("scanActionForCookies")
  private ScanActionForCookiesEnum scanActionForCookies = null;

  /**
   * The action to take when a CVE exploit is detected. Searchable as Choice. Available when &#39;customScanActionsEnabled&#39; is true.
   */
  public enum ScanActionForCVEEnum {
    PASS("pass"),
    
    DELETE("delete"),
    
    QUARANTINE("quarantine"),
    
    DENY_ACCESS("deny-access");

    private String value;

    ScanActionForCVEEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ScanActionForCVEEnum fromValue(String text) {
      for (ScanActionForCVEEnum b : ScanActionForCVEEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("scanActionForCVE")
  private ScanActionForCVEEnum scanActionForCVE = null;

  /**
   * The action to take when malware identified with heuristics are detected. Searchable as Choice. Available when &#39;customScanActionsEnabled&#39; is true.
   */
  public enum ScanActionForHeuristicsEnum {
    PASS("pass"),
    
    DELETE("delete"),
    
    QUARANTINE("quarantine"),
    
    DENY_ACCESS("deny-access");

    private String value;

    ScanActionForHeuristicsEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ScanActionForHeuristicsEnum fromValue(String text) {
      for (ScanActionForHeuristicsEnum b : ScanActionForHeuristicsEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("scanActionForHeuristics")
  private ScanActionForHeuristicsEnum scanActionForHeuristics = null;

  /**
   * The action to take when possible malware is detected. Searchable as Choice. Available when &#39;customRemediationActionsEnabled&#39; is true.
   */
  public enum ScanActionForPossibleMalwareEnum {
    ACTIVE_ACTION("active-action"),
    
    PASS("pass"),
    
    DELETE("delete"),
    
    QUARANTINE("quarantine"),
    
    DENY_ACCESS("deny-access");

    private String value;

    ScanActionForPossibleMalwareEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ScanActionForPossibleMalwareEnum fromValue(String text) {
      for (ScanActionForPossibleMalwareEnum b : ScanActionForPossibleMalwareEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("scanActionForPossibleMalware")
  private ScanActionForPossibleMalwareEnum scanActionForPossibleMalware = null;

  @JsonProperty("amsiScanEnabled")
  private Boolean amsiScanEnabled = null;

  /**
   * The action to take when suspicious activity and unauthorized changes are detected. Searchable as Choice. Available when &#39;behaviorMonitoringEnabled&#39; is true.
   */
  public enum ScanActionForBehaviorMonitoringEnum {
    ACTIVE_ACTION("active-action"),
    
    PASS("pass");

    private String value;

    ScanActionForBehaviorMonitoringEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ScanActionForBehaviorMonitoringEnum fromValue(String text) {
      for (ScanActionForBehaviorMonitoringEnum b : ScanActionForBehaviorMonitoringEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("scanActionForBehaviorMonitoring")
  private ScanActionForBehaviorMonitoringEnum scanActionForBehaviorMonitoring = null;

  /**
   * The action to take when malware identified with machine learning is detected. Searchable as Choice. Available when &#39;machineLearningEnabled&#39; is true.
   */
  public enum ScanActionForMachineLearningEnum {
    PASS("pass"),
    
    DELETE("delete"),
    
    QUARANTINE("quarantine");

    private String value;

    ScanActionForMachineLearningEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ScanActionForMachineLearningEnum fromValue(String text) {
      for (ScanActionForMachineLearningEnum b : ScanActionForMachineLearningEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("scanActionForMachineLearning")
  private ScanActionForMachineLearningEnum scanActionForMachineLearning = null;

  /**
   * The action to take when malware identified with AMSI protection is detected. Available when &#39;amsiScanEnabled&#39; is true.
   */
  public enum ScanActionForAmsiEnum {
    PASS("pass"),
    
    TERMINATE("terminate");

    private String value;

    ScanActionForAmsiEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ScanActionForAmsiEnum fromValue(String text) {
      for (ScanActionForAmsiEnum b : ScanActionForAmsiEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("scanActionForAmsi")
  private ScanActionForAmsiEnum scanActionForAmsi = null;

  @JsonProperty("ID")
  private Integer ID = null;

  /**
   * Gets or Sets cpuUsage
   */
  public enum CpuUsageEnum {
    LOW("low"),
    
    MEDIUM("medium"),
    
    HIGH("high");

    private String value;

    CpuUsageEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static CpuUsageEnum fromValue(String text) {
      for (CpuUsageEnum b : CpuUsageEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("cpuUsage")
  private CpuUsageEnum cpuUsage = null;

  public AntiMalwareConfiguration name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the anti-malware configuration. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the anti-malware configuration. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public AntiMalwareConfiguration description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the anti-malware configuration. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the anti-malware configuration. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public AntiMalwareConfiguration scanType(ScanTypeEnum scanType) {
    this.scanType = scanType;
    return this;
  }

   /**
   * The type of malware scan configuration. Searchable as Choice.
   * @return scanType
  **/
  @ApiModelProperty(value = "The type of malware scan configuration. Searchable as Choice.")
  public ScanTypeEnum getScanType() {
    return scanType;
  }

  public void setScanType(ScanTypeEnum scanType) {
    this.scanType = scanType;
  }

  public AntiMalwareConfiguration documentExploitProtectionEnabled(Boolean documentExploitProtectionEnabled) {
    this.documentExploitProtectionEnabled = documentExploitProtectionEnabled;
    return this;
  }

   /**
   * Controls whether to scan for known critical vulnerabilities. Use true to enable scan.
   * @return documentExploitProtectionEnabled
  **/
  @ApiModelProperty(value = "Controls whether to scan for known critical vulnerabilities. Use true to enable scan.")
  public Boolean isDocumentExploitProtectionEnabled() {
    return documentExploitProtectionEnabled;
  }

  public void setDocumentExploitProtectionEnabled(Boolean documentExploitProtectionEnabled) {
    this.documentExploitProtectionEnabled = documentExploitProtectionEnabled;
  }

  public AntiMalwareConfiguration documentExploitProtection(DocumentExploitProtectionEnum documentExploitProtection) {
    this.documentExploitProtection = documentExploitProtection;
    return this;
  }

   /**
   * Scan for exploits against known critical vulnerabilities only. Searchable as Choice.
   * @return documentExploitProtection
  **/
  @ApiModelProperty(value = "Scan for exploits against known critical vulnerabilities only. Searchable as Choice.")
  public DocumentExploitProtectionEnum getDocumentExploitProtection() {
    return documentExploitProtection;
  }

  public void setDocumentExploitProtection(DocumentExploitProtectionEnum documentExploitProtection) {
    this.documentExploitProtection = documentExploitProtection;
  }

  public AntiMalwareConfiguration documentExploitHeuristicLevel(DocumentExploitHeuristicLevelEnum documentExploitHeuristicLevel) {
    this.documentExploitHeuristicLevel = documentExploitHeuristicLevel;
    return this;
  }

   /**
   * Controls whether to scan for exploits of known critical vulnerabilites as well as aggessively detect suspicious behaviour that could be an unknown exploit. Searchable as Choice.
   * @return documentExploitHeuristicLevel
  **/
  @ApiModelProperty(value = "Controls whether to scan for exploits of known critical vulnerabilites as well as aggessively detect suspicious behaviour that could be an unknown exploit. Searchable as Choice.")
  public DocumentExploitHeuristicLevelEnum getDocumentExploitHeuristicLevel() {
    return documentExploitHeuristicLevel;
  }

  public void setDocumentExploitHeuristicLevel(DocumentExploitHeuristicLevelEnum documentExploitHeuristicLevel) {
    this.documentExploitHeuristicLevel = documentExploitHeuristicLevel;
  }

  public AntiMalwareConfiguration machineLearningEnabled(Boolean machineLearningEnabled) {
    this.machineLearningEnabled = machineLearningEnabled;
    return this;
  }

   /**
   * Controls whether predictive machine learning is enabled.  Set to true to enable. Searchable as Boolean.
   * @return machineLearningEnabled
  **/
  @ApiModelProperty(value = "Controls whether predictive machine learning is enabled.  Set to true to enable. Searchable as Boolean.")
  public Boolean isMachineLearningEnabled() {
    return machineLearningEnabled;
  }

  public void setMachineLearningEnabled(Boolean machineLearningEnabled) {
    this.machineLearningEnabled = machineLearningEnabled;
  }

  public AntiMalwareConfiguration behaviorMonitoringEnabled(Boolean behaviorMonitoringEnabled) {
    this.behaviorMonitoringEnabled = behaviorMonitoringEnabled;
    return this;
  }

   /**
   * Controls whether to detect suspicious activity and unauthorized changes (including ransomware). Set to true to detect.
   * @return behaviorMonitoringEnabled
  **/
  @ApiModelProperty(value = "Controls whether to detect suspicious activity and unauthorized changes (including ransomware). Set to true to detect.")
  public Boolean isBehaviorMonitoringEnabled() {
    return behaviorMonitoringEnabled;
  }

  public void setBehaviorMonitoringEnabled(Boolean behaviorMonitoringEnabled) {
    this.behaviorMonitoringEnabled = behaviorMonitoringEnabled;
  }

  public AntiMalwareConfiguration documentRecoveryEnabled(Boolean documentRecoveryEnabled) {
    this.documentRecoveryEnabled = documentRecoveryEnabled;
    return this;
  }

   /**
   * Controls whether to back up ransomware-encrypted files. Set to true to back up. Searchable as Boolean.
   * @return documentRecoveryEnabled
  **/
  @ApiModelProperty(value = "Controls whether to back up ransomware-encrypted files. Set to true to back up. Searchable as Boolean.")
  public Boolean isDocumentRecoveryEnabled() {
    return documentRecoveryEnabled;
  }

  public void setDocumentRecoveryEnabled(Boolean documentRecoveryEnabled) {
    this.documentRecoveryEnabled = documentRecoveryEnabled;
  }

  public AntiMalwareConfiguration intelliTrapEnabled(Boolean intelliTrapEnabled) {
    this.intelliTrapEnabled = intelliTrapEnabled;
    return this;
  }

   /**
   * Controls whether IntelliTrap is enabled. Set to true to enable. Searchable as Boolean.
   * @return intelliTrapEnabled
  **/
  @ApiModelProperty(value = "Controls whether IntelliTrap is enabled. Set to true to enable. Searchable as Boolean.")
  public Boolean isIntelliTrapEnabled() {
    return intelliTrapEnabled;
  }

  public void setIntelliTrapEnabled(Boolean intelliTrapEnabled) {
    this.intelliTrapEnabled = intelliTrapEnabled;
  }

  public AntiMalwareConfiguration memoryScanEnabled(Boolean memoryScanEnabled) {
    this.memoryScanEnabled = memoryScanEnabled;
    return this;
  }

   /**
   * Controls whether to scan process memory for malware. Use true to enable scan. Searchable as Boolean.
   * @return memoryScanEnabled
  **/
  @ApiModelProperty(value = "Controls whether to scan process memory for malware. Use true to enable scan. Searchable as Boolean.")
  public Boolean isMemoryScanEnabled() {
    return memoryScanEnabled;
  }

  public void setMemoryScanEnabled(Boolean memoryScanEnabled) {
    this.memoryScanEnabled = memoryScanEnabled;
  }

  public AntiMalwareConfiguration spywareEnabled(Boolean spywareEnabled) {
    this.spywareEnabled = spywareEnabled;
    return this;
  }

   /**
   * Controls whether to enable spyware/grayware protection. Set to true to enable. Searchable as Boolean.
   * @return spywareEnabled
  **/
  @ApiModelProperty(value = "Controls whether to enable spyware/grayware protection. Set to true to enable. Searchable as Boolean.")
  public Boolean isSpywareEnabled() {
    return spywareEnabled;
  }

  public void setSpywareEnabled(Boolean spywareEnabled) {
    this.spywareEnabled = spywareEnabled;
  }

  public AntiMalwareConfiguration alertEnabled(Boolean alertEnabled) {
    this.alertEnabled = alertEnabled;
    return this;
  }

   /**
   * Controls whether to create an alert when the Malware Scan Configuration logs an event. Set to true to enable the alert. Searchable as Boolean.
   * @return alertEnabled
  **/
  @ApiModelProperty(value = "Controls whether to create an alert when the Malware Scan Configuration logs an event. Set to true to enable the alert. Searchable as Boolean.")
  public Boolean isAlertEnabled() {
    return alertEnabled;
  }

  public void setAlertEnabled(Boolean alertEnabled) {
    this.alertEnabled = alertEnabled;
  }

  public AntiMalwareConfiguration directoriesToScan(DirectoriesToScanEnum directoriesToScan) {
    this.directoriesToScan = directoriesToScan;
    return this;
  }

   /**
   * Specify if the scan will be peformed on all the directories or on a subset. Searchable as Choice.
   * @return directoriesToScan
  **/
  @ApiModelProperty(value = "Specify if the scan will be peformed on all the directories or on a subset. Searchable as Choice.")
  public DirectoriesToScanEnum getDirectoriesToScan() {
    return directoriesToScan;
  }

  public void setDirectoriesToScan(DirectoriesToScanEnum directoriesToScan) {
    this.directoriesToScan = directoriesToScan;
  }

  public AntiMalwareConfiguration directoryListID(Integer directoryListID) {
    this.directoryListID = directoryListID;
    return this;
  }

   /**
   * ID of the directory list to scan. Set to 0 to remove any assignment. Searchable as Numeric.
   * @return directoryListID
  **/
  @ApiModelProperty(value = "ID of the directory list to scan. Set to 0 to remove any assignment. Searchable as Numeric.")
  public Integer getDirectoryListID() {
    return directoryListID;
  }

  public void setDirectoryListID(Integer directoryListID) {
    this.directoryListID = directoryListID;
  }

  public AntiMalwareConfiguration filesToScan(FilesToScanEnum filesToScan) {
    this.filesToScan = filesToScan;
    return this;
  }

   /**
   * Specify if scan will be performed on all files, a subset or by using IntelliScan. Searchable as Choice.
   * @return filesToScan
  **/
  @ApiModelProperty(value = "Specify if scan will be performed on all files, a subset or by using IntelliScan. Searchable as Choice.")
  public FilesToScanEnum getFilesToScan() {
    return filesToScan;
  }

  public void setFilesToScan(FilesToScanEnum filesToScan) {
    this.filesToScan = filesToScan;
  }

  public AntiMalwareConfiguration fileExtensionListID(Integer fileExtensionListID) {
    this.fileExtensionListID = fileExtensionListID;
    return this;
  }

   /**
   * ID of the file extension list to scan. Set to 0 to remove any assignment. Searchable as Numeric.
   * @return fileExtensionListID
  **/
  @ApiModelProperty(value = "ID of the file extension list to scan. Set to 0 to remove any assignment. Searchable as Numeric.")
  public Integer getFileExtensionListID() {
    return fileExtensionListID;
  }

  public void setFileExtensionListID(Integer fileExtensionListID) {
    this.fileExtensionListID = fileExtensionListID;
  }

  public AntiMalwareConfiguration excludedDirectoryListID(Integer excludedDirectoryListID) {
    this.excludedDirectoryListID = excludedDirectoryListID;
    return this;
  }

   /**
   * ID of the directory list to exclude from the scan. Set to 0 to remove any assignment. Searchable as Numeric.
   * @return excludedDirectoryListID
  **/
  @ApiModelProperty(value = "ID of the directory list to exclude from the scan. Set to 0 to remove any assignment. Searchable as Numeric.")
  public Integer getExcludedDirectoryListID() {
    return excludedDirectoryListID;
  }

  public void setExcludedDirectoryListID(Integer excludedDirectoryListID) {
    this.excludedDirectoryListID = excludedDirectoryListID;
  }

  public AntiMalwareConfiguration excludedFileListID(Integer excludedFileListID) {
    this.excludedFileListID = excludedFileListID;
    return this;
  }

   /**
   * ID of the file list to exclude from the scan. Set to 0 to remove any assignment. Searchable as Numeric.
   * @return excludedFileListID
  **/
  @ApiModelProperty(value = "ID of the file list to exclude from the scan. Set to 0 to remove any assignment. Searchable as Numeric.")
  public Integer getExcludedFileListID() {
    return excludedFileListID;
  }

  public void setExcludedFileListID(Integer excludedFileListID) {
    this.excludedFileListID = excludedFileListID;
  }

  public AntiMalwareConfiguration excludedFileExtensionListID(Integer excludedFileExtensionListID) {
    this.excludedFileExtensionListID = excludedFileExtensionListID;
    return this;
  }

   /**
   * ID of the file extension list to exclude from the scan. Set to 0 to remove any assignment. Searchable as Numeric.
   * @return excludedFileExtensionListID
  **/
  @ApiModelProperty(value = "ID of the file extension list to exclude from the scan. Set to 0 to remove any assignment. Searchable as Numeric.")
  public Integer getExcludedFileExtensionListID() {
    return excludedFileExtensionListID;
  }

  public void setExcludedFileExtensionListID(Integer excludedFileExtensionListID) {
    this.excludedFileExtensionListID = excludedFileExtensionListID;
  }

  public AntiMalwareConfiguration excludedProcessImageFileListID(Integer excludedProcessImageFileListID) {
    this.excludedProcessImageFileListID = excludedProcessImageFileListID;
    return this;
  }

   /**
   * ID of the process image file list to exclude from the scan. Set to 0 to remove any assignment. Searchable as Numeric.
   * @return excludedProcessImageFileListID
  **/
  @ApiModelProperty(value = "ID of the process image file list to exclude from the scan. Set to 0 to remove any assignment. Searchable as Numeric.")
  public Integer getExcludedProcessImageFileListID() {
    return excludedProcessImageFileListID;
  }

  public void setExcludedProcessImageFileListID(Integer excludedProcessImageFileListID) {
    this.excludedProcessImageFileListID = excludedProcessImageFileListID;
  }

  public AntiMalwareConfiguration realTimeScan(RealTimeScanEnum realTimeScan) {
    this.realTimeScan = realTimeScan;
    return this;
  }

   /**
   * Specify when to perform the real-time scan. Searchable as Choice.
   * @return realTimeScan
  **/
  @ApiModelProperty(value = "Specify when to perform the real-time scan. Searchable as Choice.")
  public RealTimeScanEnum getRealTimeScan() {
    return realTimeScan;
  }

  public void setRealTimeScan(RealTimeScanEnum realTimeScan) {
    this.realTimeScan = realTimeScan;
  }

  public AntiMalwareConfiguration scanCompressedEnabled(Boolean scanCompressedEnabled) {
    this.scanCompressedEnabled = scanCompressedEnabled;
    return this;
  }

   /**
   * Controls whether to scan compressed files. Use true to enable scan. Searchable as Boolean.
   * @return scanCompressedEnabled
  **/
  @ApiModelProperty(value = "Controls whether to scan compressed files. Use true to enable scan. Searchable as Boolean.")
  public Boolean isScanCompressedEnabled() {
    return scanCompressedEnabled;
  }

  public void setScanCompressedEnabled(Boolean scanCompressedEnabled) {
    this.scanCompressedEnabled = scanCompressedEnabled;
  }

  public AntiMalwareConfiguration scanCompressedMaximumSize(Integer scanCompressedMaximumSize) {
    this.scanCompressedMaximumSize = scanCompressedMaximumSize;
    return this;
  }

   /**
   * Maximum size of compressed files to scan, in MB. Searchable as Numeric.
   * @return scanCompressedMaximumSize
  **/
  @ApiModelProperty(value = "Maximum size of compressed files to scan, in MB. Searchable as Numeric.")
  public Integer getScanCompressedMaximumSize() {
    return scanCompressedMaximumSize;
  }

  public void setScanCompressedMaximumSize(Integer scanCompressedMaximumSize) {
    this.scanCompressedMaximumSize = scanCompressedMaximumSize;
  }

  public AntiMalwareConfiguration scanCompressedMaximumLevels(Integer scanCompressedMaximumLevels) {
    this.scanCompressedMaximumLevels = scanCompressedMaximumLevels;
    return this;
  }

   /**
   * The maximum number of levels of compression to scan. Searchable as Numeric.
   * @return scanCompressedMaximumLevels
  **/
  @ApiModelProperty(value = "The maximum number of levels of compression to scan. Searchable as Numeric.")
  public Integer getScanCompressedMaximumLevels() {
    return scanCompressedMaximumLevels;
  }

  public void setScanCompressedMaximumLevels(Integer scanCompressedMaximumLevels) {
    this.scanCompressedMaximumLevels = scanCompressedMaximumLevels;
  }

  public AntiMalwareConfiguration scanCompressedMaximumFiles(Integer scanCompressedMaximumFiles) {
    this.scanCompressedMaximumFiles = scanCompressedMaximumFiles;
    return this;
  }

   /**
   * Maximum number of files to extract. Searchable as Numeric.
   * @return scanCompressedMaximumFiles
  **/
  @ApiModelProperty(value = "Maximum number of files to extract. Searchable as Numeric.")
  public Integer getScanCompressedMaximumFiles() {
    return scanCompressedMaximumFiles;
  }

  public void setScanCompressedMaximumFiles(Integer scanCompressedMaximumFiles) {
    this.scanCompressedMaximumFiles = scanCompressedMaximumFiles;
  }

  public AntiMalwareConfiguration microsoftOfficeEnabled(Boolean microsoftOfficeEnabled) {
    this.microsoftOfficeEnabled = microsoftOfficeEnabled;
    return this;
  }

   /**
   * Controls whether to scan Embedded Microsoft Office Objects. Use true to enable scan. Searchable as Boolean.
   * @return microsoftOfficeEnabled
  **/
  @ApiModelProperty(value = "Controls whether to scan Embedded Microsoft Office Objects. Use true to enable scan. Searchable as Boolean.")
  public Boolean isMicrosoftOfficeEnabled() {
    return microsoftOfficeEnabled;
  }

  public void setMicrosoftOfficeEnabled(Boolean microsoftOfficeEnabled) {
    this.microsoftOfficeEnabled = microsoftOfficeEnabled;
  }

  public AntiMalwareConfiguration microsoftOfficeLayers(Integer microsoftOfficeLayers) {
    this.microsoftOfficeLayers = microsoftOfficeLayers;
    return this;
  }

   /**
   * Number of Microsoft Object Linking and Embedding (OLE) Layers to scan. Searchable as Numeric.
   * @return microsoftOfficeLayers
  **/
  @ApiModelProperty(value = "Number of Microsoft Object Linking and Embedding (OLE) Layers to scan. Searchable as Numeric.")
  public Integer getMicrosoftOfficeLayers() {
    return microsoftOfficeLayers;
  }

  public void setMicrosoftOfficeLayers(Integer microsoftOfficeLayers) {
    this.microsoftOfficeLayers = microsoftOfficeLayers;
  }

  public AntiMalwareConfiguration networkDirectoriesEnabled(Boolean networkDirectoriesEnabled) {
    this.networkDirectoriesEnabled = networkDirectoriesEnabled;
    return this;
  }

   /**
   * Controls whether to scan network directories. Set to true to enable. Searchable as Boolean.
   * @return networkDirectoriesEnabled
  **/
  @ApiModelProperty(value = "Controls whether to scan network directories. Set to true to enable. Searchable as Boolean.")
  public Boolean isNetworkDirectoriesEnabled() {
    return networkDirectoriesEnabled;
  }

  public void setNetworkDirectoriesEnabled(Boolean networkDirectoriesEnabled) {
    this.networkDirectoriesEnabled = networkDirectoriesEnabled;
  }

  public AntiMalwareConfiguration customRemediationActionsEnabled(Boolean customRemediationActionsEnabled) {
    this.customRemediationActionsEnabled = customRemediationActionsEnabled;
    return this;
  }

   /**
   * Controls whether to use the action ActiveActions recommends when malware is detected. Set to true to use the action ActiveAction recommends.
   * @return customRemediationActionsEnabled
  **/
  @ApiModelProperty(value = "Controls whether to use the action ActiveActions recommends when malware is detected. Set to true to use the action ActiveAction recommends.")
  public Boolean isCustomRemediationActionsEnabled() {
    return customRemediationActionsEnabled;
  }

  public void setCustomRemediationActionsEnabled(Boolean customRemediationActionsEnabled) {
    this.customRemediationActionsEnabled = customRemediationActionsEnabled;
  }

  public AntiMalwareConfiguration customScanActionsEnabled(Boolean customScanActionsEnabled) {
    this.customScanActionsEnabled = customScanActionsEnabled;
    return this;
  }

   /**
   * Controls whether to use custom actions. Use true to enable custom actions. Available when &#39;customRemediationActionsEnabled&#39; is true.
   * @return customScanActionsEnabled
  **/
  @ApiModelProperty(value = "Controls whether to use custom actions. Use true to enable custom actions. Available when 'customRemediationActionsEnabled' is true.")
  public Boolean isCustomScanActionsEnabled() {
    return customScanActionsEnabled;
  }

  public void setCustomScanActionsEnabled(Boolean customScanActionsEnabled) {
    this.customScanActionsEnabled = customScanActionsEnabled;
  }

  public AntiMalwareConfiguration scanActionForVirus(ScanActionForVirusEnum scanActionForVirus) {
    this.scanActionForVirus = scanActionForVirus;
    return this;
  }

   /**
   * The action to perform when a virus is detected. Searchable as Choice. Available when &#39;customScanActionsEnabled&#39; is true.
   * @return scanActionForVirus
  **/
  @ApiModelProperty(value = "The action to perform when a virus is detected. Searchable as Choice. Available when 'customScanActionsEnabled' is true.")
  public ScanActionForVirusEnum getScanActionForVirus() {
    return scanActionForVirus;
  }

  public void setScanActionForVirus(ScanActionForVirusEnum scanActionForVirus) {
    this.scanActionForVirus = scanActionForVirus;
  }

  public AntiMalwareConfiguration scanActionForTrojans(ScanActionForTrojansEnum scanActionForTrojans) {
    this.scanActionForTrojans = scanActionForTrojans;
    return this;
  }

   /**
   * The action to perform when a trojan is detected. Searchable as Choice. Available when &#39;customScanActionsEnabled&#39; is true.
   * @return scanActionForTrojans
  **/
  @ApiModelProperty(value = "The action to perform when a trojan is detected. Searchable as Choice. Available when 'customScanActionsEnabled' is true.")
  public ScanActionForTrojansEnum getScanActionForTrojans() {
    return scanActionForTrojans;
  }

  public void setScanActionForTrojans(ScanActionForTrojansEnum scanActionForTrojans) {
    this.scanActionForTrojans = scanActionForTrojans;
  }

  public AntiMalwareConfiguration scanActionForPacker(ScanActionForPackerEnum scanActionForPacker) {
    this.scanActionForPacker = scanActionForPacker;
    return this;
  }

   /**
   * The action to perform when a packer is detected. Searchable as Choice. Available when &#39;customScanActionsEnabled&#39; is true.
   * @return scanActionForPacker
  **/
  @ApiModelProperty(value = "The action to perform when a packer is detected. Searchable as Choice. Available when 'customScanActionsEnabled' is true.")
  public ScanActionForPackerEnum getScanActionForPacker() {
    return scanActionForPacker;
  }

  public void setScanActionForPacker(ScanActionForPackerEnum scanActionForPacker) {
    this.scanActionForPacker = scanActionForPacker;
  }

  public AntiMalwareConfiguration scanActionForSpyware(ScanActionForSpywareEnum scanActionForSpyware) {
    this.scanActionForSpyware = scanActionForSpyware;
    return this;
  }

   /**
   * The action to perform when spyware is detected. Searchable as Choice. Available when &#39;customScanActionsEnabled&#39; is true.
   * @return scanActionForSpyware
  **/
  @ApiModelProperty(value = "The action to perform when spyware is detected. Searchable as Choice. Available when 'customScanActionsEnabled' is true.")
  public ScanActionForSpywareEnum getScanActionForSpyware() {
    return scanActionForSpyware;
  }

  public void setScanActionForSpyware(ScanActionForSpywareEnum scanActionForSpyware) {
    this.scanActionForSpyware = scanActionForSpyware;
  }

  public AntiMalwareConfiguration scanActionForOtherThreats(ScanActionForOtherThreatsEnum scanActionForOtherThreats) {
    this.scanActionForOtherThreats = scanActionForOtherThreats;
    return this;
  }

   /**
   * The action to take when other threats are detected. Searchable as Choice. Available when &#39;customScanActionsEnabled&#39; is true.
   * @return scanActionForOtherThreats
  **/
  @ApiModelProperty(value = "The action to take when other threats are detected. Searchable as Choice. Available when 'customScanActionsEnabled' is true.")
  public ScanActionForOtherThreatsEnum getScanActionForOtherThreats() {
    return scanActionForOtherThreats;
  }

  public void setScanActionForOtherThreats(ScanActionForOtherThreatsEnum scanActionForOtherThreats) {
    this.scanActionForOtherThreats = scanActionForOtherThreats;
  }

  public AntiMalwareConfiguration scanActionForCookies(ScanActionForCookiesEnum scanActionForCookies) {
    this.scanActionForCookies = scanActionForCookies;
    return this;
  }

   /**
   * The action to take when cookies are detected. Searchable as Choice. Available when &#39;customScanActionsEnabled&#39; is true.
   * @return scanActionForCookies
  **/
  @ApiModelProperty(value = "The action to take when cookies are detected. Searchable as Choice. Available when 'customScanActionsEnabled' is true.")
  public ScanActionForCookiesEnum getScanActionForCookies() {
    return scanActionForCookies;
  }

  public void setScanActionForCookies(ScanActionForCookiesEnum scanActionForCookies) {
    this.scanActionForCookies = scanActionForCookies;
  }

  public AntiMalwareConfiguration scanActionForCVE(ScanActionForCVEEnum scanActionForCVE) {
    this.scanActionForCVE = scanActionForCVE;
    return this;
  }

   /**
   * The action to take when a CVE exploit is detected. Searchable as Choice. Available when &#39;customScanActionsEnabled&#39; is true.
   * @return scanActionForCVE
  **/
  @ApiModelProperty(value = "The action to take when a CVE exploit is detected. Searchable as Choice. Available when 'customScanActionsEnabled' is true.")
  public ScanActionForCVEEnum getScanActionForCVE() {
    return scanActionForCVE;
  }

  public void setScanActionForCVE(ScanActionForCVEEnum scanActionForCVE) {
    this.scanActionForCVE = scanActionForCVE;
  }

  public AntiMalwareConfiguration scanActionForHeuristics(ScanActionForHeuristicsEnum scanActionForHeuristics) {
    this.scanActionForHeuristics = scanActionForHeuristics;
    return this;
  }

   /**
   * The action to take when malware identified with heuristics are detected. Searchable as Choice. Available when &#39;customScanActionsEnabled&#39; is true.
   * @return scanActionForHeuristics
  **/
  @ApiModelProperty(value = "The action to take when malware identified with heuristics are detected. Searchable as Choice. Available when 'customScanActionsEnabled' is true.")
  public ScanActionForHeuristicsEnum getScanActionForHeuristics() {
    return scanActionForHeuristics;
  }

  public void setScanActionForHeuristics(ScanActionForHeuristicsEnum scanActionForHeuristics) {
    this.scanActionForHeuristics = scanActionForHeuristics;
  }

  public AntiMalwareConfiguration scanActionForPossibleMalware(ScanActionForPossibleMalwareEnum scanActionForPossibleMalware) {
    this.scanActionForPossibleMalware = scanActionForPossibleMalware;
    return this;
  }

   /**
   * The action to take when possible malware is detected. Searchable as Choice. Available when &#39;customRemediationActionsEnabled&#39; is true.
   * @return scanActionForPossibleMalware
  **/
  @ApiModelProperty(value = "The action to take when possible malware is detected. Searchable as Choice. Available when 'customRemediationActionsEnabled' is true.")
  public ScanActionForPossibleMalwareEnum getScanActionForPossibleMalware() {
    return scanActionForPossibleMalware;
  }

  public void setScanActionForPossibleMalware(ScanActionForPossibleMalwareEnum scanActionForPossibleMalware) {
    this.scanActionForPossibleMalware = scanActionForPossibleMalware;
  }

  public AntiMalwareConfiguration amsiScanEnabled(Boolean amsiScanEnabled) {
    this.amsiScanEnabled = amsiScanEnabled;
    return this;
  }

   /**
   * Controls whether Windows Antimalware Scan Interface (AMSI) protection is enabled. Set to true to enable.
   * @return amsiScanEnabled
  **/
  @ApiModelProperty(value = "Controls whether Windows Antimalware Scan Interface (AMSI) protection is enabled. Set to true to enable.")
  public Boolean isAmsiScanEnabled() {
    return amsiScanEnabled;
  }

  public void setAmsiScanEnabled(Boolean amsiScanEnabled) {
    this.amsiScanEnabled = amsiScanEnabled;
  }

  public AntiMalwareConfiguration scanActionForBehaviorMonitoring(ScanActionForBehaviorMonitoringEnum scanActionForBehaviorMonitoring) {
    this.scanActionForBehaviorMonitoring = scanActionForBehaviorMonitoring;
    return this;
  }

   /**
   * The action to take when suspicious activity and unauthorized changes are detected. Searchable as Choice. Available when &#39;behaviorMonitoringEnabled&#39; is true.
   * @return scanActionForBehaviorMonitoring
  **/
  @ApiModelProperty(value = "The action to take when suspicious activity and unauthorized changes are detected. Searchable as Choice. Available when 'behaviorMonitoringEnabled' is true.")
  public ScanActionForBehaviorMonitoringEnum getScanActionForBehaviorMonitoring() {
    return scanActionForBehaviorMonitoring;
  }

  public void setScanActionForBehaviorMonitoring(ScanActionForBehaviorMonitoringEnum scanActionForBehaviorMonitoring) {
    this.scanActionForBehaviorMonitoring = scanActionForBehaviorMonitoring;
  }

  public AntiMalwareConfiguration scanActionForMachineLearning(ScanActionForMachineLearningEnum scanActionForMachineLearning) {
    this.scanActionForMachineLearning = scanActionForMachineLearning;
    return this;
  }

   /**
   * The action to take when malware identified with machine learning is detected. Searchable as Choice. Available when &#39;machineLearningEnabled&#39; is true.
   * @return scanActionForMachineLearning
  **/
  @ApiModelProperty(value = "The action to take when malware identified with machine learning is detected. Searchable as Choice. Available when 'machineLearningEnabled' is true.")
  public ScanActionForMachineLearningEnum getScanActionForMachineLearning() {
    return scanActionForMachineLearning;
  }

  public void setScanActionForMachineLearning(ScanActionForMachineLearningEnum scanActionForMachineLearning) {
    this.scanActionForMachineLearning = scanActionForMachineLearning;
  }

  public AntiMalwareConfiguration scanActionForAmsi(ScanActionForAmsiEnum scanActionForAmsi) {
    this.scanActionForAmsi = scanActionForAmsi;
    return this;
  }

   /**
   * The action to take when malware identified with AMSI protection is detected. Available when &#39;amsiScanEnabled&#39; is true.
   * @return scanActionForAmsi
  **/
  @ApiModelProperty(value = "The action to take when malware identified with AMSI protection is detected. Available when 'amsiScanEnabled' is true.")
  public ScanActionForAmsiEnum getScanActionForAmsi() {
    return scanActionForAmsi;
  }

  public void setScanActionForAmsi(ScanActionForAmsiEnum scanActionForAmsi) {
    this.scanActionForAmsi = scanActionForAmsi;
  }

   /**
   * ID of the anti-malware configuration. This ID is set automatically. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the anti-malware configuration. This ID is set automatically. Searchable as ID.")
  public Integer getID() {
    return ID;
  }

  public AntiMalwareConfiguration cpuUsage(CpuUsageEnum cpuUsage) {
    this.cpuUsage = cpuUsage;
    return this;
  }

   /**
   * Get cpuUsage
   * @return cpuUsage
  **/
  @ApiModelProperty(value = "")
  public CpuUsageEnum getCpuUsage() {
    return cpuUsage;
  }

  public void setCpuUsage(CpuUsageEnum cpuUsage) {
    this.cpuUsage = cpuUsage;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    AntiMalwareConfiguration antiMalwareConfiguration = (AntiMalwareConfiguration) o;
    return Objects.equals(this.name, antiMalwareConfiguration.name) &&
        Objects.equals(this.description, antiMalwareConfiguration.description) &&
        Objects.equals(this.scanType, antiMalwareConfiguration.scanType) &&
        Objects.equals(this.documentExploitProtectionEnabled, antiMalwareConfiguration.documentExploitProtectionEnabled) &&
        Objects.equals(this.documentExploitProtection, antiMalwareConfiguration.documentExploitProtection) &&
        Objects.equals(this.documentExploitHeuristicLevel, antiMalwareConfiguration.documentExploitHeuristicLevel) &&
        Objects.equals(this.machineLearningEnabled, antiMalwareConfiguration.machineLearningEnabled) &&
        Objects.equals(this.behaviorMonitoringEnabled, antiMalwareConfiguration.behaviorMonitoringEnabled) &&
        Objects.equals(this.documentRecoveryEnabled, antiMalwareConfiguration.documentRecoveryEnabled) &&
        Objects.equals(this.intelliTrapEnabled, antiMalwareConfiguration.intelliTrapEnabled) &&
        Objects.equals(this.memoryScanEnabled, antiMalwareConfiguration.memoryScanEnabled) &&
        Objects.equals(this.spywareEnabled, antiMalwareConfiguration.spywareEnabled) &&
        Objects.equals(this.alertEnabled, antiMalwareConfiguration.alertEnabled) &&
        Objects.equals(this.directoriesToScan, antiMalwareConfiguration.directoriesToScan) &&
        Objects.equals(this.directoryListID, antiMalwareConfiguration.directoryListID) &&
        Objects.equals(this.filesToScan, antiMalwareConfiguration.filesToScan) &&
        Objects.equals(this.fileExtensionListID, antiMalwareConfiguration.fileExtensionListID) &&
        Objects.equals(this.excludedDirectoryListID, antiMalwareConfiguration.excludedDirectoryListID) &&
        Objects.equals(this.excludedFileListID, antiMalwareConfiguration.excludedFileListID) &&
        Objects.equals(this.excludedFileExtensionListID, antiMalwareConfiguration.excludedFileExtensionListID) &&
        Objects.equals(this.excludedProcessImageFileListID, antiMalwareConfiguration.excludedProcessImageFileListID) &&
        Objects.equals(this.realTimeScan, antiMalwareConfiguration.realTimeScan) &&
        Objects.equals(this.scanCompressedEnabled, antiMalwareConfiguration.scanCompressedEnabled) &&
        Objects.equals(this.scanCompressedMaximumSize, antiMalwareConfiguration.scanCompressedMaximumSize) &&
        Objects.equals(this.scanCompressedMaximumLevels, antiMalwareConfiguration.scanCompressedMaximumLevels) &&
        Objects.equals(this.scanCompressedMaximumFiles, antiMalwareConfiguration.scanCompressedMaximumFiles) &&
        Objects.equals(this.microsoftOfficeEnabled, antiMalwareConfiguration.microsoftOfficeEnabled) &&
        Objects.equals(this.microsoftOfficeLayers, antiMalwareConfiguration.microsoftOfficeLayers) &&
        Objects.equals(this.networkDirectoriesEnabled, antiMalwareConfiguration.networkDirectoriesEnabled) &&
        Objects.equals(this.customRemediationActionsEnabled, antiMalwareConfiguration.customRemediationActionsEnabled) &&
        Objects.equals(this.customScanActionsEnabled, antiMalwareConfiguration.customScanActionsEnabled) &&
        Objects.equals(this.scanActionForVirus, antiMalwareConfiguration.scanActionForVirus) &&
        Objects.equals(this.scanActionForTrojans, antiMalwareConfiguration.scanActionForTrojans) &&
        Objects.equals(this.scanActionForPacker, antiMalwareConfiguration.scanActionForPacker) &&
        Objects.equals(this.scanActionForSpyware, antiMalwareConfiguration.scanActionForSpyware) &&
        Objects.equals(this.scanActionForOtherThreats, antiMalwareConfiguration.scanActionForOtherThreats) &&
        Objects.equals(this.scanActionForCookies, antiMalwareConfiguration.scanActionForCookies) &&
        Objects.equals(this.scanActionForCVE, antiMalwareConfiguration.scanActionForCVE) &&
        Objects.equals(this.scanActionForHeuristics, antiMalwareConfiguration.scanActionForHeuristics) &&
        Objects.equals(this.scanActionForPossibleMalware, antiMalwareConfiguration.scanActionForPossibleMalware) &&
        Objects.equals(this.amsiScanEnabled, antiMalwareConfiguration.amsiScanEnabled) &&
        Objects.equals(this.scanActionForBehaviorMonitoring, antiMalwareConfiguration.scanActionForBehaviorMonitoring) &&
        Objects.equals(this.scanActionForMachineLearning, antiMalwareConfiguration.scanActionForMachineLearning) &&
        Objects.equals(this.scanActionForAmsi, antiMalwareConfiguration.scanActionForAmsi) &&
        Objects.equals(this.ID, antiMalwareConfiguration.ID) &&
        Objects.equals(this.cpuUsage, antiMalwareConfiguration.cpuUsage);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, scanType, documentExploitProtectionEnabled, documentExploitProtection, documentExploitHeuristicLevel, machineLearningEnabled, behaviorMonitoringEnabled, documentRecoveryEnabled, intelliTrapEnabled, memoryScanEnabled, spywareEnabled, alertEnabled, directoriesToScan, directoryListID, filesToScan, fileExtensionListID, excludedDirectoryListID, excludedFileListID, excludedFileExtensionListID, excludedProcessImageFileListID, realTimeScan, scanCompressedEnabled, scanCompressedMaximumSize, scanCompressedMaximumLevels, scanCompressedMaximumFiles, microsoftOfficeEnabled, microsoftOfficeLayers, networkDirectoriesEnabled, customRemediationActionsEnabled, customScanActionsEnabled, scanActionForVirus, scanActionForTrojans, scanActionForPacker, scanActionForSpyware, scanActionForOtherThreats, scanActionForCookies, scanActionForCVE, scanActionForHeuristics, scanActionForPossibleMalware, amsiScanEnabled, scanActionForBehaviorMonitoring, scanActionForMachineLearning, scanActionForAmsi, ID, cpuUsage);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class AntiMalwareConfiguration {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    scanType: ").append(toIndentedString(scanType)).append("\n");
    sb.append("    documentExploitProtectionEnabled: ").append(toIndentedString(documentExploitProtectionEnabled)).append("\n");
    sb.append("    documentExploitProtection: ").append(toIndentedString(documentExploitProtection)).append("\n");
    sb.append("    documentExploitHeuristicLevel: ").append(toIndentedString(documentExploitHeuristicLevel)).append("\n");
    sb.append("    machineLearningEnabled: ").append(toIndentedString(machineLearningEnabled)).append("\n");
    sb.append("    behaviorMonitoringEnabled: ").append(toIndentedString(behaviorMonitoringEnabled)).append("\n");
    sb.append("    documentRecoveryEnabled: ").append(toIndentedString(documentRecoveryEnabled)).append("\n");
    sb.append("    intelliTrapEnabled: ").append(toIndentedString(intelliTrapEnabled)).append("\n");
    sb.append("    memoryScanEnabled: ").append(toIndentedString(memoryScanEnabled)).append("\n");
    sb.append("    spywareEnabled: ").append(toIndentedString(spywareEnabled)).append("\n");
    sb.append("    alertEnabled: ").append(toIndentedString(alertEnabled)).append("\n");
    sb.append("    directoriesToScan: ").append(toIndentedString(directoriesToScan)).append("\n");
    sb.append("    directoryListID: ").append(toIndentedString(directoryListID)).append("\n");
    sb.append("    filesToScan: ").append(toIndentedString(filesToScan)).append("\n");
    sb.append("    fileExtensionListID: ").append(toIndentedString(fileExtensionListID)).append("\n");
    sb.append("    excludedDirectoryListID: ").append(toIndentedString(excludedDirectoryListID)).append("\n");
    sb.append("    excludedFileListID: ").append(toIndentedString(excludedFileListID)).append("\n");
    sb.append("    excludedFileExtensionListID: ").append(toIndentedString(excludedFileExtensionListID)).append("\n");
    sb.append("    excludedProcessImageFileListID: ").append(toIndentedString(excludedProcessImageFileListID)).append("\n");
    sb.append("    realTimeScan: ").append(toIndentedString(realTimeScan)).append("\n");
    sb.append("    scanCompressedEnabled: ").append(toIndentedString(scanCompressedEnabled)).append("\n");
    sb.append("    scanCompressedMaximumSize: ").append(toIndentedString(scanCompressedMaximumSize)).append("\n");
    sb.append("    scanCompressedMaximumLevels: ").append(toIndentedString(scanCompressedMaximumLevels)).append("\n");
    sb.append("    scanCompressedMaximumFiles: ").append(toIndentedString(scanCompressedMaximumFiles)).append("\n");
    sb.append("    microsoftOfficeEnabled: ").append(toIndentedString(microsoftOfficeEnabled)).append("\n");
    sb.append("    microsoftOfficeLayers: ").append(toIndentedString(microsoftOfficeLayers)).append("\n");
    sb.append("    networkDirectoriesEnabled: ").append(toIndentedString(networkDirectoriesEnabled)).append("\n");
    sb.append("    customRemediationActionsEnabled: ").append(toIndentedString(customRemediationActionsEnabled)).append("\n");
    sb.append("    customScanActionsEnabled: ").append(toIndentedString(customScanActionsEnabled)).append("\n");
    sb.append("    scanActionForVirus: ").append(toIndentedString(scanActionForVirus)).append("\n");
    sb.append("    scanActionForTrojans: ").append(toIndentedString(scanActionForTrojans)).append("\n");
    sb.append("    scanActionForPacker: ").append(toIndentedString(scanActionForPacker)).append("\n");
    sb.append("    scanActionForSpyware: ").append(toIndentedString(scanActionForSpyware)).append("\n");
    sb.append("    scanActionForOtherThreats: ").append(toIndentedString(scanActionForOtherThreats)).append("\n");
    sb.append("    scanActionForCookies: ").append(toIndentedString(scanActionForCookies)).append("\n");
    sb.append("    scanActionForCVE: ").append(toIndentedString(scanActionForCVE)).append("\n");
    sb.append("    scanActionForHeuristics: ").append(toIndentedString(scanActionForHeuristics)).append("\n");
    sb.append("    scanActionForPossibleMalware: ").append(toIndentedString(scanActionForPossibleMalware)).append("\n");
    sb.append("    amsiScanEnabled: ").append(toIndentedString(amsiScanEnabled)).append("\n");
    sb.append("    scanActionForBehaviorMonitoring: ").append(toIndentedString(scanActionForBehaviorMonitoring)).append("\n");
    sb.append("    scanActionForMachineLearning: ").append(toIndentedString(scanActionForMachineLearning)).append("\n");
    sb.append("    scanActionForAmsi: ").append(toIndentedString(scanActionForAmsi)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("    cpuUsage: ").append(toIndentedString(cpuUsage)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

