/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.PolicyModuleStatus;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Policy-level configuration for the Anti-Malware module
 */
@ApiModel(description = "Policy-level configuration for the Anti-Malware module")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class AntiMalwarePolicyExtension {
  /**
   * Module state. The &#39;inherited&#39; value is write-only.
   */
  public enum StateEnum {
    INHERITED("inherited"),
    
    ON("on"),
    
    OFF("off");

    private String value;

    StateEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StateEnum fromValue(String text) {
      for (StateEnum b : StateEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("state")
  private StateEnum state = null;

  @JsonProperty("moduleStatus")
  private PolicyModuleStatus moduleStatus = null;

  @JsonProperty("realTimeScanConfigurationID")
  private Integer realTimeScanConfigurationID = null;

  @JsonProperty("realTimeScanScheduleID")
  private Integer realTimeScanScheduleID = null;

  @JsonProperty("manualScanConfigurationID")
  private Integer manualScanConfigurationID = null;

  @JsonProperty("scheduledScanConfigurationID")
  private Integer scheduledScanConfigurationID = null;

  public AntiMalwarePolicyExtension state(StateEnum state) {
    this.state = state;
    return this;
  }

   /**
   * Module state. The &#39;inherited&#39; value is write-only.
   * @return state
  **/
  @ApiModelProperty(value = "Module state. The 'inherited' value is write-only.")
  public StateEnum getState() {
    return state;
  }

  public void setState(StateEnum state) {
    this.state = state;
  }

  public AntiMalwarePolicyExtension moduleStatus(PolicyModuleStatus moduleStatus) {
    this.moduleStatus = moduleStatus;
    return this;
  }

   /**
   * Get moduleStatus
   * @return moduleStatus
  **/
  @ApiModelProperty(value = "")
  public PolicyModuleStatus getModuleStatus() {
    return moduleStatus;
  }

  public void setModuleStatus(PolicyModuleStatus moduleStatus) {
    this.moduleStatus = moduleStatus;
  }

  public AntiMalwarePolicyExtension realTimeScanConfigurationID(Integer realTimeScanConfigurationID) {
    this.realTimeScanConfigurationID = realTimeScanConfigurationID;
    return this;
  }

   /**
   * ID of the Real Time Scan Configuration.
   * @return realTimeScanConfigurationID
  **/
  @ApiModelProperty(value = "ID of the Real Time Scan Configuration.")
  public Integer getRealTimeScanConfigurationID() {
    return realTimeScanConfigurationID;
  }

  public void setRealTimeScanConfigurationID(Integer realTimeScanConfigurationID) {
    this.realTimeScanConfigurationID = realTimeScanConfigurationID;
  }

  public AntiMalwarePolicyExtension realTimeScanScheduleID(Integer realTimeScanScheduleID) {
    this.realTimeScanScheduleID = realTimeScanScheduleID;
    return this;
  }

   /**
   * ID of the Real Time Schedule.
   * @return realTimeScanScheduleID
  **/
  @ApiModelProperty(value = "ID of the Real Time Schedule.")
  public Integer getRealTimeScanScheduleID() {
    return realTimeScanScheduleID;
  }

  public void setRealTimeScanScheduleID(Integer realTimeScanScheduleID) {
    this.realTimeScanScheduleID = realTimeScanScheduleID;
  }

  public AntiMalwarePolicyExtension manualScanConfigurationID(Integer manualScanConfigurationID) {
    this.manualScanConfigurationID = manualScanConfigurationID;
    return this;
  }

   /**
   * ID of the Manual Scan Configuration.
   * @return manualScanConfigurationID
  **/
  @ApiModelProperty(value = "ID of the Manual Scan Configuration.")
  public Integer getManualScanConfigurationID() {
    return manualScanConfigurationID;
  }

  public void setManualScanConfigurationID(Integer manualScanConfigurationID) {
    this.manualScanConfigurationID = manualScanConfigurationID;
  }

  public AntiMalwarePolicyExtension scheduledScanConfigurationID(Integer scheduledScanConfigurationID) {
    this.scheduledScanConfigurationID = scheduledScanConfigurationID;
    return this;
  }

   /**
   * ID of the Scheduled Scan Configuration.
   * @return scheduledScanConfigurationID
  **/
  @ApiModelProperty(value = "ID of the Scheduled Scan Configuration.")
  public Integer getScheduledScanConfigurationID() {
    return scheduledScanConfigurationID;
  }

  public void setScheduledScanConfigurationID(Integer scheduledScanConfigurationID) {
    this.scheduledScanConfigurationID = scheduledScanConfigurationID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    AntiMalwarePolicyExtension antiMalwarePolicyExtension = (AntiMalwarePolicyExtension) o;
    return Objects.equals(this.state, antiMalwarePolicyExtension.state) &&
        Objects.equals(this.moduleStatus, antiMalwarePolicyExtension.moduleStatus) &&
        Objects.equals(this.realTimeScanConfigurationID, antiMalwarePolicyExtension.realTimeScanConfigurationID) &&
        Objects.equals(this.realTimeScanScheduleID, antiMalwarePolicyExtension.realTimeScanScheduleID) &&
        Objects.equals(this.manualScanConfigurationID, antiMalwarePolicyExtension.manualScanConfigurationID) &&
        Objects.equals(this.scheduledScanConfigurationID, antiMalwarePolicyExtension.scheduledScanConfigurationID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(state, moduleStatus, realTimeScanConfigurationID, realTimeScanScheduleID, manualScanConfigurationID, scheduledScanConfigurationID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class AntiMalwarePolicyExtension {\n");
    
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("    moduleStatus: ").append(toIndentedString(moduleStatus)).append("\n");
    sb.append("    realTimeScanConfigurationID: ").append(toIndentedString(realTimeScanConfigurationID)).append("\n");
    sb.append("    realTimeScanScheduleID: ").append(toIndentedString(realTimeScanScheduleID)).append("\n");
    sb.append("    manualScanConfigurationID: ").append(toIndentedString(manualScanConfigurationID)).append("\n");
    sb.append("    scheduledScanConfigurationID: ").append(toIndentedString(scheduledScanConfigurationID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

