/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.893
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.ComputerFilter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Controls the behavior of a scheduled task of type: scan-for-malware.
 */
@ApiModel(description = "Controls the behavior of a scheduled task of type: scan-for-malware.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-20T04:42:32.040Z")
public class ScanForMalwareTaskParameters {
  @JsonProperty("computerFilter")
  private ComputerFilter computerFilter = null;

  /**
   * Maximum time after the scheduled start time that anti-malware scans will run.
   */
  public enum TimeoutEnum {
    NEVER("never"),
    
    ONE_HOUR("one-hour"),
    
    TWO_HOURS("two-hours"),
    
    FOUR_HOURS("four-hours"),
    
    EIGHT_HOURS("eight-hours"),
    
    TWELVE_HOURS("twelve-hours"),
    
    ONE_DAY("one-day"),
    
    ONE_AND_A_HALF_DAYS("one-and-a-half-days"),
    
    TWO_DAYS("two-days");

    private String value;

    TimeoutEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TimeoutEnum fromValue(String text) {
      for (TimeoutEnum b : TimeoutEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("timeout")
  private TimeoutEnum timeout = null;

  public ScanForMalwareTaskParameters computerFilter(ComputerFilter computerFilter) {
    this.computerFilter = computerFilter;
    return this;
  }

   /**
   * Controls which computer(s) to scan.
   * @return computerFilter
  **/
  @ApiModelProperty(value = "Controls which computer(s) to scan.")
  public ComputerFilter getComputerFilter() {
    return computerFilter;
  }

  public void setComputerFilter(ComputerFilter computerFilter) {
    this.computerFilter = computerFilter;
  }

  public ScanForMalwareTaskParameters timeout(TimeoutEnum timeout) {
    this.timeout = timeout;
    return this;
  }

   /**
   * Maximum time after the scheduled start time that anti-malware scans will run.
   * @return timeout
  **/
  @ApiModelProperty(value = "Maximum time after the scheduled start time that anti-malware scans will run.")
  public TimeoutEnum getTimeout() {
    return timeout;
  }

  public void setTimeout(TimeoutEnum timeout) {
    this.timeout = timeout;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ScanForMalwareTaskParameters scanForMalwareTaskParameters = (ScanForMalwareTaskParameters) o;
    return Objects.equals(this.computerFilter, scanForMalwareTaskParameters.computerFilter) &&
        Objects.equals(this.timeout, scanForMalwareTaskParameters.timeout);
  }

  @Override
  public int hashCode() {
    return Objects.hash(computerFilter, timeout);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ScanForMalwareTaskParameters {\n");
    
    sb.append("    computerFilter: ").append(toIndentedString(computerFilter)).append("\n");
    sb.append("    timeout: ").append(toIndentedString(timeout)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

